/*******************************************************************/
/* Comptabilit Analytique Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* Procdures de base :                                            */
/*   - Selection serveur                                           */
/*   - Selection user                                              */
/*   - Saisie nouvelle socit                                     */
/* Fichier source                                                  */
/*******************************************************************/

#include <stdio.h>
#include <gtk/gtk.h>
#include <mysql/mysql.h>
#include <gnome.h>
#include "support.h"
#include "common.h"
#include "gtksql.h"
#include "base.h"

int ModalResult;

/* Protos */
void SelServ_BtApply_clicked(GtkButton *button,gpointer user_data);
GtkWidget* create_SelServeur (void);
/***/
GtkWidget* create_SelUser (void);
void SelUser_BtApply_clicked(GtkButton *button,gpointer user_data);
/***/
GtkWidget* create_NewSociety(void);
void NewSociety_BtApply_clicked(GtkButton *button,gpointer user_data);
void CancelEntry_clicked(GtkButton *button,gpointer user_data);

/* Annulation modale **********************************************/
void CancelEntry_clicked(GtkButton *button,gpointer user_data)
{
  ModalResult=MR_CANCEL;
  gtk_widget_destroy(GTK_WIDGET (button));
}

/***********************************************************/
/* Selection serveur ***************************************/
GtkWidget* create_SelServeur (void)
{
  GtkWidget *SelServeur;
  GtkWidget *vbox3;
  GtkWidget *hbox1;
  GtkWidget *label35;
  GtkWidget *TxtServeur;
  GtkWidget *hbox2;
  GtkWidget *BtApply;
  GtkWidget *BtAnnul;

  SelServeur = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (SelServeur), "SelServeur", SelServeur);
  gtk_window_set_title (GTK_WINDOW (SelServeur), _("Selection serveur"));
  gtk_window_set_position (GTK_WINDOW (SelServeur), GTK_WIN_POS_MOUSE);
  gtk_window_set_default_size (GTK_WINDOW (SelServeur), 380, 65);

  vbox3 = gtk_vbox_new (TRUE, 10);
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (SelServeur), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_container_add (GTK_CONTAINER (SelServeur), vbox3);
  gtk_container_set_border_width (GTK_CONTAINER (vbox3), 6);

  hbox1 = gtk_hbox_new (FALSE, 14);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (SelServeur), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox1, TRUE, TRUE, 0);

  label35 = gtk_label_new (_("Serveur :"));
  gtk_widget_ref (label35);
  gtk_object_set_data_full (GTK_OBJECT (SelServeur), "label35", label35,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label35);
  gtk_box_pack_start (GTK_BOX (hbox1), label35, FALSE, FALSE, 0);

  TxtServeur = gtk_entry_new_with_max_length (15);
  gtk_widget_ref (TxtServeur);
  gtk_object_set_data_full (GTK_OBJECT (SelServeur), "TxtServeur", TxtServeur,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (TxtServeur);
  gtk_box_pack_start (GTK_BOX (hbox1), TxtServeur, TRUE, TRUE, 0);

  hbox2 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (SelServeur), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox2, TRUE, TRUE, 0);
  gtk_widget_set_usize (hbox2, -2, 20);

  BtApply = gnome_stock_button (GNOME_STOCK_BUTTON_APPLY);
  gtk_widget_ref (BtApply);
  gtk_object_set_data_full (GTK_OBJECT (SelServeur), "BtApply", BtApply,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtApply);
  gtk_box_pack_start (GTK_BOX (hbox2), BtApply, FALSE, FALSE, 0);

  BtAnnul = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (BtAnnul);
  gtk_object_set_data_full (GTK_OBJECT (SelServeur), "BtAnnul", BtAnnul,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtAnnul);
  gtk_box_pack_start (GTK_BOX (hbox2), BtAnnul, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (BtApply), "clicked",
                      GTK_SIGNAL_FUNC (SelServ_BtApply_clicked),
                      NULL);
  gtk_signal_connect_object(GTK_OBJECT (BtAnnul), "clicked",
                      GTK_SIGNAL_FUNC (CancelEntry_clicked),
                      GTK_OBJECT (SelServeur));

  return SelServeur;
}

void SelServ_BtApply_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *Wcall;

  Wcall=lookup_widget(GTK_WIDGET (button),"TxtServeur");
  strcpy(MySqlServer,gtk_entry_get_text(GTK_ENTRY(Wcall)));
  ModalResult=MR_OK;
  Wcall=lookup_widget(GTK_WIDGET (button),"SelServeur");
  gtk_widget_destroy(GTK_WIDGET(Wcall));
}

int SelectServer(void)
{
  GtkWidget *SelServ;
  GtkEntry *Entrie;

  SelServ=create_SelServeur();
  gtk_widget_show_all(SelServ);
  Entrie=GTK_ENTRY (lookup_widget(GTK_WIDGET (SelServ),"TxtServeur"));
  gtk_entry_set_text(Entrie,MySqlServer);
  ModalResult=MR_NONE;
  while (ModalResult==MR_NONE)
    if (gtk_events_pending()) gtk_main_iteration();
  return (ModalResult);
}

/******************************************************************/
/* Selection utilisateur ******************************************/
GtkWidget* create_SelUser (void)
{
  GtkWidget *SelUser;
  GtkWidget *vbox4;
  GtkWidget *vbox5;
  GtkWidget *hbox4;
  GtkWidget *label38;
  GtkWidget *EntryUser;
  GtkWidget *hbox5;
  GtkWidget *label39;
  GtkWidget *EntryPasse;
  GtkWidget *hbox3;
  GtkWidget *BtApply;
  GtkWidget *BtAnnul;

  SelUser = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (SelUser), "SelUser", SelUser);
  gtk_window_set_title (GTK_WINDOW (SelUser), _("Slection utilisateur"));

  vbox4 = gtk_vbox_new (TRUE, 0);
  gtk_widget_ref (vbox4);
  gtk_object_set_data_full (GTK_OBJECT (SelUser), "vbox4", vbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (SelUser), vbox4);
  gtk_container_set_border_width (GTK_CONTAINER (vbox4), 10);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (SelUser), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_box_pack_start (GTK_BOX (vbox4), vbox5, TRUE, TRUE, 0);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (SelUser), "hbox4", hbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox4, TRUE, TRUE, 4);
  gtk_container_set_border_width (GTK_CONTAINER (hbox4), 6);

  label38 = gtk_label_new (_("Utilisateur :"));
  gtk_widget_ref (label38);
  gtk_object_set_data_full (GTK_OBJECT (SelUser), "label38", label38,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label38);
  gtk_box_pack_start (GTK_BOX (hbox4), label38, FALSE, FALSE, 0);

  EntryUser = gtk_entry_new ();
  gtk_widget_ref (EntryUser);
  gtk_object_set_data_full (GTK_OBJECT (SelUser), "EntryUser", EntryUser,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EntryUser);
  gtk_box_pack_start (GTK_BOX (hbox4), EntryUser, FALSE, FALSE, 0);
  gtk_widget_set_usize (EntryUser, 117, -2);

  hbox5 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox5);
  gtk_object_set_data_full (GTK_OBJECT (SelUser), "hbox5", hbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox5);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox5, FALSE, TRUE, 0);

  label39 = gtk_label_new (_("Mot de passe :"));
  gtk_widget_ref (label39);
  gtk_object_set_data_full (GTK_OBJECT (SelUser), "label39", label39,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label39);
  gtk_box_pack_start (GTK_BOX (hbox5), label39, FALSE, FALSE, 0);

  EntryPasse = gtk_entry_new ();
  gtk_widget_ref (EntryPasse);
  gtk_object_set_data_full (GTK_OBJECT (SelUser), "EntryPasse", EntryPasse,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EntryPasse);
  gtk_box_pack_start (GTK_BOX (hbox5), EntryPasse, FALSE, FALSE, 17);
  gtk_widget_set_usize (EntryPasse, 111, -2);
  gtk_entry_set_visibility (GTK_ENTRY (EntryPasse), FALSE);

  hbox3 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (SelUser), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox3, FALSE, FALSE, 0);

  BtApply = gnome_stock_button (GNOME_STOCK_BUTTON_APPLY);
  gtk_widget_ref (BtApply);
  gtk_object_set_data_full (GTK_OBJECT (SelUser), "BtApply", BtApply,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtApply);
  gtk_box_pack_start (GTK_BOX (hbox3), BtApply, FALSE, FALSE, 0);

  BtAnnul = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (BtAnnul);
  gtk_object_set_data_full (GTK_OBJECT (SelUser), "BtAnnul", BtAnnul,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtAnnul);
  gtk_box_pack_start (GTK_BOX (hbox3), BtAnnul, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (BtApply), "clicked",
                      GTK_SIGNAL_FUNC (SelUser_BtApply_clicked),
                      NULL);
  gtk_signal_connect_object(GTK_OBJECT (BtAnnul), "clicked",
                      GTK_SIGNAL_FUNC (CancelEntry_clicked),
                      GTK_OBJECT (SelUser));

  return SelUser;
}

void SelUser_BtApply_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *Wcall;

  Wcall=lookup_widget(GTK_WIDGET (button),"EntryUser");
  strcpy(MySqlUser,gtk_entry_get_text(GTK_ENTRY(Wcall)));
  Wcall=lookup_widget(GTK_WIDGET (button),"EntryPasse");
  strcpy(MySqlPassword,gtk_entry_get_text(GTK_ENTRY(Wcall)));
  ModalResult=MR_OK;
  Wcall=lookup_widget(GTK_WIDGET (button),"SelUser");
  gtk_widget_destroy(GTK_WIDGET(Wcall));
}

int SelectUser(void)
{
  GtkWidget *SelUser;
  GtkEntry *Entrie;

  SelUser=create_SelUser();
  gtk_widget_show_all(SelUser);
  Entrie=GTK_ENTRY (lookup_widget(GTK_WIDGET (SelUser),"EntryUser"));
  gtk_entry_set_text(Entrie,MySqlUser);
  Entrie=GTK_ENTRY (lookup_widget(GTK_WIDGET (SelUser),"EntryPasse"));
  gtk_entry_set_text(Entrie,MySqlPassword);
  ModalResult=MR_NONE;
  while (ModalResult==MR_NONE)
    if (gtk_events_pending()) gtk_main_iteration();
  return (ModalResult);
}

/**********************************************************************/
/* Saisie d'une nouvelle socit **************************************/
GtkWidget* create_NewSociety(void)
{
  GtkWidget *NewSociety;
  GtkWidget *MainBox;
  GtkWidget *EntryVBox;
  GtkWidget *CodeBox;
  GtkWidget *LabelCode;
  GtkWidget *EntryCode;
  GtkWidget *LibBox;
  GtkWidget *LabelLib;
  GtkWidget *EntryLib;
  GtkWidget *ButtonBox;
  GtkWidget *BtApply;
  GtkWidget *BtAnnul;

  NewSociety = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (NewSociety), "NewSociety", NewSociety);
  gtk_window_set_title (GTK_WINDOW (NewSociety), _("Nouvelle socit"));

  MainBox = gtk_vbox_new (TRUE, 0);
  gtk_widget_ref (MainBox);
  gtk_object_set_data_full (GTK_OBJECT (NewSociety), "MainBox", MainBox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (MainBox);
  gtk_container_add (GTK_CONTAINER (NewSociety), MainBox);
  gtk_container_set_border_width (GTK_CONTAINER (MainBox), 10);

  EntryVBox = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (EntryVBox);
  gtk_object_set_data_full (GTK_OBJECT (NewSociety), "EntryVBox", EntryVBox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EntryVBox);
  gtk_box_pack_start (GTK_BOX (MainBox), EntryVBox, TRUE, TRUE, 0);

  /***/
  CodeBox = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (CodeBox);
  gtk_object_set_data_full (GTK_OBJECT (NewSociety), "CodeBox", CodeBox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CodeBox);
  gtk_box_pack_start (GTK_BOX (EntryVBox), CodeBox, TRUE, TRUE, 4);
  gtk_container_set_border_width (GTK_CONTAINER (CodeBox), 6);

  LabelCode = gtk_label_new (_("Code :"));
  gtk_widget_ref (LabelCode);
  gtk_object_set_data_full (GTK_OBJECT (NewSociety), "LabelCode", LabelCode,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (LabelCode);
  gtk_box_pack_start (GTK_BOX (CodeBox), LabelCode, FALSE, FALSE, 0);

  EntryCode = gtk_entry_new_with_max_length(LEN_COD_SOC);
  gtk_widget_ref (EntryCode);
  gtk_object_set_data_full (GTK_OBJECT (NewSociety), "EntryCode", EntryCode,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EntryCode);
  gtk_box_pack_start (GTK_BOX (CodeBox), EntryCode, FALSE, FALSE, 0);
  gtk_widget_set_usize (EntryCode, 117, -2);

  /****/
  LibBox = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (LibBox);
  gtk_object_set_data_full (GTK_OBJECT (NewSociety), "LibBox", LibBox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (LibBox);
  gtk_box_pack_start (GTK_BOX (EntryVBox), LibBox, FALSE, TRUE, 0);

  LabelLib = gtk_label_new (_("Libell :"));
  gtk_widget_ref (LabelLib);
  gtk_object_set_data_full (GTK_OBJECT (NewSociety), "LabelLib", LabelLib,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (LabelLib);
  gtk_box_pack_start (GTK_BOX (LibBox), LabelLib, FALSE, FALSE, 0);

  EntryLib = gtk_entry_new_with_max_length(25);
  gtk_widget_ref (EntryLib);
  gtk_object_set_data_full (GTK_OBJECT (NewSociety), "EntryLib", EntryLib,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EntryLib);
  gtk_box_pack_start (GTK_BOX (LibBox), EntryLib, FALSE, FALSE, 17);
  gtk_widget_set_usize (EntryLib, 111, -2);

  /***/
  ButtonBox = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (ButtonBox);
  gtk_object_set_data_full (GTK_OBJECT (NewSociety), "ButtonBox", ButtonBox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ButtonBox);
  gtk_box_pack_start (GTK_BOX (MainBox), ButtonBox, FALSE, FALSE, 0);

  BtApply = gnome_stock_button (GNOME_STOCK_BUTTON_APPLY);
  gtk_widget_ref (BtApply);
  gtk_object_set_data_full (GTK_OBJECT (NewSociety), "BtApply", BtApply,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtApply);
  gtk_box_pack_start (GTK_BOX (ButtonBox), BtApply, FALSE, FALSE, 0);

  BtAnnul = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (BtAnnul);
  gtk_object_set_data_full (GTK_OBJECT (NewSociety), "BtAnnul", BtAnnul,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtAnnul);
  gtk_box_pack_start (GTK_BOX (ButtonBox), BtAnnul, FALSE, FALSE, 0);
  /***/
  gtk_signal_connect (GTK_OBJECT (BtApply), "clicked",
                      GTK_SIGNAL_FUNC (NewSociety_BtApply_clicked),
                      NULL);
  gtk_signal_connect_object (GTK_OBJECT (BtAnnul), "clicked",
			     GTK_SIGNAL_FUNC (CancelEntry_clicked),
                      GTK_OBJECT (NewSociety));

  return NewSociety;
}

void NewSociety_BtApply_clicked(GtkButton *button,gpointer user_data)
{
  GtkWidget *widget;
  gchar SqlCmd[300],*End,PsCle[LEN_COD_SOC+1];

  OpenDbLcpt();
  End=strmov(SqlCmd,"Insert into Societe (PsCle,PsNom,PsDevise,PsEuro) Values (");
  widget=lookup_widget(GTK_WIDGET (button),"EntryCode");
  strcpy(PsCle,gtk_entry_get_text(GTK_ENTRY (widget)));
  End=StrSql(End,PsCle);
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"EntryLib");
  End=strmov(End,",'FR',6.55957)");
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    sprintf(SqlCmd,"Insert into ModeRegl (Soc,Code,Libelle) Values ('%s','01','ESPECES')",PsCle);
    if (mysql_query(DbLcpt,SqlCmd)!=0) g_print("Erreur cration rglement !\n");
    sprintf(SqlCmd,"Insert into ModeRegl (Soc,Code,Libelle) Values ('%s','02','CHEQUE')",PsCle);
    if (mysql_query(DbLcpt,SqlCmd)!=0) g_print("Erreur cration rglement !\n");
    sprintf(SqlCmd,"Insert into ModeRegl (Soc,Code,Libelle) Values ('%s','03','CARTE BANQUAIRE')",PsCle);
    if (mysql_query(DbLcpt,SqlCmd)!=0) g_print("Erreur cration rglement !\n");
    sprintf(SqlCmd,"Insert into ModeRegl (Soc,Code,Libelle) Values ('%s','04','LCR')",PsCle);
    if (mysql_query(DbLcpt,SqlCmd)!=0) g_print("Erreur cration rglement !\n");
    sprintf(SqlCmd,"Insert into ModeRegl (Soc,Code,Libelle) Values ('%s','05','VIREMENT')",PsCle);
    if (mysql_query(DbLcpt,SqlCmd)!=0) g_print("Erreur cration rglement !\n");
    sprintf(SqlCmd,"Insert into ModeRegl (Soc,Code,Libelle) Values ('%s','06','TRAITE')",PsCle);
    if (mysql_query(DbLcpt,SqlCmd)!=0) g_print("Erreur cration rglement !\n");
    sprintf(SqlCmd,"Insert into ModeRegl (Soc,Code,Libelle) Values ('%s','07','PRELEVEMENT')",PsCle);
    if (mysql_query(DbLcpt,SqlCmd)!=0) g_print("Erreur cration rglement !\n");
  } else  MessageAlerte("Impossible de crer cette socit !?");
  /***/
  sprintf(SqlCmd,"Insert Into Pgx (PgCle,PgSLett,PgCdgc,PgPdgc,PgAtt,PgResul,PgResb,PgResp,PgJo,PgJc,PgOd) Values ('%s',100.0,'65800000','75800000','47100000','12000000','12100000','12900000','OU','CL','OD')",PsCle);
    if (mysql_query(DbLcpt,SqlCmd)!=0) g_print(_("Erreur cration paramtres gnraux !\n"));
/***/
  ModalResult=MR_OK;
  /***/
  widget=lookup_widget(GTK_WIDGET (button),"NewSociety");
  gtk_widget_destroy(GTK_WIDGET(widget));
}

int NewSociety(void)
{
  GtkWidget *Win;

  Win=create_NewSociety();
  gtk_widget_show_all(Win);
  ModalResult=MR_NONE;
  while (ModalResult==MR_NONE)
    if (gtk_events_pending()) gtk_main_iteration();
  return (ModalResult);
}
