/******************************************************/
/* Outils divers                                      */
/* Version 0.1 : 01/02/02                             */
/* CONRAD Pascal                                      */
/*----------------------------------------------------*/
/* A Faire :                                          */
/* - Dplacer les traitements de chaine de callback   */
/* 21/03/2002 - restucturation selections             */
/* 09/05/2002 - Ajout SqlGetString                    */
/* 30/06/2002 - Ajout GetMonthString                  */
/******************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <mysql/mysql.h>
#include <gtk/gtk.h>
#include <gnome.h>
#include "common.h"
#include "support.h"
#include "base.h"

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

/* Public */
MYSQL *DbLcpt;
gchar MySqlServer[16],MySqlUser[16],MySqlPassword[16];
gchar AfmDir[512];
gchar PREFIX[512];
/* Priv */
gchar PsCle[LEN_COD_SOC+1];
gchar Tempo[255];
gint ModalResult;
gchar *FR_month[]={"Janvier","Fevrier","Mars","Avril","Mai","Juin",
		   "Juillet","Aout","Septembre","Octobre","Novembre","Dcembre"};
gchar *EN_month[]={"January","February","March","April","May","June",
		   "July","August","September","October","November","December"};

/* Protos */
GtkWidget* create_SelectFont (void);
GtkWidget* create_SelectColor (void);
void BtOk_clicked(GtkButton *button,gpointer user_data);
void BtCancel_clicked(GtkButton *button,gpointer user_data);
void SelDate_BtOk_clicked (GtkButton *button,gpointer user_data);
void SelColor_BtOk_clicked(GtkButton *button,gpointer user_data);
void SelFont_BtOk_clicked(GtkButton *button,gpointer user_data);

/* Fonction divers ************************************************/
char *DateToIso(char *Dest,char *Src)
{
  gint d,m,y;

  ExplodeDate(Src,&d,&m,&y);
  sprintf(Dest,"%04i-%02i-%02i",y,m,d);
  return (Dest);
}

char *IsoToDate(char *Dest,char *Src)
{
  char *a;

  a=Dest+5;
  *a++='/';
  *a++=*Src++;
  *a++=*Src++;
  *a++=*Src++;
  *a++=*Src++;
  *a=0;
  Src++;
  a=Dest+2;
  *a++='/';
  *a++=*Src++;
  *a++=*Src++;
  Src++;
  a=Dest;
  *a++=*Src++;
  *a++=*Src++;
  return (Dest);
}

gint GetDay(gchar *D)
{
  gint Ret;

  Ret=0;
  while ((*D!=0) && (*D!='/')) {
    Ret=(Ret*10)+(*D-48);
    D++;
  }
  return (Ret);
}

gint GetMonth(gchar *D)
{
  gint Ret;

  Ret=0;
  while ((*D!=0) && (*D!='/')) D++;
  if (*D!=0) {
    D++;
    while ((*D!=0) && (*D!='/')) {
      Ret=(Ret*10)+(*D-48);
      D++;
    }
  }
  return (Ret);
}

gchar *GetMonthString(int m)
{
  gchar *Ret,*RetMonth;

  RetMonth=EN_month[m-1];
  if ((Ret = g_getenv("LANGUAGE")) == NULL) {
    Ret = g_getenv("LANG");
  }
  if (Ret != NULL) {
    if (strncmp(Ret,"fr", 2)==0) RetMonth=FR_month[m-1];
  }
  return (RetMonth);
}

gint GetYear(gchar *D)
{
  gint Ret;

  Ret=0;
  while ((*D!=0) && (*D!='/')) D++;
  if (*D!=0) {
    D++;
    while ((*D!=0) && (*D!='/')) D++;
    if (*D!=0) {
      D++;
      while ((*D!=0) && (*D!='/')) {
	Ret=(Ret*10)+(*D-48);
	D++;
      }
    }
  }
  return (Ret);
}

void ExplodeDate(gchar *D,gint *J,gint *M,gint *A)
{
  int j,m,a,Cnt;

  Cnt=1;
  j=m=a=0;
  while (*D) {
    if (*D!='/') {
			switch (Cnt)
			{
				case 1 : j=(j*10)+(*D-48);
					 break;
				case 2 : m=(m*10)+(*D-48);
					 break;
				case 3 : a=(a*10)+(*D-48);
					break;
			};
    } else Cnt++;;
    D++;
  };
  if (J!=NULL) *J=j;
  if (M!=NULL) *M=m;
  if (a<1900) {
    if (a<100) a+=2000;else a+=1900;
  }
  if (A!=NULL) *A=a;
}

/* Copie d'unbe chaine de caractres *******************/
char *strmov(char *Dest,char *Src)
{
  while (*Src) *Dest++=*Src++;
  *Dest='\0';
  return (Dest);
}

char *StrSql(char *Str,char *V)
{
  *Str++='\'';
  if (V!=NULL) while (*V) *Str++=*V++;
  *Str++='\'';
  *Str=0;
  return (Str);
}

char *NumSql(char *Str,char *V)
{
  while (*V) {
    if (*V==',') {
      *Str++='.';
      V++;
    } else *Str++=*V++;
  }
  *Str=0;
  return (Str);
}

void GetDate(char *st)
{
  time_t timer;
  struct tm *tblock;

  timer = time(NULL);
  tblock = localtime(&timer);
	strftime(st,12,"%d/%m/%Y",tblock);
};

int ControleDate(char *D)
{
  static int Mx[12]={31,28,31,30,31,30,31,31,30,31,30,31};
  int j,m,a,Cnt,Ok;
  char Tmp[11],*Org;

  Cnt=1;
  j=m=a=0;
  Ok=TRUE;
  Org=D;
  while (*D) {
    if (*D!='/') {
		 switch (Cnt)
		 {
			 case 1 : j=(j*10)+(*D-48);
					break;
			 case 2 : m=(m*10)+(*D-48);
					break;
			 case 3 : a=(a*10)+(*D-48);
				 break;
		 };
    } else Cnt++;;
    D++;
  };
  Ok=FALSE;
  if ((j>0) && (m>0)) if (m<=12) if (j<=Mx[m-1]) Ok=TRUE;
  if (Ok) {
    if (a<100) {
			if (a<40) a+=2000; else a+=1900;
    }
    sprintf(Tmp,"%02i/%02i/%04i",j,m,a);
    strcpy(Org,Tmp);
  }
  return Ok;
};

int strval(char *V)
{
  int n,Sgn;

  while (*V==32) V++;
  n=0;
  Sgn=1;
  if (*V=='-') {
    Sgn=-1;
    V++;
  }
  while (isdigit(*V)){
    n=(n*10)+(*V-48);
    V++;
  }
  n=n*Sgn;
  return (n);
};

int SearchInArray(char *Array[],int Nb,char *Valor)
{
	int i;
	
	i=0;
	while ((strcmp(Array[i],Valor)!=0) && (i<Nb)) i++;
  if (i>=Nb) i=-1;
	return (i);
}

/* Gestion des liste de selection ***************************/
select_list *Select_Append(select_list *ORG_SELECT,gint Row,char *P)
{
  select_list *Old,*SelList;

  Old=ORG_SELECT;
  if (Old!=NULL) while (Old->Su!=NULL) Old=Old->Su;
  SelList=(select_list *) malloc(sizeof(select_list));
  if (ORG_SELECT==NULL) ORG_SELECT=SelList;
  if (Old!=NULL) Old->Su=SelList;
  SelList->Su=NULL;
  SelList->Row=Row;
  strcpy(SelList->Code,P);
  return (ORG_SELECT);
}

select_list *Select_Delete(select_list *ORG_SELECT,gint Row)
{
  select_list *Prior,*SelList;

  Prior=SelList=ORG_SELECT;
  while (SelList!=NULL) {
    if (SelList->Row==Row) break;
    Prior=SelList;
    SelList=SelList->Su;
  }
  if (SelList!=NULL) {
    if (SelList==ORG_SELECT) ORG_SELECT=SelList->Su;else Prior->Su=SelList->Su;
    free(SelList);
  }
  return (ORG_SELECT);
}

void Select_DeleteAll(select_list *ORG_SELECT)
{
  select_list *Next,*SelList;

  SelList=ORG_SELECT;
  while (SelList!=NULL) {
    Next=SelList->Su;
    free(SelList);
    SelList=Next;
  }
  ORG_SELECT=NULL;
}

/* Les controles de saisie ************************************************/
void ControleSaisieInteger(GtkEditable *Ed,gchar *Texte,gint Long,gint *Pos,gpointer *Data)
{
  gchar *P;
  gboolean Ok;
  gint i;

  P=Texte;
  Ok=TRUE;
  i=0;
  while (i<Long) {
    if (!isdigit(*P)) Ok=FALSE;
    P++;
    i++;
  }
  if (!Ok) {
    gdk_beep();
    gtk_signal_emit_stop_by_name(GTK_OBJECT (Ed),"insert_text");
  }
}

void ControleSaisieFloat(GtkEditable *Ed,gchar *Texte,gint Long,gint *Pos,gpointer *Data)
{
  gchar *P,*Ori;
  gboolean Ok,SepFound;
  gint i;

  SepFound=FALSE;
  Ori=gtk_entry_get_text(GTK_ENTRY (Ed));
  while (*Ori) {
    if (*Ori=='.') SepFound=TRUE;
    Ori++;
  }
  P=Texte;
  Ok=TRUE;
  i=0;
  while (i<Long) {
    if (!isdigit(*P)) {
      if (*P=='.') {
	if (SepFound==FALSE) SepFound=TRUE;else Ok=FALSE;
      } else Ok=FALSE;
    }
    P++;
    i++;
  }
  if (!Ok) {
    gdk_beep();
    gtk_signal_emit_stop_by_name(GTK_OBJECT (Ed),"insert_text");
  }
}

void ControleSaisieDate(GtkEditable *Ed,gchar *Texte,gint Long,gint *Pos,gpointer *Data)
{
  gchar *P,*Ori;
  gboolean Ok;
  gint SepFound,i;

   P=Texte;
   Ok=TRUE;
   SepFound=0;
   Ori=gtk_entry_get_text(GTK_ENTRY (Ed));
	 if (Ori!=NULL) {
		 while (*Ori) {
			 if (*Ori=='/') SepFound++;
			 Ori++;
		 }
		 i=0;
		 while (i<Long){
			 if (!isdigit(*P)) {
				 if (*P=='/') {
					 if (SepFound<2) SepFound++;else Ok=FALSE;
				 } else Ok=FALSE;
			 }
			 P++;
			 i++;
		 }
		 if (!Ok) {
			 gdk_beep();
			 gtk_signal_emit_stop_by_name(GTK_OBJECT (Ed),"insert_text");
		 }
	}
}

/* Recherche un code   particulier dans un rsultat mysql **********************/
my_ulonglong  SearchCode(MYSQL_RES *Res,gchar *Code,int Col)
{
  MYSQL_ROW Row;
  my_ulonglong Mp;
  int a;

  Mp=0;
  mysql_data_seek(Res,Mp);
  do {
    Row=mysql_fetch_row(Res);
    Mp++;
  } while (((a=strcmp(Row[Col],Code))!=0) && (Mp<mysql_num_rows(Res)));
  if (a==0) {
    Mp--;
    mysql_data_seek(Res,Mp);
  } else {
    mysql_data_seek(Res,0);
    Mp=-1;
  }
  return (Mp);
} 

/* Retourne en Id en fontion du libell (pour ComboBox) *************************/
char *LibToID(char *Ret,gchar *Lib[],gchar *ID[],int NbID,gchar *LibVal)
{
  int i;
  char *P;

  i=0;
  P=NULL;
  do {
    if (strcasecmp(Lib[i],LibVal)==0) {
      P=ID[i];
      break;
    }
    i++;
  } while (i<NbID);
  if (P!=NULL) strcpy(Ret,P);
  return (P);
}

char *IDToLib(char *Ret,gchar *ID[],gchar *Lib[],int NbID,gchar *IDVal)
{
  int i;
  char *P;

  i=0;
  P=NULL;
  do {
    if (g_strcasecmp(ID[i],IDVal)==0) {
      P=Lib[i];
      break;
    }
    i++;
  } while (i<NbID);
  if (P!=NULL) strcpy(Ret,P);
  return (P);
}

/*******************************************************************/
/* Chargement type Id & Lib ****************************************/
listidlib *LoadModRegl(void)
{
  listidlib *Old,*ORG_REGL,*Regl;
  char PsCle[LEN_COD_SOC+1],SqlCmd[120];
  MYSQL_RES *MyRes;
  MYSQL_ROW Row;

  GetSocRun(PsCle);
  Old=ORG_REGL=NULL;
  sprintf(SqlCmd,"Select * From ModeRegl Where Soc='%s'",PsCle);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    MyRes=mysql_store_result(DbLcpt);
    while ((Row=mysql_fetch_row(MyRes))) {
      Regl=(listidlib *) malloc(sizeof(listidlib));
      if (ORG_REGL==NULL) ORG_REGL=Regl;
      if (Old!=NULL) Old->Su=Regl;
      Regl->Su=NULL;
      Old=Regl;
      strcpy(Regl->ID,Row[1]);
      strcpy(Regl->Lib,Row[2]);
    }
    mysql_free_result(MyRes);
  }
  return ORG_REGL;
}

void FreeModRegl(listidlib *Lib)
{
  listidlib *Old,*ORG_REGL,*Regl;

  Regl=ORG_REGL=Lib;
  while (Regl!=NULL) {
    Old=Regl->Su;
    free(Regl);
    Regl=Old;
  }
  ORG_REGL=NULL;
}

listidlib *LoadCdeAna(void)
{
  listidlib *Old,*ORG_ANA,*Analyt;
  char PsCle[LEN_COD_SOC+1],SqlCmd[120];
  MYSQL_RES *MyRes;
  MYSQL_ROW Row;

  GetSocRun(PsCle);
  Old=ORG_ANA=NULL;
  sprintf(SqlCmd,"Select * From Analytique Where AnaSoc='%s'",PsCle);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    MyRes=mysql_store_result(DbLcpt);
    while ((Row=mysql_fetch_row(MyRes))) {
      Analyt=(listidlib *) malloc(sizeof(listidlib));
      if (ORG_ANA==NULL) ORG_ANA=Analyt;
      if (Old!=NULL) Old->Su=Analyt;
      Analyt->Su=NULL;
      Old=Analyt;
      strcpy(Analyt->ID,Row[1]);
      strcpy(Analyt->Lib,Row[2]);
    }
    mysql_free_result(MyRes);
  }
  return (ORG_ANA);
}

void FreeCdeAna(listidlib *Lib)
{
  listidlib *Old,*ORG_ANA,*Analyt;

  Analyt=ORG_ANA=Lib;
  while (Analyt!=NULL) {
    Old=Analyt->Su;
    free(Analyt);
    Analyt=Old;
  }
  ORG_ANA=NULL;
}

gchar *ComboMRLib(gchar *Str,GtkWidget *button,listidlib *List,char *Name)
{
  GtkWidget *Entrie,*Combo;
  gchar Tempo[25];

  Combo=lookup_widget(GTK_WIDGET (button),Name);
  if (Combo!=NULL) {
    Entrie=GTK_COMBO (Combo)->entry;
    strcpy(Tempo,gtk_entry_get_text(GTK_ENTRY(Entrie)));
    *Str++='\'';
    while (List!=NULL) {
      if (strcmp(Tempo,List->Lib)==0) break;
      List=List->Su;
    }
    if (List!=NULL) Str=strmov(Str,List->ID);
    *Str++='\'';
    *Str='\0';
  };
  return (Str);
}

void ComboMRID(GtkWidget *button,listidlib *List,char *Name,gchar *ID)
{
  GtkWidget *Entrie,*Combo;

  Combo=lookup_widget(GTK_WIDGET (button),Name);
  if (Combo!=NULL) {
    Entrie=GTK_COMBO (Combo)->entry;
    if (ID!=NULL) {
      while (List!=NULL) {
	if (strcmp(ID,List->ID)==0) break;
	List=List->Su;
      }
      if (List!=NULL) gtk_entry_set_text(GTK_ENTRY(Entrie),List->Lib); else gtk_entry_set_text(GTK_ENTRY(Entrie)," ");
    } else gtk_entry_set_text(GTK_ENTRY(Entrie)," ");
  };
}

/* init de la base lincompta **************************/
int OpenDbLcpt(void)
{
  DbLcpt=mysql_init(NULL);
  if (DbLcpt==NULL) {
      MessageErreur(_("Connection mysql impossible !!!"));
      exit(1);
    }
  DbLcpt=mysql_real_connect(DbLcpt,MySqlServer,MySqlUser,MySqlPassword,"lincompta",0,NULL,0);
  if (DbLcpt==NULL) {
    MessageErreur(_("Connection aux donnes impossible !!!"));
    exit(1);
  }
  return (DbLcpt!=NULL);
}

void CloseDbLcpt(void)
{
	mysql_close(DbLcpt);
	DbLcpt=NULL;
}

/* Retourne un nombre d'une requte SQL (int) **********************************/
int SqlGetNumber(gchar *SqlCmd)
{
  MYSQL_RES *MyRes;
  MYSQL_ROW Row;
  int Ret;

  Ret=0;
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    MyRes=mysql_use_result(DbLcpt);
    if ((Row=mysql_fetch_row(MyRes))) if (Row[0]!=NULL) Ret=strval(Row[0]);
    mysql_free_result(MyRes);
  }
  return (Ret);
}

/* Retourne un nombre d'une requte SQL (float) **********************************/
float SqlGetFloat(gchar *SqlCmd)
{
  MYSQL_RES *MyRes;
  MYSQL_ROW Row;
  float Ret;

  Ret=0;
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    MyRes=mysql_use_result(DbLcpt);
    if ((Row=mysql_fetch_row(MyRes))) if (Row[0]!=NULL) Ret=atof(Row[0]);
    mysql_free_result(MyRes);
  }
  return (Ret);
}

/*retourne un chaine de caractre d'une requte SQL ****************************/
void SqlGetString(gchar *SqlCmd,char *Ret)
{
  MYSQL_RES *MyRes;
  MYSQL_ROW Row;

  *Ret=0;
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    MyRes=mysql_use_result(DbLcpt);
    if ((Row=mysql_fetch_row(MyRes))) if (Row[0]!=NULL) strcpy(Ret,Row[0]);
    mysql_free_result(MyRes);
  }
}

/* Retourne ne code socit *****************************************************/
void GetSocRun(char *Str)
{
  strcpy(Str,PsCle);
};

/* Retourne les date d'exercice *************************************************/
void GetDateExercice(char *Deb,char *Fin,char *Soc)
{
  char SqlCmd[120];
  MYSQL_RES *Res;
  MYSQL_ROW Row;

  sprintf(SqlCmd,"Select HisDebEx,HisFinEx From Histo Where HisSoc='%s' Order by HisNumEx Desc",Soc);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    Res=mysql_store_result(DbLcpt);
    Row=mysql_fetch_row(Res);
    strcpy(Deb,Row[0]);
    strcpy(Fin,Row[1]);
		mysql_free_result(Res);
  }
}

/* Retourne le libell de la socit ********************************************/
void GetSocLib(char *Str,char *Soc)
{
  char SqlCmd[120];
  MYSQL_RES *Res;
  MYSQL_ROW Row;

  sprintf(SqlCmd,"Select PsNom From Societe Where PsCle='%s'",Soc);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    Res=mysql_store_result(DbLcpt);
    Row=mysql_fetch_row(Res);
    strcpy(Str,Row[0]);
		mysql_free_result(Res);
  }
}

void SetSocRun(char *Str)
{
  strcpy(PsCle,Str);
};

/* Change le titre du programme **********************************/
void ChangeComptaTitle(GtkWidget *WindCompta)
{
  char Title[128],PsCle[LEN_COD_SOC+1],SqlCmd[128];
  MYSQL_RES *MyRes;
  MYSQL_ROW Row;

  strcpy(Title,_("Comptabilit Analytique Pro. - "));
  GetSocRun(PsCle);
  OpenDbLcpt();
  if (DbLcpt!=NULL) {
    sprintf(SqlCmd,"SELECT * FROM Societe WHERE PsCle='%s'",PsCle);
    mysql_query(DbLcpt,SqlCmd);
    MyRes=mysql_store_result(DbLcpt);
    if (MyRes!=NULL) {
      Row=mysql_fetch_row(MyRes);
      strcat(Title,Row[1]);
      CloseDbLcpt();
    }
  }
  gtk_window_set_title(GTK_WINDOW (WindCompta),Title);
}

/* Cration d'un pixmap en cherchant le rpertoire d'install ************/
GtkWidget *Load_XPMPixmap(char *path,GtkWidget *dial)
{
  GdkBitmap *Mask;
  GtkStyle *Style;
  GdkPixmap *GdPix;
	char location[255];
	
	sprintf(location,"%s/%s","../pixmaps",path);
  Style=gtk_widget_get_style(dial);
  GdPix=gdk_pixmap_colormap_create_from_xpm(NULL,gtk_widget_get_colormap(dial),&Mask,NULL,location);
	return gtk_pixmap_new(GdPix,Mask);
}

/* Cration d'un pixmap en cherchant le rpertoire d'install ************/
GtkWidget *Load_XPMIcon(char *path,GtkWidget *dial)
{
  GdkBitmap *Mask;
  GtkStyle *Style;
  GdkPixmap *GdPix;
	char location[255];
	
	sprintf(location,"%s/%s","../icons",path);
  Style=gtk_widget_get_style(dial);
  GdPix=gdk_pixmap_colormap_create_from_xpm(NULL,gtk_widget_get_colormap(dial),&Mask,NULL,location);
	return gtk_pixmap_new(GdPix,Mask);
}

/* Message d'info ************************************************/
void MessageInfo(gchar *message)
{
  GtkWidget *dialog, *label, *button,*HBox,*HBoxb,*VBox,*PixMap;
  
  dialog = gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_window_set_title(GTK_WINDOW (dialog),_("Information"));
  gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (dialog), TRUE);
  VBox=gtk_vbox_new(TRUE,0);
  HBox=gtk_hbox_new(FALSE,0);
	HBoxb=gtk_hbox_new(TRUE,0);
  /****/
  button = gtk_button_new_with_label(_("Ok"));
	gtk_widget_set_usize(button,65,26);
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",GTK_SIGNAL_FUNC (BtOk_clicked), GTK_OBJECT (dialog));
	gtk_box_pack_start(GTK_BOX (HBoxb),button,FALSE,FALSE,0);
  PixMap=Load_XPMIcon("info.xpm",dialog);
  gtk_box_pack_start(GTK_BOX (HBox),PixMap,FALSE,TRUE,4);
  label = gtk_label_new (message);
  gtk_box_pack_start(GTK_BOX (HBox),label,FALSE,TRUE,4);
  /****/
  gtk_box_pack_start(GTK_BOX (VBox),HBox,FALSE,TRUE,4);
  gtk_box_pack_start(GTK_BOX (VBox),HBoxb,FALSE,FALSE,0);

  gtk_container_add (GTK_CONTAINER (dialog),VBox);
  gtk_widget_show_all (dialog);
  ModalResult=MR_NONE;
  while (ModalResult==MR_NONE)
    if (gtk_events_pending()) gtk_main_iteration();
};

void MessageAlerte(gchar *message)
{
  GtkWidget *dialog, *label, *button,*HBox,*HBoxb,*VBox,*PixMap;
  
  dialog = gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_window_set_title(GTK_WINDOW (dialog),_("Attention !"));
  gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (dialog), TRUE);
  VBox=gtk_vbox_new(FALSE,0);
  HBox=gtk_hbox_new(FALSE,0);
	HBoxb=gtk_hbox_new(TRUE,0);
  /****/
  button = gtk_button_new_with_label(_("Ok"));
  gtk_widget_set_usize(button,65,32);
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",GTK_SIGNAL_FUNC (BtOk_clicked), GTK_OBJECT (dialog));
  gtk_box_pack_start(GTK_BOX (HBoxb),button,FALSE,FALSE,0);	
	/****/
	PixMap=Load_XPMIcon("warning.xpm",dialog);
  gtk_box_pack_start(GTK_BOX (HBox),PixMap,FALSE,TRUE,4);
  label = gtk_label_new (message);
  gtk_box_pack_start(GTK_BOX (HBox),label,FALSE,TRUE,4);
  /****/
  gtk_box_pack_start(GTK_BOX (VBox),HBox,FALSE,TRUE,4);
  gtk_box_pack_start(GTK_BOX (VBox),HBoxb,FALSE,FALSE,0);

  gtk_container_add (GTK_CONTAINER (dialog),VBox);
  gtk_widget_show_all (dialog);
  ModalResult=MR_NONE;
  while (ModalResult==MR_NONE)
    if (gtk_events_pending()) gtk_main_iteration();
};

void MessageErreur(gchar *message)
{
  GtkWidget *dialog, *label, *button,*HBox,*HBoxb,*VBox,*PixMap;
  
  dialog = gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_window_set_title(GTK_WINDOW (dialog),_("Erreur !"));
  gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (dialog), TRUE);
  VBox=gtk_vbox_new(FALSE,0);
  HBox=gtk_hbox_new(FALSE,0);
  HBoxb=gtk_hbox_new(TRUE,0);
  /****/
  button = gtk_button_new_with_label(_("Ok"));
  gtk_widget_set_usize(GTK_WIDGET (button),65,32);
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",GTK_SIGNAL_FUNC (BtOk_clicked), GTK_OBJECT (dialog));
  gtk_box_pack_start(GTK_BOX (HBoxb),button,FALSE,TRUE,4);
  /****/
  PixMap=Load_XPMIcon("error.xpm",dialog);
  gtk_box_pack_start(GTK_BOX (HBox),PixMap,FALSE,TRUE,4);
  label = gtk_label_new (message);
  gtk_box_pack_start(GTK_BOX (HBox),label,FALSE,TRUE,4);
  /****/
  gtk_box_pack_start(GTK_BOX (VBox),HBox,FALSE,TRUE,4);
  gtk_box_pack_start(GTK_BOX (VBox),HBoxb,FALSE,TRUE,4);

  gtk_container_add (GTK_CONTAINER (dialog),VBox);
  gtk_widget_show_all (dialog);
  ModalResult=MR_NONE;
  while (ModalResult==MR_NONE)
    if (gtk_events_pending()) gtk_main_iteration();
};

/*************************************************************/
/* Boite de dialogue Ok,Cancel *******************************/
void BtOk_clicked(GtkButton *button,gpointer user_data)
{
  ModalResult=MR_OK;
  gtk_widget_destroy(GTK_WIDGET (button));
}

void BtCancel_clicked(GtkButton *button,gpointer user_data)
{
  ModalResult=MR_CANCEL;
  gtk_widget_destroy(GTK_WIDGET (button));
}

int MsgQuestion(gchar *message)
{
  GtkWidget *dialog, *label, *BtOk,*BtCancel,*HBox,*VBox,*HBoxButt,*PixMap;
  
  dialog = gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_window_set_title(GTK_WINDOW (dialog),_("Question !"));
  gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (dialog), TRUE);
  VBox=gtk_vbox_new(FALSE,0);
  HBoxButt=gtk_hbox_new(FALSE,0);
  HBox=gtk_hbox_new(FALSE,0);

  /****/
  BtOk = gtk_button_new_with_label(_("Ok"));
  gtk_widget_set_usize(GTK_WIDGET (BtOk),65,20);
  gtk_signal_connect_object (GTK_OBJECT (BtOk), "clicked",GTK_SIGNAL_FUNC (BtOk_clicked), GTK_OBJECT (dialog));
  BtCancel = gtk_button_new_with_label(_("Annuler"));
  gtk_widget_set_usize(GTK_WIDGET (BtCancel),65,20);
  gtk_signal_connect_object (GTK_OBJECT (BtCancel), "clicked",GTK_SIGNAL_FUNC (BtCancel_clicked), GTK_OBJECT (dialog));
  /****/
  PixMap=Load_XPMIcon("question.xpm",dialog);;
  gtk_box_pack_start(GTK_BOX (HBox),PixMap,FALSE,TRUE,4);
  label = gtk_label_new (message);
  gtk_box_pack_start(GTK_BOX (HBox),label,FALSE,TRUE,4);
  /****/
  gtk_box_pack_start(GTK_BOX (HBoxButt),BtOk,TRUE,TRUE,4);
  gtk_box_pack_start(GTK_BOX (HBoxButt),BtCancel,TRUE,TRUE,4);
  /****/
  gtk_box_pack_start(GTK_BOX (VBox),HBox,FALSE,TRUE,4);
  gtk_box_pack_start(GTK_BOX (VBox),HBoxButt,TRUE,TRUE,4);

  gtk_container_add (GTK_CONTAINER (dialog),VBox);
  gtk_widget_show_all (dialog);
  ModalResult=0;
  while (ModalResult==0)
    if (gtk_events_pending()) gtk_main_iteration();
  return (ModalResult);
};

/**********************************************************************/
/* Selection d'une date ***********************************************/
int SelectDate (char *Ret,char *Org)
{
  GtkWidget *SelDate;
  GtkWidget *vbox18;
  GtkWidget *Calendar;
  GtkWidget *fixed18;
  GtkWidget *SelDate_BtOk;
  GtkWidget *SelDate_BtCancel;
  gint Month,Year,Day;

  SelDate = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (SelDate), "SelDate", SelDate);
  gtk_window_set_title (GTK_WINDOW (SelDate), _("Calendrier"));

  vbox18 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox18);
  gtk_object_set_data_full (GTK_OBJECT (SelDate), "vbox18", vbox18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox18);
  gtk_container_add (GTK_CONTAINER (SelDate), vbox18);

  Calendar = gtk_calendar_new ();
  gtk_widget_ref (Calendar);
  gtk_object_set_data_full (GTK_OBJECT (SelDate), "Calendar", Calendar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Calendar);
  gtk_box_pack_start (GTK_BOX (vbox18), Calendar, TRUE, TRUE, 0);
  gtk_calendar_display_options (GTK_CALENDAR (Calendar),
                                GTK_CALENDAR_SHOW_HEADING
                                | GTK_CALENDAR_SHOW_DAY_NAMES);
  if (Org!=NULL) {
    ExplodeDate(Org,&Day,&Month,&Year);
    gtk_calendar_select_month(GTK_CALENDAR (Calendar),Month,Year);
    gtk_calendar_select_day(GTK_CALENDAR (Calendar),Day);
  }
  fixed18 = gtk_fixed_new ();
  gtk_widget_ref (fixed18);
  gtk_object_set_data_full (GTK_OBJECT (SelDate), "fixed18", fixed18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed18);
  gtk_box_pack_start (GTK_BOX (vbox18), fixed18, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (fixed18), 2);

  SelDate_BtOk = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (SelDate_BtOk);
  gtk_object_set_data_full (GTK_OBJECT (SelDate), "SelDate_BtOk", SelDate_BtOk,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (SelDate_BtOk);
  gtk_fixed_put (GTK_FIXED (fixed18), SelDate_BtOk, 188, 4);
  gtk_widget_set_uposition (SelDate_BtOk, 188, 4);
  gtk_widget_set_usize (SelDate_BtOk, 80, 24);

  SelDate_BtCancel = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (SelDate_BtCancel);
  gtk_object_set_data_full (GTK_OBJECT (SelDate), "SelDate_BtCancel", SelDate_BtCancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (SelDate_BtCancel);
  gtk_fixed_put (GTK_FIXED (fixed18), SelDate_BtCancel, 280, 4);
  gtk_widget_set_uposition (SelDate_BtCancel, 280, 4);
  gtk_widget_set_usize (SelDate_BtCancel, 80, 24);

  gtk_signal_connect_object(GTK_OBJECT (SelDate_BtOk), "clicked",
                            GTK_SIGNAL_FUNC (SelDate_BtOk_clicked),
                            GTK_OBJECT (SelDate));
  gtk_signal_connect_object (GTK_OBJECT (SelDate_BtCancel), "clicked",
                             GTK_SIGNAL_FUNC (BtCancel_clicked),
                             GTK_OBJECT (SelDate));

  gtk_widget_show_all(SelDate);
  ModalResult=MR_NONE;
  while (ModalResult==MR_NONE)
    if (gtk_events_pending()) gtk_main_iteration();
  if (ModalResult==MR_OK) strcpy(Ret,Tempo);
  return (ModalResult);
}

void SelDate_BtOk_clicked (GtkButton *button,gpointer user_data)
{
  GtkWidget *Widget;
  gint J,M,A;
  gchar *P;
  
  Widget=lookup_widget(GTK_WIDGET (button),"Calendar");
  gtk_calendar_get_date(GTK_CALENDAR (Widget),&A,&M,&J);
  sprintf(Tempo,"%i/%i/%i",J,M,A);
  P=Tempo;
  while (*P) {
    if (*P==32) *P='0';
    P++;
  }
  ModalResult=MR_OK;
  gtk_widget_destroy(GTK_WIDGET (button));
}

/* Selection d'une couleur ***************************************/
GtkWidget* create_SelectColor (void)
{
  GtkWidget *SelectColor;
  GtkWidget *SelColor_BtOk;
  GtkWidget *cancel_button1;
  GtkWidget *help_button1;

  SelectColor = gtk_color_selection_dialog_new (_("Choix de la couleur"));
  gtk_object_set_data (GTK_OBJECT (SelectColor), "SelectColor", SelectColor);
  gtk_container_set_border_width (GTK_CONTAINER (SelectColor), 10);
  gtk_window_set_position (GTK_WINDOW (SelectColor), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (SelectColor), TRUE);

  SelColor_BtOk = GTK_COLOR_SELECTION_DIALOG (SelectColor)->ok_button;
  gtk_object_set_data (GTK_OBJECT (SelectColor), "SelColor_BtOk", SelColor_BtOk);
  gtk_widget_show (SelColor_BtOk);
  GTK_WIDGET_SET_FLAGS (SelColor_BtOk, GTK_CAN_DEFAULT);

  cancel_button1 = GTK_COLOR_SELECTION_DIALOG (SelectColor)->cancel_button;
  gtk_object_set_data (GTK_OBJECT (SelectColor), "cancel_button1", cancel_button1);
  gtk_widget_show (cancel_button1);
  GTK_WIDGET_SET_FLAGS (cancel_button1, GTK_CAN_DEFAULT);

  help_button1 = GTK_COLOR_SELECTION_DIALOG (SelectColor)->help_button;
  gtk_object_set_data (GTK_OBJECT (SelectColor), "help_button1", help_button1);
  gtk_widget_show (help_button1);
  GTK_WIDGET_SET_FLAGS (help_button1, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (SelColor_BtOk), "clicked",
                      GTK_SIGNAL_FUNC (SelColor_BtOk_clicked),
                      NULL);
  gtk_signal_connect_object (GTK_OBJECT (cancel_button1), "clicked",
                             GTK_SIGNAL_FUNC (BtCancel_clicked),
                             GTK_OBJECT (SelectColor));

  return SelectColor;
}

void SelColor_BtOk_clicked(GtkButton *button,gpointer user_data)
{
  GtkWidget *Win,*ColSel;
  gdouble Color[4];
  int r,v,b;

  Win=lookup_widget(GTK_WIDGET(button),"SelectColor");
  if (Win!=NULL) {
    ColSel=GTK_COLOR_SELECTION_DIALOG(Win)->colorsel;
    gtk_color_selection_get_color(GTK_COLOR_SELECTION(ColSel),Color);
    r=(int) 65535.0*Color[0];
    v=(int) 65535.0*Color[1];
    b=(int) 65535.0*Color[2];
  } else MessageAlerte(_("Erreur retour couleur !"));
  ModalResult=MR_OK;
  gtk_widget_destroy(GTK_WIDGET (Win));
}

int SelectColor(gchar *Color)
{
  GtkWidget *Win;

  Win=create_SelectColor();
  gtk_widget_show_all(Win);
  ModalResult=MR_NONE;
  while (ModalResult==MR_NONE)
    if (gtk_events_pending()) gtk_main_iteration();
  if (ModalResult==MR_OK) strcpy(Color,Tempo);
  return (ModalResult);
}

/* Selection d'une fonte *****************************************/
GtkWidget* create_SelectFont (void)
{
  GtkWidget *SelectFont;
  GtkWidget *SelFont_BtOk;
  GtkWidget *cancel_button2;
  GtkWidget *apply_button1;

  SelectFont = gtk_font_selection_dialog_new (_("Choisir la police"));
  gtk_object_set_data (GTK_OBJECT (SelectFont), "SelectFont", SelectFont);
  gtk_container_set_border_width (GTK_CONTAINER (SelectFont), 4);
  gtk_window_set_modal (GTK_WINDOW (SelectFont), TRUE);
  gtk_window_set_policy (GTK_WINDOW (SelectFont), FALSE, TRUE, TRUE);

  SelFont_BtOk = GTK_FONT_SELECTION_DIALOG (SelectFont)->ok_button;
  gtk_object_set_data (GTK_OBJECT (SelectFont), "SelFont_BtOk", SelFont_BtOk);
  gtk_widget_show (SelFont_BtOk);
  GTK_WIDGET_SET_FLAGS (SelFont_BtOk, GTK_CAN_DEFAULT);

  cancel_button2 = GTK_FONT_SELECTION_DIALOG (SelectFont)->cancel_button;
  gtk_object_set_data (GTK_OBJECT (SelectFont), "cancel_button2", cancel_button2);
  gtk_widget_show (cancel_button2);
  GTK_WIDGET_SET_FLAGS (cancel_button2, GTK_CAN_DEFAULT);

  apply_button1 = GTK_FONT_SELECTION_DIALOG (SelectFont)->apply_button;
  gtk_object_set_data (GTK_OBJECT (SelectFont), "apply_button1", apply_button1);
  gtk_widget_show (apply_button1);
  GTK_WIDGET_SET_FLAGS (apply_button1, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (SelFont_BtOk), "clicked",
                      GTK_SIGNAL_FUNC (SelFont_BtOk_clicked),
                      NULL);
  gtk_signal_connect_object (GTK_OBJECT (cancel_button2), "clicked",
                             GTK_SIGNAL_FUNC (BtCancel_clicked),
                             GTK_OBJECT (SelectFont));

  return SelectFont;
}

void SelFont_BtOk_clicked(GtkButton *button,gpointer user_data)
{
  GdkFont *Font;
  GtkWidget *Win;
  gchar *FtName;
 
  Win=lookup_widget(GTK_WIDGET(button),"SelectFont");
  if (Win!=NULL) {
    Font=gtk_font_selection_dialog_get_font(GTK_FONT_SELECTION_DIALOG(Win));
    FtName=gtk_font_selection_dialog_get_font_name(GTK_FONT_SELECTION_DIALOG(Win));
    strcpy(Tempo,FtName);
  } else MessageAlerte(_("Erreur retour fonte !"));
  ModalResult=MR_OK;
  gtk_widget_destroy(GTK_WIDGET (Win));
}

int SelectFont(gchar *Fonte)
{
  GtkWidget *Win;

  Win=create_SelectFont();
  gtk_widget_show_all(Win);
  ModalResult=MR_NONE;
  while (ModalResult==MR_NONE)
    if (gtk_events_pending()) gtk_main_iteration();
  if (ModalResult==MR_OK) strcpy(Fonte,Tempo);
  return (ModalResult);
}

/* A propos *********************************************************/
void APropos (void)
{
  const gchar *authors[] = {
    "CONRAD Pascal (02/2001)",
    NULL
  };
  GtkWidget *APropos;
	gchar *Location;
	
  Location=g_strdup_printf("%s/%s","/usr/share/pixmaps/lincompta","logo.xpm");
  APropos = gnome_about_new ("LinCompta", VERSION,
                        _("Logiciel en license GPL"),
                        authors,
                        _("Comptabilit Analytique Professionnel sous Linux"),
                        Location);
  gtk_object_set_data (GTK_OBJECT (APropos), "APropos", APropos);
  gtk_window_set_modal (GTK_WINDOW (APropos), TRUE);

  gtk_widget_show_all(APropos);
	free(Location);
}
