/******************************************************/
/* Outils divers                                      */
/* Version 0.1 : 01/02/02                             */
/* CONRAD Pascal                                      */
/*----------------------------------------------------*/
/* 09/05/2002 - Ajout SqlGetString                    */
/* 30/06/2002 - Ajout GetMonthString                  */
/*----------------------------------------------------*/
/* A Faire :                                          */
/******************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 

#ifndef __COMMON_H__
#define __COMMON_H__

#include <gtk/gtk.h>
#include <mysql/mysql.h>

#define MR_NONE 0
#define MR_OK 1
#define MR_CANCEL 2

#ifndef LEN_COD_SOC
#define LEN_COD_SOC 2
#endif

extern MYSQL *DbLcpt;
extern gchar MySqlServer[16],MySqlUser[16],MySqlPassword[16];
extern gchar AfmDir[512];
extern gchar PREFIX[512];
extern int verbose;

/* Selection pointage/lettrage */
typedef struct _select_list
{
  gint Row;
  gchar Code[15];
  struct _select_list *Su;
} select_list;

typedef struct _listidlib
{
  gchar ID[3],Lib[26];
  struct _listidlib *Su;
} listidlib;

char *DateToIso(char *Dest,char *Src);
char *IsoToDate(char *Dest,char *Src);
char *strmov(char *Dest,char *Src);
void Select_DeleteAll(select_list *ORG_SELECT);
select_list *Select_Delete(select_list *ORG_SELECT,gint Row);
select_list *Select_Append(select_list *ORG_SELECT,gint Row,char *P);
void ControleSaisieInteger(GtkEditable *Ed,gchar *Texte,gint Long,gint *Pos,gpointer *Data);
void ControleSaisieFloat(GtkEditable *Ed,gchar *Texte,gint Long,gint *Pos,gpointer *Data);
void ControleSaisieDate(GtkEditable *Ed,gchar *Texte,gint Long,gint *Pos,gpointer *Data);
char *LibToID(char *Ret,gchar *Lib[],gchar *ID[],int NbID,gchar *LibVal);
char *IDToLib(char *Ret,gchar *ID[],gchar *Lib[],int NbID,gchar *IDVal);
listidlib *LoadModRegl(void);
void FreeModRegl(listidlib *Lib);
listidlib *LoadCdeAna(void);
void FreeCdeAna(listidlib *Lib);
gchar *ComboMRLib(gchar *Str,GtkWidget *button,listidlib *List,char *Name);
void ComboMRID(GtkWidget *button,listidlib *List,char *Name,gchar *ID);
int OpenDbLcpt(void);
void CloseDbLcpt(void);
int SqlGetNumber(char *SqlCmd);
float SqlGetFloat(char *SqlCmd);
void SqlGetString(gchar *SqlCmd,char *Ret);
void GetSocRun(char *Str);
void GetDateExercice(char *Deb,char *Fin,char *Soc);
void GetSocLib(char *Str,char *Soc);
void SetSocRun(char *Str);
void ChangeComptaTitle(GtkWidget *WindCompta);
void MessageInfo(gchar *message);
void MessageErreur(gchar *message);
void MessageAlerte(gchar *message);
int MsgQuestion(gchar *message);
int SelectDate (char *Ret,char *Org);
gint GetYear(gchar *D);
gint GetMonth(gchar *D);
gchar *GetMonthString(int m);
gint GetDay(gchar *D);
void ExplodeDate(gchar *D,gint *J,gint *M,gint *A);
char *StrSql(char *Str,char *V);
char *NumSql(char *Str,char *V);
void GetDate(char *st);
int ControleDate(char *D);
int strval(char *V);
int SearchInArray(char *Array[],int Nb,char *Valor);
my_ulonglong SearchCode(MYSQL_RES *Res,gchar *Code,int Col);
int SelectColor(gchar *Color);
int SelectFont(gchar *Fonte);
void APropos (void);

#endif /* __COMMON_H__ */
