/*******************************************************************/
/* Comptabilit Analytique Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* Procdures principale                                           */
/* Fichier d'entte                                                */
/* 07/03/02 - Ajout grille de saisie des critures                 */
/* 21/03/02 - Extraction functions divers,Pointage/Lettrage        */
/* 21/04/02 - Extraction totale et renomage fichiers               */
/* 08/07/02 - Ajout fonction d'impression balance et Grand Livre   */
/* 11/07/02 - Ajout lettres de relance                             */
/*******************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <string.h>
#include <ctype.h>
#include <mysql/mysql.h>

#include "compta.h"
#include "search.h"
#include "support.h"
#include "common.h"
#include "ldconf.h"
#include "select.h"
#include "selectsoc.h"
#include "lettrage.h"
#include "pointage.h"
#include "gtksql.h"
#include "consult.h"
#include "paramsoc.h"
#include "paramgenx.h"
#include "edtplc.h"
#include "edtjrn.h"
#include "edtcol.h"
#include "edtcpt.h"
#include "result.h"
#include "base.h"
#include "impjrn.h"
#include "impbal.h"
#include "impgl.h"
#include "relance.h"

/*** Variables ***/
gchar        PsCle[LEN_COD_SOC+1],Journal[3];
gchar        SelectCodeRet[16];
GtkWidget    *WindCompta,*WinOnScreen;
my_ulonglong MysqlPtr;
gint         RowSel,ModalResult,JOURNAUX_VIDE;

/*** Protos ***/
int ControleDateEx(void);
void InitListJrn(void);
void on_param_tres_soci_t_1_activate(GtkMenuItem *menuitem,gpointer user_data);
void on_quitter1_activate(GtkMenuItem *menuitem,gpointer user_data);
void on_editions1_activate(GtkMenuItem *menuitem,gpointer user_data);
void on_imprimer_journal1_activate(GtkMenuItem *menuitem,gpointer user_data);

void on_imprimer_balance1_activate     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void on_imprimer_grand_livre1_activate  (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void on_imprimer_analytique_activate   (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void on_a_propos1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void on_button2_clicked                (GtkButton       *button,
                                        gpointer         user_data);

void on_Compta_destroy                 (GtkObject       *object,
                                        gpointer         user_data);

void on_Compta_show                    (GtkWidget       *widget,
                                        gpointer         user_data);
void on_s_lection_serveur1_activate    (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void on_BtFermer_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void SelectionUser_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
void on_Param_Gen1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
void on_planCompt1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void ret_planCompt1_activate(int empty);
void on_collectifs1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void on_journaux1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data);


void on_edition_des_journaux1_activate (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void on_selection_soci_t_1_activate    (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
void on_ComptaOpen_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void on_ComptaEdit_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void on_ComptaSearch_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void on_ComptaQuitte_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void Compta_ListJrn_select_row         (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void Compta_ListJrn_unselect_row       (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

gboolean Compta_ListJrn_button_press_event(GtkWidget       *widget,
					   GdkEventButton  *event,
					   gpointer         user_data);

void on_pointage1_activate(GtkMenuItem *menuitem,gpointer user_data);
void on_lettrage1_activate(GtkMenuItem *menuitem,gpointer user_data);
void on_ConsultComptes1_activate(GtkMenuItem *menuitem,gpointer user_data);
void on_relance_activate(GtkMenuItem *menuitem,gpointer user_data);
void on_NewSociete_activate(GtkMenuItem *menuitem,gpointer user_data);
void on_Cloture_activate(GtkMenuItem  *menuitem,gpointer user_data);

/*** Les menues ************************************************/
static GnomeUIInfo fichiers1_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("Paramtres socit"),
    NULL,
    (gpointer) on_param_tres_soci_t_1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_EXEC,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Paramtres Gnraux"),
    NULL,
    (gpointer) on_Param_Gen1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_EXEC,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Plan comptable"),
    NULL,
    (gpointer) on_planCompt1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_EXEC,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Collectifs"),
    NULL,
    (gpointer) on_collectifs1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_EXEC,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Journaux"),
    NULL,
    (gpointer) on_journaux1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_EXEC,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_SEPARATOR,
  {
    GNOME_APP_UI_ITEM, N_("Slection serveur"),
    NULL,
    (gpointer) on_s_lection_serveur1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_HOME,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Slection utilisateur"),
    NULL,
    (gpointer) SelectionUser_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_HOME,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Selection socit"),
    NULL,
    (gpointer) on_selection_soci_t_1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_HOME,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_SEPARATOR,
  {
    GNOME_APP_UI_ITEM, N_("Quitter"),
    NULL,
    (gpointer) on_quitter1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_EXIT,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo editions1_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("Edition des journaux"),
    NULL,
    (gpointer) on_edition_des_journaux1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_PROP,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Pointage"),
    NULL,
    (gpointer) on_pointage1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_INDEX,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Lettrage"),
    NULL,
    (gpointer) on_lettrage1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_SPELLCHECK,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_SEPARATOR,
  {
    GNOME_APP_UI_ITEM, N_("Consultation des Comptes"),
    NULL,
    (gpointer) on_ConsultComptes1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_SEARCH,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

/* Menu des impressions ****************************************/
static GnomeUIInfo impression1_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("Imprimer journal"),
    NULL,
    (gpointer) on_imprimer_journal1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_BOOK_RED,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Imprimer Balance"),
    NULL,
    (gpointer) on_imprimer_balance1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_BOOK_GREEN,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Imprimer Grand Livre"),
    NULL,
    (gpointer) on_imprimer_grand_livre1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_BOOK_BLUE,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Imprimer Analytique"),
    NULL,
    (gpointer) on_imprimer_analytique_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_BOOK_BLUE,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

/* Menu des outils ******************************************/
static GnomeUIInfo outils_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("Lettres de relances"),
    NULL,
    (gpointer) on_relance_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_NEW,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Ajouter socit"),
    NULL,
    (gpointer) on_NewSociete_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_NEW,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Clture compte"),
    NULL,
    (gpointer) on_Cloture_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_TIMER,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

/* Menu aide/info ***************************************************/
static GnomeUIInfo aide1_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("A Propos"),
    NULL,
    (gpointer) on_a_propos1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_ABOUT,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

/* Menu principale **************************************************/
static GnomeUIInfo menubar1_uiinfo[] =
{
  {
    GNOME_APP_UI_SUBTREE, N_("Fichiers"),
    NULL,
    fichiers1_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_SUBTREE, N_("Editions"),
    NULL,
    editions1_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_SUBTREE, N_("Impression"),
    NULL,
    impression1_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_SUBTREE, N_("Outils"),
    NULL,
    outils_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_SUBTREE, N_("Aide"),
    NULL,
    aide1_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

/**************************************************************/
/* LE MENU PRINCIPALE *****************************************/

/* Menu fichiers ***************************************************************/
void on_param_tres_soci_t_1_activate   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  Dialog_ParamSoc();
  ChangeComptaTitle(WindCompta);
}

/*** Plan comptable ***/
void on_planCompt1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  Dialog_EdtPlc(&ret_planCompt1_activate);
}

void ret_planCompt1_activate(int empty)
{
	InitListJrn();
}

/*** Collectifs ***/
void on_collectifs1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  Dialog_EdtCol();
}

void on_journaux1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if (*Journal) Dialog_EdtJrn(Journal);else Dialog_EdtJrn(NULL);
}

void on_selection_soci_t_1_activate    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if (DialSelectSoc()==MR_OK) {
    ControleDateEx();
    ChangeComptaTitle(WindCompta);
    InitListJrn();
  }
}

void on_s_lection_serveur1_activate    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  SelectServer();
}

void SelectionUser_activate         (GtkMenuItem     *menuitem,
				     gpointer         user_data)
{
  SelectUser();
}

void on_quitter1_activate(GtkMenuItem *menuitem,gpointer user_data)
{
  gtk_main_quit();
}


/* Menu des ditions **************************************************************/
void on_editions1_activate(GtkMenuItem *menuitem,gpointer user_data)
{

}

void on_edition_des_journaux1_activate(GtkMenuItem *menuitem,gpointer user_data)
{
  if (!JOURNAUX_VIDE) Dialog_EdtCpt(NULL);
}

void on_pointage1_activate(GtkMenuItem *menuitem,gpointer user_data)
{
  Dialog_Pointage();
}


void on_lettrage1_activate(GtkMenuItem *menuitem,gpointer user_data)
{
  Dialog_Lettrage();
}

void on_ConsultComptes1_activate(GtkMenuItem *menuitem,gpointer user_data)
{
  Dialog_Consult();
}

/* Menu impressions *********************************************/
void on_imprimer_journal1_activate(GtkMenuItem *menuitem,gpointer user_data)
{
  Dialog_ImpJrn();
}

void on_imprimer_balance1_activate(GtkMenuItem *menuitem,gpointer user_data)
{
  Dialog_ImpBal();
}

void on_imprimer_grand_livre1_activate(GtkMenuItem *menuitem,gpointer user_data)
{
  Dialog_ImpGL();
}

void on_imprimer_analytique_activate(GtkMenuItem *menuitem,gpointer user_data)
{
  MessageInfo(_("Dsol! En cours ..."));
}

/* Menu outils **************************************************/
void on_relance_activate(GtkMenuItem *menuitem,gpointer user_data)
{
  Dialog_Relance();
}

void on_NewSociete_activate(GtkMenuItem *menuitem,gpointer user_data)
{
  NewSociety();
}

void on_Cloture_activate(GtkMenuItem *menuitem,gpointer user_data)
{
  MessageInfo(_("Dsol! En cours ..."));
}

/* A Propos *****************************************************/
void on_a_propos1_activate(GtkMenuItem     *menuitem,gpointer         user_data)
{
  APropos();
}

/******************************************************************/
/* Fenetre principale *********************************************/
void on_Compta_destroy(GtkObject       *object,gpointer         user_data)
{
  /*  if (DbLcpt!=NULL) CloseDbLcpt(); */
  gtk_main_quit();
}

void on_Compta_show(GtkWidget *widget,gpointer user_data)
{
  gboolean Continue;
  gchar SqlCmd[120];

  Continue=TRUE;
  WindCompta=widget;
  if (!ReadLinComptaRc()) {
    *MySqlServer=0;
    *MySqlUser=0;
    *MySqlPassword=0;
    if (SelectServer()==MR_OK) {
      if (SelectUser()==MR_CANCEL) Continue=FALSE;
    }
    if (Continue) {
      if (!WriteLinComptaRc()) MessageAlerte(_("Impossible de crer le fichier de configuration !"));
    }
  }
  if (Continue) {
    OpenDbLcpt();
    strcpy(SqlCmd,"Select Count(*) From Societe");
    if (SqlGetNumber(SqlCmd)==0) {
      if (NewSociety()==MR_CANCEL) Continue=FALSE;
    }
    CloseDbLcpt();
    if (Continue) {
      if (DialSelectSoc()==MR_OK) {
				ControleDateEx();
				ChangeComptaTitle(WindCompta);
				InitListJrn();
				*Journal=0;
      } else Continue=FALSE;
    }
  }
  if (!Continue) gtk_widget_destroy(WindCompta);
}

void InitListJrn(void)
{
  gchar PsCle[LEN_COD_SOC+1],SqlCmd[200],JCode[3],*Gr[5],T1[15],T2[15],T3[15];
	gchar DebExercice[12],FinExercice[12];
  GtkWidget *Lst,*widget;
  MYSQL_RES *Result,*Calcul;
  MYSQL_ROW Row,CaRow;
  double d,c,s;
	int    CloseOnExit;

  Lst=lookup_widget(GTK_WIDGET (WindCompta),"ListJrn");
  gtk_clist_clear(GTK_CLIST (Lst));
  GetSocRun(PsCle);
	CloseOnExit=TRUE;
  if (DbLcpt==NULL) OpenDbLcpt();else CloseOnExit=FALSE;
  GetDateExercice(DebExercice,FinExercice,PsCle);
  sprintf(SqlCmd,"Select * From Jrn where JSoc='%s' Order by JCode",PsCle);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    Result=mysql_store_result(DbLcpt);
		if (mysql_num_rows(Result)!=0) {
			while ((Row=mysql_fetch_row(Result))) {
				strcpy(JCode,Row[1]);
				d=c=0;
				sprintf(SqlCmd,"Select Sum(EcrDebit),Sum(EcrCredit) From Ecrit Where EcrSoc='%s' And EcrJrn='%s' And EcrDate Between '%s' And '%s'",PsCle,JCode,DebExercice,FinExercice);
				if (mysql_query(DbLcpt,SqlCmd)==0) {
					Calcul=mysql_use_result(DbLcpt);
					CaRow=mysql_fetch_row(Calcul);
					if (CaRow[0]!=NULL) {
						d=atof(CaRow[0]);
						c=atof(CaRow[1]);
					}
					mysql_free_result(Calcul);
				}
				s=d-c;
				sprintf(T1,"%-8.2f",d);
				sprintf(T2,"%-8.2f",c);
				sprintf(T3,"%-8.2f",s);
				g_strstrip(T1);
				g_strstrip(T2);
				g_strstrip(T3);
				Gr[0]=JCode;
				Gr[1]=Row[2];
				Gr[2]=T1;
				Gr[3]=T2;
				Gr[4]=T3;
				gtk_clist_append(GTK_CLIST (Lst),Gr);
			}
			JOURNAUX_VIDE=FALSE;
			widget=lookup_widget(GTK_WIDGET (WindCompta),"ComptaEdit");
			gtk_widget_set_sensitive(widget,TRUE);
			widget=lookup_widget(GTK_WIDGET (WindCompta),"ComptaOpen");
			gtk_widget_set_sensitive(widget,TRUE);			
		} else {
			widget=lookup_widget(GTK_WIDGET (WindCompta),"ComptaEdit");
			gtk_widget_set_sensitive(widget,FALSE);
			widget=lookup_widget(GTK_WIDGET (WindCompta),"ComptaOpen");
			gtk_widget_set_sensitive(widget,FALSE);
			JOURNAUX_VIDE=TRUE;
		}
    mysql_free_result(Result);
  }
  if (CloseOnExit) CloseDbLcpt();
}

void on_ComptaOpen_clicked(GtkButton       *button,gpointer         user_data)
{
  if (*Journal) Dialog_EdtCpt(Journal);else Dialog_EdtCpt(NULL);
}


void on_ComptaEdit_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  if (*Journal) Dialog_EdtJrn(Journal);else Dialog_EdtJrn(NULL);
}


void on_ComptaSearch_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  MYSQL_RES *Result;

  OpenDbLcpt();
  Result=Dialog_Search(NULL);
  if (Result!=NULL) {
    Dialog_ResSearch(Result);
  }
  CloseDbLcpt();
}

void on_ComptaQuitte_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  /*  if (DbLcpt!=NULL) CloseDbLcpt();*/
  gtk_main_quit();
}

/* Selection journal **************************************************/
void Compta_ListJrn_select_row         (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gchar *P;

  gtk_clist_get_text(clist,row,0,&P);
  strcpy(Journal,P);
}

void Compta_ListJrn_unselect_row       (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  *Journal='\0';
}

gboolean Compta_ListJrn_button_press_event(GtkWidget *widget,GdkEventButton  *event,gpointer user_data)
{

  return FALSE;
}

int ControleDateEx(void)
{
  gchar SqlCmd[120],PsCle[LEN_COD_SOC+1];
  gint Ret;

  GetSocRun(PsCle);
  OpenDbLcpt();
  sprintf(SqlCmd,"Select Count(*) From Histo Where HisSoc='%s'",PsCle);
  if (SqlGetNumber(SqlCmd)==0) {
    MessageInfo(_("Cette socit ne possede pas de date d'exercice.\nVous devez saisir ces dates !"));
    Ret=SaisieComplements();
  } else Ret=MR_OK;
  CloseDbLcpt();
  return (Ret);
}

/* Paramtres Socit (ParamSoc) **************************************/
void on_Param_Gen1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  Dialog_ParamGenx();
}

/************************************************************************/
/* Boite de dialogue principale *****************************************/
GtkWidget* create_Compta (void)
{
  GtkWidget *Compta;
  GtkWidget *vbox1;
  GtkWidget *menubar1;
  GtkWidget *vbox14;
  GtkWidget *toolbar1;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *ComptaOpen;
  GtkWidget *ComptaEdit;
  GtkWidget *ComptaSearch;
  GtkWidget *vseparator7;
  GtkWidget *ComptaQuitte;
  GtkWidget *scrolledwindow9;
  GtkWidget *ListJrn;
  GtkWidget *label140;
  GtkWidget *label141;
  GtkWidget *label142;
  GtkWidget *label143;
  GtkWidget *label144;
  GtkWidget *statusbar1;

  Compta = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (Compta), "Compta", Compta);
  gtk_window_set_title (GTK_WINDOW (Compta), _("Comptabilit Analytique"));
  gtk_window_set_position (GTK_WINDOW (Compta), GTK_WIN_POS_CENTER);
  gtk_window_set_default_size (GTK_WINDOW (Compta), 640, 480);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (Compta), vbox1);

  menubar1 = gtk_menu_bar_new ();
  gtk_widget_ref (menubar1);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "menubar1", menubar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar1);
  gtk_box_pack_start (GTK_BOX (vbox1), menubar1, FALSE, FALSE, 0);
  gnome_app_fill_menu (GTK_MENU_SHELL (menubar1), menubar1_uiinfo,
                       NULL, FALSE, 0);

  gtk_widget_ref (menubar1_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "fichiers1",
                            menubar1_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (fichiers1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "param_tres_soci_t_1",
                            fichiers1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (fichiers1_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "Param_Gen1",
                            fichiers1_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (fichiers1_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "plan_comptable1",
                            fichiers1_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (fichiers1_menu_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "collectifs1",
                            fichiers1_menu_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (fichiers1_menu_uiinfo[4].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "journaux1",
                            fichiers1_menu_uiinfo[4].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (fichiers1_menu_uiinfo[5].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "s_parateur1",
                            fichiers1_menu_uiinfo[5].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (fichiers1_menu_uiinfo[6].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "s_lection_serveur1",
                            fichiers1_menu_uiinfo[6].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (fichiers1_menu_uiinfo[7].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "s_lection_utilisateur1",
                            fichiers1_menu_uiinfo[7].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (fichiers1_menu_uiinfo[8].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "selection_soci_t_1",
                            fichiers1_menu_uiinfo[8].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (fichiers1_menu_uiinfo[9].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "s_parateur2",
                            fichiers1_menu_uiinfo[9].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (fichiers1_menu_uiinfo[10].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "quitter1",
                            fichiers1_menu_uiinfo[10].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar1_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "editions1",
                            menubar1_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (editions1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "edition_des_journaux1",
                            editions1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (editions1_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "pointage1",
                            editions1_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (editions1_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "lettrage1",
                            editions1_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (editions1_menu_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "s_parateur3",
                            editions1_menu_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (editions1_menu_uiinfo[4].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "ConsultComptes1",
                            editions1_menu_uiinfo[4].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar1_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "impression1",
                            menubar1_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (impression1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "imprimer_journal1",
                            impression1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (impression1_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "imprimer_balance1",
                            impression1_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (impression1_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "imprimer_grand_livre1",
                            impression1_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar1_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "aide1",
                            menubar1_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (aide1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "a_propos1",
                            aide1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  vbox14 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox14);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "vbox14", vbox14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox14);
  gtk_box_pack_start (GTK_BOX (vbox1), vbox14, TRUE, TRUE, 0);

  toolbar1 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_widget_ref (toolbar1);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "toolbar1", toolbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar1);
  gtk_box_pack_start (GTK_BOX (vbox14), toolbar1, FALSE, FALSE, 0);
  gtk_toolbar_set_button_relief (GTK_TOOLBAR (toolbar1), GTK_RELIEF_NONE);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (Compta, GNOME_STOCK_PIXMAP_OPEN);
  ComptaOpen = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Ouvrir"),
                                _("Editions des critures."), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (ComptaOpen);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "ComptaOpen", ComptaOpen,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ComptaOpen);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (Compta, GNOME_STOCK_PIXMAP_PROPERTIES);
  ComptaEdit = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Edition"),
                                _("Edition des paramtres du journal."), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (ComptaEdit);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "ComptaEdit", ComptaEdit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ComptaEdit);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (Compta, GNOME_STOCK_PIXMAP_SEARCH);
  ComptaSearch = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Recherche"),
                                _("Recherche une criture."), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (ComptaSearch);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "ComptaSearch", ComptaSearch,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ComptaSearch);

  vseparator7 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator7);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "vseparator7", vseparator7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator7);
  gtk_toolbar_append_widget (GTK_TOOLBAR (toolbar1), vseparator7, NULL, NULL);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (Compta, GNOME_STOCK_PIXMAP_EXIT);
  ComptaQuitte = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Quitter"),
                                _("Quitter LinCompta."), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (ComptaQuitte);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "ComptaQuitte", ComptaQuitte,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ComptaQuitte);

  scrolledwindow9 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow9);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "scrolledwindow9", scrolledwindow9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow9);
  gtk_box_pack_start (GTK_BOX (vbox14), scrolledwindow9, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow9), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  /*** Tableau des journaux ***/
  ListJrn = gtk_clist_new (5);
  gtk_widget_ref (ListJrn);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "ListJrn", ListJrn,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ListJrn);
  gtk_container_add (GTK_CONTAINER (scrolledwindow9), ListJrn);
  gtk_container_set_border_width (GTK_CONTAINER (ListJrn), 2);
  gtk_clist_set_column_width (GTK_CLIST (ListJrn), 0, 47);
  gtk_clist_set_column_width (GTK_CLIST (ListJrn), 1, 257);
  gtk_clist_set_column_width (GTK_CLIST (ListJrn), 2, 84);
  gtk_clist_set_column_width (GTK_CLIST (ListJrn), 3, 90);
  gtk_clist_set_column_width (GTK_CLIST (ListJrn), 4, 80);
  gtk_clist_column_titles_show (GTK_CLIST (ListJrn));
  gtk_clist_set_column_resizeable(GTK_CLIST (ListJrn),0,FALSE);
  gtk_clist_set_column_justification(GTK_CLIST (ListJrn),2,GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_resizeable(GTK_CLIST (ListJrn),2,FALSE);
  gtk_clist_set_column_justification(GTK_CLIST (ListJrn),3,GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_resizeable(GTK_CLIST (ListJrn),3,FALSE);
  gtk_clist_set_column_justification(GTK_CLIST (ListJrn),4,GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_resizeable(GTK_CLIST (ListJrn),4,FALSE);

  label140 = gtk_label_new (_("Jrn"));
  gtk_widget_ref (label140);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "label140", label140,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label140);
  gtk_clist_set_column_widget (GTK_CLIST (ListJrn), 0, label140);

  label141 = gtk_label_new (_("Libell"));
  gtk_widget_ref (label141);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "label141", label141,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label141);
  gtk_clist_set_column_widget (GTK_CLIST (ListJrn), 1, label141);

  label142 = gtk_label_new (_("Dbit"));
  gtk_widget_ref (label142);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "label142", label142,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label142);
  gtk_clist_set_column_widget (GTK_CLIST (ListJrn), 2, label142);

  label143 = gtk_label_new (_("Crdit"));
  gtk_widget_ref (label143);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "label143", label143,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label143);
  gtk_clist_set_column_widget (GTK_CLIST (ListJrn), 3, label143);

  label144 = gtk_label_new (_("Solde"));
  gtk_widget_ref (label144);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "label144", label144,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label144);
  gtk_clist_set_column_widget (GTK_CLIST (ListJrn), 4, label144);

  statusbar1 = gtk_statusbar_new ();
  gtk_widget_ref (statusbar1);
  gtk_object_set_data_full (GTK_OBJECT (Compta), "statusbar1", statusbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (statusbar1);
  gtk_box_pack_start (GTK_BOX (vbox1), statusbar1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (statusbar1), 2);

  gtk_signal_connect (GTK_OBJECT (Compta), "destroy",
                      GTK_SIGNAL_FUNC (on_Compta_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Compta), "show",
                      GTK_SIGNAL_FUNC (on_Compta_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ComptaOpen), "clicked",
                      GTK_SIGNAL_FUNC (on_ComptaOpen_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ComptaEdit), "clicked",
                      GTK_SIGNAL_FUNC (on_ComptaEdit_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ComptaSearch), "clicked",
                      GTK_SIGNAL_FUNC (on_ComptaSearch_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ComptaQuitte), "clicked",
                      GTK_SIGNAL_FUNC (on_ComptaQuitte_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ListJrn), "select_row",
                      GTK_SIGNAL_FUNC (Compta_ListJrn_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ListJrn), "unselect_row",
                      GTK_SIGNAL_FUNC (Compta_ListJrn_unselect_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ListJrn), "button_press_event",
                      GTK_SIGNAL_FUNC (Compta_ListJrn_button_press_event),
                      NULL);

  return Compta;
}
