/*******************************************************************/
/* Comptabilit Analytique Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 22/03/02 - Consultation des comptes                             */
/* Fichier source                                                  */
/*******************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 


#include <gtk/gtk.h>
#include <gnome.h>
#include <string.h>
#include <ctype.h>
#include <mysql/mysql.h>
#include "support.h"
#include "common.h"
#include "gtksql.h"
#include "select.h"
#include "relance.h"
#include "edtcom.h"

#include "consult.h"

/* Variables */
GtkWidget    *MenuOpt;
MYSQL_RES    *EdtPlcRes;
gboolean     AFFICHE_LETTREE;
double       Ecart;
my_ulonglong MysqlPtr;
GtkWidget    *Consult;
gchar        CodeSelect[11],CodeDisplay[11];
listidlib    *ORG_REGL,*Regl;
/* Protos */
GtkWidget* create_ConsultCompte (void);
void Dialog_Consult();
GtkWidget* create_ModifEcrit (void);
void VisCpt_DispData(void);
void VisCpt_DispTab(void);
void Modification(void);
void VisCpt_ListEcr_select_row         (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void VisCpt_ListEcr_unselect_row       (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

gboolean VisCpt_ListEcr_button_press_event      (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

void VisCpt_BtLet_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void VisCpt_BtNLet_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void on_VisCpt_BtFermer_clicked        (GtkButton       *button,
                                        gpointer         user_data);

void on_VisCpt_BtPrec_clicked          (GtkButton       *button,
                                        gpointer         user_data);

void on_VisCpt_Sel_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void on_VisCpt_BtSuiv_clicked          (GtkButton       *button,
                                        gpointer         user_data);

void on_ConsultCompte_show             (GtkWidget       *widget,
                                        gpointer         user_data);

void on_ConsultCompte_destroy          (GtkObject       *object,
                                        gpointer         user_data);

void on_ModEcr_BtOk_clicked            (GtkButton       *button,
                                        gpointer         user_data);
void ModifEcrit_destroy                (GtkObject *object,gpointer user_data);
static gint on_VisCpt_BtOpt_clicked(GtkWidget *button,GdkEvent *event);					
void VisCpt_MenuRelance(gchar *string);
void VisCpt_MenuExtrait(gchar *string);
void VisCpt_MenuNote(gchar *string);
void VisCpt_CreateMenuOpt(void);
/**********/

void ModifEcrit_destroy(GtkObject *object,gpointer user_data)
{
  FreeModRegl(ORG_REGL);
}

GtkWidget* create_ModifEcrit (void)
{
  GtkWidget *ModifEcrit;
  GtkWidget *vbox17;
  GtkWidget *fixed17;
  GtkWidget *label163;
  GtkWidget *EcrLib;
  GtkWidget *label164;
  GtkWidget *label165;
  GtkWidget *EcrEch;
  GtkWidget *label166;
  GtkWidget *EcrDatePtg;
  GtkWidget *hseparator19;
  GtkWidget *EcrMr;
  GtkWidget *combo_entry7;
  GtkWidget *fixed16;
  GtkWidget *ModEcr_BtOk;
  GtkWidget *ModEcr_BtCancel;

  ModifEcrit = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (ModifEcrit), "ModifEcrit", ModifEcrit);
  gtk_window_set_title (GTK_WINDOW (ModifEcrit), _("Modification criture"));
  gtk_window_set_modal(GTK_WINDOW (ModifEcrit),TRUE);
  gtk_signal_connect (GTK_OBJECT (ModifEcrit), "destroy",
                      GTK_SIGNAL_FUNC (ModifEcrit_destroy),
                      NULL);

  vbox17 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox17);
  gtk_object_set_data_full (GTK_OBJECT (ModifEcrit), "vbox17", vbox17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox17);
  gtk_container_add (GTK_CONTAINER (ModifEcrit), vbox17);

  fixed17 = gtk_fixed_new ();
  gtk_widget_ref (fixed17);
  gtk_object_set_data_full (GTK_OBJECT (ModifEcrit), "fixed17", fixed17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed17);
  gtk_box_pack_start (GTK_BOX (vbox17), fixed17, TRUE, TRUE, 0);

  label163 = gtk_label_new (_("Libell :"));
  gtk_widget_ref (label163);
  gtk_object_set_data_full (GTK_OBJECT (ModifEcrit), "label163", label163,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label163);
  gtk_fixed_put (GTK_FIXED (fixed17), label163, 20, 16);
  gtk_widget_set_uposition (label163, 20, 16);
  gtk_widget_set_usize (label163, 56, 16);
  gtk_misc_set_alignment (GTK_MISC (label163), 0, 0.5);

  EcrLib = gtk_entry_new ();
  gtk_widget_ref (EcrLib);
  gtk_object_set_data_full (GTK_OBJECT (ModifEcrit), "EcrLib", EcrLib,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EcrLib);
  gtk_fixed_put (GTK_FIXED (fixed17), EcrLib, 72, 12);
  gtk_widget_set_uposition (EcrLib, 72, 12);
  gtk_widget_set_usize (EcrLib, 208, 24);

  label164 = gtk_label_new (_("Mode de rglement :"));
  gtk_widget_ref (label164);
  gtk_object_set_data_full (GTK_OBJECT (ModifEcrit), "label164", label164,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label164);
  gtk_fixed_put (GTK_FIXED (fixed17), label164, 20, 44);
  gtk_widget_set_uposition (label164, 20, 44);
  gtk_widget_set_usize (label164, 124, 16);
  gtk_misc_set_alignment (GTK_MISC (label164), 0, 0.5);

  label165 = gtk_label_new (_("Echance :"));
  gtk_widget_ref (label165);
  gtk_object_set_data_full (GTK_OBJECT (ModifEcrit), "label165", label165,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label165);
  gtk_fixed_put (GTK_FIXED (fixed17), label165, 20, 72);
  gtk_widget_set_uposition (label165, 20, 72);
  gtk_widget_set_usize (label165, 72, 16);
  gtk_misc_set_alignment (GTK_MISC (label165), 0, 0.5);

  EcrEch = gtk_entry_new ();
  gtk_widget_ref (EcrEch);
  gtk_object_set_data_full (GTK_OBJECT (ModifEcrit), "EcrEch", EcrEch,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EcrEch);
  gtk_fixed_put (GTK_FIXED (fixed17), EcrEch, 92, 68);
  gtk_widget_set_uposition (EcrEch, 92, 68);
  gtk_widget_set_usize (EcrEch, 80, 24);

  label166 = gtk_label_new (_("Date de pointage :"));
  gtk_widget_ref (label166);
  gtk_object_set_data_full (GTK_OBJECT (ModifEcrit), "label166", label166,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label166);
  gtk_fixed_put (GTK_FIXED (fixed17), label166, 20, 100);
  gtk_widget_set_uposition (label166, 20, 100);
  gtk_widget_set_usize (label166, 104, 16);
  gtk_misc_set_alignment (GTK_MISC (label166), 0, 0.5);

  EcrDatePtg = gtk_entry_new ();
  gtk_widget_ref (EcrDatePtg);
  gtk_object_set_data_full (GTK_OBJECT (ModifEcrit), "EcrDatePtg", EcrDatePtg,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EcrDatePtg);
  gtk_fixed_put (GTK_FIXED (fixed17), EcrDatePtg, 128, 96);
  gtk_widget_set_uposition (EcrDatePtg, 128, 96);
  gtk_widget_set_usize (EcrDatePtg, 92, 24);

  hseparator19 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator19);
  gtk_object_set_data_full (GTK_OBJECT (ModifEcrit), "hseparator19", hseparator19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator19);
  gtk_fixed_put (GTK_FIXED (fixed17), hseparator19, 4, 128);
  gtk_widget_set_uposition (hseparator19, 4, 128);
  gtk_widget_set_usize (hseparator19, 384, 16);

  EcrMr = gtk_combo_new ();
  gtk_widget_ref (EcrMr);
  gtk_object_set_data_full (GTK_OBJECT (ModifEcrit), "EcrMr", EcrMr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EcrMr);
  gtk_fixed_put (GTK_FIXED (fixed17), EcrMr, 140, 40);
  gtk_widget_set_uposition (EcrMr, 140, 40);
  gtk_widget_set_usize (EcrMr, 175, 22);

  combo_entry7 = GTK_COMBO (EcrMr)->entry;
  gtk_widget_ref (combo_entry7);
  gtk_object_set_data_full (GTK_OBJECT (ModifEcrit), "combo_entry7", combo_entry7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_entry7);

  fixed16 = gtk_fixed_new ();
  gtk_widget_ref (fixed16);
  gtk_object_set_data_full (GTK_OBJECT (ModifEcrit), "fixed16", fixed16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed16);
  gtk_box_pack_start (GTK_BOX (vbox17), fixed16, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (fixed16), 2);

  ModEcr_BtOk = gnome_stock_button (GNOME_STOCK_BUTTON_APPLY);
  gtk_widget_ref (ModEcr_BtOk);
  gtk_object_set_data_full (GTK_OBJECT (ModifEcrit), "ModEcr_BtOk", ModEcr_BtOk,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ModEcr_BtOk);
  gtk_fixed_put (GTK_FIXED (fixed16), ModEcr_BtOk, 196, 8);
  gtk_widget_set_uposition (ModEcr_BtOk, 196, 8);
  gtk_widget_set_usize (ModEcr_BtOk, 92, 24);

  ModEcr_BtCancel = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (ModEcr_BtCancel);
  gtk_object_set_data_full (GTK_OBJECT (ModifEcrit), "ModEcr_BtCancel", ModEcr_BtCancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ModEcr_BtCancel);
  gtk_fixed_put (GTK_FIXED (fixed16), ModEcr_BtCancel, 300, 8);
  gtk_widget_set_uposition (ModEcr_BtCancel, 300, 8);
  gtk_widget_set_usize (ModEcr_BtCancel, 92, 24);

  gtk_signal_connect (GTK_OBJECT (EcrEch), "insert_text",
                      GTK_SIGNAL_FUNC (ControleSaisieDate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EcrDatePtg), "insert_text",
                      GTK_SIGNAL_FUNC (ControleSaisieDate),
                      NULL);
  gtk_signal_connect_object (GTK_OBJECT (ModEcr_BtOk), "clicked",
			     GTK_SIGNAL_FUNC (on_ModEcr_BtOk_clicked),
			     GTK_OBJECT (ModifEcrit));
  gtk_signal_connect_object (GTK_OBJECT (ModEcr_BtCancel), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (ModifEcrit));

  return ModifEcrit;
}

void on_ModEcr_BtOk_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  char *End,SqlCmd[200],PsCle[LEN_COD_SOC+1];

  GetSocRun(PsCle);
  End=strmov(SqlCmd,"Update Ecrit Set EcrLib=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"EcrLib");
  End=strmov(End,",EcrMr=");
  End=ComboMRLib(End,GTK_WIDGET (button),ORG_REGL,"EcrMr");
  End=strmov(End,",EcrEch=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"EcrEch");
  End=strmov(End,",EcrDatePtg=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"EcrDatePtg");
  End=strmov(End," Where EcrSoc=");
  End=StrSql(End,PsCle);
  End=strmov(End," And EcrCode=");
  End=StrSql(End,CodeSelect);
  if (mysql_query(DbLcpt,SqlCmd)!=0) MessageAlerte(_("Modification non effectu !"));
  gtk_widget_destroy(GTK_WIDGET (button));
}

void Modification(void)
{
  GtkWidget *Win,*Combo;
  MYSQL_RES *Result;
  MYSQL_ROW Row;
  gchar SqlCmd[120],Tmp[20],PsCle[LEN_COD_SOC+1];
  GList *Items;

  Win=create_ModifEcrit();
  ORG_REGL=LoadModRegl();
  Combo=lookup_widget(GTK_WIDGET (Win),"EcrMr");
  Items=NULL;
  Regl=ORG_REGL;
  while (Regl!=NULL) {
    Items=g_list_append(Items,Regl->Lib);
    Regl=Regl->Su;
  }
  gtk_combo_set_popdown_strings(GTK_COMBO (Combo),Items);
  g_list_free(Items);
  /****/
  GetSocRun(PsCle);
  sprintf(SqlCmd,"Select EcrLib,EcrMr,EcrEch,EcrDatePtg From Ecrit Where EcrSoc='%s' And EcrCode='%s'",PsCle,CodeSelect);
  g_print("%s\n",SqlCmd);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    Result=mysql_store_result(DbLcpt);
    Row=mysql_fetch_row(Result);
    StrSqlToGtk(GTK_WIDGET (Win),"EcrLib",Row[0]);
    ComboMRID(GTK_WIDGET (Win),ORG_REGL,"EcrMr",Row[1]);
    IsoToDate(Tmp,Row[2]);
    StrSqlToGtk(GTK_WIDGET (Win),"EcrEch",Tmp);
    IsoToDate(Tmp,Row[3]);
    StrSqlToGtk(GTK_WIDGET (Win),"EcrDatePtg",Tmp);
    mysql_free_result(Result);
  } else MessageAlerte(_("Code criture non trouv !?"));
  gtk_widget_show_all(Win);
}

/********************************************************************/
/* Fenetre principale ***********************************************/
void VisCpt_DispTab(void)
{
  GtkWidget *ListHis,*Ecart,*Entry;
  gchar *Ptr[10],PsCle[LEN_COD_SOC+1],SqlCmd[200],Tmp[15],CptCode[11];
  MYSQL_RES *Result;
  MYSQL_ROW Row;
  gint Ligne;

  GetSocRun(PsCle);
  Entry=lookup_widget(GTK_WIDGET (Consult),"CptCode");
  strcpy(CptCode,gtk_entry_get_text(GTK_ENTRY (Entry)));
  ListHis=lookup_widget(GTK_WIDGET (Consult),"ListEcr");
  gtk_clist_freeze(GTK_CLIST (ListHis));
  gtk_clist_clear(GTK_CLIST (ListHis));
  if (AFFICHE_LETTREE)
    sprintf(SqlCmd,"Select * From Ecrit Where EcrSoc='%s' And EcrCpt='%s' And EcrLet<>'' Order By EcrDate",PsCle,CptCode);
  else sprintf(SqlCmd,"Select * From Ecrit Where EcrSoc='%s' And EcrCpt='%s' And EcrLet='' Order By EcrDate",PsCle,CptCode);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    Result=mysql_store_result(DbLcpt);
    while ((Row=mysql_fetch_row(Result))) {
      IsoToDate(Tmp,Row[3]);
      Ptr[0]=Tmp;
      Ptr[1]=Row[9];
      Ptr[2]=Row[4];
      Ptr[3]=Row[5]+2;
      Ptr[4]=Row[13];
      Ptr[5]=Row[14];
      Ptr[6]=Row[19];
      Ptr[7]=Row[20];
      Ptr[8]=Row[12];
      Ptr[9]=Row[10];
      Ligne=gtk_clist_append(GTK_CLIST (ListHis),Ptr);
      gtk_clist_set_row_data(GTK_CLIST (ListHis),Ligne,(gpointer) Row[1]);
    }
    gtk_clist_thaw(GTK_CLIST (ListHis));
  }
  sprintf(SqlCmd,"Select Sum(EcrDebit)-Sum(EcrCredit) From Ecrit Where EcrSoc='%s' And EcrCpt='%s'",PsCle,CptCode);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    Result=mysql_store_result(DbLcpt);
    if ((Row=mysql_fetch_row(Result))) {
      Ecart=lookup_widget(GTK_WIDGET (Consult),"Ecart");
      if (Row[0]!=NULL) gtk_entry_set_text(GTK_ENTRY (Ecart),Row[0]);
      else gtk_entry_set_text(GTK_ENTRY (Ecart),"0.00");
    }
		mysql_free_result(Result);
  }
}

void VisCpt_DispData(void)
{
  gchar SqlCmd[250],PsCle[LEN_COD_SOC+1];
  int Valid;
  MYSQL_ROW Row;
  GtkWidget *Widget;

  GetSocRun(PsCle);
  if (EdtPlcRes==NULL) {
    Valid=FALSE;
    MysqlPtr=0;
    sprintf(SqlCmd,"Select CptCode,CptLib From Comptes Where CptSoc='%s'",PsCle);
    if (!mysql_query(DbLcpt,SqlCmd)) {
      EdtPlcRes=mysql_store_result(DbLcpt);
      if (EdtPlcRes)  {
	if (mysql_num_rows(EdtPlcRes)==0) {
	  Widget=lookup_widget(GTK_WIDGET (Consult),"VisCpt_BtPrec");
	  if (Widget!=NULL) gtk_widget_set_sensitive(Widget,FALSE);
	  Widget=lookup_widget(GTK_WIDGET (Consult),"VisCpt_BtSuiv");
	  if (Widget!=NULL) gtk_widget_set_sensitive(Widget,FALSE);
	  Widget=lookup_widget(GTK_WIDGET (Consult),"VisCpt_Sel");
	  if (Widget!=NULL) gtk_widget_set_sensitive(Widget,FALSE);
	  Widget=lookup_widget(GTK_WIDGET (Consult),"VisCpt_BtOpt");
	  if (Widget!=NULL) gtk_widget_set_sensitive(Widget,FALSE);
	} else Valid=TRUE;
      }
    }
  } else Valid=TRUE;
  if (Valid) {
    Row=mysql_fetch_row(EdtPlcRes);
    StrSqlToGtk(GTK_WIDGET (Consult),"CptCode",Row[0]);
		strcpy(CodeDisplay,Row[0]);
    StrSqlToGtk(GTK_WIDGET (Consult),"CptLib",Row[1]);
    VisCpt_DispTab();
  }
}

void on_VisCpt_BtFermer_clicked(GtkButton *button,gpointer user_data)
{
  GtkWidget *Wcall;

  Wcall=lookup_widget(GTK_WIDGET (button),"ConsultCompte");
  gtk_widget_destroy(GTK_WIDGET(Wcall));
}

void on_VisCpt_BtPrec_clicked(GtkButton *button,gpointer user_data)
{
  if (MysqlPtr>0) {
    MysqlPtr--;
    mysql_data_seek(EdtPlcRes,MysqlPtr);
    VisCpt_DispData();
  }
}


void on_VisCpt_BtSuiv_clicked(GtkButton *button,gpointer user_data)
{
  if (MysqlPtr<mysql_num_rows(EdtPlcRes)-1) {
    VisCpt_DispData();
    MysqlPtr++;
  }
}

void on_VisCpt_Sel_clicked(GtkButton *button,gpointer user_data)
{
  gchar CptRet[11];

  if (ListSelect(CptRet,"Comptes","CptSoc","CptCode","CptLib",NULL)==MR_OK) {
    if ((MysqlPtr = SearchCode(EdtPlcRes, CptRet, 0)) != -1)
      VisCpt_DispData();
    else
      if (verbose) g_print("Code %s non retrouv !!!\n", CptRet);
  }
}

void VisCpt_ListEcr_select_row(GtkCList *clist,gint row,gint column,GdkEvent *event,gpointer user_data)
{
  gchar *P;

  P=gtk_clist_get_row_data(clist,row);
  strcpy(CodeSelect,P);
}

void VisCpt_ListEcr_unselect_row(GtkCList *clist,gint row,gint column,GdkEvent *event,gpointer user_data)
{
  *CodeSelect='\0';
}


gboolean VisCpt_ListEcr_button_press_event(GtkWidget *widget,GdkEventButton  *event,gpointer user_data)
{
  if (event->type==GDK_2BUTTON_PRESS) {
    if (*CodeSelect!=0) Modification();
  }
  return FALSE;
}


void VisCpt_BtLet_clicked(GtkButton *button,gpointer user_data)
{
  AFFICHE_LETTREE=TRUE;
  VisCpt_DispTab();
}


void VisCpt_BtNLet_clicked(GtkButton *button,gpointer user_data)
{
  AFFICHE_LETTREE=FALSE;
  VisCpt_DispTab();
}

void on_ConsultCompte_show(GtkWidget *widget,gpointer user_data)
{
  GtkWidget *Lst;
  gint i;

  OpenDbLcpt();
  Lst=lookup_widget(GTK_WIDGET (widget),"ListEcr");
  for (i=0;i<10;i++) gtk_clist_set_column_resizeable(GTK_CLIST (Lst),i,FALSE);
  gtk_clist_set_column_justification(GTK_CLIST (Lst),6,GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_justification(GTK_CLIST (Lst),7,GTK_JUSTIFY_RIGHT);
  AFFICHE_LETTREE=FALSE;
}

void on_ConsultCompte_destroy               (GtkObject       *object,
                                        gpointer         user_data)
{
  CloseDbLcpt();
  DbLcpt=NULL;
}

void VisCpt_MenuNote(gchar *string)
{
	Dialog_EdtComm(CodeDisplay);
}

void VisCpt_MenuExtrait(gchar *string)
{
}

void VisCpt_MenuRelance(gchar *string)
{
	Dialog_RelanceNew(CodeDisplay);
}

static gint on_VisCpt_BtOpt_clicked(GtkWidget *button,GdkEvent *event)
{
	 GdkEventButton *bevent;
	 
	 if (event->type==GDK_BUTTON_PRESS) {
			bevent= (GdkEventButton *) event;
			gtk_menu_popup(GTK_MENU (MenuOpt),NULL,NULL,NULL,NULL,bevent->button,bevent->time);
			return TRUE;
	 }
	 return FALSE;
}

GtkWidget* create_ConsultCompte (void)
{
  GtkWidget *ConsultCompte;
  GtkWidget *vbox11;
  GtkWidget *hbox12;
  GtkWidget *label109;
  GtkWidget *CptCode;
  GtkWidget *CptLib;
  GtkWidget *VisCpt_BtPrec;
  GtkWidget *VisCpt_Sel;
  GtkWidget *VisCpt_BtSuiv;
  GtkWidget *hbox14;
  GtkWidget *label120;
  GtkWidget *Ecart;
  GtkWidget *scrolledwindow6;
  GtkWidget *ListEcr;
  GtkWidget *label110;
  GtkWidget *label111;
  GtkWidget *label112;
  GtkWidget *label113;
  GtkWidget *label114;
  GtkWidget *label115;
  GtkWidget *label116;
  GtkWidget *label117;
  GtkWidget *label118;
  GtkWidget *label119;
  GtkWidget *hbox13;
  GtkWidget *VisCpt_BtLet;
  GtkWidget *VisCpt_BtNLet;
  GtkWidget *VisCpt_BtOpt;
  GtkWidget *VisCpt_BtFermer;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  ConsultCompte = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (ConsultCompte), "ConsultCompte", ConsultCompte);
  gtk_window_set_title (GTK_WINDOW (ConsultCompte), _("Consultation des Comptes"));
  gtk_window_set_position (GTK_WINDOW (ConsultCompte), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (ConsultCompte), TRUE);

  vbox11 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox11);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "vbox11", vbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox11);
  gtk_container_add (GTK_CONTAINER (ConsultCompte), vbox11);
  gtk_widget_set_usize (vbox11, 760, 362);
  gtk_container_set_border_width (GTK_CONTAINER (vbox11), 4);

  hbox12 = gtk_hbox_new (FALSE, 3);
  gtk_widget_ref (hbox12);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "hbox12", hbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox12);
  gtk_box_pack_start (GTK_BOX (vbox11), hbox12, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox12), 4);

  label109 = gtk_label_new (_("Compte :"));
  gtk_widget_ref (label109);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "label109", label109,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label109);
  gtk_box_pack_start (GTK_BOX (hbox12), label109, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label109), 0, 0);
  gtk_misc_set_padding (GTK_MISC (label109), 0, 6);

  CptCode = gtk_entry_new_with_max_length (8);
  gtk_widget_ref (CptCode);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "CptCode", CptCode,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptCode);
  gtk_box_pack_start (GTK_BOX (hbox12), CptCode, FALSE, TRUE, 0);
  gtk_widget_set_usize (CptCode, 80, -2);

  CptLib = gtk_entry_new ();
  gtk_widget_ref (CptLib);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "CptLib", CptLib,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptLib);
  gtk_box_pack_start (GTK_BOX (hbox12), CptLib, FALSE, FALSE, 0);
  gtk_widget_set_usize (CptLib, 242, -2);

  VisCpt_BtPrec = gnome_stock_button (GNOME_STOCK_BUTTON_PREV);
  gtk_widget_ref (VisCpt_BtPrec);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "VisCpt_BtPrec", VisCpt_BtPrec,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (VisCpt_BtPrec);
  gtk_box_pack_start (GTK_BOX (hbox12), VisCpt_BtPrec, FALSE, FALSE, 0);
  gtk_widget_add_accelerator (VisCpt_BtPrec, "clicked", accel_group,
                              GDK_Page_Up, 0,
                              GTK_ACCEL_VISIBLE);

  VisCpt_Sel = gtk_button_new_with_label (_("Sl."));
  gtk_widget_ref (VisCpt_Sel);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "VisCpt_Sel", VisCpt_Sel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (VisCpt_Sel);
  gtk_box_pack_start (GTK_BOX (hbox12), VisCpt_Sel, FALSE, FALSE, 0);
  gtk_widget_add_accelerator (VisCpt_Sel, "clicked", accel_group,
                              GDK_F5, 0,
                              GTK_ACCEL_VISIBLE);

  VisCpt_BtSuiv = gnome_stock_button (GNOME_STOCK_BUTTON_NEXT);
  gtk_widget_ref (VisCpt_BtSuiv);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "VisCpt_BtSuiv", VisCpt_BtSuiv,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (VisCpt_BtSuiv);
  gtk_box_pack_start (GTK_BOX (hbox12), VisCpt_BtSuiv, FALSE, FALSE, 0);
  gtk_widget_add_accelerator (VisCpt_BtSuiv, "clicked", accel_group,
                              GDK_Page_Down, 0,
                              GTK_ACCEL_VISIBLE);

  hbox14 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox14);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "hbox14", hbox14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox14);
  gtk_box_pack_start (GTK_BOX (hbox12), hbox14, TRUE, TRUE, 0);

  label120 = gtk_label_new (_("Solde :"));
  gtk_widget_ref (label120);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "label120", label120,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label120);
  gtk_box_pack_start (GTK_BOX (hbox14), label120, FALSE, FALSE, 0);

  Ecart = gtk_entry_new ();
  gtk_widget_ref (Ecart);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "Ecart", Ecart,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Ecart);
  gtk_box_pack_start (GTK_BOX (hbox14), Ecart, TRUE, TRUE, 0);
  gtk_widget_set_sensitive (Ecart, FALSE);
  GTK_WIDGET_UNSET_FLAGS (Ecart, GTK_CAN_FOCUS);
  gtk_entry_set_editable (GTK_ENTRY (Ecart), FALSE);

  scrolledwindow6 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow6);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "scrolledwindow6", scrolledwindow6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow6);
  gtk_box_pack_start (GTK_BOX (vbox11), scrolledwindow6, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow6), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  ListEcr = gtk_clist_new (10);
  gtk_widget_ref (ListEcr);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "ListEcr", ListEcr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ListEcr);
  gtk_container_add (GTK_CONTAINER (scrolledwindow6), ListEcr);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 0, 72);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 1, 163);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 2, 21);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 3, 59);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 4, 19);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 5, 80);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 6, 80);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 7, 80);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 8, 17);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 9, 80);
  gtk_clist_column_titles_show (GTK_CLIST (ListEcr));

  label110 = gtk_label_new (_("Date"));
  gtk_widget_ref (label110);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "label110", label110,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label110);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 0, label110);

  label111 = gtk_label_new (_("Libell"));
  gtk_widget_ref (label111);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "label111", label111,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label111);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 1, label111);

  label112 = gtk_label_new (_("Jrn"));
  gtk_widget_ref (label112);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "label112", label112,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label112);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 2, label112);

  label113 = gtk_label_new (_("Pice"));
  gtk_widget_ref (label113);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "label113", label113,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label113);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 3, label113);

  label114 = gtk_label_new (_("Rg"));
  gtk_widget_ref (label114);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "label114", label114,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label114);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 4, label114);

  label115 = gtk_label_new (_("Echance"));
  gtk_widget_ref (label115);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "label115", label115,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label115);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 5, label115);

  label116 = gtk_label_new (_("Dbit"));
  gtk_widget_ref (label116);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "label116", label116,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label116);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 6, label116);

  label117 = gtk_label_new (_("Crdit"));
  gtk_widget_ref (label117);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "label117", label117,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label117);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 7, label117);

  label118 = gtk_label_new (_("P"));
  gtk_widget_ref (label118);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "label118", label118,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label118);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 8, label118);

  label119 = gtk_label_new (_("Lettrage"));
  gtk_widget_ref (label119);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "label119", label119,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label119);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 9, label119);

  hbox13 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox13);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "hbox13", hbox13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox13);
  gtk_box_pack_start (GTK_BOX (vbox11), hbox13, FALSE, TRUE, 4);

  VisCpt_BtLet = gtk_button_new_with_label (_("Compte lettrer"));
  gtk_widget_ref (VisCpt_BtLet);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "VisCpt_BtLet", VisCpt_BtLet,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (VisCpt_BtLet);
  gtk_box_pack_start (GTK_BOX (hbox13), VisCpt_BtLet, FALSE, FALSE, 0);

  VisCpt_BtNLet = gtk_button_new_with_label (_("Compte non Lettrer"));
  gtk_widget_ref (VisCpt_BtNLet);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "VisCpt_BtNLet", VisCpt_BtNLet,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (VisCpt_BtNLet);
  gtk_box_pack_start (GTK_BOX (hbox13), VisCpt_BtNLet, FALSE, FALSE, 0);

  VisCpt_BtOpt = gtk_button_new_with_label (_("Options"));
  gtk_widget_ref (VisCpt_BtOpt);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "VisCpt_BtOpt", VisCpt_BtOpt,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (VisCpt_BtOpt);
  gtk_box_pack_start (GTK_BOX (hbox13), VisCpt_BtOpt, FALSE, FALSE, 0);

  VisCpt_BtFermer = gnome_stock_button (GNOME_STOCK_BUTTON_CLOSE);
  gtk_widget_ref (VisCpt_BtFermer);
  gtk_object_set_data_full (GTK_OBJECT (ConsultCompte), "VisCpt_BtFermer", VisCpt_BtFermer,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (VisCpt_BtFermer);
  gtk_box_pack_start (GTK_BOX (hbox13), VisCpt_BtFermer, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (ConsultCompte), "show",
                      GTK_SIGNAL_FUNC (on_ConsultCompte_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ConsultCompte), "destroy",
                      GTK_SIGNAL_FUNC (on_ConsultCompte_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (VisCpt_BtPrec), "clicked",
                      GTK_SIGNAL_FUNC (on_VisCpt_BtPrec_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (VisCpt_Sel), "clicked",
                      GTK_SIGNAL_FUNC (on_VisCpt_Sel_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (VisCpt_BtSuiv), "clicked",
                      GTK_SIGNAL_FUNC (on_VisCpt_BtSuiv_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ListEcr), "select_row",
                      GTK_SIGNAL_FUNC (VisCpt_ListEcr_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ListEcr), "unselect_row",
                      GTK_SIGNAL_FUNC (VisCpt_ListEcr_unselect_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ListEcr), "button_press_event",
                      GTK_SIGNAL_FUNC (VisCpt_ListEcr_button_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (VisCpt_BtLet), "clicked",
                      GTK_SIGNAL_FUNC (VisCpt_BtLet_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (VisCpt_BtNLet), "clicked",
                      GTK_SIGNAL_FUNC (VisCpt_BtNLet_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (VisCpt_BtFermer), "clicked",
                      GTK_SIGNAL_FUNC (on_VisCpt_BtFermer_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (VisCpt_BtOpt), "event",
                      GTK_SIGNAL_FUNC (on_VisCpt_BtOpt_clicked),
                      NULL);
  gtk_window_add_accel_group (GTK_WINDOW (ConsultCompte), accel_group);

  return ConsultCompte;
}

void VisCpt_CreateMenuOpt(void)
{
	GtkWidget *Mnu1,*Mnu2,*Mnu3;
	
	Mnu1=gtk_menu_item_new_with_label(_("Ajouter note"));
	Mnu2=gtk_menu_item_new_with_label(_("Lettre de relance"));
  Mnu3=gtk_menu_item_new_with_label(_("Imprimer un extrait de compte"));
	
	MenuOpt=gtk_menu_new();
	gtk_menu_append(GTK_MENU (MenuOpt),Mnu1);
	gtk_menu_append(GTK_MENU (MenuOpt),Mnu2);
	gtk_menu_append(GTK_MENU (MenuOpt),Mnu3);	
	gtk_signal_connect(GTK_OBJECT (Mnu1),"activate",GTK_SIGNAL_FUNC (VisCpt_MenuNote),NULL);
	gtk_signal_connect(GTK_OBJECT (Mnu2),"activate",GTK_SIGNAL_FUNC (VisCpt_MenuRelance),NULL);	
	gtk_signal_connect(GTK_OBJECT (Mnu3),"activate",GTK_SIGNAL_FUNC (VisCpt_MenuExtrait),NULL);		
	gtk_widget_show(Mnu1);
	gtk_widget_show(Mnu2);
	gtk_widget_show(Mnu3);	
}

void Dialog_Consult(void)
{
  Consult=create_ConsultCompte();
  gtk_widget_show_all(Consult);
	VisCpt_CreateMenuOpt();
  EdtPlcRes=NULL;
  VisCpt_DispData();
}
