/*******************************************************************/
/* Comptabilit Analytique Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 22/03/02 - Edition des plans collectifs                         */
/* Fichier source                                                  */
/*******************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 


#include <gtk/gtk.h>
#include <gnome.h>
#include <string.h>
#include <ctype.h>
#include <mysql/mysql.h>
#include "support.h"
#include "common.h"
#include "gtksql.h"
#include "select.h"

#include "edtcol.h"

/* Variables */
GtkWidget    *Collectifs;
my_ulonglong MysqlPtr;
MYSQL_RES    *EdtColRes;
/* constantes */
int MAX_TYPE=11;
char *TypLib[]={"Capitaux","Clients","Fournisseurs","Immobilisations","Amortissements","Stocks","Tiers","Salaris","Tresorerie","Charges","Produits"};
char *TypID[]={"CA","CL","FO","IM","AM","ST","TI","SA","TR","CH","PR"};
/* Protos */
void EdtCol_DispData(void);
GtkWidget* create_EditCol (void);
void on_EdtCol_BtPrec_clicked          (GtkButton       *button,
                                        gpointer         user_data);

void on_EdtCol_BtSuiv_clicked          (GtkButton       *button,
                                        gpointer         user_data);

void on_EditCol_destroy                (GtkObject       *object,
                                        gpointer         user_data);

void on_EditCol_show                   (GtkWidget       *widget,
                                        gpointer         user_data);

gboolean EdtCol_Code_key_press_event   (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

void EdtCol_BtClose_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void EdtCol_BtCol_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void on_EdtColBtAjouter_clicked        (GtkButton       *button,
                                        gpointer         user_data);

void on_EdtColBtModifier_clicked       (GtkButton       *button,
                                        gpointer         user_data);

void on_EdtColBtSupp_clicked           (GtkButton       *button,
                                        gpointer         user_data);

static gint on_EdtColBtOpt_clicked(GtkWidget *button,GdkEvent *event);
void EdtCol_InitButtons(gboolean Sensitive);

/**********************************************************************/
void EdtCol_InitButtons(gboolean Sensitive)
{
  GtkWidget *Widget;

  Widget=lookup_widget(GTK_WIDGET (Collectifs),"EdtCol_BtPrec");
  gtk_widget_set_sensitive(Widget,Sensitive);
  Widget=lookup_widget(GTK_WIDGET (Collectifs),"EdtCol_BtSuiv");
  gtk_widget_set_sensitive(Widget,Sensitive);
  Widget=lookup_widget(GTK_WIDGET (Collectifs),"EdtCol_BtCol");
  gtk_widget_set_sensitive(Widget,Sensitive);
  Widget=lookup_widget(GTK_WIDGET (Collectifs),"EdtColBtModifier");
  gtk_widget_set_sensitive(Widget,Sensitive);
  Widget=lookup_widget(GTK_WIDGET (Collectifs),"EdtColBtSupp");
  gtk_widget_set_sensitive(Widget,Sensitive);
}

void EdtCol_DispData(void)
{
  char SqlCmd[250],PsCle[LEN_COD_SOC+1],ColCle[9],Tmp[25];
  char *ColTfe[]={"S","D","R","*"};
  char *ColLp[]={"L","P","N","*"};
	char DebExercice[12],FinExercice[12];
  MYSQL_RES *Result;
  MYSQL_ROW Row;
  int Valid;
  GtkWidget *Stat;
  double a,b,c;

  GetSocRun(PsCle);
  if (EdtColRes==NULL) {
    Valid=FALSE;
    MysqlPtr=0;
    sprintf(SqlCmd,"Select * From Col Where ColSoc='%s'",PsCle);
    if (!mysql_query(DbLcpt,SqlCmd)) {
      EdtColRes=mysql_store_result(DbLcpt);
      if (EdtColRes)  if (mysql_num_rows(EdtColRes)!=0) Valid=TRUE;
    }
  } else Valid=TRUE;
  EdtCol_InitButtons(Valid);
  if (Valid) {
    Row=mysql_fetch_row(EdtColRes);
    StrSqlToGtk(GTK_WIDGET (Collectifs),"ColCode",Row[1]);
    strcpy(ColCle,Row[1]);
    BooleanSqlToGtk(GTK_WIDGET (Collectifs),"ColCpt",Row[2]);
    StrSqlToGtk(GTK_WIDGET (Collectifs),"ColLib",Row[3]);
    IDToLib(Tmp,TypID,TypLib,MAX_TYPE,Row[4]);
    ComboSqlToGtk(GTK_WIDGET (Collectifs),"ColTyp",Tmp);
    RadioSqlToGtk(GTK_WIDGET (Collectifs),"RdColTfe",Row[5],ColTfe);
    RadioSqlToGtk(GTK_WIDGET (Collectifs),"RdColLp",Row[6],ColLp);
    BooleanSqlToGtk(GTK_WIDGET (Collectifs),"ColCent",Row[7]);
    Stat=lookup_widget(GTK_WIDGET (Collectifs),"ListStat");
    /* Ligne 1 */
    if (Row[8]!=NULL) a=atof(Row[8]);else a=0;
    sprintf(Tmp,"%8.2f",a);
    gtk_clist_set_text(GTK_CLIST (Stat),0,0,Tmp);
    if (Row[9]!=NULL) b=atof(Row[9]);else b=0;
    sprintf(Tmp,"%8.2f",b);
    gtk_clist_set_text(GTK_CLIST (Stat),0,1,Tmp);
    c=a-b;
    sprintf(Tmp,"%8.2f",c);
    gtk_clist_set_text(GTK_CLIST (Stat),0,2,Tmp);
    /* Ligne 2 */
    if (Row[10]!=NULL) a=atof(Row[10]);else a=0;
    sprintf(Tmp,"%8.2f",a);
    gtk_clist_set_text(GTK_CLIST (Stat),1,0,Tmp);
    if (Row[11]!=NULL) b=atof(Row[11]);else b=0;
    sprintf(Tmp,"%8.2f",b);
    gtk_clist_set_text(GTK_CLIST (Stat),1,1,Tmp);
    sprintf(Tmp,"%8.2f",a-b);
    gtk_clist_set_text(GTK_CLIST (Stat),1,2,Tmp);
    if ((a!=0) || (b!=0)) {
      if (c!=0) c=(a-b)/c; else c=1;
      if (c>=1) c=(c-1)*100; else c=(100-(c*100))*-1;
      if (c==0) c=100;
      sprintf(Tmp,"%-3.2f%%",c);
      gtk_clist_set_text(GTK_CLIST (Stat),1,3,Tmp);
    }
    c=a-b;
    /* Ligne 3 */
    GetDateExercice(DebExercice,FinExercice,PsCle);
    sprintf(SqlCmd,"Select Sum(EcrDebit),Sum(EcrCredit) from Ecrit where EcrSoc='%s' And EcrCol='%s' And EcrDate Between '%s' And '%s'",PsCle,ColCle,DebExercice,FinExercice);
    if (mysql_query(DbLcpt,SqlCmd)==0) {
      Result=mysql_store_result(DbLcpt);
      if (Result) {
	Stat=lookup_widget(GTK_WIDGET (Collectifs),"ListStat");
	a=0;
	b=0;
	if (mysql_num_rows(Result)!=0) {
	  Row=mysql_fetch_row(Result);
	  if (Row[0]!=NULL) a=atof(Row[0]);
	  if (Row[1]!=NULL) b= atof(Row[1]);
	}
	sprintf(Tmp,"%8.2f",a);
	gtk_clist_set_text(GTK_CLIST (Stat),2,0,Tmp);
	sprintf(Tmp,"%8.2f",b);
	gtk_clist_set_text(GTK_CLIST (Stat),2,1,Tmp);
	sprintf(Tmp,"%8.2f",a-b);
	gtk_clist_set_text(GTK_CLIST (Stat),2,2,Tmp);
	if ((a!=0) || (b!=0)) {
	  if (c!=0) c=(a-b)/c;else c=1;
	  if (c>=1) c=(c-1)*100; else c=(100-(c*100))*-1;
	  if (c==0) c=100;
	  sprintf(Tmp,"%-3.2f%%",c);
	  gtk_clist_set_text(GTK_CLIST (Stat),2,3,Tmp);
	}
	c=a-b;
	mysql_free_result(Result);
      } else MessageInfo("Rsultat SQL NULL !");
    }
    /* Ligne 4 */
    sprintf(SqlCmd,"Select Sum(EcrDebit),Sum(EcrCredit) from Ecrit where EcrSoc='%s' And EcrCol='%s' And EcrDate >'%s'",PsCle,ColCle,FinExercice);
    if (mysql_query(DbLcpt,SqlCmd)==0) {
      Result=mysql_store_result(DbLcpt);
      if (Result) {
	Stat=lookup_widget(GTK_WIDGET (Collectifs),"ListStat");
	a=0;
	b=0;
	if (mysql_num_rows(Result)!=0) {
	  Row=mysql_fetch_row(Result);
	  if (Row[0]!=NULL) a=atof(Row[0]);
	  if (Row[1]!=NULL) b= atof(Row[1]);
	}
	sprintf(Tmp,"%8.2f",a);
	gtk_clist_set_text(GTK_CLIST (Stat),3,0,Tmp);
	sprintf(Tmp,"%8.2f",b);
	gtk_clist_set_text(GTK_CLIST (Stat),3,1,Tmp);
	sprintf(Tmp,"%8.2f",a-b);
	gtk_clist_set_text(GTK_CLIST (Stat),3,2,Tmp);
	if ((a!=0) || (b!=0)) {
	  if (c!=0) c=(a-b)/c;else c=1;
	  if (c>=1) c=(c-1)*100; else c=(100-(c*100))*-1;
	  if (c==0) c=100;
	  sprintf(Tmp,"%-3.2f%%",c);
	  gtk_clist_set_text(GTK_CLIST (Stat),3,3,Tmp);
	}
	mysql_free_result(Result);
      } else MessageInfo("Rsultat SQL NULL !");
    } else MessageInfo("Echec SQL !");
  }
}

void
on_EditCol_show                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
  GtkCList *CList;
  gchar *Bidon[4]={" "," "," "," "};

  OpenDbLcpt();
  CList=GTK_CLIST (lookup_widget(GTK_WIDGET (widget),"ListStat"));
  if (CList!=NULL) {
    gtk_clist_set_column_justification(CList,0,GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification(CList,1,GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification(CList,2,GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification(CList,3,GTK_JUSTIFY_RIGHT);
    gtk_clist_append(CList,Bidon);
    gtk_clist_append(CList,Bidon);
    gtk_clist_append(CList,Bidon);
 gtk_clist_append(CList,Bidon);
  }
}


void
on_EditCol_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{
  if (DbLcpt!=NULL) CloseDbLcpt();
  if (EdtColRes!=NULL) mysql_free_result(EdtColRes);
}

void
on_EdtCol_BtPrec_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  if (MysqlPtr>0) {
    MysqlPtr--;
    mysql_data_seek(EdtColRes,MysqlPtr);
    EdtCol_DispData();
  }
}


void on_EdtCol_BtSuiv_clicked(GtkButton *button,gpointer user_data)
{
  if (MysqlPtr<mysql_num_rows(EdtColRes)-1) {
    EdtCol_DispData();
    MysqlPtr++;
  }
}

gboolean EdtCol_Code_key_press_event(GtkWidget *widget,GdkEventKey *event,gpointer user_data)
{
  char ColCode[9];
  my_ulonglong Loc;

  if (event->type==GDK_KEY_PRESS) {
    if ((event->keyval==GDK_Return) || (event->keyval==GDK_KP_Enter)) {
      strcpy(ColCode,gtk_entry_get_text(GTK_ENTRY (widget)));
      while (strlen(ColCode)<4) strcat(ColCode,"0");
      gtk_entry_set_text(GTK_ENTRY (widget),ColCode);
      if ((Loc=SearchCode(EdtColRes,ColCode,1))==-1) MessageAlerte("Code inexistant !");else MysqlPtr=Loc;
      EdtCol_DispData();
    }
  }
  return FALSE;
}

void on_EdtColBtAjouter_clicked(GtkButton *button,gpointer user_data)
{
  gchar PsCle[LEN_COD_SOC+1],ColCode[5],SqlCmd[500],*End,Tmp[25],Cde[3];
  char *ColTfe[]={"S","D","R","*"};
  char *ColLp[]={"L","P","N","*"};
  GtkWidget *CoWdg,*Combo,*Entry;

  GetSocRun(PsCle);
  CoWdg=lookup_widget(GTK_WIDGET (button),"ColCode");
  strcpy(ColCode,gtk_entry_get_text(GTK_ENTRY (CoWdg)));
  End=strmov(SqlCmd,"Insert Into Col (ColSoc,ColCode,ColCpt,ColLib,ColTyp,ColTfe,ColLp,ColCent) Values ('");
  End=strmov(End,PsCle);
  *End++='\'';
  *End++=',';
  *End++='\'';
  End=strmov(End,ColCode);
  *End++='\'';
  *End++=',';
  End=GtkToBooleanSql(End,GTK_WIDGET (button),"ColCpt");
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"ColLib");
  *End++=',';
  /***/
  Combo=lookup_widget(GTK_WIDGET (button),"ColTyp");
  if (Combo!=NULL) {
    Entry=GTK_COMBO (Combo)->entry;
    strcpy(Tmp,gtk_entry_get_text(GTK_ENTRY(Entry)));
  }
  *End++='\'';
  LibToID(Cde,TypLib,TypID,MAX_TYPE,Tmp);
  End=strmov(End,Cde);
  *End++='\'';
  *End++=',';
  End=GtkToRadioSql(End,GTK_WIDGET (button),"RdColTfe",ColTfe);
  *End++=',';
  End=GtkToRadioSql(End,GTK_WIDGET (button),"RdColLp",ColLp);
  *End++=',';
  End=GtkToBooleanSql(End,GTK_WIDGET (button),"ColCent");
  *End++=')';
  *End='\0';
  g_print("%s",SqlCmd);
  if (mysql_query(DbLcpt,SqlCmd)!=0) MessageAlerte("Insertion Collectif impossible !");
  mysql_free_result(EdtColRes);
  EdtColRes=NULL;
  EdtCol_DispData();
  MysqlPtr=SearchCode(EdtColRes,ColCode,1);
  EdtCol_DispData();
}

void on_EdtColBtModifier_clicked(GtkButton *button,gpointer user_data)
{
  gchar PsCle[LEN_COD_SOC+1],ColCode[5],SqlCmd[500],*End,Tmp[25],Cde[3];
  char *ColTfe[]={"S","D","R","*"};
  char *ColLp[]={"L","P","N","*"};
  GtkWidget *CoWdg,*Combo,*Entry;

  GetSocRun(PsCle);
  CoWdg=lookup_widget(GTK_WIDGET (button),"ColCode");
  strcpy(ColCode,gtk_entry_get_text(GTK_ENTRY (CoWdg)));
  End=strmov(SqlCmd,"Update Col Set ColLib=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"ColLib");
  End=strmov(End,",ColCpt=");
  End=GtkToBooleanSql(End,GTK_WIDGET (button),"ColCpt");
  End=strmov(End,",ColTyp=");
  /***/
  Combo=lookup_widget(GTK_WIDGET (button),"ColTyp");
  if (Combo!=NULL) {
    Entry=GTK_COMBO (Combo)->entry;
    strcpy(Tmp,gtk_entry_get_text(GTK_ENTRY(Entry)));
  }
  *End++='\'';
  LibToID(Cde,TypLib,TypID,MAX_TYPE,Tmp);
  End=strmov(End,Cde);
  *End++='\'';
  End=strmov(End,",ColTfe=");
  End=GtkToRadioSql(End,GTK_WIDGET (button),"RdColTfe",ColTfe);
  End=strmov(End,",ColLp=");
  End=GtkToRadioSql(End,GTK_WIDGET (button),"RdColLp",ColLp);
  End=strmov(End,",ColCent=");
  End=GtkToBooleanSql(End,GTK_WIDGET (button),"ColCent");
  End=strmov(End," Where ColCode='");
  End=strmov(End,ColCode);
  End=strmov(End,"' And ColSoc='");
  End=strmov(End,PsCle);
  *End++='\'';
  *End='\0';
  g_print("%s",SqlCmd);
  if (mysql_query(DbLcpt,SqlCmd)!=0) MessageInfo("Modification collectif impossible !");
  mysql_free_result(EdtColRes);
  EdtColRes=NULL;
  EdtCol_DispData();
  MysqlPtr=SearchCode(EdtColRes,ColCode,1);
  EdtCol_DispData();
}

void on_EdtColBtSupp_clicked(GtkButton       *button,gpointer         user_data)
{
  GtkWidget *Entry;
  gchar SqlCmd[120],ColCode[9],Soc[LEN_COD_SOC+1];
  MYSQL_ROW Row;

  if (MsgQuestion("Supprimer ce collectif ?")==1) {
    Entry=lookup_widget(GTK_WIDGET (button),"ColCode");
    if (Entry!=NULL) {
      GetSocRun(Soc);
      strcpy(ColCode,gtk_entry_get_text(GTK_ENTRY (Entry)));
      sprintf(SqlCmd,"Delete from Col Where ColSoc='%s' And ColCode='%s'",Soc,ColCode);
      if (mysql_query(DbLcpt,SqlCmd)==0) {
	if (MysqlPtr==mysql_num_rows(EdtColRes)-1) {
	  MysqlPtr--;
	  mysql_data_seek(EdtColRes,MysqlPtr);
	}
	Row=mysql_fetch_row(EdtColRes);
	strcpy(ColCode,Row[1]);
	mysql_free_result(EdtColRes);
	EdtColRes=NULL;
	EdtCol_DispData();
	MysqlPtr=SearchCode(EdtColRes,ColCode,1);
	EdtCol_DispData();
      } else MessageErreur("Echec SQL");
    }
  }
}

static gint on_EdtColBtOpt_clicked(GtkWidget *button,GdkEvent *event)
{
	 GdkEventButton *bevent;
	 
	bevent= (GdkEventButton *) event;
  return FALSE;
}

void EdtCol_BtClose_clicked(GtkButton *button,gpointer user_data)
{
  GtkWidget *Wcall;

  Wcall=lookup_widget(GTK_WIDGET (button),"EditCol");
  gtk_widget_destroy(GTK_WIDGET(Wcall));
}


void EdtCol_BtCol_clicked(GtkButton *button,gpointer user_data)
{
  GtkEntry *Entry;
  gchar ColRet[5];

  Entry=GTK_ENTRY (lookup_widget(GTK_WIDGET (button),"ColCode"));
  if (Entry!=NULL) {
    if (ListSelect(ColRet,"Col","ColSoc","ColCode","ColLib",NULL)==MR_OK) {
      gtk_entry_set_text(GTK_ENTRY (Entry),ColRet);
      MysqlPtr=SearchCode(EdtColRes,ColRet,1);
      EdtCol_DispData();
    }
  }
}

GtkWidget* create_EditCol (void)
{
  GtkWidget *EditCol;
  GtkWidget *vbox7;
  GtkWidget *fixed4;
  GtkWidget *ColCode;
  GtkWidget *ColLib;
  GtkWidget *label57;
  GtkWidget *label55;
  GSList *CoTfe_group = NULL;
  GtkWidget *radiobutton10;
  GtkWidget *radiobutton11;
  GtkWidget *label58;
  GSList *ColLp_group = NULL;
  GtkWidget *radiobutton13;
  GtkWidget *radiobutton14;
  GtkWidget *ListStat;
  GtkWidget *label60;
  GtkWidget *label61;
  GtkWidget *label62;
  GtkWidget *label63;
  GtkWidget *label64;
  GtkWidget *label65;
  GtkWidget *label66;
  GtkWidget *label67;
  GtkWidget *EdtCol_BtPrec;
  GtkWidget *EdtCol_BtSuiv;
  GtkWidget *hseparator8;
  GtkWidget *hseparator9;
  GtkWidget *label59;
  GtkWidget *RdColTfe;
  GtkWidget *EdtCol_BtCol;
  GtkWidget *label56;
  GtkWidget *RdColLp;
  GtkWidget *ColTyp;
  GList *ColTyp_items = NULL;
  GtkWidget *combo_entry2;
  GtkWidget *ColCent;
  GtkWidget *ColCpt;
  GtkWidget *hbox7;
  GtkWidget *EdtColBtAjouter;
  GtkWidget *EdtColBtModifier;
  GtkWidget *EdtColBtSupp;
  GtkWidget *EdtColBtOpt;
  GtkWidget *EdtColBtClose;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  EditCol = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (EditCol), "EditCol", EditCol);
  gtk_window_set_title (GTK_WINDOW (EditCol), _("Collectifs"));
  gtk_window_set_position (GTK_WINDOW (EditCol), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (EditCol), FALSE, FALSE, FALSE);

  vbox7 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox7);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "vbox7", vbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox7);
  gtk_container_add (GTK_CONTAINER (EditCol), vbox7);

  fixed4 = gtk_fixed_new ();
  gtk_widget_ref (fixed4);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "fixed4", fixed4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed4);
  gtk_box_pack_start (GTK_BOX (vbox7), fixed4, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (fixed4), 5);

  ColCode = gtk_entry_new ();
  gtk_widget_ref (ColCode);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "ColCode", ColCode,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ColCode);
  gtk_fixed_put (GTK_FIXED (fixed4), ColCode, 68, 16);
  gtk_widget_set_uposition (ColCode, 68, 16);
  gtk_widget_set_usize (ColCode, 48, 20);

  ColLib = gtk_entry_new ();
  gtk_widget_ref (ColLib);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "ColLib", ColLib,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ColLib);
  gtk_fixed_put (GTK_FIXED (fixed4), ColLib, 172, 16);
  gtk_widget_set_uposition (ColLib, 172, 16);
  gtk_widget_set_usize (ColLib, 212, 20);

  label57 = gtk_label_new (_("Type de collectif :"));
  gtk_widget_ref (label57);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "label57", label57,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label57);
  gtk_fixed_put (GTK_FIXED (fixed4), label57, 24, 48);
  gtk_widget_set_uposition (label57, 24, 48);
  gtk_widget_set_usize (label57, 108, 16);
  gtk_label_set_justify (GTK_LABEL (label57), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label57), 0, 0.5);

  label55 = gtk_label_new (_("Code :"));
  gtk_widget_ref (label55);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "label55", label55,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label55);
  gtk_fixed_put (GTK_FIXED (fixed4), label55, 24, 20);
  gtk_widget_set_uposition (label55, 24, 20);
  gtk_widget_set_usize (label55, 41, 16);
  gtk_label_set_justify (GTK_LABEL (label55), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label55), 0, 0.5);

  radiobutton10 = gtk_radio_button_new_with_label (CoTfe_group, _("Dtail"));
  CoTfe_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton10));
  gtk_widget_ref (radiobutton10);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "radiobutton10", radiobutton10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton10);
  gtk_fixed_put (GTK_FIXED (fixed4), radiobutton10, 188, 92);
  gtk_widget_set_uposition (radiobutton10, 188, 92);
  gtk_widget_set_usize (radiobutton10, 64, 24);

  radiobutton11 = gtk_radio_button_new_with_label (CoTfe_group, _("Rsultat"));
  CoTfe_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton11));
  gtk_widget_ref (radiobutton11);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "radiobutton11", radiobutton11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton11);
  gtk_fixed_put (GTK_FIXED (fixed4), radiobutton11, 188, 108);
  gtk_widget_set_uposition (radiobutton11, 188, 108);
  gtk_widget_set_usize (radiobutton11, 72, 24);

  label58 = gtk_label_new (_("Traitement en fin d'exercice :"));
  gtk_widget_ref (label58);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "label58", label58,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label58);
  gtk_fixed_put (GTK_FIXED (fixed4), label58, 20, 80);
  gtk_widget_set_uposition (label58, 20, 80);
  gtk_widget_set_usize (label58, 172, 16);
  gtk_label_set_justify (GTK_LABEL (label58), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label58), 0, 0.5);

  radiobutton13 = gtk_radio_button_new_with_label (ColLp_group, _("Pointage"));
  ColLp_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton13));
  gtk_widget_ref (radiobutton13);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "radiobutton13", radiobutton13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton13);
  gtk_fixed_put (GTK_FIXED (fixed4), radiobutton13, 308, 92);
  gtk_widget_set_uposition (radiobutton13, 308, 92);
  gtk_widget_set_usize (radiobutton13, 76, 24);

  radiobutton14 = gtk_radio_button_new_with_label (ColLp_group, _("Non"));
  ColLp_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton14));
  gtk_widget_ref (radiobutton14);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "radiobutton14", radiobutton14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton14);
  gtk_fixed_put (GTK_FIXED (fixed4), radiobutton14, 308, 108);
  gtk_widget_set_uposition (radiobutton14, 308, 108);
  gtk_widget_set_usize (radiobutton14, 100, 24);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton14), TRUE);

  ListStat = gtk_clist_new (4);
  gtk_widget_ref (ListStat);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "ListStat", ListStat,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ListStat);
  gtk_fixed_put (GTK_FIXED (fixed4), ListStat, 76, 160);
  gtk_widget_set_uposition (ListStat, 76, 160);
  gtk_widget_set_usize (ListStat, 356, 88);
  gtk_clist_set_column_width (GTK_CLIST (ListStat), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (ListStat), 1, 80);
  gtk_clist_set_column_width (GTK_CLIST (ListStat), 2, 80);
  gtk_clist_set_column_width (GTK_CLIST (ListStat), 3, 80);
  gtk_clist_column_titles_show (GTK_CLIST (ListStat));

  label60 = gtk_label_new (_("Dbit"));
  gtk_widget_ref (label60);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "label60", label60,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label60);
  gtk_clist_set_column_widget (GTK_CLIST (ListStat), 0, label60);

  label61 = gtk_label_new (_("Crdit"));
  gtk_widget_ref (label61);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "label61", label61,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label61);
  gtk_clist_set_column_widget (GTK_CLIST (ListStat), 1, label61);

  label62 = gtk_label_new (_("Solde"));
  gtk_widget_ref (label62);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "label62", label62,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label62);
  gtk_clist_set_column_widget (GTK_CLIST (ListStat), 2, label62);

  label63 = gtk_label_new (_("Evolution"));
  gtk_widget_ref (label63);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "label63", label63,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label63);
  gtk_clist_set_column_widget (GTK_CLIST (ListStat), 3, label63);

  label64 = gtk_label_new (_("N-2"));
  gtk_widget_ref (label64);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "label64", label64,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label64);
  gtk_fixed_put (GTK_FIXED (fixed4), label64, 32, 184);
  gtk_widget_set_uposition (label64, 32, 184);
  gtk_widget_set_usize (label64, 41, 16);

  label65 = gtk_label_new (_("N-1"));
  gtk_widget_ref (label65);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "label65", label65,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label65);
  gtk_fixed_put (GTK_FIXED (fixed4), label65, 32, 200);
  gtk_widget_set_uposition (label65, 32, 200);
  gtk_widget_set_usize (label65, 41, 16);

  label66 = gtk_label_new (_("N"));
  gtk_widget_ref (label66);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "label66", label66,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label66);
  gtk_fixed_put (GTK_FIXED (fixed4), label66, 32, 216);
  gtk_widget_set_uposition (label66, 32, 216);
  gtk_widget_set_usize (label66, 41, 16);

  label67 = gtk_label_new (_("N+1"));
  gtk_widget_ref (label67);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "label67", label67,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label67);
  gtk_fixed_put (GTK_FIXED (fixed4), label67, 32, 232);
  gtk_widget_set_uposition (label67, 32, 232);
  gtk_widget_set_usize (label67, 41, 16);

  EdtCol_BtPrec = gnome_stock_button (GNOME_STOCK_BUTTON_PREV);
  gtk_widget_ref (EdtCol_BtPrec);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "EdtCol_BtPrec", EdtCol_BtPrec,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtCol_BtPrec);
  gtk_fixed_put (GTK_FIXED (fixed4), EdtCol_BtPrec, 12, 264);
  gtk_widget_set_uposition (EdtCol_BtPrec, 12, 264);
  gtk_widget_set_usize (EdtCol_BtPrec, 84, 16);
  gtk_widget_add_accelerator (EdtCol_BtPrec, "clicked", accel_group,
                              GDK_Page_Up, 0,
                              GTK_ACCEL_VISIBLE);

  EdtCol_BtSuiv = gnome_stock_button (GNOME_STOCK_BUTTON_NEXT);
  gtk_widget_ref (EdtCol_BtSuiv);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "EdtCol_BtSuiv", EdtCol_BtSuiv,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtCol_BtSuiv);
  gtk_fixed_put (GTK_FIXED (fixed4), EdtCol_BtSuiv, 100, 264);
  gtk_widget_set_uposition (EdtCol_BtSuiv, 100, 264);
  gtk_widget_set_usize (EdtCol_BtSuiv, 88, 16);
  gtk_widget_add_accelerator (EdtCol_BtSuiv, "clicked", accel_group,
                              GDK_Page_Down, 0,
                              GTK_ACCEL_VISIBLE);

  hseparator8 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator8);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "hseparator8", hseparator8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator8);
  gtk_fixed_put (GTK_FIXED (fixed4), hseparator8, 8, 248);
  gtk_widget_set_uposition (hseparator8, 8, 248);
  gtk_widget_set_usize (hseparator8, 456, 16);

  hseparator9 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator9);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "hseparator9", hseparator9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator9);
  gtk_fixed_put (GTK_FIXED (fixed4), hseparator9, 0, 144);
  gtk_widget_set_uposition (hseparator9, 0, 144);
  gtk_widget_set_usize (hseparator9, 464, 16);

  label59 = gtk_label_new (_("Type :"));
  gtk_widget_ref (label59);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "label59", label59,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label59);
  gtk_fixed_put (GTK_FIXED (fixed4), label59, 264, 80);
  gtk_widget_set_uposition (label59, 264, 80);
  gtk_widget_set_usize (label59, 41, 16);
  gtk_label_set_justify (GTK_LABEL (label59), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label59), 0, 0.5);

  RdColTfe = gtk_radio_button_new_with_label (CoTfe_group, _("Solde"));
  CoTfe_group = gtk_radio_button_group (GTK_RADIO_BUTTON (RdColTfe));
  gtk_widget_ref (RdColTfe);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "RdColTfe", RdColTfe,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RdColTfe);
  gtk_fixed_put (GTK_FIXED (fixed4), RdColTfe, 188, 76);
  gtk_widget_set_uposition (RdColTfe, 188, 76);
  gtk_widget_set_usize (RdColTfe, 60, 24);

  EdtCol_BtCol = gtk_button_new_with_label (_("Slection"));
  gtk_widget_ref (EdtCol_BtCol);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "EdtCol_BtCol", EdtCol_BtCol,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtCol_BtCol);
  gtk_fixed_put (GTK_FIXED (fixed4), EdtCol_BtCol, 392, 20);
  gtk_widget_set_uposition (EdtCol_BtCol, 392, 20);
  gtk_widget_set_usize (EdtCol_BtCol, 64, 16);
  gtk_widget_add_accelerator (EdtCol_BtCol, "clicked", accel_group,
                              GDK_F5, 0,
                              GTK_ACCEL_VISIBLE);

  label56 = gtk_label_new (_("Libell :"));
  gtk_widget_ref (label56);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "label56", label56,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label56);
  gtk_fixed_put (GTK_FIXED (fixed4), label56, 128, 20);
  gtk_widget_set_uposition (label56, 128, 20);
  gtk_widget_set_usize (label56, 52, 16);
  gtk_label_set_justify (GTK_LABEL (label56), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label56), 0, 0.5);

  RdColLp = gtk_radio_button_new_with_label (ColLp_group, _("Lettrage"));
  ColLp_group = gtk_radio_button_group (GTK_RADIO_BUTTON (RdColLp));
  gtk_widget_ref (RdColLp);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "RdColLp", RdColLp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RdColLp);
  gtk_fixed_put (GTK_FIXED (fixed4), RdColLp, 308, 76);
  gtk_widget_set_uposition (RdColLp, 308, 76);
  gtk_widget_set_usize (RdColLp, 72, 24);

  ColTyp = gtk_combo_new ();
  gtk_widget_ref (ColTyp);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "ColTyp", ColTyp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ColTyp);
  gtk_fixed_put (GTK_FIXED (fixed4), ColTyp, 128, 44);
  gtk_widget_set_uposition (ColTyp, 128, 44);
  gtk_widget_set_usize (ColTyp, 172, 20);
  gtk_combo_set_value_in_list (GTK_COMBO (ColTyp), TRUE, FALSE);
  ColTyp_items = g_list_append (ColTyp_items, (gpointer) _("Capitaux"));
  ColTyp_items = g_list_append (ColTyp_items, (gpointer) _("Immobilisations"));
  ColTyp_items = g_list_append (ColTyp_items, (gpointer) _("Amortissements"));
  ColTyp_items = g_list_append (ColTyp_items, (gpointer) _("Stocks"));
  ColTyp_items = g_list_append (ColTyp_items, (gpointer) _("Tiers"));
  ColTyp_items = g_list_append (ColTyp_items, (gpointer) _("Clients"));
  ColTyp_items = g_list_append (ColTyp_items, (gpointer) _("Fournisseurs"));
  ColTyp_items = g_list_append (ColTyp_items, (gpointer) _("Salaris"));
  ColTyp_items = g_list_append (ColTyp_items, (gpointer) _("Tresorerie"));
  ColTyp_items = g_list_append (ColTyp_items, (gpointer) _("Charges"));
  ColTyp_items = g_list_append (ColTyp_items, (gpointer) _("Produits"));
  gtk_combo_set_popdown_strings (GTK_COMBO (ColTyp), ColTyp_items);
  g_list_free (ColTyp_items);

  combo_entry2 = GTK_COMBO (ColTyp)->entry;
  gtk_widget_ref (combo_entry2);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "combo_entry2", combo_entry2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_entry2);

  ColCent = gtk_check_button_new_with_label (_("Centralis"));
  gtk_widget_ref (ColCent);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "ColCent", ColCent,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ColCent);
  gtk_fixed_put (GTK_FIXED (fixed4), ColCent, 16, 124);
  gtk_widget_set_uposition (ColCent, 16, 124);
  gtk_widget_set_usize (ColCent, 99, 24);

  ColCpt = gtk_check_button_new_with_label (_("Contient des comptes"));
  gtk_widget_ref (ColCpt);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "ColCpt", ColCpt,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ColCpt);
  gtk_fixed_put (GTK_FIXED (fixed4), ColCpt, 312, 44);
  gtk_widget_set_uposition (ColCpt, 312, 44);
  gtk_widget_set_usize (ColCpt, 152, 24);

  hbox7 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox7);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "hbox7", hbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox7);
  gtk_box_pack_start (GTK_BOX (vbox7), hbox7, FALSE, TRUE, 0);

  EdtColBtAjouter = gtk_button_new_with_label (_("Ajouter"));
  gtk_widget_ref (EdtColBtAjouter);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "EdtColBtAjouter", EdtColBtAjouter,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtColBtAjouter);
  gtk_box_pack_start (GTK_BOX (hbox7), EdtColBtAjouter, FALSE, FALSE, 0);

  EdtColBtModifier = gtk_button_new_with_label (_("Modifier"));
  gtk_widget_ref (EdtColBtModifier);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "EdtColBtModifier", EdtColBtModifier,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtColBtModifier);
  gtk_box_pack_start (GTK_BOX (hbox7), EdtColBtModifier, FALSE, FALSE, 0);

  EdtColBtSupp = gtk_button_new_with_label (_("Supprimer"));
  gtk_widget_ref (EdtColBtSupp);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "EdtColBtSupp", EdtColBtSupp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtColBtSupp);
  gtk_box_pack_start (GTK_BOX (hbox7), EdtColBtSupp, FALSE, FALSE, 0);

  EdtColBtOpt = gtk_button_new_with_label (_("Options"));
  gtk_widget_ref (EdtColBtOpt);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "EdtColBtOpt", EdtColBtOpt,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtColBtOpt);
  gtk_box_pack_start (GTK_BOX (hbox7), EdtColBtOpt, FALSE, FALSE, 0);

  EdtColBtClose = gnome_stock_button (GNOME_STOCK_BUTTON_CLOSE);
  gtk_widget_ref (EdtColBtClose);
  gtk_object_set_data_full (GTK_OBJECT (EditCol), "EdtColBtClose", EdtColBtClose,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtColBtClose);
  gtk_box_pack_start (GTK_BOX (hbox7), EdtColBtClose, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (EditCol), "destroy",
                      GTK_SIGNAL_FUNC (on_EditCol_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EditCol), "show",
                      GTK_SIGNAL_FUNC (on_EditCol_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ColCode), "key_press_event",
                      GTK_SIGNAL_FUNC (EdtCol_Code_key_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtCol_BtPrec), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtCol_BtPrec_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtCol_BtSuiv), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtCol_BtSuiv_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtCol_BtCol), "clicked",
                      GTK_SIGNAL_FUNC (EdtCol_BtCol_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtColBtAjouter), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtColBtAjouter_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtColBtModifier), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtColBtModifier_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtColBtSupp), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtColBtSupp_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtColBtOpt), "event",
                      GTK_SIGNAL_FUNC (on_EdtColBtOpt_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtColBtClose), "clicked",
                      GTK_SIGNAL_FUNC (EdtCol_BtClose_clicked),
                      NULL);

  gtk_window_add_accel_group (GTK_WINDOW (EditCol), accel_group);

  return EditCol;
}

void Dialog_EdtCol(void)
{
	Collectifs=create_EditCol();
	gtk_widget_show_all(Collectifs);
	EdtColRes=NULL;
	EdtCol_DispData();
}
