/*******************************************************************/
/* Comptabilit Analytique Professionnel                           */
/* 01/01/2002 - Version 0.3.4                                      */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 10/01/03 - Gestion des commentaires de comptes                  */
/* Fichier source                                                  */
/*******************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 


#include <gtk/gtk.h>
#include <gnome.h>
#include <string.h>
#include <ctype.h>
#include <mysql/mysql.h>
#include "support.h"
#include "common.h"
#include "gtksql.h"

#include "edtcom.h"

/* Variables *********************************************************/
GtkWidget    *Commentaires;
gchar	  		 CptUse[9];
int          ComExist;

/* Protos */
GtkWidget* create_EdtComm (void);
void on_EdtCom_BtApply_clicked(GtkButton *button,gpointer  user_data);
void EdtCom_Display(void);

/**********************************************************************/
void on_EdtCom_BtApply_clicked(GtkButton *button,gpointer  user_data)
{
	gchar SqlCmd[2048],PsCle[LEN_COD_SOC+1],*End,*Ptr;
	GtkWidget *Zt;
	
	GetSocRun(PsCle);
	Zt=lookup_widget(GTK_WIDGET (Commentaires),"ZComm");
	Ptr=gtk_editable_get_chars(GTK_EDITABLE (Zt),0,-1);
	if (Ptr!=NULL) {
		if (ComExist) {
			End=strmov(SqlCmd,"update Comment set CComment='");
			End+=mysql_escape_string(End,Ptr,strlen(Ptr));
			*End++='\'';
			End=strmov(End," Where CSoc='");
			End=strmov(End,PsCle);
			End=strmov(End,"' And CCpt='");
			End=strmov(End,CptUse);
			*End++='\'';
			*End=0;
		} else {
			sprintf(SqlCmd,"Insert into Comment (CSoc,CCpt,CComment) Values ('%s','%s','",PsCle,CptUse);
			End=SqlCmd+strlen(SqlCmd);
			End+=mysql_escape_string(End,Ptr,strlen(Ptr));
			*End++='\'';
			*End++=')';
			*End=0;
		}
		if (mysql_query(DbLcpt,SqlCmd)==0) gtk_widget_destroy(Commentaires);else MessageAlerte("Mise  jour commentaires impossible !");
	}
}

void EdtCom_Display(void)
{
	gchar SqlCmd[2048],PsCle[LEN_COD_SOC+1];
	MYSQL_RES *Res;
	MYSQL_ROW Row;
	GtkWidget *Zt;
	
	ComExist=FALSE;
	GetSocRun(PsCle);
	sprintf(SqlCmd,"Select CComment From Comment where CSoc='%s' and CCpt='%s'",PsCle,CptUse);
	if (mysql_query(DbLcpt,SqlCmd)==0) {
		Res=mysql_store_result(DbLcpt);
		if (mysql_num_rows(Res)!=0) {
			Row=mysql_fetch_row(Res);
			if (Row[0]!=NULL) {
				Zt=lookup_widget(GTK_WIDGET (Commentaires),"ZComm");
				gtk_text_insert(GTK_TEXT (Zt),NULL,NULL,NULL,Row[0],-1);
				ComExist=TRUE;
			}
		}
	}
}

GtkWidget* create_EdtComm (void)
{
  GtkWidget *EdtComm;
  GtkWidget *DivHorizontal;
  GtkWidget *scrolledwindow1;
  GtkWidget *ZComm;
  GtkWidget *DivisionBoutons;
  GtkWidget *EdtCom_BtApply;
  GtkWidget *EdtCom_BtClose;
	gchar      Title[60];

  EdtComm = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_modal(GTK_WINDOW (EdtComm),TRUE);
	gtk_window_set_default_size(GTK_WINDOW (EdtComm),600,250);
  gtk_object_set_data (GTK_OBJECT (EdtComm), "EdtComm", EdtComm);
	sprintf(Title,_("Commentaires du compte %s"),CptUse);
  gtk_window_set_title (GTK_WINDOW (EdtComm), Title);

  DivHorizontal = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (DivHorizontal);
  gtk_object_set_data_full (GTK_OBJECT (EdtComm), "DivHorizontal", DivHorizontal,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (DivHorizontal);
  gtk_container_add (GTK_CONTAINER (EdtComm), DivHorizontal);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (EdtComm), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (DivHorizontal), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  ZComm = gtk_text_new (NULL, NULL);
	gtk_text_set_editable(GTK_TEXT (ZComm),TRUE);
  gtk_widget_ref (ZComm);
  gtk_object_set_data_full (GTK_OBJECT (EdtComm), "ZComm", ZComm,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ZComm);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), ZComm);

  DivisionBoutons = gtk_hbox_new (FALSE, 3);
  gtk_widget_ref (DivisionBoutons);
  gtk_object_set_data_full (GTK_OBJECT (EdtComm), "DivisionBoutons", DivisionBoutons,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (DivisionBoutons);
  gtk_box_pack_start (GTK_BOX (DivHorizontal), DivisionBoutons, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (DivisionBoutons), 3);

  EdtCom_BtApply = gnome_stock_button (GNOME_STOCK_BUTTON_APPLY);
  gtk_widget_ref (EdtCom_BtApply);
  gtk_object_set_data_full (GTK_OBJECT (EdtComm), "EdtCom_BtApply", EdtCom_BtApply,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtCom_BtApply);
  gtk_box_pack_start (GTK_BOX (DivisionBoutons), EdtCom_BtApply, FALSE, FALSE, 0);

  EdtCom_BtClose = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (EdtCom_BtClose);
  gtk_object_set_data_full (GTK_OBJECT (EdtComm), "EdtCom_BtClose", EdtCom_BtClose,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtCom_BtClose);
  gtk_box_pack_start (GTK_BOX (DivisionBoutons), EdtCom_BtClose, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (EdtCom_BtApply), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtCom_BtApply_clicked),
                      NULL);
  gtk_signal_connect_object (GTK_OBJECT (EdtCom_BtClose), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (EdtComm));

  return EdtComm;
}

void Dialog_EdtComm(char *Cpt)
{
	strcpy(CptUse,Cpt);
	Commentaires=create_EdtComm();
	gtk_widget_show_all(Commentaires);
	EdtCom_Display();
}
