/*******************************************************************/
/* Comptabilit Analytique Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 22/03/02 - Edition des critures                                */
/* Fichier source                                                  */
/*******************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 


#include <gtk/gtk.h>
#include <gnome.h>
#include <string.h>
#include <ctype.h>
#include <mysql/mysql.h>
#include "support.h"
#include "common.h"
#include "gtksql.h"
#include "select.h"
#include "lcpt_tab.h"
#include "search.h"

#include "edtcpt.h"

/* Variables */
GtkWidget    *Edition;
my_ulonglong MysqlPtr;
MYSQL_RES    *EdtJrnRes,*ResultLoc;
MYSQL_ROW    RowLocate;
gchar        PieceEnCours[11],Journal[3],JrnTyp[3];
/* Protos */
GtkWidget* create_EdtCompta (void);
void EdtCpt_DispData(void);
void on_EdtCompta_show                 (GtkWidget       *widget,
                                        gpointer         user_data);
void on_EdtCpt_BtSel_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void on_EdtCpt_BtSuiv_clicked          (GtkButton       *button,
                                        gpointer         user_data);

void on_EdtCpt_BtPrec_clicked          (GtkButton       *button,
                                        gpointer         user_data);

void on_EdtCompta_destroy              (GtkObject       *object,
                                        gpointer         user_data);
void EdtCpt_lcpt_ecart(LcptTab *LTab,gint NewPiece,gfloat ecart);
gboolean EdtCpt_lcpt_change_column(LcptTab *LTab,gint Column);
gboolean EdtCpt_lcpt_change_row(LcptTab *LTab);
gboolean EdtCpt_lcpt_change_row_after(LcptTab *LTab);
gboolean EdtCpt_lcpt_insert(LcptTab *LTab);
gboolean EdtCpt_lcpt_change(LcptTab *LTab);
void EdtCpt_BtUndo_clicked(GtkButton *But,gpointer user_data);
void EdtCpt_BtSearch_clicked(GtkWidget *button,gpointer user_data);
double InfoLastEcrit(void);
void ControlCompte(LcptTab *LTab,gint Column);
gboolean ControleLib(LcptTab *LTab,gint column,gchar *str,gchar *Text);
void DeleteAccount(GtkButton *But,gpointer user_data);
void ValidRow(GtkButton *But,gpointer user_data);

/*********************************************************************/
void on_EdtCompta_show                 (GtkWidget       *widget,
                                        gpointer         user_data)
{
  GtkWidget *Area;

  OpenDbLcpt();
  Area=lookup_widget(widget,"EdtEcr");
  EdtJrnRes=NULL;
  ResultLoc=NULL;
  EdtCpt_DispData();
  InfoLastEcrit();
}

void EdtCpt_DispData(void)
{
  gchar SqlCmd[250],PsCle[LEN_COD_SOC+1],Tmp[50],Piece[11],JCode[3];
  MYSQL_RES *Result;
  MYSQL_ROW Row;
  my_ulonglong Loc;
  double D,C;
  gint Valid;
  GtkWidget *Area,*Label;

  GetSocRun(PsCle);
  Valid=TRUE;
  if (EdtJrnRes==NULL) {
    sprintf(SqlCmd,"Select * From Jrn Where JSoc='%s'",PsCle);
    if (mysql_query(DbLcpt,SqlCmd)==0) {
      EdtJrnRes=mysql_store_result(DbLcpt);
      MysqlPtr=0;
      if (*Journal) {
	if ((Loc=SearchCode(EdtJrnRes,Journal,1))!=-1) MysqlPtr=Loc;
      }
    } else Valid=FALSE;
  }
  Area=lookup_widget(GTK_WIDGET (Edition),"EdtEcr");
  Label=lookup_widget(GTK_WIDGET (Edition),"Info");
  gtk_label_set_text(GTK_LABEL (Label),"-");
  if (Valid) {
    Row=mysql_fetch_row(EdtJrnRes);
    StrSqlToGtk(GTK_WIDGET (Edition),"JCode",Row[1]);
    strcpy(Journal,Row[1]);
    StrSqlToGtk(GTK_WIDGET (Edition),"JLib",Row[2]);
    strcpy(JCode,Row[1]);
    strcpy(JrnTyp,Row[3]);
    sprintf(SqlCmd,"Select * From Ecrit Where EcrSoc='%s' And EcrJrn='%s' Order By EcrPiece",PsCle,JCode);
    if (!mysql_query(DbLcpt,SqlCmd)) {
      Result=mysql_store_result(DbLcpt);
      if (mysql_num_rows(Result)!=0) {
	lcpt_tab_row_delete_all(LCPT_TAB (Area));
	lcpt_tab_freeze(LCPT_TAB (Area));
	while ((Row=mysql_fetch_row(Result))) {
	  if (Row[19]!=NULL) D=atof(Row[19]);else D=0;
	  if (Row[20]!=NULL) C=atof(Row[20]);else C=0;
	  if (Row[3]!=NULL) IsoToDate(Tmp,Row[3]);else strcpy(Tmp,"Err");
	  if (Row[5]!=NULL) strcpy(Piece,Row[5]+2);else strcpy(Piece,"Err");
	  lcpt_tab_row_new(LCPT_TAB (Area),Row[1],Tmp,Row[9],Piece,Row[2],D,C);
	}
      }
      mysql_free_result(Result);
    }
    lcpt_tab_row_empty_new(LCPT_TAB (Area));
    lcpt_tab_thaw(LCPT_TAB (Area));
  };
  gtk_widget_show(GTK_WIDGET (Area));
}

void on_EdtCompta_destroy              (GtkObject       *object,
                                        gpointer         user_data)
{
  mysql_free_result(EdtJrnRes);
  if (ResultLoc) mysql_free_result(ResultLoc);
  CloseDbLcpt();
}


void on_EdtCpt_BtPrec_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  if (MysqlPtr>0) {
    MysqlPtr--;
    mysql_data_seek(EdtJrnRes,MysqlPtr);
    EdtCpt_DispData();
  }
}


void on_EdtCpt_BtSel_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkEntry *Entry;
  gchar CptRet[11],Tmp[11];

  Entry=GTK_ENTRY (lookup_widget(GTK_WIDGET (button),"JCode"));
  strcpy(Tmp,gtk_entry_get_text(GTK_ENTRY (Entry)));
  if (Entry!=NULL) {
    if (ListSelect(CptRet,"Jrn","JSoc","JCode","JLib",Tmp)==MR_OK) gtk_entry_set_text(GTK_ENTRY (Entry),CptRet);
  }
}


void on_EdtCpt_BtSuiv_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  if (MysqlPtr<mysql_num_rows(EdtJrnRes)-1) {
    EdtCpt_DispData();
    MysqlPtr++;
  }
}

/* Opration sur les enregistrments ********************************/
double InfoLastEcrit(void)
{
  gchar SqlCmd[120],PsCle[LEN_COD_SOC+1],MaxPiece[11];
  MYSQL_RES *Result;
  MYSQL_ROW Row;
  double Ecart;

  GetSocRun(PsCle);
  Ecart=0;
  sprintf(SqlCmd,"Select Count(*),Max(EcrPiece) From Ecrit Where EcrSoc='%s' And EcrJrn='%s'",PsCle,Journal);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    Result=mysql_use_result(DbLcpt);
    Row=mysql_fetch_row(Result);
    if (atol(Row[0]) > 0L) {
      strcpy(MaxPiece,Row[1]);
      mysql_free_result(Result);
      sprintf(SqlCmd,"select Sum(EcrDebit)-Sum(EcrCredit) From Ecrit Where EcrPiece='%s' And EcrSoc='%s'",MaxPiece,PsCle);
      if (mysql_query(DbLcpt,SqlCmd)==0) {
	Result=mysql_use_result(DbLcpt);
	Row=mysql_fetch_row(Result);
	Ecart=atof(Row[0]);
	mysql_free_result(Result);
      }
    } else mysql_free_result(Result);
  }
  if (Ecart!=0) strcpy(PieceEnCours,MaxPiece);else *PieceEnCours=0;
  return (Ecart);
}

gboolean EdtCpt_lcpt_change(LcptTab *LTab)
{
  gchar PsCle[LEN_COD_SOC+1],SqlCmd[500],EcrDate[11],*End;
  gchar EcrLib[31],EcrPiece[11],EcrCpt[11],EcrCode[11];
  gchar EcrCol[5],Tmp[15];
  double Deb,Cre;
  MYSQL_RES *Result;
  MYSQL_ROW Row;

  GetSocRun(PsCle);
  lcpt_tab_row_get_data(LTab,EcrCode,EcrDate,EcrLib,EcrPiece,EcrCpt,&Deb,&Cre);
  /* rcupre le N de collectif du compte */
  sprintf(SqlCmd,"Select CptCol From Comptes Where CptSoc='%s' And CptCode='%s'",PsCle,EcrCpt);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    Result=mysql_use_result(DbLcpt);
    if ((Row=mysql_fetch_row(Result))) strcpy(EcrCol,Row[0]);
    mysql_free_result(Result);
  } else *EcrCol='\0';
  /* on compose la commande Sql de modification */
  End=strmov(SqlCmd,"Update Ecrit Set EcrDate=");
  DateToIso(Tmp,EcrDate);
  End=StrSql(End,Tmp);
  End=strmov(End,",EcrLib=");
  End=StrSql(End,EcrLib);
  End=strmov(End,",EcrCpt=");
  End=StrSql(End,EcrCpt);
  End=strmov(End,",EcrCol=");
  End=StrSql(End,EcrCol);
  End=strmov(End,",EcrDebit=");
  sprintf(Tmp,"%-8.2f",Deb);
  End=NumSql(End,Tmp);
  End=strmov(End,",EcrCredit=");
  sprintf(Tmp,"%-8.2f",Cre);
  End=NumSql(End,Tmp);
  End=strmov(End," Where EcrSoc=");
  End=StrSql(End,PsCle);
  End=strmov(End," And EcrCode=");
  End=StrSql(End,EcrCode);
  if (mysql_query(DbLcpt,SqlCmd)!=0) MessageAlerte(_("Impossible de mettre  jour l'enregistrement !"));
  return TRUE;
}

gboolean EdtCpt_lcpt_insert(LcptTab *LTab)
{
  gchar PsCle[LEN_COD_SOC+1],SqlCmd[500],EcrDate[11],*End;
  gchar EcrLib[31],EcrPiece[11],EcrCpt[11],EcrCode[11];
  gchar EcrCol[5],Tmp[15];
  double Deb,Cre;
  int An,An2,MaxCpt,MaxPiece;
  MYSQL_RES *Result;
  MYSQL_ROW Row;

  GetSocRun(PsCle);
  lcpt_tab_row_get_data(LTab,EcrCode,EcrDate,EcrLib,EcrPiece,EcrCpt,&Deb,&Cre);
  An=GetYear(EcrDate);
  if (*EcrPiece) sprintf(PieceEnCours,"%02i%s",(An>2000) ? An-2000 : An-1900,EcrPiece);else *PieceEnCours=0;
  /* verouillage table */
  strcpy(SqlCmd,"Lock Tables CptCount Write,Comptes Write,Ecrit Write");
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    /* incrmentation des compteur */
    MaxCpt=0;
    MaxPiece=0;
    sprintf(SqlCmd,"Select CNum,CPiece From CptCount Where CSoc='%s' And CJrn='%s' And CAnnee=%i",PsCle,Journal,An);
    if (mysql_query(DbLcpt,SqlCmd)==0) {
      Result=mysql_store_result(DbLcpt);
      if (mysql_num_rows(Result)!=0) {
	if ((Row=mysql_fetch_row(Result))) {
	  MaxCpt=strval(Row[0]);
	  MaxPiece=strval(Row[1]);
	}
      } else {
	sprintf(SqlCmd,"Insert Into CptCount (CSoc,CJrn,CAnnee,CNum,CPiece) Values ('%s','%s',%i,0,0)",PsCle,Journal,An);
	if (mysql_query(DbLcpt,SqlCmd)!=0) MessageAlerte(_("Impossible d'initialiser le compteur de pice !"));
      }
      mysql_free_result(Result);
    }
    MaxCpt++;
    MaxPiece++;
    if (*PieceEnCours) sprintf(SqlCmd,"Update CptCount Set CNum=%i Where CSoc='%s' And CJrn='%s' And CAnnee=%i",MaxCpt,PsCle,Journal,An);
    else sprintf(SqlCmd,"Update CptCount Set CNum=%i,CPiece=%i Where CSoc='%s' And CJrn='%s' And CAnnee=%i",MaxCpt,MaxPiece,PsCle,Journal,An);
    if (mysql_query(DbLcpt,SqlCmd)==0) {
      if (An<2000) An2=An-1900;else An2=An-2000;
      sprintf(EcrCode,"%s%02i%06i",Journal,An2,MaxCpt);
      if (*PieceEnCours==0) {
	sprintf(PieceEnCours,"%4i%02i%04i",An,GetMonth(EcrDate),MaxPiece);
	strcpy(EcrPiece,PieceEnCours+2);
      } else strcpy(EcrPiece,PieceEnCours+2);
      /* rcupre le N de collectif du compte */
      sprintf(SqlCmd,"Select CptCol From Comptes Where CptSoc='%s' And CptCode='%s'",PsCle,EcrCpt);
      if (mysql_query(DbLcpt,SqlCmd)==0) {
	Result=mysql_use_result(DbLcpt);
	if ((Row=mysql_fetch_row(Result))) strcpy(EcrCol,Row[0]);
	mysql_free_result(Result);
      } else *EcrCol='\0';
      /* on compose la commande Sql d'ajout */
      End=strmov(SqlCmd,"Insert into Ecrit (EcrSoc,EcrCode,EcrCpt,EcrDate,EcrJrn,EcrPiece,EcrCol,EcrLib,EcrDebit,EcrCredit) Values (");
      End=StrSql(End,PsCle);
      *End++=',';
      End=StrSql(End,EcrCode);
      *End++=',';
      End=StrSql(End,EcrCpt);
      *End++=',';
      DateToIso(Tmp,EcrDate);
      End=StrSql(End,Tmp);
      *End++=',';
      End=StrSql(End,Journal);
      *End++=',';
      End=StrSql(End,EcrPiece);
      *End++=',';
      End=StrSql(End,EcrCol);
      *End++=',';
      End=StrSql(End,EcrLib);
      *End++=',';
      sprintf(Tmp,"%-8.2f",Deb);
      End=NumSql(End,Tmp);
      *End++=',';
      sprintf(Tmp,"%-8.2f",Cre);
      End=NumSql(End,Tmp);
      *End++=')';
      *End='\0';
      lcpt_tab_row_set_data(LTab,EcrCode,NULL,NULL,EcrPiece,NULL,NULL,NULL);
      lcpt_tab_row_empty_new(LTab);
      if (mysql_query(DbLcpt,SqlCmd)!=0) MessageAlerte(_("Impossible d'ajouter un enregistrement !"));
    } else MessageAlerte(_("Erreur sur compteur !"));
    /* dverouillage tables */
    strcpy(SqlCmd,"Unlock Tables");
    mysql_query(DbLcpt,SqlCmd);
  } else MessageAlerte(_("Vrouillage tables impossible !"));
  return TRUE;
}

void ControlCompte(LcptTab *LTab,gint Column)
{
  gchar Tmp[15],OrgCpt[15],PsCle[LEN_COD_SOC+1],Nom[60],SqlCmd[120],Collectif[5];
  GtkWidget *widget;
  MYSQL_RES *Result;
  MYSQL_ROW Row;

  lcpt_tab_row_get_data(LTab,NULL,NULL,NULL,NULL,Tmp,NULL,NULL);
  g_strup(Tmp);
  strcpy(OrgCpt,Tmp);
  if (isdigit(*Tmp)) while (strlen(Tmp)<8) strcat(Tmp,"0");
  lcpt_tab_row_set_data(LTab,NULL,NULL,NULL,NULL,Tmp,NULL,NULL);
  GetSocRun(PsCle);
  widget=lookup_widget(GTK_WIDGET (Edition),"Info");
  strcpy(Nom,"-");
  *Collectif=0;
  sprintf(SqlCmd,"Select CptLib,CptCol From Comptes Where CptSoc='%s' And CptCode='%s'",PsCle,Tmp);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    Result=mysql_store_result(DbLcpt);
    if (mysql_num_rows(Result)!=0) {
      Row=mysql_fetch_row(Result);
      if (Row[0]!=NULL) strcpy(Nom,Row[0]);
      if (Row[1]!=NULL) strcpy(Collectif,Row[1]);
    } else {
      if (ListSelect(Tmp,"Comptes","CptSoc","CptCode","CptLib",OrgCpt)==MR_OK) {
	lcpt_tab_row_set_data(LTab,NULL,NULL,NULL,NULL,Tmp,NULL,NULL);
	mysql_free_result(Result);
	sprintf(SqlCmd,"Select CptLib,CptCol From Comptes Where CptSoc='%s' And CptCode='%s'",PsCle,Tmp);
	if (mysql_query(DbLcpt,SqlCmd)==0) {
	  Result=mysql_store_result(DbLcpt);
	  if (mysql_num_rows(Result)!=0) {
	    Row=mysql_fetch_row(Result);
	    if (Row[0]!=NULL) strcpy(Nom,Row[0]);
	    if (Row[1]!=NULL) strcpy(Collectif,Row[1]);
	  }
	}
      }
      mysql_free_result(Result);
    }
  }
  if (Column>0) {
    if (*Collectif) {
      gtk_signal_handler_block_by_func(GTK_OBJECT (LTab),(GtkSignalFunc) EdtCpt_lcpt_change_column,NULL);
      if (strcmp(JrnTyp,"AC")==0) {
	if (strcmp(Collectif,"4010")==0) lcpt_tab_change_column(LTab,LCPT_TAB_COLUMN_CREDIT);
      } else {
	if (strcmp(JrnTyp,"VE")==0) {
	  if (strcmp(Collectif,"4110")==0) lcpt_tab_change_column(LTab,LCPT_TAB_COLUMN_CREDIT);
	} else {
	  if (strcmp(JrnTyp,"TR")==0) {
	    if ((strcmp(Collectif,"4010")==0) || (*Collectif=='6')) lcpt_tab_change_column(LTab,LCPT_TAB_COLUMN_DEBIT);
	    if ((strcmp(Collectif,"4110")==0) || (*Collectif=='7')) lcpt_tab_change_column(LTab,LCPT_TAB_COLUMN_CREDIT);
	  }
	}
      }
      gtk_signal_handler_unblock_by_func(GTK_OBJECT (LTab),(GtkSignalFunc) EdtCpt_lcpt_change_column,NULL);
    }
  }
  gtk_label_set_text(GTK_LABEL(widget),Nom);
}

gboolean ControleLib(LcptTab *LTab,gint column,gchar *str,gchar *Text)
{
  gchar SqlCmd[150],Tmp[61],PsCle[LEN_COD_SOC+1];
  MYSQL_RES *Result;
  MYSQL_ROW Row;
  gboolean Ok;

  Ok=TRUE;
  if (column==LCPT_TAB_COLUMN_LIBELLE) {
    strcpy(Tmp,Text);
    strcat(Tmp,str);
    g_strup(Tmp);
    if (strlen(Tmp)<=2) {
      GetSocRun(PsCle);
      sprintf(SqlCmd,"Select JLLib From JrnL Where JLSoc='%s' And JLJrn='%s' And JLCode='%s'",PsCle,Journal,Tmp);
      if (mysql_query(DbLcpt,SqlCmd)==0) {
	Result=mysql_store_result(DbLcpt);
	if (mysql_num_rows(Result)!=0) {
	  Row=mysql_fetch_row(Result);
	  if (Row[0]!=NULL) {
	    lcpt_tab_delete_text(LTab,-1,2);
	    lcpt_tab_insert_text(LTab,Row[0]);
	    Ok=FALSE;   /* ne pas traiter en suivant */
	  }
	}
	mysql_free_result(Result);
      }
    }
  }
  return (Ok);
}

gboolean EdtCpt_lcpt_change_column(LcptTab *LTab,int Column)
{
  gchar Tmp[15],PsCle[LEN_COD_SOC+1];
	gchar DebExercice[12],FinExercice[12];
  gboolean Ok;

  Ok=TRUE;
  switch (Column)
    {
    case LCPT_TAB_COLUMN_DATE :
      GetSocRun(PsCle);
      GetDateExercice(DebExercice,FinExercice,PsCle);
      lcpt_tab_row_get_data(LTab,NULL,Tmp,NULL,NULL,NULL,NULL,NULL);
      if ((Ok=ControleDate(Tmp))) lcpt_tab_row_set_data(LTab,NULL,Tmp,NULL,NULL,NULL,NULL,NULL);
      break;
    case LCPT_TAB_COLUMN_COMPTE : 
      ControlCompte(LTab,Column);
      break;
    }
  return (Ok);
}

gboolean EdtCpt_lcpt_change_row_after(LcptTab *LTab)
{
  gchar Tmp[15],SqlCmd[120],Nom[61],PsCle[LEN_COD_SOC+1];
  GtkWidget *widget;
  MYSQL_RES *Result;
  MYSQL_ROW Row;

  lcpt_tab_row_get_data(LTab,NULL,NULL,NULL,NULL,Tmp,NULL,NULL);
  if (*Tmp!=0) {
    GetSocRun(PsCle);
    widget=lookup_widget(GTK_WIDGET (Edition),"Info");
    strcpy(Nom,"-");
    sprintf(SqlCmd,"Select CptLib From Comptes Where CptSoc='%s' And CptCode='%s'",PsCle,Tmp);
    if (mysql_query(DbLcpt,SqlCmd)==0) {
      Result=mysql_store_result(DbLcpt);
      if (mysql_num_rows(Result)!=0) {
	Row=mysql_fetch_row(Result);
	if (Row[0]!=NULL) strcpy(Nom,Row[0]);
      }
      mysql_free_result(Result);
    }
    gtk_label_set_text(GTK_LABEL(widget),Nom);
  }
  return TRUE;
}

gboolean EdtCpt_lcpt_change_row(LcptTab *LTab)
{
  return TRUE;
}

void EdtCpt_lcpt_ecart(LcptTab *LTab,gint NewPiece,gfloat ecart)
{
  GtkWidget *Widget;
  char Tmp[15];
  sprintf(Tmp,"%-8.2f",ecart);
  Widget=lookup_widget(GTK_WIDGET (Edition),"Ecart");
  gtk_entry_set_text(GTK_ENTRY (Widget),Tmp);
  if (NewPiece) *PieceEnCours=0;  else {
    lcpt_tab_row_get_data(LTab,NULL,NULL,NULL,Tmp,NULL,NULL,NULL);
    if (*Tmp!=0) strcpy(PieceEnCours,Tmp);
  }
}

/* Suppression d'une piece ************************************/
void DeleteAccount(GtkButton *But,gpointer user_data)
{
  gchar SqlCmd[120],Piece[15],PsCle[LEN_COD_SOC+1],Code[11];
  GtkWidget *LTab;
  MYSQL_RES *Result;
  MYSQL_ROW Row;

  LTab=lookup_widget(GTK_WIDGET (But),"EdtEcr");
  GetSocRun(PsCle);
  lcpt_tab_row_get_data(LCPT_TAB (LTab),Code,NULL,NULL,Piece,NULL,NULL,NULL);
  sprintf(SqlCmd,"Select EcrPiece From Ecrit Where EcrSoc='%s' And EcrCode='%s'",PsCle,Code);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    Result=mysql_store_result(DbLcpt);
    Row=mysql_fetch_row(Result);
    if (Row[0]!=NULL) strcpy(Piece,Row[0]);
    mysql_free_result(Result);
    if (MsgQuestion(_("Suppression de cette pice ?"))==MR_OK) {
      sprintf(SqlCmd,"Delete From Ecrit Where EcrSoc='%s' And EcrJrn='%s' And EcrPiece='%s'",PsCle,Journal,Piece);
      if (mysql_query(DbLcpt,SqlCmd)==0) {
	lcpt_tab_freeze(LCPT_TAB (LTab));
	while (lcpt_tab_row_search(LCPT_TAB (LTab),LCPT_TAB_COLUMN_PIECE,Piece+2)) {
	  lcpt_tab_row_delete(LCPT_TAB (LTab));
	}
	lcpt_tab_thaw(LCPT_TAB (LTab));
      } else MessageAlerte(_("Suppression impossible !"));
    }
  } else MessageAlerte(_("Ecriture introuvable dans la base !"));
}

/* Validation rapide d'une ligne ********************************/
void ValidRow(GtkButton *But,gpointer user_data)
{
  gchar SqlCmd[120],Compte[9],PsCle[LEN_COD_SOC+1];
  GtkWidget *LTab;
  MYSQL_RES *Result;
  MYSQL_ROW Row;
  double Ecart,Deb,Cre;

  Ecart=InfoLastEcrit();
  if (Ecart!=0) {
    LTab=lookup_widget(GTK_WIDGET (But),"EdtEcr");
    GetSocRun(PsCle);
    sprintf(SqlCmd,"Select JCptAssoc From Jrn Where JSoc='%s' And JCode='%s'",PsCle,Journal);
    if (mysql_query(DbLcpt,SqlCmd)==0) {
      Result=mysql_store_result(DbLcpt);
      Row=mysql_fetch_row(Result);
      if (Row[0]!=NULL) strcpy(Compte,Row[0]);
      mysql_free_result(Result);
      Deb=Cre=0.0;
      if (Ecart<0.0) Deb=abs(Ecart);else Cre=(Ecart);
      lcpt_tab_row_set_data(LCPT_TAB (LTab),NULL,NULL,NULL,NULL,Compte,&Deb,&Cre);
      if (Deb!=0.0) lcpt_tab_change_column(LCPT_TAB (LTab),LCPT_TAB_COLUMN_DEBIT);
      else lcpt_tab_change_column(LCPT_TAB (LTab),LCPT_TAB_COLUMN_CREDIT);
      lcpt_tab_row_valid(LCPT_TAB(LTab));
    } else MessageAlerte(_("Erreur sur lecture journal !"));
  }
}

void EdtCpt_BtUndo_clicked(GtkButton *But,gpointer user_data)
{
  char Code[15],SqlCmd[255],PsCle[LEN_COD_SOC+1],Tmp[15];
  double Dv,Cv;
  GtkWidget *LTab;
  MYSQL_RES *Result;
  MYSQL_ROW Row;

  LTab=lookup_widget(GTK_WIDGET (But),"EdtEcr");
  lcpt_tab_row_get_data(LCPT_TAB (LTab),Code,NULL,NULL,NULL,NULL,NULL,NULL);
  GetSocRun(PsCle);
  if (*Code) {
    sprintf(SqlCmd,"Select EcrCode,EcrDate,EcrLib,EcrPiece,EcrCpt,EcrDebit,EcrCredit From Ecrit Where EcrSoc='%s' And EcrCode='%s'",PsCle,Code);
    if (mysql_query(DbLcpt,SqlCmd)==0) {
      Result=mysql_store_result(DbLcpt);
      Row=mysql_fetch_row(Result);
      Dv=atof(Row[5]);
      Cv=atof(Row[6]);
      IsoToDate(Tmp,Row[1]);
      lcpt_tab_row_set_data(LCPT_TAB (LTab),Row[0],Tmp,Row[2],Row[3]+2,Row[4],&Dv,&Cv);
      mysql_free_result(Result);
      lcpt_tab_change_column(LCPT_TAB (LTab),LCPT_TAB_COLUMN_DATE);
    } else MessageAlerte(_("Code criture introuvable !"));
  } else {
    Dv=0;
    Cv=0;
    lcpt_tab_row_set_data(LCPT_TAB (LTab),"","","","","",&Dv,&Cv);
    lcpt_tab_change_column(LCPT_TAB (LTab),LCPT_TAB_COLUMN_DATE);
  }
}

void EdtCpt_BtSearch_clicked(GtkWidget *button,gpointer user_data)
{
  GtkWidget *LTab;

  LTab=lookup_widget(GTK_WIDGET (button),"EdtEcr");
  ResultLoc=Dialog_Search(Journal);
  if (ResultLoc!=NULL) {
    RowLocate=mysql_fetch_row(ResultLoc);
    lcpt_tab_row_search(LCPT_TAB (LTab),LCPT_TAB_COLUMN_CODE,(gchar *) RowLocate[0]);
  }
}

GtkWidget* create_EdtCompta (void)
{
  GtkWidget *EdtCompta;
  GtkWidget *VBoxTotal;
  GtkWidget *toolbar2;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *EdtCpt_BtDel;
  GtkWidget *EdtCpt_BtUndo;
  GtkWidget *EdtCpt_BtValide;
  GtkWidget *EdtCpt_BtSearch;
  GtkWidget *EdtCpt_BtFermer;
  GtkWidget *hbox18;
  GtkWidget *HBoxJournal;
  GtkWidget *label122;
  GtkWidget *JCode;
  GtkWidget *JLib;
  GtkWidget *EdtCpt_BtPrec;
  GtkWidget *EdtCpt_BtSel;
  GtkWidget *EdtCpt_BtSuiv;
  GtkWidget *EdtEcr;
  GtkWidget *hbox16;
  GtkWidget *Info;
  GtkWidget *HBoxEcart;
  GtkWidget *label121;
  GtkWidget *Ecart;
  GtkWidget *scrolledwindow11;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  EdtCompta = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (EdtCompta), "EdtCompta", EdtCompta);
  gtk_window_set_title (GTK_WINDOW (EdtCompta), _("Edition des Journaux"));
  gtk_window_set_position (GTK_WINDOW (EdtCompta), GTK_WIN_POS_CENTER);
  gtk_window_set_default_size (GTK_WINDOW (EdtCompta), 640, 320);

  VBoxTotal = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (VBoxTotal);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "VBoxTotal", VBoxTotal,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (VBoxTotal);
  gtk_container_add (GTK_CONTAINER (EdtCompta), VBoxTotal);
  /* TOOLBAR */
  toolbar2 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_widget_ref (toolbar2);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "toolbar2", toolbar2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar2);
  gtk_box_pack_start (GTK_BOX (VBoxTotal), toolbar2, FALSE, FALSE, 0);
  gtk_toolbar_set_button_relief (GTK_TOOLBAR (toolbar2), GTK_RELIEF_NONE);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (EdtCompta, GNOME_STOCK_PIXMAP_CLEAR);
  EdtCpt_BtDel = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Effacer"),
                                _("Effacer la saisie."), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (EdtCpt_BtDel);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "EdtCpt_BtDel", EdtCpt_BtDel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtCpt_BtDel);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (EdtCompta, GNOME_STOCK_PIXMAP_UNDELETE);
  EdtCpt_BtUndo = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Annuler"),
                                _("Annuler la saisie."), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (EdtCpt_BtUndo);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "EdtCpt_BtUndo", EdtCpt_BtUndo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtCpt_BtUndo);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (EdtCompta, GNOME_STOCK_PIXMAP_JUMP_TO);
  EdtCpt_BtValide = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Valide"),
                                _("Validation rapide de la ligne."), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (EdtCpt_BtValide);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "EdtCpt_BtValide", EdtCpt_BtValide,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_add_accelerator (EdtCpt_BtValide, "clicked", accel_group,
                              GDK_F10, 0,
                              GTK_ACCEL_VISIBLE);
  gtk_widget_show (EdtCpt_BtValide);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (EdtCompta, GNOME_STOCK_PIXMAP_SEARCH);
  EdtCpt_BtSearch = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Recherche"),
                                _("Recherche d'une criture."), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (EdtCpt_BtSearch);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "EdtCpt_BtSearch", EdtCpt_BtSearch,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtCpt_BtSearch);

  gtk_toolbar_append_space (GTK_TOOLBAR (toolbar2));

  tmp_toolbar_icon = gnome_stock_pixmap_widget (EdtCompta, GNOME_STOCK_PIXMAP_EXIT);
  EdtCpt_BtFermer = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Fermer"),
                                _("Fermer la fentre de saisie."), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_signal_connect_object (GTK_OBJECT (EdtCpt_BtFermer), "clicked",
                      GTK_SIGNAL_FUNC (gtk_object_destroy),
                      GTK_OBJECT (EdtCompta));
  gtk_widget_ref (EdtCpt_BtFermer);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "EdtCpt_BtFermer", EdtCpt_BtFermer,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtCpt_BtFermer);

  hbox18 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox18);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "hbox18", hbox18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox18);
  gtk_box_pack_start (GTK_BOX (VBoxTotal), hbox18, FALSE, TRUE, 0);

  HBoxJournal = gtk_hbox_new (FALSE, 2);
  gtk_widget_ref (HBoxJournal);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "HBoxJournal", HBoxJournal,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (HBoxJournal);
  gtk_box_pack_start (GTK_BOX (hbox18), HBoxJournal, FALSE, TRUE, 0);

  label122 = gtk_label_new (_("Journal :"));
  gtk_widget_ref (label122);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "label122", label122,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label122);
  gtk_box_pack_start (GTK_BOX (HBoxJournal), label122, FALSE, FALSE, 0);

  JCode = gtk_entry_new_with_max_length (2);
  gtk_widget_ref (JCode);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "JCode", JCode,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (JCode);
  gtk_box_pack_start (GTK_BOX (HBoxJournal), JCode, TRUE, TRUE, 0);
  gtk_widget_set_usize (JCode, 27, -2);

  JLib = gtk_entry_new_with_max_length (20);
  gtk_widget_ref (JLib);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "JLib", JLib,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (JLib);
  gtk_box_pack_start (GTK_BOX (HBoxJournal), JLib, TRUE, TRUE, 0);
  gtk_widget_set_usize (JLib, 158, -2);
  gtk_entry_set_editable (GTK_ENTRY (JLib), FALSE);

  EdtCpt_BtPrec = gnome_stock_button (GNOME_STOCK_BUTTON_PREV);
  gtk_widget_ref (EdtCpt_BtPrec);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "EdtCpt_BtPrec", EdtCpt_BtPrec,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtCpt_BtPrec);
  gtk_box_pack_start (GTK_BOX (HBoxJournal), EdtCpt_BtPrec, FALSE, FALSE, 0);

  EdtCpt_BtSel = gtk_button_new_with_label (_("Sel."));
  gtk_widget_ref (EdtCpt_BtSel);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "EdtCpt_BtSel", EdtCpt_BtSel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtCpt_BtSel);
  gtk_box_pack_start (GTK_BOX (HBoxJournal), EdtCpt_BtSel, FALSE, FALSE, 0);

  EdtCpt_BtSuiv = gnome_stock_button (GNOME_STOCK_BUTTON_NEXT);
  gtk_widget_ref (EdtCpt_BtSuiv);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "EdtCpt_BtSuiv", EdtCpt_BtSuiv,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtCpt_BtSuiv);
  gtk_box_pack_start (GTK_BOX (HBoxJournal), EdtCpt_BtSuiv, FALSE, FALSE, 0);

  /*  InfoBis = gtk_label_new (_("Info"));
      gtk_widget_ref (InfoBis);
      gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "InfoBis", InfoBis,
      (GtkDestroyNotify) gtk_widget_unref);
      gtk_widget_show (InfoBis);
  gtk_box_pack_start (GTK_BOX (hbox18), InfoBis, TRUE, FALSE, 0); */

  scrolledwindow11 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow11); 
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "scrolledwindow11", scrolledwindow11,(GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow11);
  gtk_box_pack_start (GTK_BOX (VBoxTotal), scrolledwindow11, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow11), 2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow11), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
  /* la liste des critures */
  EdtEcr = lcpt_tab_new();
  gtk_widget_ref (EdtEcr);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "EdtEcr", EdtEcr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtEcr);
  gtk_container_add (GTK_CONTAINER (scrolledwindow11), EdtEcr);
  /*****/
  hbox16 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox16);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "hbox16", hbox16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox16);
  gtk_box_pack_start (GTK_BOX (VBoxTotal), hbox16, FALSE, TRUE, 0);

  Info = gtk_label_new ("-");
  gtk_widget_ref (Info);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "Info", Info,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Info);
  gtk_box_pack_start (GTK_BOX (hbox16), Info, TRUE, FALSE, 0);

  HBoxEcart = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (HBoxEcart);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "HBoxEcart", HBoxEcart,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (HBoxEcart);
  gtk_box_pack_start (GTK_BOX (hbox16), HBoxEcart, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (HBoxEcart), 4);

  label121 = gtk_label_new (_("Ecart de saisie :"));
  gtk_widget_ref (label121);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "label121", label121,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label121);
  gtk_box_pack_start (GTK_BOX (HBoxEcart), label121, FALSE, FALSE, 0);

  Ecart = gtk_entry_new ();
  gtk_widget_ref (Ecart);
  gtk_object_set_data_full (GTK_OBJECT (EdtCompta), "Ecart", Ecart,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Ecart);
  gtk_box_pack_start (GTK_BOX (HBoxEcart), Ecart, FALSE, TRUE, 0);
  gtk_widget_set_usize (Ecart, 100, -2);
  gtk_entry_set_editable (GTK_ENTRY (Ecart), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET (Ecart),FALSE);

  gtk_window_set_focus(GTK_WINDOW (EdtCompta),EdtEcr);
  /*** Signaux ***/
  gtk_signal_connect (GTK_OBJECT (EdtCompta), "show",
                      GTK_SIGNAL_FUNC (on_EdtCompta_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtCompta), "destroy",
                      GTK_SIGNAL_FUNC (on_EdtCompta_destroy),
                      NULL);
  /*  gtk_signal_connect (GTK_OBJECT (JCode), "key_press_event",
                      GTK_SIGNAL_FUNC (on_JCode_key_press_event),
                      NULL);*/
  gtk_signal_connect (GTK_OBJECT (EdtCpt_BtPrec), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtCpt_BtPrec_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtCpt_BtSel), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtCpt_BtSel_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtCpt_BtSuiv), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtCpt_BtSuiv_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtEcr), "lcpt_change",
                      GTK_SIGNAL_FUNC (EdtCpt_lcpt_change),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtEcr), "lcpt_insert",
                      GTK_SIGNAL_FUNC (EdtCpt_lcpt_insert),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtEcr), "lcpt_change_column",
                      GTK_SIGNAL_FUNC (EdtCpt_lcpt_change_column),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtEcr), "lcpt_ecart",
                      GTK_SIGNAL_FUNC (EdtCpt_lcpt_ecart),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtEcr), "lcpt_change_row_after",
                      GTK_SIGNAL_FUNC (EdtCpt_lcpt_change_row_after),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtEcr), "lcpt_change_row",
                      GTK_SIGNAL_FUNC (EdtCpt_lcpt_change_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtEcr), "lcpt_insert_text",
                      GTK_SIGNAL_FUNC (ControleLib),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtCpt_BtDel), "clicked",
                      GTK_SIGNAL_FUNC (DeleteAccount),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtCpt_BtValide), "clicked",
                      GTK_SIGNAL_FUNC (ValidRow),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtCpt_BtUndo), "clicked",
                      GTK_SIGNAL_FUNC (EdtCpt_BtUndo_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtCpt_BtSearch), "clicked",
                      GTK_SIGNAL_FUNC (EdtCpt_BtSearch_clicked),
                      NULL);
  return EdtCompta;
}


void Dialog_EdtCpt(gchar *JDep)
{
  Edition=create_EdtCompta();
  EdtJrnRes=NULL;
  gtk_widget_show_all(Edition);
  if (JDep!=NULL) strcpy(Journal,JDep);else *Journal='\0';
}
