/*******************************************************************/
/* Comptabilit Analytique Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 22/03/02 - Edition des plans journaux                           */
/* Fichier source                                                  */
/*******************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <gtk/gtk.h>
#include <gnome.h>
#include <string.h>
#include <ctype.h>
#include <mysql/mysql.h>
#include "support.h"
#include "common.h"
#include "gtksql.h"
#include "select.h"

#include "edtjrn.h"

/* Variables */
GtkWidget    *Journaux;
my_ulonglong MysqlPtr;
MYSQL_RES    *EdtJrnRes;
gchar        SelectVent[11],SelectLibA[3];
gboolean     CREATE_MODE;
/* Constantes */
int JMAX_TYPE=9;
gchar *JTypLib[]={_("Achats"),_("Ventes"),_("Opration divers"),_("Trsorerie"),_("Ouverture"),
	                _("Cloture"),_("Inventaire"),_("Extournes"),_("Provisoire")};
gchar *JTypID[]={"AC","VE","OD","TR","OU","CL","IN","EX","PR"};
/* Protos */
GtkWidget* create_EditJrn (void);
GtkWidget* create_EdtLibAuto (void);
void EdtJrn_DispData(void);
void EdtJrn_DispTab1(void);
void EdtJrn_DispTab2(void);
gboolean on_ListLib_button_press_event (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

void on_EdtLibA_btOk_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void on_ListVentil_select_child        (GtkList         *list,
                                        GtkWidget       *widget,
                                        gpointer         user_data);
void on_ListLib_select_row             (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);
void on_EditJrn_show                   (GtkWidget       *widget,
                                        gpointer         user_data);

void on_EditJrn_destroy                (GtkObject       *object,
                                        gpointer         user_data);

void on_EdtJrn_BtPrec_clicked          (GtkButton       *button,
                                        gpointer         user_data);

void on_EdtJrn_BtSuiv_clicked          (GtkButton       *button,
                                        gpointer         user_data);
void EdtJrn_BtJrn_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void on_EdtJrn_BtClose_clicked         (GtkButton       *button,
                                        gpointer         user_data);

void on_EdtJrn_BtAjouter_clicked       (GtkButton       *button,
                                        gpointer         user_data);

void on_EdtJrn_BtModifier_clicked      (GtkButton       *button,
                                        gpointer         user_data);

void on_EdtJrn_BtSupp_clicked          (GtkButton       *button,
                                        gpointer         user_data);

void on_EdtJrn_BtOpt_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void on_EdtJrn_BtSelVent_clicked       (GtkButton       *button,
                                        gpointer         user_data);

void on_EdtJrn_BtSuppVent_clicked      (GtkButton       *button,
                                        gpointer         user_data);

void on_EdtJrn_BtAjoutLib_clicked      (GtkButton       *button,
                                        gpointer         user_data);

void on_EdtJrn_BtSuppLib_clicked       (GtkButton       *button,
                                        gpointer         user_data);
gboolean on_JCode_key_press_event      (GtkWidget       *widget,
					GdkEventKey     *event,
					gpointer         user_data);
gboolean on_JCptAssoc_key_press_event    (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);
void EdtJrn_InitButtons(gboolean Sensitive);

/* Edition des libell automatique ******************************/
GtkWidget* create_EdtLibAuto (void)
{
  GtkWidget *EdtLibAuto;
  GtkWidget *vbox12;
  GtkWidget *fixed10;
  GtkWidget *label126;
  GtkWidget *EdtLibA_Code;
  GtkWidget *EdtLibA_Lib;
  GtkWidget *label127;
  GtkWidget *EdtLibA_Cont;
  GtkWidget *hbox19;
  GtkWidget *EdtLibA_btOk;
  GtkWidget *EdtLibA_btCAncel;

  EdtLibAuto = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (EdtLibAuto), "EdtLibAuto", EdtLibAuto);
  gtk_window_set_title (GTK_WINDOW (EdtLibAuto), _("Raccourcis clavier"));
  gtk_window_set_position (GTK_WINDOW (EdtLibAuto), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (EdtLibAuto), TRUE);

  vbox12 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox12);
  gtk_object_set_data_full (GTK_OBJECT (EdtLibAuto), "vbox12", vbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox12);
  gtk_container_add (GTK_CONTAINER (EdtLibAuto), vbox12);

  fixed10 = gtk_fixed_new ();
  gtk_widget_ref (fixed10);
  gtk_object_set_data_full (GTK_OBJECT (EdtLibAuto), "fixed10", fixed10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed10);
  gtk_box_pack_start (GTK_BOX (vbox12), fixed10, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (fixed10), 5);

  label126 = gtk_label_new (_("Code :"));
  gtk_widget_ref (label126);
  gtk_object_set_data_full (GTK_OBJECT (EdtLibAuto), "label126", label126,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label126);
  gtk_fixed_put (GTK_FIXED (fixed10), label126, 8, 12);
  gtk_widget_set_uposition (label126, 8, 12);
  gtk_widget_set_usize (label126, 48, 16);

  EdtLibA_Code = gtk_entry_new_with_max_length (2);
  gtk_widget_ref (EdtLibA_Code);
  gtk_object_set_data_full (GTK_OBJECT (EdtLibAuto), "EdtLibA_Code", EdtLibA_Code,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtLibA_Code);
  gtk_fixed_put (GTK_FIXED (fixed10), EdtLibA_Code, 60, 8);
  gtk_widget_set_uposition (EdtLibA_Code, 60, 8);
  gtk_widget_set_usize (EdtLibA_Code, 36, 20);

  EdtLibA_Lib = gtk_entry_new ();
  gtk_widget_ref (EdtLibA_Lib);
  gtk_object_set_data_full (GTK_OBJECT (EdtLibAuto), "EdtLibA_Lib", EdtLibA_Lib,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtLibA_Lib);
  gtk_fixed_put (GTK_FIXED (fixed10), EdtLibA_Lib, 60, 40);
  gtk_widget_set_uposition (EdtLibA_Lib, 60, 40);
  gtk_widget_set_usize (EdtLibA_Lib, 208, 20);

  label127 = gtk_label_new (_("Texte :"));
  gtk_widget_ref (label127);
  gtk_object_set_data_full (GTK_OBJECT (EdtLibAuto), "label127", label127,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label127);
  gtk_fixed_put (GTK_FIXED (fixed10), label127, 16, 44);
  gtk_widget_set_uposition (label127, 16, 44);
  gtk_widget_set_usize (label127, 48, 16);
  gtk_label_set_justify (GTK_LABEL (label127), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label127), 0, 0.5);

  EdtLibA_Cont = gtk_check_button_new_with_label (_("Continuer saisie"));
  gtk_widget_ref (EdtLibA_Cont);
  gtk_object_set_data_full (GTK_OBJECT (EdtLibAuto), "EdtLibA_Cont", EdtLibA_Cont,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtLibA_Cont);
  gtk_fixed_put (GTK_FIXED (fixed10), EdtLibA_Cont, 60, 68);
  gtk_widget_set_uposition (EdtLibA_Cont, 60, 68);
  gtk_widget_set_usize (EdtLibA_Cont, 124, 20);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (EdtLibA_Cont), TRUE);

  hbox19 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox19);
  gtk_object_set_data_full (GTK_OBJECT (EdtLibAuto), "hbox19", hbox19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox19);
  gtk_box_pack_start (GTK_BOX (vbox12), hbox19, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox19), 4);

  EdtLibA_btOk = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (EdtLibA_btOk);
  gtk_object_set_data_full (GTK_OBJECT (EdtLibAuto), "EdtLibA_btOk", EdtLibA_btOk,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtLibA_btOk);
  gtk_box_pack_start (GTK_BOX (hbox19), EdtLibA_btOk, FALSE, FALSE, 0);

  EdtLibA_btCAncel = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (EdtLibA_btCAncel);
  gtk_object_set_data_full (GTK_OBJECT (EdtLibAuto), "EdtLibA_btCAncel", EdtLibA_btCAncel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtLibA_btCAncel);
  gtk_box_pack_start (GTK_BOX (hbox19), EdtLibA_btCAncel, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (EdtLibA_btOk), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtLibA_btOk_clicked),
                      NULL);
  gtk_signal_connect_object (GTK_OBJECT (EdtLibA_btCAncel), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (EdtLibAuto));

  return EdtLibAuto;
}

void EdtJrn_InitButtons(gboolean Sensitive)
{
  GtkWidget *Widget;

  Widget=lookup_widget(GTK_WIDGET (Journaux),"EdtJrn_BtPrec");
  gtk_widget_set_sensitive(Widget,Sensitive);
  Widget=lookup_widget(GTK_WIDGET (Journaux),"EdtJrn_BtSuiv");
  gtk_widget_set_sensitive(Widget,Sensitive);
  Widget=lookup_widget(GTK_WIDGET (Journaux),"EdtJrn_BtJrn");
  gtk_widget_set_sensitive(Widget,Sensitive);
  Widget=lookup_widget(GTK_WIDGET (Journaux),"EdtJrn_BtModifier");
  gtk_widget_set_sensitive(Widget,Sensitive);
  Widget=lookup_widget(GTK_WIDGET (Journaux),"EdtJrn_BtSupp");
  gtk_widget_set_sensitive(Widget,Sensitive);
}

void EdtJrn_DispData(void)
{
  gchar SqlCmd[250],PsCle[LEN_COD_SOC+1],JCle[3],Tmp[25];
	gchar DebExercice[12],FinExercice[12];
  MYSQL_RES *Result;
  MYSQL_ROW Row;
  int Valid;
  GtkWidget *Stat;
  double a,b,c;

  GetSocRun(PsCle);
  if (EdtJrnRes==NULL) {
    Valid=FALSE;
    MysqlPtr=0;
    sprintf(SqlCmd,"Select * From Jrn Where JSoc='%s'",PsCle);
    if (!mysql_query(DbLcpt,SqlCmd)) {
      EdtJrnRes=mysql_store_result(DbLcpt);
      if (EdtJrnRes) if (mysql_num_rows(EdtJrnRes)!=0)  Valid=TRUE;
    }
  } else Valid=TRUE;
  EdtJrn_InitButtons(Valid);
  if (Valid) {
    Row=mysql_fetch_row(EdtJrnRes);
    StrSqlToGtk(GTK_WIDGET (Journaux),"JCode",Row[1]);
    strcpy(JCle,Row[1]);
    StrSqlToGtk(GTK_WIDGET (Journaux),"JLib",Row[2]);
    IDToLib(Tmp,JTypID,JTypLib,9,Row[3]);
    ComboSqlToGtk(GTK_WIDGET (Journaux),"JTyp",Tmp);
    StrSqlToGtk(GTK_WIDGET (Journaux),"JCptAssoc",Row[4]);
    Stat=lookup_widget(GTK_WIDGET (Journaux),"ListStat");
    /* Ligne 1 */
    if (Row[8]!=NULL) a=atof(Row[8]);else a=0;
    sprintf(Tmp,"%8.2f",a);
    gtk_clist_set_text(GTK_CLIST (Stat),0,0,Tmp);
    if (Row[9]!=NULL) b=atof(Row[9]);else b=0;
    sprintf(Tmp,"%8.2f",b);
    gtk_clist_set_text(GTK_CLIST (Stat),0,1,Tmp);
    c=a-b;
    sprintf(Tmp,"%8.2f",c);
    gtk_clist_set_text(GTK_CLIST (Stat),0,2,Tmp);
    /* Ligne 2 */
    if (Row[10]!=NULL) a=atof(Row[10]);else a=0;
    sprintf(Tmp,"%8.2f",a);
    gtk_clist_set_text(GTK_CLIST (Stat),1,0,Tmp);
    if (Row[11]!=NULL) b=atof(Row[11]);else b=0;
    sprintf(Tmp,"%8.2f",b);
    gtk_clist_set_text(GTK_CLIST (Stat),1,1,Tmp);
    sprintf(Tmp,"%8.2f",a-b);
    gtk_clist_set_text(GTK_CLIST (Stat),1,2,Tmp);
    if ((a!=0) || (b!=0)) {
      if (c!=0) c=(a-b)/c; else c=1;
      if (c>=1) c=(c-1)*100; else c=(100-(c*100))*-1;
      if (c==0) c=100;
      sprintf(Tmp,"%-3.2f%%",c);
      gtk_clist_set_text(GTK_CLIST (Stat),1,3,Tmp);
    }
    c=a-b;
    /* Ligne 3 */
    GetDateExercice(DebExercice,FinExercice,PsCle);
    sprintf(SqlCmd,"Select Sum(EcrDebit),Sum(EcrCredit) from Ecrit where EcrSoc='%s' And EcrJrn='%s' And EcrDate Between '%s' And '%s'",PsCle,JCle,DebExercice,FinExercice);
    if (mysql_query(DbLcpt,SqlCmd)==0) {
      Result=mysql_store_result(DbLcpt);
      if (Result) {
				Stat=lookup_widget(GTK_WIDGET (Journaux),"ListStat");
				a=0;
				b=0;
				if (mysql_num_rows(Result)!=0) {
					Row=mysql_fetch_row(Result);
					if (Row[0]!=NULL) a=atof(Row[0]);
					if (Row[1]!=NULL) b= atof(Row[1]);
				}
				sprintf(Tmp,"%8.2f",a);
				gtk_clist_set_text(GTK_CLIST (Stat),2,0,Tmp);
				sprintf(Tmp,"%8.2f",b);
				gtk_clist_set_text(GTK_CLIST (Stat),2,1,Tmp);
				sprintf(Tmp,"%8.2f",a-b);
				gtk_clist_set_text(GTK_CLIST (Stat),2,2,Tmp);
				if ((a!=0) || (b!=0)) {
					if (c!=0) c=(a-b)/c;else c=1;
					if (c>=1) c=(c-1)*100; else c=(100-(c*100))*-1;
					if (c==0) c=100;
					sprintf(Tmp,"%-3.2f%%",c);
					gtk_clist_set_text(GTK_CLIST (Stat),2,3,Tmp);
				}
				c=a-b;
				mysql_free_result(Result);
      } else MessageInfo(_("Rsultat SQL NULL !"));
    }
    /* Ligne 4 */
    sprintf(SqlCmd,"Select Sum(EcrDebit),Sum(EcrCredit) from Ecrit where EcrSoc='%s' And EcrJrn='%s' And EcrDate >'%s'",PsCle,JCle,FinExercice);
    if (mysql_query(DbLcpt,SqlCmd)==0) {
      Result=mysql_store_result(DbLcpt);
      if (Result) {
				Stat=lookup_widget(GTK_WIDGET (Journaux),"ListStat");
				a=0;
				b=0;
				if (mysql_num_rows(Result)!=0) {
					Row=mysql_fetch_row(Result);
					if (Row[0]!=NULL) a=atof(Row[0]);
					if (Row[1]!=NULL) b= atof(Row[1]);
				}
				sprintf(Tmp,"%8.2f",a);
				gtk_clist_set_text(GTK_CLIST (Stat),3,0,Tmp);
				sprintf(Tmp,"%8.2f",b);
				gtk_clist_set_text(GTK_CLIST (Stat),3,1,Tmp);
				sprintf(Tmp,"%8.2f",a-b);
				gtk_clist_set_text(GTK_CLIST (Stat),3,2,Tmp);
				if ((a!=0) || (b!=0)) {
					if (c!=0) c=(a-b)/c;else c=1;
					if (c>=1) c=(c-1)*100; else c=(100-(c*100))*-1;
					if (c==0) c=100;
					sprintf(Tmp,"%-3.2f%%",c);
					gtk_clist_set_text(GTK_CLIST (Stat),3,3,Tmp);
				}
				mysql_free_result(Result);
      } else MessageInfo(_("Rsultat SQL NULL !"));
    } else MessageInfo(_("Echec SQL !"));
    EdtJrn_DispTab1();
    EdtJrn_DispTab2();
  }
}

void EdtJrn_DispTab1(void)
{
  GtkWidget *Tab,*Elem;
  GList *Items;
  char SqlCmd[120],PsCle[LEN_COD_SOC+1],JCle[3];
  MYSQL_RES *Result;
  MYSQL_ROW Row;

  GetSocRun(PsCle);
  Elem=lookup_widget(GTK_WIDGET (Journaux),"JCode");
  strcpy(JCle,gtk_entry_get_text(GTK_ENTRY (Elem)));
  Tab=lookup_widget(GTK_WIDGET (Journaux),"ListVentil");
  gtk_list_clear_items(GTK_LIST (Tab),0,-1);
  Items=NULL;
  sprintf(SqlCmd,"Select JVCode From JrnV Where JVSoc='%s' And JVJrn='%s' Order By JVCode",PsCle,JCle);
  if (mysql_query(DbLcpt,SqlCmd)==0){
    Result=mysql_store_result(DbLcpt);
    while ((Row=mysql_fetch_row(Result))) {
      Elem=gtk_list_item_new_with_label(Row[0]);
      gtk_object_set_user_data(GTK_OBJECT(Elem), (gpointer)Row[0]);
      Items=g_list_append(Items,Elem);
    }
    gtk_list_append_items(GTK_LIST (Tab),Items);
    gtk_widget_show_all(GTK_WIDGET (Tab));
  }
}

void EdtJrn_DispTab2(void)
{
  GtkWidget *Tab,*Elem;
  char SqlCmd[120],PsCle[LEN_COD_SOC+1],JCle[3];
  MYSQL_RES *Result;
  MYSQL_ROW Row;
  gchar *Ptr[2];

  GetSocRun(PsCle);
  Elem=lookup_widget(GTK_WIDGET (Journaux),"JCode");
  strcpy(JCle,gtk_entry_get_text(GTK_ENTRY (Elem)));
  Tab=lookup_widget(GTK_WIDGET (Journaux),"ListLib");
  gtk_clist_clear(GTK_CLIST (Tab));
  sprintf(SqlCmd,"Select JLCode,JLLib From JrnL Where JLSoc='%s' And JLJrn='%s' Order By JLCode",PsCle,JCle);
  if (mysql_query(DbLcpt,SqlCmd)==0){
    Result=mysql_store_result(DbLcpt);
    while ((Row=mysql_fetch_row(Result))) {
      Ptr[0]=Row[0];
      Ptr[1]=Row[1];
      gtk_clist_append(GTK_CLIST (Tab),Ptr);
    }
  }
}

void on_EditJrn_show(GtkWidget *widget,gpointer user_data)
{
  GtkCList *CList;
  gchar *Bidon[4]={" "," "," "," "};

  OpenDbLcpt();
  CList=GTK_CLIST (lookup_widget(GTK_WIDGET (widget),"ListStat"));
  if (CList!=NULL) {
    gtk_clist_set_column_justification(CList,0,GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification(CList,1,GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification(CList,2,GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification(CList,3,GTK_JUSTIFY_RIGHT);
    gtk_clist_append(CList,Bidon);
    gtk_clist_append(CList,Bidon);
    gtk_clist_append(CList,Bidon);
    gtk_clist_append(CList,Bidon);
  }
}


void on_EditJrn_destroy(GtkObject *object,gpointer user_data)
{
  if (DbLcpt!=NULL) CloseDbLcpt();
  if (EdtJrnRes!=NULL) mysql_free_result(EdtJrnRes);
}

void on_EdtJrn_BtPrec_clicked(GtkButton *button,gpointer user_data)
{
  if (MysqlPtr>0) {
    MysqlPtr--;
    mysql_data_seek(EdtJrnRes,MysqlPtr);
    EdtJrn_DispData();
  }
}


void on_EdtJrn_BtSuiv_clicked(GtkButton *button,gpointer user_data)
{
  if (MysqlPtr<mysql_num_rows(EdtJrnRes)-1) {
    EdtJrn_DispData();
    MysqlPtr++;
  }
}

gboolean on_JCode_key_press_event(GtkWidget *widget,GdkEventKey *event,gpointer user_data)
{
  char JCode[3];
  my_ulonglong Loc;

  if (event->type==GDK_KEY_PRESS) {
    if ((event->keyval==GDK_Return) || (event->keyval==GDK_KP_Enter)) {
      strcpy(JCode,gtk_entry_get_text(GTK_ENTRY (widget)));
      gtk_entry_set_text(GTK_ENTRY (widget),JCode);
      if ((Loc=SearchCode(EdtJrnRes,JCode,1))==-1) MessageAlerte(_("Code inexistant !"));else MysqlPtr=Loc;
      EdtJrn_DispData();
    }
  }
  return FALSE;
}

gboolean on_JCptAssoc_key_press_event(GtkWidget *widget,GdkEventKey *event,gpointer user_data)
{
  char JCptAssoc[9];

  if (event->type==GDK_KEY_PRESS) {
    if ((event->keyval==GDK_Return) || (event->keyval==GDK_KP_Enter)) {
      strcpy(JCptAssoc,gtk_entry_get_text(GTK_ENTRY (widget)));
      gtk_entry_set_text(GTK_ENTRY (widget),JCptAssoc);
      while (strlen(JCptAssoc)<8) strcat(JCptAssoc,"0");
      gtk_entry_set_text(GTK_ENTRY (widget),JCptAssoc);
    }
  }
  return FALSE;
}

void on_EdtJrn_BtClose_clicked(GtkButton *button,gpointer user_data)
{
  GtkWidget *Wcall;

  Wcall=lookup_widget(GTK_WIDGET (button),"EditJrn");
  gtk_widget_destroy(GTK_WIDGET(Wcall));
}


void EdtJrn_BtJrn_clicked(GtkButton *button,gpointer user_data)
{
  GtkEntry *Entry;
  gchar JrnRet[3];
  my_ulonglong Loc;

  Entry=GTK_ENTRY (lookup_widget(GTK_WIDGET (button),"JCode"));
  if (Entry!=NULL) {
    if (ListSelect(JrnRet,"Jrn","JSoc","JCode","JLib",NULL)==MR_OK) {
      if ((Loc=SearchCode(EdtJrnRes,JrnRet,1))==-1) MessageAlerte(_("Code inexistant !"));else MysqlPtr=Loc;
      EdtJrn_DispData();
    }
  }
}

void
on_EdtJrn_BtAjouter_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  gchar PsCle[LEN_COD_SOC+1],JCode[5],SqlCmd[500],*End,Tmp[25],Cde[3];
  GtkWidget *JrWdg,*Combo,*Entry;

  GetSocRun(PsCle);
  JrWdg=lookup_widget(GTK_WIDGET (button),"JCode");
  strcpy(JCode,gtk_entry_get_text(GTK_ENTRY (JrWdg)));
  End=strmov(SqlCmd,"Insert Into Jrn (JCode,JSoc,JLib,JTyp,JCptAssoc) Values (");
  *End++='\'';
  End=strmov(End,JCode);
  *End++='\'';
  *End++=',';
  *End++='\'';
  End=strmov(End,PsCle);
  *End++='\'';
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"JLib");
  *End++=',';
  /***/
  Combo=lookup_widget(GTK_WIDGET (button),"JTyp");
  if (Combo!=NULL) {
    Entry=GTK_COMBO (Combo)->entry;
    strcpy(Tmp,gtk_entry_get_text(GTK_ENTRY(Entry)));
  }
  *End++='\'';
  LibToID(Cde,JTypLib,JTypID,JMAX_TYPE,Tmp);
  End=strmov(End,Cde);
  *End++='\'';
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"JCptAssoc");
  *End++=')';
  *End='\0';
  if (mysql_query(DbLcpt,SqlCmd)!=0) MessageInfo(_("Insertion journal impossible !"));
  mysql_free_result(EdtJrnRes);
  EdtJrnRes=NULL;
  EdtJrn_DispData();
  MysqlPtr=SearchCode(EdtJrnRes,JCode,1);
  EdtJrn_DispData();
}


void
on_EdtJrn_BtModifier_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  gchar PsCle[LEN_COD_SOC+1],JCode[5],SqlCmd[500],*End,Tmp[25],Cde[3];
  GtkWidget *JrWdg,*Combo,*Entry;

  GetSocRun(PsCle);
  JrWdg=lookup_widget(GTK_WIDGET (button),"JCode");
  strcpy(JCode,gtk_entry_get_text(GTK_ENTRY (JrWdg)));
  End=strmov(SqlCmd,"Update Jrn Set JLib=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"JLib");
  End=strmov(End,",JTyp=");
  /***/
  Combo=lookup_widget(GTK_WIDGET (button),"JTyp");
  if (Combo!=NULL) {
    Entry=GTK_COMBO (Combo)->entry;
    strcpy(Tmp,gtk_entry_get_text(GTK_ENTRY(Entry)));
  }
  *End++='\'';
  LibToID(Cde,JTypLib,JTypID,JMAX_TYPE,Tmp);
  End=strmov(End,Cde);
  *End++='\'';
  End=strmov(End,",JCptAssoc=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"JCptAssoc");
  End=strmov(End," Where JCode='");
  End=strmov(End,JCode);
  End=strmov(End,"' And JSoc='");
  End=strmov(End,PsCle);
  *End++='\'';
  *End='\0';
  if (mysql_query(DbLcpt,SqlCmd)!=0) MessageInfo(_("Modification Journal impossible !"));
  mysql_free_result(EdtJrnRes);
  EdtJrnRes=NULL;
  EdtJrn_DispData();
  MysqlPtr=SearchCode(EdtJrnRes,JCode,1);
  EdtJrn_DispData();
}


void on_EdtJrn_BtSupp_clicked(GtkButton *button,gpointer user_data)
{
  GtkWidget *JrWdg;
  gchar SqlCmd[120],JCode[3],PsCle[LEN_COD_SOC+1];
  MYSQL_ROW Row;

  if (MsgQuestion(_("Suppression de ce journal ?"))==MR_OK) {
    GetSocRun(PsCle);
    JrWdg=lookup_widget(GTK_WIDGET (button),"JCode");
    strcpy(JCode,gtk_entry_get_text(GTK_ENTRY (JrWdg)));
    sprintf(SqlCmd,"Delete From Jrn Where JSoc='%s' And JCode='%s'",PsCle,JCode);
    if (mysql_query(DbLcpt,SqlCmd)!=0) MessageAlerte(_("Suppression impossible !"));
    if ((Row=mysql_fetch_row(EdtJrnRes))) {
      strcpy(JCode,Row[1]);
    } else {
      MysqlPtr--;
      mysql_data_seek(EdtJrnRes,MysqlPtr);
      if ((Row=mysql_fetch_row(EdtJrnRes))) strcpy(JCode,Row[1]);
    }
    mysql_free_result(EdtJrnRes);
    EdtJrnRes=NULL;
    EdtJrn_DispData();
    MysqlPtr=SearchCode(EdtJrnRes,JCode,1);
    EdtJrn_DispData();
  }
}


void on_EdtJrn_BtOpt_clicked(GtkButton *button,gpointer user_data)
{

}

/* Ventilations ***************************************************/
void on_ListVentil_select_child(GtkList *list,GtkWidget *widget,gpointer user_data)
{
  GList *items;

  items=GTK_LIST(list)->selection;
  if (GTK_IS_LIST_ITEM(items->data)) {
    strcpy(SelectVent,(gchar *) gtk_object_get_user_data(items->data));
  }
}

void on_EdtJrn_BtSelVent_clicked(GtkButton *button,gpointer user_data)
{
  char SqlCmd[120],PsCle[LEN_COD_SOC+1],JCle[3],CptRet[11];
  GtkWidget *Widget;
  int Max;

  GetSocRun(PsCle);
  Widget=lookup_widget(GTK_WIDGET (Journaux),"JCode");
  strcpy(JCle,gtk_entry_get_text(GTK_ENTRY (Widget)));
  if (ListSelect(CptRet,"Comptes","CptSoc","CptCode","CptLib",NULL)==MR_OK) {
    /*    sprintf(SqlCmd,"Select Max(JVNum) From JrnV Where JVSoc='%s' And JVJrn='%s'",PsCle,JCle); */
    sprintf(SqlCmd,"Select Max(JVNum) From JrnV Where JVSoc='%s'",PsCle);
    Max=SqlGetNumber(SqlCmd);
    Max++;
    sprintf(SqlCmd,"Insert Into JrnV (JVSoc,JVNum,JVJrn,JVCode) Values ('%s',%i,'%s','%s')",PsCle,Max,JCle,CptRet);
    if (mysql_query(DbLcpt,SqlCmd)!=0) MessageAlerte(_("Insertion ventilation impossible !"));
  }
}

void on_EdtJrn_BtSuppVent_clicked(GtkButton *button,gpointer user_data)
{
  char SqlCmd[120],PsCle[LEN_COD_SOC+1],JCle[3];
  GtkWidget *Widget;

  GetSocRun(PsCle);
  Widget=lookup_widget(GTK_WIDGET (Journaux),"JCode");
  strcpy(JCle,gtk_entry_get_text(GTK_ENTRY (Widget)));
  sprintf(SqlCmd,"Delete From JrnV Where JVSoc='%s' And JVCode='%s'",PsCle,SelectVent);
  if (mysql_query(DbLcpt,SqlCmd)!=0) MessageAlerte(_("Insertion ventilation impossible !"));
  EdtJrn_DispTab1();
}


/* Gestion des raccourcis clavier *************************************/
void on_EdtJrn_BtAjoutLib_clicked(GtkButton *button,gpointer user_data)
{
  GtkWidget *Win,*Widget;

  CREATE_MODE=TRUE;
  Win=create_EdtLibAuto();
  Widget=lookup_widget(GTK_WIDGET (Win),"EdtLibA_Code");
  gtk_entry_set_editable(GTK_ENTRY (Widget),TRUE);
  gtk_widget_show_all(Win);
}


void on_EdtJrn_BtSuppLib_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *Widget;
  gchar SqlCmd[120],PsCle[LEN_COD_SOC+1],JCode[3];

  GetSocRun(PsCle);
  Widget=lookup_widget(GTK_WIDGET (button),"JCode");
  strcpy(JCode,gtk_entry_get_text(GTK_ENTRY (Widget)));
  sprintf(SqlCmd,"Delete From JrnL where JLSoc='%s' And JLJrn='%s' And JLCode='%s'",PsCle,JCode,SelectLibA);
  if (mysql_query(DbLcpt,SqlCmd)!=0) MessageAlerte(_("Impossible de supprimer ce journal !"));else EdtJrn_DispTab2();
}

void on_ListLib_select_row(GtkCList *clist,gint row,gint column,GdkEvent *event,gpointer user_data)
{
  gchar *Txt;

  gtk_clist_get_text(clist,row,0,&Txt);
  strcpy(SelectLibA,Txt);
}


gboolean on_ListLib_button_press_event(GtkWidget *widget,GdkEventButton *event,gpointer user_data)
{
  GtkWidget *Win,*Widget;
  gchar SqlCmd[120],JCode[3],PsCle[LEN_COD_SOC+1];
  MYSQL_RES *Result;
  MYSQL_ROW Row;

  if (event->type==GDK_2BUTTON_PRESS) {
    CREATE_MODE=FALSE;
    GetSocRun(PsCle);
    Widget=lookup_widget(GTK_WIDGET (Journaux),"JCode");
    strcpy(JCode,gtk_entry_get_text(GTK_ENTRY (Widget)));
    sprintf(SqlCmd,"Select JLLib From JrnL Where JLSoc='%s' And JLJrn='%s' And JLCode='%s'",PsCle,JCode,SelectLibA);
    if (mysql_query(DbLcpt,SqlCmd)==0) {
      Result=mysql_store_result(DbLcpt);
      if ((Row=mysql_fetch_row(Result))) {
	Win=create_EdtLibAuto();
	Widget=lookup_widget(GTK_WIDGET (Win),"EdtLibA_Code");
	gtk_entry_set_text(GTK_ENTRY (Widget),SelectLibA);
	gtk_entry_set_editable(GTK_ENTRY (Widget),FALSE);
	Widget=lookup_widget(GTK_WIDGET (Win),"EdtLibA_Lib");
	if (Row[0]!=NULL) gtk_entry_set_text(GTK_ENTRY (Widget),Row[0]);
	gtk_widget_show_all(Win);
      }
    }
  }
  return FALSE;
}


void on_EdtLibA_btOk_clicked(GtkButton *button,gpointer user_data)
{
  GtkWidget *Widget;
  gchar Cde[3],Lib[31],PsCle[LEN_COD_SOC+1],JCode[3],SqlCmd[250],*End;

  Widget=lookup_widget(GTK_WIDGET (button),"EdtLibA_Code");
  strcpy(Cde,gtk_entry_get_text(GTK_ENTRY (Widget)));
  Widget=lookup_widget(GTK_WIDGET (button),"EdtLibA_Lib");
  strcpy(Lib,gtk_entry_get_text(GTK_ENTRY (Widget)));
  GetSocRun(PsCle);
  Widget=lookup_widget(GTK_WIDGET (Journaux),"JCode");
  strcpy(JCode,gtk_entry_get_text(GTK_ENTRY (Widget)));
  if (CREATE_MODE) {
    End=strmov(SqlCmd,"Insert Into JrnL (JLSoc,JLJrn,JLCode,JLLib) values (");
    End=StrSql(End,PsCle);
    *End++=',';
    End=StrSql(End,JCode);
    *End++=',';
    End=StrSql(End,Cde);
    *End++=',';
    End=StrSql(End,Lib);
    *End++=')';
    *End=0;
  } else {
    sprintf(SqlCmd,"Update JrnL set JLLib='%s' Where JLSoc='%s' And JLJrn='%s' And JLCode='%s'",Lib,PsCle,JCode,Cde);
  }
  g_print("%s\n",SqlCmd);
  if (mysql_query(DbLcpt,SqlCmd)==0) EdtJrn_DispTab2(); else MessageAlerte("Modification impossible !");
  Widget=lookup_widget(GTK_WIDGET (button),"EdtLibAuto");
  gtk_widget_destroy(Widget);
}

GtkWidget* create_EditJrn (void)
{
  GtkWidget *EditJrn;
  GtkWidget *vbox10;
  GtkWidget *fixed9;
  GtkWidget *EdtJrn_BtPrec;
  GtkWidget *EdtJrn_BtSuiv;
  GtkWidget *JCode;
  GtkWidget *JLib;
  GtkWidget *label94;
  GtkWidget *ListStat;
  GtkWidget *label96;
  GtkWidget *label97;
  GtkWidget *label98;
  GtkWidget *label99;
  GtkWidget *EdtJrn_BtSelVent;
  GtkWidget *EdtJrn_BtSuppVent;
  GtkWidget *label95;
  GtkWidget *label102;
  GtkWidget *label103;
  GtkWidget *label101;
  GtkWidget *label100;
  GtkWidget *EdtJrn_BtAjoutLib;
  GtkWidget *label104;
  GtkWidget *label107;
  GtkWidget *EdtJrn_BtSuppLib;
  GtkWidget *label108;
  GtkWidget *hseparator11;
  GtkWidget *vseparator4;
  GtkWidget *hseparator10;
  GtkWidget *EdtJrn_BtJrn;
  GtkWidget *scrolledwindow5;
  GtkWidget *ListLib;
  GtkWidget *label105;
  GtkWidget *label106;
  GtkWidget *scrolledwindow4;
  GtkWidget *viewport1;
  GtkWidget *ListVentil;
  GtkWidget *JTyp;
  GList *JTyp_items = NULL;
  GtkWidget *entry19;
  GtkWidget *hbox11;
  GtkWidget *EdtJrn_BtAjouter;
  GtkWidget *EdtJrn_BtModifier;
  GtkWidget *EdtJrn_BtSupp;
  GtkWidget *EdtJrn_BtOpt;
  GtkWidget *EdtJrn_BtClose;
  GtkWidget *LabCptDef;
  GtkWidget *JCptAssoc;
  GtkAccelGroup *accel_group;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  accel_group = gtk_accel_group_new ();

  EditJrn = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (EditJrn), "EditJrn", EditJrn);
  gtk_window_set_title (GTK_WINDOW (EditJrn), _("Edition journaux"));
  gtk_window_set_position (GTK_WINDOW (EditJrn), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (EditJrn), TRUE);

  vbox10 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox10);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "vbox10", vbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox10);
  gtk_container_add (GTK_CONTAINER (EditJrn), vbox10);

  fixed9 = gtk_fixed_new ();
  gtk_widget_ref (fixed9);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "fixed9", fixed9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed9);
  gtk_box_pack_start (GTK_BOX (vbox10), fixed9, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (fixed9), 4);

  EdtJrn_BtPrec = gnome_stock_button (GNOME_STOCK_BUTTON_PREV);
  gtk_widget_ref (EdtJrn_BtPrec);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "EdtJrn_BtPrec", EdtJrn_BtPrec,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtJrn_BtPrec);
  gtk_fixed_put (GTK_FIXED (fixed9), EdtJrn_BtPrec, 12, 320);
  gtk_widget_set_uposition (EdtJrn_BtPrec, 12, 320);
  gtk_widget_set_usize (EdtJrn_BtPrec, 88, 16);
  gtk_widget_add_accelerator (EdtJrn_BtPrec, "clicked", accel_group,
                              GDK_Page_Up, 0,
                              GTK_ACCEL_VISIBLE);

  EdtJrn_BtSuiv = gnome_stock_button (GNOME_STOCK_BUTTON_NEXT);
  gtk_widget_ref (EdtJrn_BtSuiv);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "EdtJrn_BtSuiv", EdtJrn_BtSuiv,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtJrn_BtSuiv);
  gtk_fixed_put (GTK_FIXED (fixed9), EdtJrn_BtSuiv, 112, 320);
  gtk_widget_set_uposition (EdtJrn_BtSuiv, 112, 320);
  gtk_widget_set_usize (EdtJrn_BtSuiv, 80, 16);
  gtk_widget_add_accelerator (EdtJrn_BtSuiv, "clicked", accel_group,
                              GDK_Page_Down, 0,
                              GTK_ACCEL_VISIBLE);
  /***/
  label95 = gtk_label_new (_("Libell :"));
  gtk_widget_ref (label95);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "label95", label95,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label95);
  gtk_fixed_put (GTK_FIXED (fixed9), label95, 16, 36);
  gtk_widget_set_uposition (label95, 16, 36);
  gtk_widget_set_usize (label95, 52, 16);
  gtk_misc_set_alignment (GTK_MISC (label95), 0, 0);

  JLib = gtk_entry_new ();
  gtk_widget_ref (JLib);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "JLib", JLib,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (JLib);
  gtk_fixed_put (GTK_FIXED (fixed9), JLib, 64, 32);
  gtk_widget_set_uposition (JLib, 64, 32);
  gtk_widget_set_usize (JLib, 168, 20);
  /****/
  label94 = gtk_label_new (_("Journal :"));
  gtk_widget_ref (label94);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "label94", label94,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label94);
  gtk_fixed_put (GTK_FIXED (fixed9), label94, 12, 12);
  gtk_widget_set_uposition (label94, 12, 12);
  gtk_widget_set_usize (label94, 56, 16);
  gtk_misc_set_alignment (GTK_MISC (label94), 0, 0);

  JCode = gtk_entry_new ();
  gtk_widget_ref (JCode);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "JCode", JCode,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (JCode);
  gtk_fixed_put (GTK_FIXED (fixed9), JCode, 64, 8);
  gtk_widget_set_uposition (JCode, 64, 8);
  gtk_widget_set_usize (JCode, 28, 20);

  EdtJrn_BtJrn = gtk_button_new_with_label (_("Slection"));
  gtk_widget_ref (EdtJrn_BtJrn);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "EdtJrn_BtJrn", EdtJrn_BtJrn,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtJrn_BtJrn);
  gtk_fixed_put (GTK_FIXED (fixed9), EdtJrn_BtJrn, 108, 8);
  gtk_widget_set_uposition (EdtJrn_BtJrn, 108, 8);
  gtk_widget_set_usize (EdtJrn_BtJrn, 76, 16);
  gtk_widget_add_accelerator (EdtJrn_BtJrn, "clicked", accel_group,
                              GDK_F5, 0,
                              GTK_ACCEL_VISIBLE);
  /****/
  label108 = gtk_label_new (_("Type de Journal :"));
  gtk_widget_ref (label108);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "label108", label108,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label108);
  gtk_fixed_put (GTK_FIXED (fixed9), label108, 12, 60);
  gtk_widget_set_uposition (label108, 12, 60);
  gtk_widget_set_usize (label108, 152, 16);
  gtk_misc_set_alignment (GTK_MISC (label108), 0, 0);

  JTyp = gtk_combo_new ();
  gtk_widget_ref (JTyp);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "JTyp", JTyp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (JTyp);
  gtk_fixed_put (GTK_FIXED (fixed9), JTyp, 112, 56);
  gtk_widget_set_uposition (JTyp, 112, 56);
  gtk_widget_set_usize (JTyp, 164, 20);
  gtk_combo_set_value_in_list (GTK_COMBO (JTyp), TRUE, FALSE);
  JTyp_items = g_list_append (JTyp_items, (gpointer) _("Achats"));
  JTyp_items = g_list_append (JTyp_items, (gpointer) _("Ventes"));
  JTyp_items = g_list_append (JTyp_items, (gpointer) _("Opration divers"));
  JTyp_items = g_list_append (JTyp_items, (gpointer) _("Trsorerie"));
  JTyp_items = g_list_append (JTyp_items, (gpointer) _("Ouverture"));
  JTyp_items = g_list_append (JTyp_items, (gpointer) _("Cloture"));
  JTyp_items = g_list_append (JTyp_items, (gpointer) _("Inventaire"));
  JTyp_items = g_list_append (JTyp_items, (gpointer) _("Extournes"));
  JTyp_items = g_list_append (JTyp_items, (gpointer) _("Provisoire"));
  gtk_combo_set_popdown_strings (GTK_COMBO (JTyp), JTyp_items);
  g_list_free (JTyp_items);

  entry19 = GTK_COMBO (JTyp)->entry;
  gtk_widget_ref (entry19);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "entry19", entry19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry19);
  gtk_entry_set_text (GTK_ENTRY (entry19), _("Achats"));
  /****/
  LabCptDef = gtk_label_new (_("Compte li :"));
  gtk_widget_ref (LabCptDef);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "LabCptDef", LabCptDef,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (LabCptDef);
  gtk_fixed_put (GTK_FIXED (fixed9), LabCptDef, 300, 60);
  gtk_widget_set_uposition (LabCptDef, 300, 60);
  gtk_widget_set_usize (LabCptDef, 152, 16);
  gtk_misc_set_alignment (GTK_MISC (LabCptDef), 0, 0);

  JCptAssoc = gtk_entry_new ();
  gtk_widget_ref (JCptAssoc);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "JCptAssoc", JCptAssoc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (JCptAssoc);
  gtk_fixed_put (GTK_FIXED (fixed9), JCptAssoc, 380, 56);
  gtk_widget_set_uposition (JCptAssoc, 380, 56);
  gtk_widget_set_usize (JCptAssoc, 70, 20);
  /*** tableau ***/
  ListStat = gtk_clist_new (4);
  gtk_widget_ref (ListStat);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "ListStat", ListStat,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ListStat);
  gtk_fixed_put (GTK_FIXED (fixed9), ListStat, 60, 220);
  gtk_widget_set_uposition (ListStat, 60, 220);
  gtk_widget_set_usize (ListStat, 368, 88);
  gtk_clist_set_column_width (GTK_CLIST (ListStat), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (ListStat), 1, 88);
  gtk_clist_set_column_width (GTK_CLIST (ListStat), 2, 93);
  gtk_clist_set_column_width (GTK_CLIST (ListStat), 3, 80);
  gtk_clist_column_titles_show (GTK_CLIST (ListStat));
  gtk_clist_set_shadow_type (GTK_CLIST (ListStat), GTK_SHADOW_OUT);

  label96 = gtk_label_new (_("Dbit"));
  gtk_widget_ref (label96);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "label96", label96,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label96);
  gtk_clist_set_column_widget (GTK_CLIST (ListStat), 0, label96);

  label97 = gtk_label_new (_("Crdit"));
  gtk_widget_ref (label97);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "label97", label97,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label97);
  gtk_clist_set_column_widget (GTK_CLIST (ListStat), 1, label97);

  label98 = gtk_label_new (_("Solde"));
  gtk_widget_ref (label98);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "label98", label98,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label98);
  gtk_clist_set_column_widget (GTK_CLIST (ListStat), 2, label98);

  label99 = gtk_label_new (_("Evolution"));
  gtk_widget_ref (label99);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "label99", label99,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label99);
  gtk_clist_set_column_widget (GTK_CLIST (ListStat), 3, label99);

  EdtJrn_BtSelVent = gtk_button_new_with_label (_("Ajouter"));
  gtk_widget_ref (EdtJrn_BtSelVent);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "EdtJrn_BtSelVent", EdtJrn_BtSelVent,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtJrn_BtSelVent);
  gtk_fixed_put (GTK_FIXED (fixed9), EdtJrn_BtSelVent, 136, 136);
  gtk_widget_set_uposition (EdtJrn_BtSelVent, 136, 136);
  gtk_widget_set_usize (EdtJrn_BtSelVent, 64, 16);
  gtk_tooltips_set_tip (tooltips, EdtJrn_BtSelVent, _("Ajouter ventilation"), NULL);

  EdtJrn_BtSuppVent = gtk_button_new_with_label (_("Supprimer"));
  gtk_widget_ref (EdtJrn_BtSuppVent);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "EdtJrn_BtSuppVent", EdtJrn_BtSuppVent,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtJrn_BtSuppVent);
  gtk_fixed_put (GTK_FIXED (fixed9), EdtJrn_BtSuppVent, 136, 160);
  gtk_widget_set_uposition (EdtJrn_BtSuppVent, 136, 160);
  gtk_widget_set_usize (EdtJrn_BtSuppVent, 64, 16);
  gtk_tooltips_set_tip (tooltips, EdtJrn_BtSuppVent, _("Supprimer ventilation"), NULL);

  label102 = gtk_label_new (_("N+1"));
  gtk_widget_ref (label102);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "label102", label102,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label102);
  gtk_fixed_put (GTK_FIXED (fixed9), label102, 16, 288);
  gtk_widget_set_uposition (label102, 16, 288);
  gtk_widget_set_usize (label102, 41, 16);

  label103 = gtk_label_new (_("N"));
  gtk_widget_ref (label103);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "label103", label103,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label103);
  gtk_fixed_put (GTK_FIXED (fixed9), label103, 16, 272);
  gtk_widget_set_uposition (label103, 16, 272);
  gtk_widget_set_usize (label103, 41, 16);

  label101 = gtk_label_new (_("N-1"));
  gtk_widget_ref (label101);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "label101", label101,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label101);
  gtk_fixed_put (GTK_FIXED (fixed9), label101, 16, 260);
  gtk_widget_set_uposition (label101, 16, 260);
  gtk_widget_set_usize (label101, 41, 16);

  label100 = gtk_label_new (_("N-2"));
  gtk_widget_ref (label100);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "label100", label100,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label100);
  gtk_fixed_put (GTK_FIXED (fixed9), label100, 16, 244);
  gtk_widget_set_uposition (label100, 16, 244);
  gtk_widget_set_usize (label100, 41, 16);

  EdtJrn_BtAjoutLib = gtk_button_new_with_label (_("Ajouter"));
  gtk_widget_ref (EdtJrn_BtAjoutLib);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "EdtJrn_BtAjoutLib", EdtJrn_BtAjoutLib,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtJrn_BtAjoutLib);
  gtk_fixed_put (GTK_FIXED (fixed9), EdtJrn_BtAjoutLib, 424, 136);
  gtk_widget_set_uposition (EdtJrn_BtAjoutLib, 424, 136);
  gtk_widget_set_usize (EdtJrn_BtAjoutLib, 64, 16);
  gtk_tooltips_set_tip (tooltips, EdtJrn_BtAjoutLib, _("Ajouter raccourcis"), NULL);

  label104 = gtk_label_new (_("Ventilation automatique :"));
  gtk_widget_ref (label104);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "label104", label104,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label104);
  gtk_fixed_put (GTK_FIXED (fixed9), label104, 12, 88);
  gtk_widget_set_uposition (label104, 12, 88);
  gtk_widget_set_usize (label104, 144, 16);
  gtk_misc_set_alignment (GTK_MISC (label104), 0, 0);

  label107 = gtk_label_new (_("Raccourcis clavier :"));
  gtk_widget_ref (label107);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "label107", label107,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label107);
  gtk_fixed_put (GTK_FIXED (fixed9), label107, 224, 88);
  gtk_widget_set_uposition (label107, 224, 88);
  gtk_widget_set_usize (label107, 124, 16);
  gtk_misc_set_alignment (GTK_MISC (label107), 0, 0);

  EdtJrn_BtSuppLib = gtk_button_new_with_label (_("Supprimer"));
  gtk_widget_ref (EdtJrn_BtSuppLib);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "EdtJrn_BtSuppLib", EdtJrn_BtSuppLib,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtJrn_BtSuppLib);
  gtk_fixed_put (GTK_FIXED (fixed9), EdtJrn_BtSuppLib, 424, 160);
  gtk_widget_set_uposition (EdtJrn_BtSuppLib, 424, 160);
  gtk_widget_set_usize (EdtJrn_BtSuppLib, 64, 16);
  gtk_tooltips_set_tip (tooltips, EdtJrn_BtSuppLib, _("Supprimer raccourcis"), NULL);

  hseparator11 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator11);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "hseparator11", hseparator11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator11);
  gtk_fixed_put (GTK_FIXED (fixed9), hseparator11, 4, 76);
  gtk_widget_set_uposition (hseparator11, 4, 76);
  gtk_widget_set_usize (hseparator11, 488, 16);

  vseparator4 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator4);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "vseparator4", vseparator4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator4);
  gtk_fixed_put (GTK_FIXED (fixed9), vseparator4, 208, 84);
  gtk_widget_set_uposition (vseparator4, 208, 84);
  gtk_widget_set_usize (vseparator4, 16, 128);

  hseparator10 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator10);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "hseparator10", hseparator10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator10);
  gtk_fixed_put (GTK_FIXED (fixed9), hseparator10, 4, 304);
  gtk_widget_set_uposition (hseparator10, 4, 304);
  gtk_widget_set_usize (hseparator10, 488, 16);

  scrolledwindow5 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow5);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "scrolledwindow5", scrolledwindow5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow5);
  gtk_fixed_put (GTK_FIXED (fixed9), scrolledwindow5, 224, 104);
  gtk_widget_set_uposition (scrolledwindow5, 224, 104);
  gtk_widget_set_usize (scrolledwindow5, 192, 96);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow5), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  ListLib = gtk_clist_new (2);
  gtk_widget_ref (ListLib);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "ListLib", ListLib,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ListLib);
  gtk_container_add (GTK_CONTAINER (scrolledwindow5), ListLib);
  gtk_tooltips_set_tip (tooltips, ListLib, _("Double cliquer pour modifier la ligne."), NULL);
  gtk_clist_set_column_width (GTK_CLIST (ListLib), 0, 27);
  gtk_clist_set_column_width (GTK_CLIST (ListLib), 1, 80);
  gtk_clist_column_titles_show (GTK_CLIST (ListLib));

  label105 = gtk_label_new (_("Code"));
  gtk_widget_ref (label105);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "label105", label105,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label105);
  gtk_clist_set_column_widget (GTK_CLIST (ListLib), 0, label105);
  gtk_widget_set_sensitive (label105, FALSE);

  label106 = gtk_label_new (_("Libell"));
  gtk_widget_ref (label106);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "label106", label106,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label106);
  gtk_clist_set_column_widget (GTK_CLIST (ListLib), 1, label106);
  gtk_widget_set_sensitive (label106, FALSE);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow4);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "scrolledwindow4", scrolledwindow4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow4);
  gtk_fixed_put (GTK_FIXED (fixed9), scrolledwindow4, 16, 104);
  gtk_widget_set_uposition (scrolledwindow4, 16, 104);
  gtk_widget_set_usize (scrolledwindow4, 112, 96);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_widget_ref (viewport1);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "viewport1", viewport1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (viewport1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), viewport1);

  ListVentil = gtk_list_new ();
  gtk_widget_ref (ListVentil);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "ListVentil", ListVentil,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ListVentil);
  gtk_container_add (GTK_CONTAINER (viewport1), ListVentil);

  hbox11 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox11);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "hbox11", hbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox11);
  gtk_box_pack_start (GTK_BOX (vbox10), hbox11, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox11), 4);

  EdtJrn_BtAjouter = gtk_button_new_with_label (_("Ajouter"));
  gtk_widget_ref (EdtJrn_BtAjouter);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "EdtJrn_BtAjouter", EdtJrn_BtAjouter,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtJrn_BtAjouter);
  gtk_box_pack_start (GTK_BOX (hbox11), EdtJrn_BtAjouter, FALSE, FALSE, 0);

  EdtJrn_BtModifier = gtk_button_new_with_label (_("Modifier"));
  gtk_widget_ref (EdtJrn_BtModifier);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "EdtJrn_BtModifier", EdtJrn_BtModifier,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtJrn_BtModifier);
  gtk_box_pack_start (GTK_BOX (hbox11), EdtJrn_BtModifier, FALSE, FALSE, 0);

  EdtJrn_BtSupp = gtk_button_new_with_label (_("Supprimer"));
  gtk_widget_ref (EdtJrn_BtSupp);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "EdtJrn_BtSupp", EdtJrn_BtSupp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtJrn_BtSupp);
  gtk_box_pack_start (GTK_BOX (hbox11), EdtJrn_BtSupp, FALSE, FALSE, 0);

  EdtJrn_BtOpt = gtk_button_new_with_label (_("Options"));
  gtk_widget_ref (EdtJrn_BtOpt);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "EdtJrn_BtOpt", EdtJrn_BtOpt,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtJrn_BtOpt);
  gtk_box_pack_start (GTK_BOX (hbox11), EdtJrn_BtOpt, FALSE, FALSE, 0);

  EdtJrn_BtClose = gnome_stock_button (GNOME_STOCK_BUTTON_CLOSE);
  gtk_widget_ref (EdtJrn_BtClose);
  gtk_object_set_data_full (GTK_OBJECT (EditJrn), "EdtJrn_BtClose", EdtJrn_BtClose,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtJrn_BtClose);
  gtk_box_pack_start (GTK_BOX (hbox11), EdtJrn_BtClose, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (EditJrn), "show",
                      GTK_SIGNAL_FUNC (on_EditJrn_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EditJrn), "destroy",
                      GTK_SIGNAL_FUNC (on_EditJrn_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtJrn_BtPrec), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtJrn_BtPrec_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtJrn_BtSuiv), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtJrn_BtSuiv_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (JCode), "key_press_event",
                      GTK_SIGNAL_FUNC (on_JCode_key_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (JCptAssoc), "key_press_event",
                      GTK_SIGNAL_FUNC (on_JCptAssoc_key_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtJrn_BtSelVent), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtJrn_BtSelVent_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtJrn_BtSuppVent), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtJrn_BtSuppVent_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtJrn_BtAjoutLib), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtJrn_BtAjoutLib_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtJrn_BtSuppLib), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtJrn_BtSuppLib_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtJrn_BtJrn), "clicked",
                      GTK_SIGNAL_FUNC (EdtJrn_BtJrn_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ListLib), "select_row",
                      GTK_SIGNAL_FUNC (on_ListLib_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ListLib), "button_press_event",
                      GTK_SIGNAL_FUNC (on_ListLib_button_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ListVentil), "select_child",
                      GTK_SIGNAL_FUNC (on_ListVentil_select_child),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtJrn_BtAjouter), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtJrn_BtAjouter_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtJrn_BtModifier), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtJrn_BtModifier_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtJrn_BtSupp), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtJrn_BtSupp_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtJrn_BtOpt), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtJrn_BtOpt_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtJrn_BtClose), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtJrn_BtClose_clicked),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (EditJrn), "tooltips", tooltips);

  gtk_window_add_accel_group (GTK_WINDOW (EditJrn), accel_group);

  return EditJrn;
}

void Dialog_EdtJrn(gchar *JSel)
{
  my_ulonglong Loc;

  Journaux=create_EditJrn();
  gtk_widget_show_all(Journaux);
  EdtJrnRes=NULL;
  EdtJrn_DispData();
  if (JSel!=NULL) {
    if ((Loc=SearchCode(EdtJrnRes,JSel,1))!=-1) {
      MysqlPtr=Loc;
      EdtJrn_DispData();
    }
  }
}
