/*******************************************************************/
/* Comptabilit Analytique Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 22/03/02 - Edition des plans comptables                         */
/* Fichier source                                                  */
/*******************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 


#include <gtk/gtk.h>
#include <gnome.h>
#include <string.h>
#include <ctype.h>
#include <mysql/mysql.h>
#include "support.h"
#include "common.h"
#include "gtksql.h"
#include "select.h"

#include "relance.h"
#include "edtplc.h"

/* Variables */
GtkWidget    *PlanComptable,*MenuOpt;
my_ulonglong MysqlPtr;
MYSQL_RES    *EdtPlcRes;
listidlib    *Analyt,*ORG_ANA,*ORG_REGL,*Regl;
gint         PageDisplay;
gchar        CptDisplay[11];
void         (*ReturnFunc) (int e);
/* Protos */
GtkWidget* create_EditPlc (void);
void EdtPlc_DispData(void);
GtkWidget* create_EdtLibAuto (void);
void on_EditPlc_show(GtkWidget *widget,gpointer user_data);

void on_EditPlc_destroy                     (GtkObject       *object,gpointer         user_data);

void EdtPlc_BtInsert_clicked                (GtkButton       *button,gpointer         user_data);

void EdtPlc_BtClose_clicked                 (GtkButton       *button,gpointer         user_data);

void EdtPlc_BtModifier_clicked              (GtkButton       *button,gpointer         user_data);

void EdtPlc_CptCode_changed                 (GtkEditable     *editable,gpointer       user_data);

void EdtPlc_OngletPlan_switch_page(GtkNotebook *notebook,GtkNotebookPage *page,gint page_num,gpointer user_data);

void EdtPlc_BtSuppr_clicked                 (GtkButton       *button,gpointer         user_data);

void EdtPlc_BtCol_clicked                   (GtkButton       *button,gpointer         user_data);

gboolean EdtPlc_CptCol_key_press_event(GtkWidget *widget,GdkEventKey *event,gpointer  user_data);

void on_EdtPlc_BtPrec_clicked               (GtkButton       *button,gpointer         user_data);

void on_EdtPlc_BtSel_clicked                (GtkButton       *button,gpointer         user_data);

void on_EdtPlc_BtSuiv_clicked               (GtkButton       *button,gpointer         user_data);

gboolean on_CptCode_key_press_event    (GtkWidget *widget,GdkEventKey *event,gpointer user_data);

void on_CptAna_toggled                 (GtkToggleButton *togglebutton,gpointer         user_data);
void EdtPlc_InitButtons(gboolean Sensitive);
void CreateMenuOpt(void);
void MenuNote(gchar *string);
void MenuRelance(gchar *string);

/**********************************************************************/
/* Controle si la validiter des boutons                               */
void EdtPlc_InitButtons(gboolean Sensitive)
{
  GtkWidget *Widget;

  Widget=lookup_widget(GTK_WIDGET (PlanComptable),"EdtPlc_BtPrec");
  gtk_widget_set_sensitive(Widget,Sensitive);
  Widget=lookup_widget(GTK_WIDGET (PlanComptable),"EdtPlc_BtSuiv");
  gtk_widget_set_sensitive(Widget,Sensitive);
  Widget=lookup_widget(GTK_WIDGET (PlanComptable),"EdtPlc_BtSel");
  gtk_widget_set_sensitive(Widget,Sensitive);
  Widget=lookup_widget(GTK_WIDGET (PlanComptable),"BtModifier");
  gtk_widget_set_sensitive(Widget,Sensitive);
  Widget=lookup_widget(GTK_WIDGET (PlanComptable),"BtSuppr");
  gtk_widget_set_sensitive(Widget,Sensitive);
}

/*******************************************************************************/
/* Procdure principale d'affichage des plan comptables                        */
/*******************************************************************************/
void EdtPlc_DispData(void)
{
  char SqlCmd[250],PsCle[LEN_COD_SOC+1],PlcCle[9],Tmp[25];
  char *CptLp[]={"N","P","L","*"};
  char *CptTfe[]={"N","D","R","*"};
  char *CptPos[]={"C","D","*"};
	char DebExercice[12],FinExercice[12];
  MYSQL_RES *Result;
  MYSQL_ROW Row;
  int Valid;
  GtkWidget *Stat,*Widget;
  double a,b,c;

  GetSocRun(PsCle);
  if (EdtPlcRes==NULL) {
    Valid=FALSE;
    MysqlPtr=0;
    sprintf(SqlCmd,"Select * From Comptes,Col Where Comptes.CptSoc='%s' And Col.ColCode=Comptes.CptCol",PsCle);
    if (!mysql_query(DbLcpt,SqlCmd)) {
      EdtPlcRes=mysql_store_result(DbLcpt);
      if (EdtPlcRes) if (mysql_num_rows(EdtPlcRes)!=0) Valid=TRUE;
    }
  } else Valid=TRUE;
  EdtPlc_InitButtons(Valid);
  if (Valid) {
    Row=mysql_fetch_row(EdtPlcRes);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptCode",Row[1]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptCodeInfo",Row[1]);
    strcpy(PlcCle,Row[1]);
		strcpy(CptDisplay,Row[1]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptLib",Row[2]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptLibInfo",Row[2]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptCol",Row[4]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"TxtCol",Row[39]);
    BooleanSqlToGtk(GTK_WIDGET (PlanComptable),"CptCent",Row[5]);
    RadioSqlToGtk(GTK_WIDGET (PlanComptable),"RdCptPos",Row[6],CptPos);
    BooleanSqlToGtk(GTK_WIDGET (PlanComptable),"CptAna",Row[7]);
    ComboMRID(GTK_WIDGET (PlanComptable),ORG_ANA,"CptCdeAna",Row[8]);
    RadioSqlToGtk(GTK_WIDGET (PlanComptable),"RdCptTfe",Row[9],CptTfe);
    RadioSqlToGtk(GTK_WIDGET (PlanComptable),"RdCptLp",Row[10],CptLp);
    BooleanSqlToGtk(GTK_WIDGET (PlanComptable),"CptBloq",Row[12]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptAdr1",Row[13]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptAdr2",Row[14]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptCp",Row[15]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptVille",Row[16]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptTel",Row[17]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptPort",Row[18]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptEmail",Row[19]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptFax",Row[20]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptInter",Row[21]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptAct",Row[22]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptBqe",Row[23]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptRib1",Row[24]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptRib2",Row[25]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptRib3",Row[26]);
    StrSqlToGtk(GTK_WIDGET (PlanComptable),"CptRib4",Row[27]);
    ComboMRID(GTK_WIDGET (PlanComptable),ORG_REGL,"CptMr",Row[28]);
    ComboSqlToGtk(GTK_WIDGET (PlanComptable),"CptEch",Row[29]);
    if (strcmp(Row[30],"N")==0) MenuSqlToGtk(GTK_WIDGET (PlanComptable),"CptEchfn",0); else MenuSqlToGtk(GTK_WIDGET (PlanComptable),"CptEchfn",1); 
    ComboSqlToGtk(GTK_WIDGET (PlanComptable),"CptEchj",Row[31]);
    Stat=lookup_widget(GTK_WIDGET (PlanComptable),"ListStat");
    /* Ligne 1 */
    if (Row[32]!=NULL) a=atof(Row[32]);else a=0;
    sprintf(Tmp,"%8.2f",a);
    gtk_clist_set_text(GTK_CLIST (Stat),0,0,Tmp);
    if (Row[33]!=NULL) b=atof(Row[33]);else b=0;
    sprintf(Tmp,"%8.2f",b);
    gtk_clist_set_text(GTK_CLIST (Stat),0,1,Tmp);
    c=a-b;
    sprintf(Tmp,"%8.2f",c);
    gtk_clist_set_text(GTK_CLIST (Stat),0,2,Tmp);
    /* Ligne 2 */
    if (Row[34]!=NULL) a=atof(Row[34]);else a=0;
    sprintf(Tmp,"%8.2f",a);
    gtk_clist_set_text(GTK_CLIST (Stat),1,0,Tmp);
    if (Row[35]!=NULL) b=atof(Row[35]);else b=0;
    sprintf(Tmp,"%8.2f",b);
    gtk_clist_set_text(GTK_CLIST (Stat),1,1,Tmp);
    sprintf(Tmp,"%8.2f",a-b);
    gtk_clist_set_text(GTK_CLIST (Stat),1,2,Tmp);
    if ((a!=0) || (b!=0)) {
      if (c!=0) c=(a-b)/c; else c=1;
      if (c>=1) c=(c-1)*100; else c=(100-(c*100))*-1;
      if (c==0) c=100;
      sprintf(Tmp,"%-3.2f%%",c);
      gtk_clist_set_text(GTK_CLIST (Stat),1,3,Tmp);
    }
    c=a-b;
    /* Ligne 3 */
    GetDateExercice(DebExercice,FinExercice,PsCle);
    sprintf(SqlCmd,"Select Sum(EcrDebit),Sum(EcrCredit) from Ecrit where EcrSoc='%s' And EcrCpt='%s' And EcrDate Between '%s' And '%s'",PsCle,PlcCle,DebExercice,FinExercice);
    if (mysql_query(DbLcpt,SqlCmd)==0) {
      Result=mysql_store_result(DbLcpt);
      if (Result) {
	Stat=lookup_widget(GTK_WIDGET (PlanComptable),"ListStat");
	a=0;
	b=0;
	if (mysql_num_rows(Result)!=0) {
	  Row=mysql_fetch_row(Result);
	  if (Row[0]!=NULL) a=atof(Row[0]);
	  if (Row[1]!=NULL) b= atof(Row[1]);
	}
	sprintf(Tmp,"%8.2f",a);
	gtk_clist_set_text(GTK_CLIST (Stat),2,0,Tmp);
	sprintf(Tmp,"%8.2f",b);
	gtk_clist_set_text(GTK_CLIST (Stat),2,1,Tmp);
	sprintf(Tmp,"%8.2f",a-b);
	gtk_clist_set_text(GTK_CLIST (Stat),2,2,Tmp);
	if ((a!=0) || (b!=0)) {
	  if (c!=0) c=(a-b)/c;else c=1;
	  if (c>=1) c=(c-1)*100; else c=(100-(c*100))*-1;
	  if (c==0) c=100;
	  sprintf(Tmp,"%-3.2f%%",c);
	  gtk_clist_set_text(GTK_CLIST (Stat),2,3,Tmp);
	}
	c=a-b;
	mysql_free_result(Result);
      } else MessageInfo("Rsultat SQL NULL !");
    }
    /* Ligne 4 */
    sprintf(SqlCmd,"Select Sum(EcrDebit),Sum(EcrCredit) from Ecrit where EcrSoc='%s' And EcrCpt='%s' And EcrDate >'%s'",PsCle,PlcCle,FinExercice);
    if (mysql_query(DbLcpt,SqlCmd)==0) {
      Result=mysql_store_result(DbLcpt);
      if (Result) {
	Stat=lookup_widget(GTK_WIDGET (PlanComptable),"ListStat");
	a=0;
	b=0;
	if (mysql_num_rows(Result)!=0) {
	  Row=mysql_fetch_row(Result);
	  if (Row[0]!=NULL) a=atof(Row[0]);
	  if (Row[1]!=NULL) b= atof(Row[1]);
	}
	sprintf(Tmp,"%8.2f",a);
	gtk_clist_set_text(GTK_CLIST (Stat),3,0,Tmp);
	sprintf(Tmp,"%8.2f",b);
	gtk_clist_set_text(GTK_CLIST (Stat),3,1,Tmp);
	sprintf(Tmp,"%8.2f",a-b);
	gtk_clist_set_text(GTK_CLIST (Stat),3,2,Tmp);
	if ((a!=0) || (b!=0)) {
	  if (c!=0) c=(a-b)/c;else c=1;
	  if (c>=1) c=(c-1)*100; else c=(100-(c*100))*-1;
	  if (c==0) c=100;
	  sprintf(Tmp,"%-3.2f%%",c);
	  gtk_clist_set_text(GTK_CLIST (Stat),3,3,Tmp);
	}
	mysql_free_result(Result);
      } else MessageInfo(_("Rsultat SQL NULL !"));
    } else MessageInfo(_("Echec SQL !"));
    Widget=lookup_widget(GTK_WIDGET(PlanComptable),"OngletPlan");
    if (isdigit(PlcCle[0]) && (PageDisplay=1)) {
      gtk_notebook_prev_page(GTK_NOTEBOOK(Widget));
      PageDisplay=0;
    }
  }
}

void on_EditPlc_show(GtkWidget *widget,gpointer user_data)
{
  GtkCList *CList;
  gchar *Bidon[4]={" "," "," "," "};

  OpenDbLcpt();
  CList=GTK_CLIST (lookup_widget(GTK_WIDGET (widget),"ListStat"));
  if (CList!=NULL) {
    gtk_clist_set_column_justification(CList,0,GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification(CList,1,GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification(CList,2,GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification(CList,3,GTK_JUSTIFY_RIGHT);
    gtk_clist_append(CList,Bidon);
    gtk_clist_append(CList,Bidon);
    gtk_clist_append(CList,Bidon);
    gtk_clist_append(CList,Bidon);
  }
  PageDisplay=0;
}

/*** Fin du plan comptable ***/
void on_EditPlc_destroy(GtkObject *object,gpointer user_data)
{
	gchar *SqlCmd,PsCle[LEN_COD_SOC+1];

  GetSocRun(PsCle);
  if (EdtPlcRes!=NULL) mysql_free_result(EdtPlcRes);
	SqlCmd=g_strdup_printf("Select count(*) From Comptes where CptSoc='%s'",PsCle);
	if (SqlGetNumber(SqlCmd)!=0)	ReturnFunc(TRUE);else ReturnFunc(FALSE);
	free(SqlCmd);
  CloseDbLcpt();
  FreeModRegl(ORG_REGL);
  FreeCdeAna(ORG_ANA);
}


void EdtPlc_BtInsert_clicked(GtkButton *button,gpointer user_data)
{
  char SqlCmd[1024],*End,PsCle[LEN_COD_SOC+1],CptCode[9];
  char *CptLp[]={"L","P","N","*"};
  char *CptTfe[]={"N","D","R","*"};
  char *CptPos[]={"D","C","*"};
  char *EchfnLib[]={_("Net"),_("Fin de mois"),"*"};
  char *EchfnID[]={"N","F"};
  GtkWidget *CptWdg;

  GetSocRun(PsCle);
  CptWdg=lookup_widget(GTK_WIDGET (button),"CptCode");
  strcpy(CptCode,gtk_entry_get_text(GTK_ENTRY (CptWdg)));
	sprintf(SqlCmd,"Select count(*) from Comptes where CptSoc='%s' and CptCode='%s'",PsCle,CptCode);
	if (SqlGetNumber(SqlCmd)!=0) {
		MessageAlerte(_("Ce code exite dj !"));
		return;
	}
  End=strmov(SqlCmd,"INSERT INTO Comptes (CptSoc,CptCode,CptLib,CptLp,CptCol,CptCent,CptTfe,CptPos,CptAna,CptCdeAna,CptBloq,CptAdr1,CptAdr2,CptCp,CptVille,CptTel,CptPort,CptEmail,CptFax,CptInter,CptAct,CptBqe,CptRib1,CptRib2,CptRib3,CptRib4,CptMr,CptEch,CptEchFn,CptEchj) VALUES (");
  *End++='\'';
  End=strmov(End,PsCle);
  *End++='\'';
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptCode");
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptLib");
  *End++=',';
  End=GtkToRadioSql(End,GTK_WIDGET (button),"RdCptLp",CptLp);
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptCol");
  *End++=',';
  End=GtkToBooleanSql(End,GTK_WIDGET (button),"CptCent");
  *End++=',';
  End=GtkToRadioSql(End,GTK_WIDGET (button),"RdCptTfe",CptTfe);
  *End++=',';
  End=GtkToRadioSql(End,GTK_WIDGET (button),"RdCptPos",CptPos);
  *End++=',';
  End=GtkToBooleanSql(End,GTK_WIDGET (button),"CptAna");
  *End++=',';
  End=ComboMRLib(End,GTK_WIDGET (button),ORG_ANA,"CptCdeAna");
  *End++=',';
  End=GtkToBooleanSql(End,GTK_WIDGET (button),"CptBloq");
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptAdr1");
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptAdr2");
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptCp");
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptVille");
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptTel");
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptPort");
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptEmail");
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptFax");
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptInter");
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptAct");
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptBqe");
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptRib1");
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptRib2");
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptRib3");
  *End++=',';
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptRib4");
  *End++=',';
  End=ComboMRLib(End,GTK_WIDGET (button),ORG_REGL,"CptMr");
  *End++=',';
  End=GtkToComboIntSql(End,GTK_WIDGET (button),"CptEch");
  *End++=',';
  End=GtkToMenuSql(End,GTK_WIDGET (button),"CptEchfn",EchfnLib,EchfnID);
  *End++=',';
  End=GtkToComboIntSql(End,GTK_WIDGET (button),"CptEchj");
  *End++=')';
  *End='\0';
  g_print("%s",SqlCmd);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    mysql_free_result(EdtPlcRes);
    EdtPlcRes=NULL;
    EdtPlc_DispData();
    MysqlPtr=SearchCode(EdtPlcRes,CptCode,1);
    EdtPlc_DispData();
  } else MessageInfo(_("Insertion erreur !"));
}


void EdtPlc_BtClose_clicked(GtkButton *button,gpointer user_data)
{
  GtkWidget *Wcall;

  Wcall=lookup_widget(GTK_WIDGET (button),"EditPlc");
  gtk_widget_destroy(GTK_WIDGET(Wcall));
}

/* Modification du plan comptable */
void EdtPlc_BtModifier_clicked(GtkButton *button,gpointer user_data)
{
  char SqlCmd[1000],*End,PsCle[LEN_COD_SOC+1],CptCode[9];
  char *CptLp[]={"L","P","N","*"};
  char *CptTfe[]={"N","D","R","*"};
  char *CptPos[]={"D","C","*"};
  char *EchfnLib[]={"Net","Fin de mois","*"};
  char *EchfnID[]={"N","F"};
  GtkWidget *CptWdg;

  GetSocRun(PsCle);
  CptWdg=lookup_widget(GTK_WIDGET (button),"CptCode");
  strcpy(CptCode,gtk_entry_get_text(GTK_ENTRY (CptWdg)));
  End=strmov(SqlCmd,"Update Comptes Set CptLib=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptLib");
  End=strmov(End,",CptLp=");
  End=GtkToRadioSql(End,GTK_WIDGET (button),"RdCptLp",CptLp);
  End=strmov(End,",CptCol=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptCol");
  End=strmov(End,",CptCent=");
  End=GtkToBooleanSql(End,GTK_WIDGET (button),"CptCent");
  End=strmov(End,",CptTfe=");
  End=GtkToRadioSql(End,GTK_WIDGET (button),"RdCptTfe",CptTfe);
  End=strmov(End,",CptPos=");
  End=GtkToRadioSql(End,GTK_WIDGET (button),"RdCptPos",CptPos);
  End=strmov(End,",CptAna=");
  End=GtkToBooleanSql(End,GTK_WIDGET (button),"CptAna");
  End=strmov(End,",CptCdeAna=");
  End=ComboMRLib(End,GTK_WIDGET (button),ORG_ANA,"CptCdeAna");
  End=strmov(End,",CptBloq=");
  End=GtkToBooleanSql(End,GTK_WIDGET (button),"CptBloq");
  End=strmov(End,",CptAdr1=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptAdr1");
  End=strmov(End,",CptAdr2=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptAdr2");
  End=strmov(End,",CptCp=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptCp");
  End=strmov(End,",CptVille=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptVille");
  End=strmov(End,",CptTel=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptTel");
  End=strmov(End,",CptPort=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptPort");
  End=strmov(End,",CptEmail=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptEmail");
  End=strmov(End,",CptFax=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptFax");
  End=strmov(End,",CptInter=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptInter");
  End=strmov(End,",CptAct=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptAct");
  End=strmov(End,",CptBqe=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptBqe");
  End=strmov(End,",CptRib1=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptRib1");
  End=strmov(End,",CptRib2=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptRib2");
  End=strmov(End,",CptRib3=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptRib3");
  End=strmov(End,",CptRib4=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"CptRib4");
  End=strmov(End,",CptMr=");
  End=ComboMRLib(End,GTK_WIDGET (button),ORG_REGL,"CptMr");
  End=strmov(End,",CptEch=");
  End=GtkToComboIntSql(End,GTK_WIDGET (button),"CptEch");
  End=strmov(End,",CptEchfn=");
  End=GtkToMenuSql(End,GTK_WIDGET (button),"CptEchfn",EchfnLib,EchfnID);
  End=strmov(End,",CptEchj=");
  End=GtkToComboIntSql(End,GTK_WIDGET (button),"CptEchj");
  End=strmov(End," Where CptCode='");
  End=strmov(End,CptCode);
  End=strmov(End,"' And CptSoc='");
  End=strmov(End,PsCle);
  *End++='\'';
  *End='\0';
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    if (mysql_affected_rows(DbLcpt)==0)  MessageInfo("Modification erreur !");
  } else MessageInfo("Modification erreur !");
  mysql_free_result(EdtPlcRes);
  EdtPlcRes=NULL;
  EdtPlc_DispData();
  MysqlPtr=SearchCode(EdtPlcRes,CptCode,1);
  EdtPlc_DispData();
}


/* Plan comptables suivant */
void on_EdtPlc_BtSuiv_clicked(GtkButton *button,gpointer user_data)
{
  if (MysqlPtr<mysql_num_rows(EdtPlcRes)-1) {
    EdtPlc_DispData();
    MysqlPtr++;
  }
}

/* Plan comptable prcdent */
void on_EdtPlc_BtPrec_clicked(GtkButton *button,gpointer user_data)
{
  if (MysqlPtr>0) {
    MysqlPtr--;
    mysql_data_seek(EdtPlcRes,MysqlPtr);
    EdtPlc_DispData();
  }
}

/* Selection d'in plan comptable */
void on_EdtPlc_BtSel_clicked(GtkButton *button,gpointer user_data)
{
  gchar CodeRet[11];

  if (ListSelect(CodeRet,"Comptes","CptSoc","CptCode","CptLib",NULL)==MR_OK) {
    MysqlPtr=SearchCode(EdtPlcRes,CodeRet,1);
    EdtPlc_DispData();
  }
}

/* Selection d'un collectif */
void EdtPlc_BtCol_clicked(GtkButton *button,gpointer user_data)
{
  GtkEntry *Entry;
  gchar ColRet[5];

  Entry=GTK_ENTRY (lookup_widget(GTK_WIDGET (button),"CptCol"));
  if (Entry!=NULL) {
    if (ListSelect(ColRet,"Col","ColSoc","ColCode","ColLib",NULL)==MR_OK) gtk_entry_set_text(GTK_ENTRY (Entry),ColRet);
  }
}

void EdtPlc_OngletPlan_switch_page(GtkNotebook *notebook,GtkNotebookPage *page,gint page_num,gpointer user_data)
{
  PageDisplay=page_num;
}

void EdtPlc_BtSuppr_clicked(GtkButton *button,gpointer user_data)
{
  GtkWidget *Entry;
  gchar SqlCmd[120],CptCode[9],Soc[3];
  MYSQL_ROW Row;

  if (MsgQuestion(_("Supprimer cette fiche ?"))==1) {
    Entry=lookup_widget(GTK_WIDGET (button),"CptCode");
    if (Entry!=NULL) {
      GetSocRun(Soc);
      strcpy(CptCode,gtk_entry_get_text(GTK_ENTRY (Entry)));
      sprintf(SqlCmd,"Delete from Comptes Where CptSoc='%s' And CptCode='%s'",Soc,CptCode);
      if (mysql_query(DbLcpt,SqlCmd)==0) {
	if (MysqlPtr==mysql_num_rows(EdtPlcRes)-1) {
	  MysqlPtr--;
	  mysql_data_seek(EdtPlcRes,MysqlPtr);
	}
	Row=mysql_fetch_row(EdtPlcRes);
	strcpy(CptCode,Row[1]);
	mysql_free_result(EdtPlcRes);
	EdtPlcRes=NULL;
	EdtPlc_DispData();
	MysqlPtr=SearchCode(EdtPlcRes,CptCode,1);
	EdtPlc_DispData();
      } else MessageErreur(_("Echec SQL"));
    }
  }
}

gboolean on_CptCode_key_press_event(GtkWidget *widget,GdkEventKey *event,gpointer user_data)
{
  char CptCode[9];
  my_ulonglong Loc;

  if (event->type==GDK_KEY_PRESS) {
    if ((event->keyval==GDK_Return) || (event->keyval==GDK_KP_Enter)) {
      strcpy(CptCode,gtk_entry_get_text(GTK_ENTRY (widget)));
      if (isdigit(*CptCode)) while (strlen(CptCode)<8) strcat(CptCode,"0");
      gtk_entry_set_text(GTK_ENTRY (widget),CptCode);
      if ((Loc=SearchCode(EdtPlcRes,CptCode,1))==-1) MessageAlerte(_("Code inexistant !"));else MysqlPtr=Loc;
      EdtPlc_DispData();
    }
  }
  return FALSE;
}

gboolean EdtPlc_CptCol_key_press_event(GtkWidget *widget,GdkEventKey *event,gpointer user_data)
{
  char CptCol[5],SqlCmd[120];
  MYSQL_RES *Res;
  MYSQL_ROW Row;
  GtkWidget *Info;

  if (event->type==GDK_KEY_PRESS) {
    if ((event->keyval==GDK_Return) || (event->keyval==GDK_KP_Enter)) {
      strcpy(CptCol,gtk_entry_get_text(GTK_ENTRY (widget)));
      while (strlen(CptCol)<4) strcat(CptCol,"0");
      gtk_entry_set_text(GTK_ENTRY (widget),CptCol);
      sprintf(SqlCmd,"Select ColCode,ColLib From Col Where ColCode='%s'",CptCol);
      if (mysql_query(DbLcpt,SqlCmd)==0) {
	Res=mysql_store_result(DbLcpt);
	if (mysql_num_rows(Res)!=0) {
	  Row=mysql_fetch_row(Res);
	  Info=lookup_widget(widget,"TxtCol");
	  if (Info!=NULL) gtk_entry_set_text(GTK_ENTRY (Info),Row[1]);
	} else MessageAlerte(_("Code collectif inexistant !"));
      } else MessageErreur(_("Erreur SQL !"));
    }
  }
  return FALSE;
}

void on_CptAna_toggled(GtkToggleButton *togglebutton,gpointer user_data)
{
  GtkWidget *Widget;

  Widget=lookup_widget(GTK_WIDGET(togglebutton),"CptCdeAna");
  if (togglebutton->active) gtk_widget_set_sensitive(GTK_WIDGET (Widget),TRUE); else gtk_widget_set_sensitive(GTK_WIDGET (Widget),FALSE);
}

void MenuNote(gchar *string)
{
}

void MenuRelance(gchar *string)
{
	 Dialog_RelanceNew(CptDisplay);
}

static gint on_EdtPlcBtOpt_clicked(GtkWidget *button,GdkEvent *event)
{
	 GdkEventButton *bevent;
	 
	 if (event->type==GDK_BUTTON_PRESS) {
			bevent= (GdkEventButton *) event;
			gtk_menu_popup(GTK_MENU (MenuOpt),NULL,NULL,NULL,NULL,bevent->button,bevent->time);
			return TRUE;
	 }
	 return FALSE;
}

GtkWidget* create_EditPlc (void)
{
  GtkWidget *EditPlc;
  GtkWidget *vbox6;
  GtkWidget *fixed3;
  GtkWidget *EdtPlc_BtSuiv;
  GtkWidget *EdtPlc_BtPrec;
  GtkWidget *OngletPlan;
  GtkWidget *fixed5;
  GtkWidget *CptCode;
  GtkWidget *CptLib;
  GtkWidget *CptCol;
  GtkWidget *EdtPlc_BtSel;
  GtkWidget *CptEchfn;
  GtkWidget *CptEchfn_menu;
  GtkWidget *glade_menuitem;
  GtkWidget *TxtCol;
  GtkWidget *hseparator3;
  GtkWidget *vseparator1;
  GtkWidget *vseparator2;
  GSList *CptLp_group = NULL;
  GtkWidget *RdCptLp;
  GtkWidget *radiobutton2;
  GtkWidget *radiobutton3;
  GtkWidget *label44;
  GSList *CptTfe_group = NULL;
  GtkWidget *radiobutton6;
  GtkWidget *radiobutton5;
  GtkWidget *RdCptTfe;
  GtkWidget *label43;
  GtkWidget *label45;
  GSList *CptPos_group = NULL;
  GtkWidget *RdCptPos;
  GtkWidget *radiobutton8;
  GtkWidget *hseparator1;
  GtkWidget *label41;
  GtkWidget *label42;
  GtkWidget *label77;
  GtkWidget *EdtPlc_BtCol;
  GtkWidget *label89;
  GtkWidget *CptEch;
  GList *CptEch_items = NULL;
  GtkWidget *combo_entry4;
  GtkWidget *CptEchj;
  GList *CptEchj_items = NULL;
  GtkWidget *combo_entry3;
  GtkWidget *label46;
  GtkWidget *CptBloq;
  GtkWidget *CptCent;
  GtkWidget *vseparator5;
  GtkWidget *label128;
  GtkWidget *CptMr;
  GtkWidget *combo_entry1;
  GtkWidget *CptAna;
  GtkWidget *CptCdeAna;
  GtkWidget *combo_entry6;
  GtkWidget *label71;
  GtkWidget *fixed6;
  GtkWidget *CptCodeInfo;
  GtkWidget *CptLibInfo;
  GtkWidget *label80;
  GtkWidget *CptAdr1;
  GtkWidget *label82;
  GtkWidget *CptAdr2;
  GtkWidget *CptCp;
  GtkWidget *label83;
  GtkWidget *label84;
  GtkWidget *CptVille;
  GtkWidget *CptTel;
  GtkWidget *CptFax;
  GtkWidget *CptPort;
  GtkWidget *label85;
  GtkWidget *label86;
  GtkWidget *label87;
  GtkWidget *CptEmail;
  GtkWidget *label81;
  GtkWidget *CptInter;
  GtkWidget *CptAct;
  GtkWidget *label92;
  GtkWidget *CptBqe;
  GtkWidget *label91;
  GtkWidget *label88;
  GtkWidget *label90;
  GtkWidget *CptRib1;
  GtkWidget *CptRib2;
  GtkWidget *CptRib3;
  GtkWidget *CptRib4;
  GtkWidget *label93;
  GtkWidget *label72;
  GtkWidget *ListStat;
  GtkWidget *label47;
  GtkWidget *label48;
  GtkWidget *label49;
  GtkWidget *label50;
  GtkWidget *label52;
  GtkWidget *label53;
  GtkWidget *label54;
  GtkWidget *label51;
  GtkWidget *hseparator2;
  GtkWidget *hbox6;
  GtkWidget *BtInsert;
  GtkWidget *BtModifier;
  GtkWidget *BtSuppr;
  GtkWidget *EdtPlcBtOpt;
  GtkWidget *EdtPlcBtClose;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  EditPlc = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (EditPlc), "EditPlc", EditPlc);
  gtk_window_set_title (GTK_WINDOW (EditPlc), _("Plan comptable"));
  gtk_window_set_position (GTK_WINDOW (EditPlc), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (EditPlc), TRUE);

  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox6);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "vbox6", vbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox6);
  gtk_container_add (GTK_CONTAINER (EditPlc), vbox6);

  fixed3 = gtk_fixed_new ();
  gtk_widget_ref (fixed3);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "fixed3", fixed3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed3);
  gtk_box_pack_start (GTK_BOX (vbox6), fixed3, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (fixed3), 5);

  EdtPlc_BtSuiv = gnome_stock_button (GNOME_STOCK_BUTTON_NEXT);
  gtk_widget_ref (EdtPlc_BtSuiv);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "EdtPlc_BtSuiv", EdtPlc_BtSuiv,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtPlc_BtSuiv);
  gtk_fixed_put (GTK_FIXED (fixed3), EdtPlc_BtSuiv, 104, 340);
  gtk_widget_set_uposition (EdtPlc_BtSuiv, 104, 340);
  gtk_widget_set_usize (EdtPlc_BtSuiv, 88, 16);
  gtk_widget_add_accelerator (EdtPlc_BtSuiv, "clicked", accel_group,
                              GDK_Page_Down, 0,
                              GTK_ACCEL_VISIBLE);

  EdtPlc_BtPrec = gnome_stock_button (GNOME_STOCK_BUTTON_PREV);
  gtk_widget_ref (EdtPlc_BtPrec);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "EdtPlc_BtPrec", EdtPlc_BtPrec,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtPlc_BtPrec);
  gtk_fixed_put (GTK_FIXED (fixed3), EdtPlc_BtPrec, 12, 340);
  gtk_widget_set_uposition (EdtPlc_BtPrec, 12, 340);
  gtk_widget_set_usize (EdtPlc_BtPrec, 88, 16);
  gtk_widget_add_accelerator (EdtPlc_BtPrec, "clicked", accel_group,
                              GDK_Page_Up, 0,
                              GTK_ACCEL_VISIBLE);

  OngletPlan = gtk_notebook_new ();
  gtk_widget_ref (OngletPlan);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "OngletPlan", OngletPlan,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (OngletPlan);
  gtk_fixed_put (GTK_FIXED (fixed3), OngletPlan, 4, 4);
  gtk_widget_set_uposition (OngletPlan, 4, 4);
  gtk_widget_set_usize (OngletPlan, 460, 229);

  fixed5 = gtk_fixed_new ();
  gtk_widget_ref (fixed5);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "fixed5", fixed5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed5);
  gtk_container_add (GTK_CONTAINER (OngletPlan), fixed5);

  CptCode = gtk_entry_new ();
  gtk_widget_ref (CptCode);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptCode", CptCode,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptCode);
  gtk_fixed_put (GTK_FIXED (fixed5), CptCode, 48, 0);
  gtk_widget_set_uposition (CptCode, 48, 0);
  gtk_widget_set_usize (CptCode, 72, 20);

  CptLib = gtk_entry_new ();
  gtk_widget_ref (CptLib);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptLib", CptLib,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptLib);
  gtk_fixed_put (GTK_FIXED (fixed5), CptLib, 80, 24);
  gtk_widget_set_uposition (CptLib, 80, 24);
  gtk_widget_set_usize (CptLib, 236, 20);

  CptCol = gtk_entry_new ();
  gtk_widget_ref (CptCol);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptCol", CptCol,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptCol);
  gtk_fixed_put (GTK_FIXED (fixed5), CptCol, 60, 48);
  gtk_widget_set_uposition (CptCol, 60, 48);
  gtk_widget_set_usize (CptCol, 36, 20);

  EdtPlc_BtSel = gtk_button_new_with_label (_("Slection"));
  gtk_widget_ref (EdtPlc_BtSel);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "EdtPlc_BtSel", EdtPlc_BtSel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtPlc_BtSel);
  gtk_fixed_put (GTK_FIXED (fixed5), EdtPlc_BtSel, 136, 0);
  gtk_widget_set_uposition (EdtPlc_BtSel, 136, 0);
  gtk_widget_set_usize (EdtPlc_BtSel, 68, 20);
  gtk_widget_add_accelerator (EdtPlc_BtSel, "clicked", accel_group,
                              GDK_F5, 0,
                              GTK_ACCEL_VISIBLE);

  CptEchfn = gtk_option_menu_new ();
  gtk_widget_ref (CptEchfn);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptEchfn", CptEchfn,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptEchfn);
  gtk_fixed_put (GTK_FIXED (fixed5), CptEchfn, 124, 176);
  gtk_widget_set_uposition (CptEchfn, 124, 176);
  gtk_widget_set_usize (CptEchfn, 100, 20);
  CptEchfn_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label (_("Net"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (CptEchfn_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("Fin de mois"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (CptEchfn_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (CptEchfn), CptEchfn_menu);

  TxtCol = gtk_entry_new ();
  gtk_widget_ref (TxtCol);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "TxtCol", TxtCol,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (TxtCol);
  gtk_fixed_put (GTK_FIXED (fixed5), TxtCol, 100, 48);
  gtk_widget_set_uposition (TxtCol, 100, 48);
  gtk_widget_set_usize (TxtCol, 128, 20);
  gtk_entry_set_editable (GTK_ENTRY (TxtCol), FALSE);

  hseparator3 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator3);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "hseparator3", hseparator3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator3);
  gtk_fixed_put (GTK_FIXED (fixed5), hseparator3, 8, 120);
  gtk_widget_set_uposition (hseparator3, 8, 120);
  gtk_widget_set_usize (hseparator3, 432, 16);

  vseparator1 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator1);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "vseparator1", vseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator1);
  gtk_fixed_put (GTK_FIXED (fixed5), vseparator1, 116, 72);
  gtk_widget_set_uposition (vseparator1, 116, 72);
  gtk_widget_set_usize (vseparator1, 16, 56);

  vseparator2 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator2);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "vseparator2", vseparator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator2);
  gtk_fixed_put (GTK_FIXED (fixed5), vseparator2, 324, 72);
  gtk_widget_set_uposition (vseparator2, 324, 72);
  gtk_widget_set_usize (vseparator2, 16, 56);

  RdCptLp = gtk_radio_button_new_with_label (CptLp_group, _("Lettrage"));
  CptLp_group = gtk_radio_button_group (GTK_RADIO_BUTTON (RdCptLp));
  gtk_widget_ref (RdCptLp);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "RdCptLp", RdCptLp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RdCptLp);
  gtk_fixed_put (GTK_FIXED (fixed5), RdCptLp, 48, 72);
  gtk_widget_set_uposition (RdCptLp, 48, 72);
  gtk_widget_set_usize (RdCptLp, 93, 24);

  radiobutton2 = gtk_radio_button_new_with_label (CptLp_group, _("Pointage"));
  CptLp_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton2));
  gtk_widget_ref (radiobutton2);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "radiobutton2", radiobutton2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton2);
  gtk_fixed_put (GTK_FIXED (fixed5), radiobutton2, 48, 88);
  gtk_widget_set_uposition (radiobutton2, 48, 88);
  gtk_widget_set_usize (radiobutton2, 93, 24);

  radiobutton3 = gtk_radio_button_new_with_label (CptLp_group, _("Non"));
  CptLp_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton3));
  gtk_widget_ref (radiobutton3);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "radiobutton3", radiobutton3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton3);
  gtk_fixed_put (GTK_FIXED (fixed5), radiobutton3, 48, 104);
  gtk_widget_set_uposition (radiobutton3, 48, 104);
  gtk_widget_set_usize (radiobutton3, 68, 20);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton3), TRUE);

  label44 = gtk_label_new (_("Type :"));
  gtk_widget_ref (label44);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label44", label44,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label44);
  gtk_fixed_put (GTK_FIXED (fixed5), label44, 8, 76);
  gtk_widget_set_uposition (label44, 8, 76);
  gtk_widget_set_usize (label44, 41, 16);
  gtk_label_set_justify (GTK_LABEL (label44), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label44), 0, 0.5);

  radiobutton6 = gtk_radio_button_new_with_label (CptTfe_group, _("Rsultat"));
  CptTfe_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton6));
  gtk_widget_ref (radiobutton6);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "radiobutton6", radiobutton6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton6);
  gtk_fixed_put (GTK_FIXED (fixed5), radiobutton6, 256, 104);
  gtk_widget_set_uposition (radiobutton6, 256, 104);
  gtk_widget_set_usize (radiobutton6, 68, 20);

  radiobutton5 = gtk_radio_button_new_with_label (CptTfe_group, _("Dtail"));
  CptTfe_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton5));
  gtk_widget_ref (radiobutton5);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "radiobutton5", radiobutton5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton5);
  gtk_fixed_put (GTK_FIXED (fixed5), radiobutton5, 256, 88);
  gtk_widget_set_uposition (radiobutton5, 256, 88);
  gtk_widget_set_usize (radiobutton5, 64, 20);

  RdCptTfe = gtk_radio_button_new_with_label (CptTfe_group, _("Non"));
  CptTfe_group = gtk_radio_button_group (GTK_RADIO_BUTTON (RdCptTfe));
  gtk_widget_ref (RdCptTfe);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "RdCptTfe", RdCptTfe,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RdCptTfe);
  gtk_fixed_put (GTK_FIXED (fixed5), RdCptTfe, 256, 72);
  gtk_widget_set_uposition (RdCptTfe, 256, 72);
  gtk_widget_set_usize (RdCptTfe, 48, 20);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (RdCptTfe), TRUE);

  label43 = gtk_label_new (_("Traitement en clture :"));
  gtk_widget_ref (label43);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label43", label43,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label43);
  gtk_fixed_put (GTK_FIXED (fixed5), label43, 128, 76);
  gtk_widget_set_uposition (label43, 128, 76);
  gtk_widget_set_usize (label43, 140, 16);
  gtk_label_set_justify (GTK_LABEL (label43), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label43), 0, 0.5);

  label45 = gtk_label_new (_("Positif :"));
  gtk_widget_ref (label45);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label45", label45,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label45);
  gtk_fixed_put (GTK_FIXED (fixed5), label45, 344, 76);
  gtk_widget_set_uposition (label45, 344, 76);
  gtk_widget_set_usize (label45, 48, 16);
  gtk_label_set_justify (GTK_LABEL (label45), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label45), 0, 0.5);

  RdCptPos = gtk_radio_button_new_with_label (CptPos_group, _("Dbit"));
  CptPos_group = gtk_radio_button_group (GTK_RADIO_BUTTON (RdCptPos));
  gtk_widget_ref (RdCptPos);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "RdCptPos", RdCptPos,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RdCptPos);
  gtk_fixed_put (GTK_FIXED (fixed5), RdCptPos, 388, 72);
  gtk_widget_set_uposition (RdCptPos, 388, 72);
  gtk_widget_set_usize (RdCptPos, 60, 24);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (RdCptPos), TRUE);

  radiobutton8 = gtk_radio_button_new_with_label (CptPos_group, _("Crdit"));
  CptPos_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton8));
  gtk_widget_ref (radiobutton8);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "radiobutton8", radiobutton8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton8);
  gtk_fixed_put (GTK_FIXED (fixed5), radiobutton8, 388, 92);
  gtk_widget_set_uposition (radiobutton8, 388, 92);
  gtk_widget_set_usize (radiobutton8, 60, 24);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator1);
  gtk_fixed_put (GTK_FIXED (fixed5), hseparator1, 8, 64);
  gtk_widget_set_uposition (hseparator1, 8, 64);
  gtk_widget_set_usize (hseparator1, 436, 16);

  label41 = gtk_label_new (_("Dsignation :"));
  gtk_widget_ref (label41);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label41", label41,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label41);
  gtk_fixed_put (GTK_FIXED (fixed5), label41, 4, 24);
  gtk_widget_set_uposition (label41, 4, 24);
  gtk_widget_set_usize (label41, 88, 16);
  gtk_misc_set_alignment (GTK_MISC (label41), 0, 0);

  label42 = gtk_label_new (_("Collectif :"));
  gtk_widget_ref (label42);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label42", label42,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label42);
  gtk_fixed_put (GTK_FIXED (fixed5), label42, 4, 52);
  gtk_widget_set_uposition (label42, 4, 52);
  gtk_widget_set_usize (label42, 60, 16);
  gtk_label_set_justify (GTK_LABEL (label42), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label42), 0, 0.5);

  label77 = gtk_label_new (_("Code :"));
  gtk_widget_ref (label77);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label77", label77,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label77);
  gtk_fixed_put (GTK_FIXED (fixed5), label77, 4, 4);
  gtk_widget_set_uposition (label77, 4, 4);
  gtk_widget_set_usize (label77, 41, 16);
  gtk_misc_set_alignment (GTK_MISC (label77), 0, 0);

  EdtPlc_BtCol = gtk_button_new_with_label (_("Slection"));
  gtk_widget_ref (EdtPlc_BtCol);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "EdtPlc_BtCol", EdtPlc_BtCol,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtPlc_BtCol);
  gtk_fixed_put (GTK_FIXED (fixed5), EdtPlc_BtCol, 244, 48);
  gtk_widget_set_uposition (EdtPlc_BtCol, 244, 48);
  gtk_widget_set_usize (EdtPlc_BtCol, 64, 20);

  label89 = gtk_label_new (_("Echance :"));
  gtk_widget_ref (label89);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label89", label89,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label89);
  gtk_fixed_put (GTK_FIXED (fixed5), label89, 8, 176);
  gtk_widget_set_uposition (label89, 8, 176);
  gtk_widget_set_usize (label89, 64, 16);
  gtk_misc_set_alignment (GTK_MISC (label89), 0, 0);

  CptEch = gtk_combo_new ();
  gtk_widget_ref (CptEch);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptEch", CptEch,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptEch);
  gtk_fixed_put (GTK_FIXED (fixed5), CptEch, 76, 176);
  gtk_widget_set_uposition (CptEch, 76, 176);
  gtk_widget_set_usize (CptEch, 40, 20);
  CptEch_items = g_list_append (CptEch_items, (gpointer) "30");
  CptEch_items = g_list_append (CptEch_items, (gpointer) "60");
  CptEch_items = g_list_append (CptEch_items, (gpointer) "90");
  CptEch_items = g_list_append (CptEch_items, (gpointer) "120");
  gtk_combo_set_popdown_strings (GTK_COMBO (CptEch), CptEch_items);
  g_list_free (CptEch_items);

  combo_entry4 = GTK_COMBO (CptEch)->entry;
  gtk_widget_ref (combo_entry4);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "combo_entry4", combo_entry4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_entry4);
  gtk_entry_set_text (GTK_ENTRY (combo_entry4), _("30"));

  CptEchj = gtk_combo_new ();
  gtk_widget_ref (CptEchj);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptEchj", CptEchj,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptEchj);
  gtk_fixed_put (GTK_FIXED (fixed5), CptEchj, 232, 176);
  gtk_widget_set_uposition (CptEchj, 232, 176);
  gtk_widget_set_usize (CptEchj, 44, 20);
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "01");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "02");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "03");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "04");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "05");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "06");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "07");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "08");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "09");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "10");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "11");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "12");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "13");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "14");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "15");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "16");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "17");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "18");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "19");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "20");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "21");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "22");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "23");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "24");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "25");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "26");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "27");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "28");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "29");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "30");
  CptEchj_items = g_list_append (CptEchj_items, (gpointer) "31");
  gtk_combo_set_popdown_strings (GTK_COMBO (CptEchj), CptEchj_items);
  g_list_free (CptEchj_items);

  combo_entry3 = GTK_COMBO (CptEchj)->entry;
  gtk_widget_ref (combo_entry3);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "combo_entry3", combo_entry3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_entry3);
  gtk_entry_set_text (GTK_ENTRY (combo_entry3), _("01"));

  label46 = gtk_label_new (_("Mode de rglement :"));
  gtk_widget_ref (label46);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label46", label46,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label46);
  gtk_fixed_put (GTK_FIXED (fixed5), label46, 8, 152);
  gtk_widget_set_uposition (label46, 8, 152);
  gtk_widget_set_usize (label46, 124, 16);
  gtk_label_set_justify (GTK_LABEL (label46), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label46), 0, 0.5);

  CptBloq = gtk_check_button_new_with_label (_("bloqu"));
  gtk_widget_ref (CptBloq);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptBloq", CptBloq,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptBloq);
  gtk_fixed_put (GTK_FIXED (fixed5), CptBloq, 132, 128);
  gtk_widget_set_uposition (CptBloq, 132, 128);
  gtk_widget_set_usize (CptBloq, 64, 20);

  CptCent = gtk_check_button_new_with_label (_("Centralis"));
  gtk_widget_ref (CptCent);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptCent", CptCent,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptCent);
  gtk_fixed_put (GTK_FIXED (fixed5), CptCent, 24, 128);
  gtk_widget_set_uposition (CptCent, 24, 128);
  gtk_widget_set_usize (CptCent, 80, 20);

  vseparator5 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator5);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "vseparator5", vseparator5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator5);
  gtk_fixed_put (GTK_FIXED (fixed5), vseparator5, 280, 128);
  gtk_widget_set_uposition (vseparator5, 280, 128);
  gtk_widget_set_usize (vseparator5, 16, 68);

  label128 = gtk_label_new (_("Code :"));
  gtk_widget_ref (label128);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label128", label128,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label128);
  gtk_fixed_put (GTK_FIXED (fixed5), label128, 296, 152);
  gtk_widget_set_uposition (label128, 296, 152);
  gtk_widget_set_usize (label128, 48, 16);

  CptMr = gtk_combo_new ();
  gtk_widget_ref (CptMr);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptMr", CptMr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptMr);
  gtk_fixed_put (GTK_FIXED (fixed5), CptMr, 128, 152);
  gtk_widget_set_uposition (CptMr, 128, 152);
  gtk_widget_set_usize (CptMr, 136, 20);
  gtk_combo_set_value_in_list (GTK_COMBO (CptMr), TRUE, TRUE);

  combo_entry1 = GTK_COMBO (CptMr)->entry;
  gtk_widget_ref (combo_entry1);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "combo_entry1", combo_entry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_entry1);

  CptAna = gtk_check_button_new_with_label (_("Analytique"));
  gtk_widget_ref (CptAna);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptAna", CptAna,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptAna);
  gtk_fixed_put (GTK_FIXED (fixed5), CptAna, 296, 132);
  gtk_widget_set_uposition (CptAna, 296, 132);
  gtk_widget_set_usize (CptAna, 84, 20);

  CptCdeAna = gtk_combo_new ();
  gtk_widget_ref (CptCdeAna);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptCdeAna", CptCdeAna,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptCdeAna);
  gtk_fixed_put (GTK_FIXED (fixed5), CptCdeAna, 296, 172);
  gtk_widget_set_uposition (CptCdeAna, 296, 172);
  gtk_widget_set_usize (CptCdeAna, 148, 20);
  gtk_widget_set_sensitive (CptCdeAna, FALSE);
  gtk_combo_set_value_in_list (GTK_COMBO (CptCdeAna), TRUE, TRUE);

  combo_entry6 = GTK_COMBO (CptCdeAna)->entry;
  gtk_widget_ref (combo_entry6);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "combo_entry6", combo_entry6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_entry6);

  label71 = gtk_label_new (_("Comptabilit"));
  gtk_widget_ref (label71);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label71", label71,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label71);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (OngletPlan), gtk_notebook_get_nth_page (GTK_NOTEBOOK (OngletPlan), 0), label71);

  fixed6 = gtk_fixed_new ();
  gtk_widget_ref (fixed6);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "fixed6", fixed6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed6);
  gtk_container_add (GTK_CONTAINER (OngletPlan), fixed6);

  CptCodeInfo = gtk_entry_new ();
  gtk_widget_ref (CptCodeInfo);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptCodeInfo", CptCodeInfo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptCodeInfo);
  gtk_fixed_put (GTK_FIXED (fixed6), CptCodeInfo, 44, 4);
  gtk_widget_set_uposition (CptCodeInfo, 44, 4);
  gtk_widget_set_usize (CptCodeInfo, 72, 20);
  gtk_entry_set_editable (GTK_ENTRY (CptCodeInfo), FALSE);

  CptLibInfo = gtk_entry_new ();
  gtk_widget_ref (CptLibInfo);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptLibInfo", CptLibInfo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptLibInfo);
  gtk_fixed_put (GTK_FIXED (fixed6), CptLibInfo, 160, 4);
  gtk_widget_set_uposition (CptLibInfo, 160, 4);
  gtk_widget_set_usize (CptLibInfo, 252, 20);
  gtk_entry_set_editable (GTK_ENTRY (CptLibInfo), FALSE);

  label80 = gtk_label_new (_("Code :"));
  gtk_widget_ref (label80);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label80", label80,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label80);
  gtk_fixed_put (GTK_FIXED (fixed6), label80, 0, 8);
  gtk_widget_set_uposition (label80, 0, 8);
  gtk_widget_set_usize (label80, 41, 16);

  CptAdr1 = gtk_entry_new ();
  gtk_widget_ref (CptAdr1);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptAdr1", CptAdr1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptAdr1);
  gtk_fixed_put (GTK_FIXED (fixed6), CptAdr1, 68, 28);
  gtk_widget_set_uposition (CptAdr1, 68, 28);
  gtk_widget_set_usize (CptAdr1, 228, 20);

  label82 = gtk_label_new (_("Adresse :"));
  gtk_widget_ref (label82);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label82", label82,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label82);
  gtk_fixed_put (GTK_FIXED (fixed6), label82, 0, 32);
  gtk_widget_set_uposition (label82, 0, 32);
  gtk_widget_set_usize (label82, 64, 16);
  gtk_misc_set_alignment (GTK_MISC (label82), 0, 0);

  CptAdr2 = gtk_entry_new ();
  gtk_widget_ref (CptAdr2);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptAdr2", CptAdr2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptAdr2);
  gtk_fixed_put (GTK_FIXED (fixed6), CptAdr2, 68, 52);
  gtk_widget_set_uposition (CptAdr2, 68, 52);
  gtk_widget_set_usize (CptAdr2, 228, 20);

  CptCp = gtk_entry_new ();
  gtk_widget_ref (CptCp);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptCp", CptCp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptCp);
  gtk_fixed_put (GTK_FIXED (fixed6), CptCp, 76, 76);
  gtk_widget_set_uposition (CptCp, 76, 76);
  gtk_widget_set_usize (CptCp, 52, 20);

  label83 = gtk_label_new (_("Code postal :"));
  gtk_widget_ref (label83);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label83", label83,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label83);
  gtk_fixed_put (GTK_FIXED (fixed6), label83, 0, 80);
  gtk_widget_set_uposition (label83, 0, 80);
  gtk_widget_set_usize (label83, 80, 16);
  gtk_misc_set_alignment (GTK_MISC (label83), 0, 0);

  label84 = gtk_label_new (_("Ville :"));
  gtk_widget_ref (label84);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label84", label84,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label84);
  gtk_fixed_put (GTK_FIXED (fixed6), label84, 136, 80);
  gtk_widget_set_uposition (label84, 136, 80);
  gtk_widget_set_usize (label84, 41, 16);
  gtk_misc_set_alignment (GTK_MISC (label84), 0, 0);

  CptVille = gtk_entry_new ();
  gtk_widget_ref (CptVille);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptVille", CptVille,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptVille);
  gtk_fixed_put (GTK_FIXED (fixed6), CptVille, 172, 76);
  gtk_widget_set_uposition (CptVille, 172, 76);
  gtk_widget_set_usize (CptVille, 180, 20);

  CptTel = gtk_entry_new ();
  gtk_widget_ref (CptTel);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptTel", CptTel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptTel);
  gtk_fixed_put (GTK_FIXED (fixed6), CptTel, 32, 100);
  gtk_widget_set_uposition (CptTel, 32, 100);
  gtk_widget_set_usize (CptTel, 116, 20);

  CptFax = gtk_entry_new ();
  gtk_widget_ref (CptFax);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptFax", CptFax,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptFax);
  gtk_fixed_put (GTK_FIXED (fixed6), CptFax, 180, 100);
  gtk_widget_set_uposition (CptFax, 180, 100);
  gtk_widget_set_usize (CptFax, 116, 20);

  CptPort = gtk_entry_new ();
  gtk_widget_ref (CptPort);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptPort", CptPort,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptPort);
  gtk_fixed_put (GTK_FIXED (fixed6), CptPort, 332, 100);
  gtk_widget_set_uposition (CptPort, 332, 100);
  gtk_widget_set_usize (CptPort, 110, 20);

  label85 = gtk_label_new (_("Tl :"));
  gtk_widget_ref (label85);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label85", label85,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label85);
  gtk_fixed_put (GTK_FIXED (fixed6), label85, 0, 104);
  gtk_widget_set_uposition (label85, 0, 104);
  gtk_widget_set_usize (label85, 32, 16);

  label86 = gtk_label_new (_("Fax :"));
  gtk_widget_ref (label86);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label86", label86,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label86);
  gtk_fixed_put (GTK_FIXED (fixed6), label86, 144, 104);
  gtk_widget_set_uposition (label86, 144, 104);
  gtk_widget_set_usize (label86, 41, 16);

  label87 = gtk_label_new (_("Port. :"));
  gtk_widget_ref (label87);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label87", label87,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label87);
  gtk_fixed_put (GTK_FIXED (fixed6), label87, 296, 104);
  gtk_widget_set_uposition (label87, 296, 104);
  gtk_widget_set_usize (label87, 41, 16);

  CptEmail = gtk_entry_new ();
  gtk_widget_ref (CptEmail);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptEmail", CptEmail,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptEmail);
  gtk_fixed_put (GTK_FIXED (fixed6), CptEmail, 284, 124);
  gtk_widget_set_uposition (CptEmail, 284, 124);
  gtk_widget_set_usize (CptEmail, 160, 20);

  label81 = gtk_label_new (_("Nom :"));
  gtk_widget_ref (label81);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label81", label81,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label81);
  gtk_fixed_put (GTK_FIXED (fixed6), label81, 124, 8);
  gtk_widget_set_uposition (label81, 124, 8);
  gtk_widget_set_usize (label81, 40, 16);
  gtk_misc_set_alignment (GTK_MISC (label81), 0, 0);

  CptInter = gtk_entry_new ();
  gtk_widget_ref (CptInter);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptInter", CptInter,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptInter);
  gtk_fixed_put (GTK_FIXED (fixed6), CptInter, 60, 124);
  gtk_widget_set_uposition (CptInter, 60, 124);
  gtk_widget_set_usize (CptInter, 160, 20);

  CptAct = gtk_entry_new ();
  gtk_widget_ref (CptAct);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptAct", CptAct,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptAct);
  gtk_fixed_put (GTK_FIXED (fixed6), CptAct, 60, 148);
  gtk_widget_set_uposition (CptAct, 60, 148);
  gtk_widget_set_usize (CptAct, 176, 20);

  label92 = gtk_label_new (_("Banque :"));
  gtk_widget_ref (label92);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label92", label92,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label92);
  gtk_fixed_put (GTK_FIXED (fixed6), label92, 4, 176);
  gtk_widget_set_uposition (label92, 4, 176);
  gtk_widget_set_usize (label92, 56, 16);
  gtk_misc_set_alignment (GTK_MISC (label92), 0, 0);

  CptBqe = gtk_entry_new ();
  gtk_widget_ref (CptBqe);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptBqe", CptBqe,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptBqe);
  gtk_fixed_put (GTK_FIXED (fixed6), CptBqe, 60, 172);
  gtk_widget_set_uposition (CptBqe, 60, 172);
  gtk_widget_set_usize (CptBqe, 140, 20);

  label91 = gtk_label_new (_("Activit :"));
  gtk_widget_ref (label91);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label91", label91,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label91);
  gtk_fixed_put (GTK_FIXED (fixed6), label91, 4, 152);
  gtk_widget_set_uposition (label91, 4, 152);
  gtk_widget_set_usize (label91, 56, 16);
  gtk_misc_set_alignment (GTK_MISC (label91), 0, 0);

  label88 = gtk_label_new (_("E-mail :"));
  gtk_widget_ref (label88);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label88", label88,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label88);
  gtk_fixed_put (GTK_FIXED (fixed6), label88, 236, 128);
  gtk_widget_set_uposition (label88, 236, 128);
  gtk_widget_set_usize (label88, 52, 16);
  gtk_misc_set_alignment (GTK_MISC (label88), 0, 0);

  label90 = gtk_label_new (_("Contact :"));
  gtk_widget_ref (label90);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label90", label90,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label90);
  gtk_fixed_put (GTK_FIXED (fixed6), label90, 4, 128);
  gtk_widget_set_uposition (label90, 4, 128);
  gtk_widget_set_usize (label90, 56, 16);
  gtk_misc_set_alignment (GTK_MISC (label90), 0, 0);

  CptRib1 = gtk_entry_new_with_max_length (5);
  gtk_widget_ref (CptRib1);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptRib1", CptRib1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptRib1);
  gtk_fixed_put (GTK_FIXED (fixed6), CptRib1, 244, 172);
  gtk_widget_set_uposition (CptRib1, 244, 172);
  gtk_widget_set_usize (CptRib1, 44, 20);

  CptRib2 = gtk_entry_new_with_max_length (5);
  gtk_widget_ref (CptRib2);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptRib2", CptRib2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptRib2);
  gtk_fixed_put (GTK_FIXED (fixed6), CptRib2, 292, 172);
  gtk_widget_set_uposition (CptRib2, 292, 172);
  gtk_widget_set_usize (CptRib2, 44, 20);

  CptRib3 = gtk_entry_new_with_max_length (11);
  gtk_widget_ref (CptRib3);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptRib3", CptRib3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptRib3);
  gtk_fixed_put (GTK_FIXED (fixed6), CptRib3, 340, 172);
  gtk_widget_set_uposition (CptRib3, 340, 172);
  gtk_widget_set_usize (CptRib3, 84, 20);

  CptRib4 = gtk_entry_new_with_max_length (2);
  gtk_widget_ref (CptRib4);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "CptRib4", CptRib4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptRib4);
  gtk_fixed_put (GTK_FIXED (fixed6), CptRib4, 428, 172);
  gtk_widget_set_uposition (CptRib4, 428, 172);
  gtk_widget_set_usize (CptRib4, 24, 20);

  label93 = gtk_label_new (_("R.I.B. :"));
  gtk_widget_ref (label93);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label93", label93,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label93);
  gtk_fixed_put (GTK_FIXED (fixed6), label93, 200, 176);
  gtk_widget_set_uposition (label93, 200, 176);
  gtk_widget_set_usize (label93, 44, 16);

  label72 = gtk_label_new (_("Information"));
  gtk_widget_ref (label72);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label72", label72,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label72);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (OngletPlan), gtk_notebook_get_nth_page (GTK_NOTEBOOK (OngletPlan), 1), label72);

  ListStat = gtk_clist_new (4);
  gtk_widget_ref (ListStat);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "ListStat", ListStat,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ListStat);
  gtk_fixed_put (GTK_FIXED (fixed3), ListStat, 52, 240);
  gtk_widget_set_uposition (ListStat, 52, 240);
  gtk_widget_set_usize (ListStat, 380, 88);
  gtk_clist_set_column_width (GTK_CLIST (ListStat), 0, 82);
  gtk_clist_set_column_width (GTK_CLIST (ListStat), 1, 88);
  gtk_clist_set_column_width (GTK_CLIST (ListStat), 2, 93);
  gtk_clist_set_column_width (GTK_CLIST (ListStat), 3, 80);
  gtk_clist_column_titles_show (GTK_CLIST (ListStat));
  gtk_clist_set_shadow_type (GTK_CLIST (ListStat), GTK_SHADOW_OUT);

  label47 = gtk_label_new (_("Dbit"));
  gtk_widget_ref (label47);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label47", label47,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label47);
  gtk_clist_set_column_widget (GTK_CLIST (ListStat), 0, label47);

  label48 = gtk_label_new (_("Crdit"));
  gtk_widget_ref (label48);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label48", label48,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label48);
  gtk_clist_set_column_widget (GTK_CLIST (ListStat), 1, label48);

  label49 = gtk_label_new (_("Solde"));
  gtk_widget_ref (label49);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label49", label49,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label49);
  gtk_clist_set_column_widget (GTK_CLIST (ListStat), 2, label49);

  label50 = gtk_label_new (_("Evolution"));
  gtk_widget_ref (label50);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label50", label50,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label50);
  gtk_clist_set_column_widget (GTK_CLIST (ListStat), 3, label50);

  label52 = gtk_label_new (_("N-1"));
  gtk_widget_ref (label52);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label52", label52,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label52);
  gtk_fixed_put (GTK_FIXED (fixed3), label52, 8, 276);
  gtk_widget_set_uposition (label52, 8, 276);
  gtk_widget_set_usize (label52, 41, 16);

  label53 = gtk_label_new (_("N"));
  gtk_widget_ref (label53);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label53", label53,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label53);
  gtk_fixed_put (GTK_FIXED (fixed3), label53, 8, 292);
  gtk_widget_set_uposition (label53, 8, 292);
  gtk_widget_set_usize (label53, 41, 16);

  label54 = gtk_label_new (_("N+1"));
  gtk_widget_ref (label54);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label54", label54,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label54);
  gtk_fixed_put (GTK_FIXED (fixed3), label54, 8, 308);
  gtk_widget_set_uposition (label54, 8, 308);
  gtk_widget_set_usize (label54, 41, 16);

  label51 = gtk_label_new (_("N-2"));
  gtk_widget_ref (label51);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "label51", label51,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label51);
  gtk_fixed_put (GTK_FIXED (fixed3), label51, 8, 260);
  gtk_widget_set_uposition (label51, 8, 260);
  gtk_widget_set_usize (label51, 41, 16);

  hseparator2 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator2);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "hseparator2", hseparator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator2);
  gtk_fixed_put (GTK_FIXED (fixed3), hseparator2, 8, 324);
  gtk_widget_set_uposition (hseparator2, 8, 324);
  gtk_widget_set_usize (hseparator2, 452, 16);

  hbox6 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox6);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "hbox6", hbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (vbox6), hbox6, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox6), 5);

  BtInsert = gtk_button_new_with_label (_("Insert"));
  gtk_widget_ref (BtInsert);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "BtInsert", BtInsert,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtInsert);
  gtk_box_pack_start (GTK_BOX (hbox6), BtInsert, FALSE, FALSE, 0);
  gtk_widget_set_usize (BtInsert, 65, -2);

  BtModifier = gtk_button_new_with_label (_("Modifie"));
  gtk_widget_ref (BtModifier);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "BtModifier", BtModifier,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtModifier);
  gtk_box_pack_start (GTK_BOX (hbox6), BtModifier, FALSE, FALSE, 0);
  gtk_widget_set_usize (BtModifier, 65, -2);

  BtSuppr = gtk_button_new_with_label (_("Supprime"));
  gtk_widget_ref (BtSuppr);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "BtSuppr", BtSuppr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtSuppr);
  gtk_box_pack_start (GTK_BOX (hbox6), BtSuppr, FALSE, FALSE, 0);
  gtk_widget_set_usize (BtSuppr, 65, -2);

  EdtPlcBtOpt = gtk_button_new_with_label (_("Options"));
  gtk_widget_ref (EdtPlcBtOpt);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "EdtPlcBtOpt", EdtPlcBtOpt,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtPlcBtOpt);
  gtk_box_pack_start (GTK_BOX (hbox6), EdtPlcBtOpt, FALSE, FALSE, 0);
  gtk_widget_set_usize (EdtPlcBtOpt, 65, -2);

  EdtPlcBtClose = gnome_stock_button (GNOME_STOCK_BUTTON_CLOSE);
  gtk_widget_ref (EdtPlcBtClose);
  gtk_object_set_data_full (GTK_OBJECT (EditPlc), "EdtPlcBtClose", EdtPlcBtClose,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtPlcBtClose);
  gtk_box_pack_start (GTK_BOX (hbox6), EdtPlcBtClose, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (EditPlc), "show",
                      GTK_SIGNAL_FUNC (on_EditPlc_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EditPlc), "destroy",
                      GTK_SIGNAL_FUNC (on_EditPlc_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtPlc_BtSuiv), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtPlc_BtSuiv_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtPlc_BtPrec), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtPlc_BtPrec_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (OngletPlan), "switch_page",
                      GTK_SIGNAL_FUNC (EdtPlc_OngletPlan_switch_page),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (CptCode), "key_press_event",
                      GTK_SIGNAL_FUNC (on_CptCode_key_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (CptCol), "key_press_event",
                      GTK_SIGNAL_FUNC (EdtPlc_CptCol_key_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtPlc_BtSel), "clicked",
                      GTK_SIGNAL_FUNC (on_EdtPlc_BtSel_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtPlc_BtCol), "clicked",
                      GTK_SIGNAL_FUNC (EdtPlc_BtCol_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtPlcBtOpt), "event",
                      GTK_SIGNAL_FUNC (on_EdtPlcBtOpt_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (CptAna), "toggled",
                      GTK_SIGNAL_FUNC (on_CptAna_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (BtInsert), "clicked",
                      GTK_SIGNAL_FUNC (EdtPlc_BtInsert_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (BtModifier), "clicked",
                      GTK_SIGNAL_FUNC (EdtPlc_BtModifier_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (BtSuppr), "clicked",
                      GTK_SIGNAL_FUNC (EdtPlc_BtSuppr_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtPlcBtClose), "clicked",
                      GTK_SIGNAL_FUNC (EdtPlc_BtClose_clicked),
                      NULL);

  gtk_window_add_accel_group (GTK_WINDOW (EditPlc), accel_group);

  return EditPlc;
}

void CreateMenuOpt(void)
{
	GtkWidget *Mnu1,*Mnu2;
	
	Mnu1=gtk_menu_item_new_with_label("Ajouter note");
	Mnu2=gtk_menu_item_new_with_label("Lettre de relance");
	
	MenuOpt=gtk_menu_new();
	gtk_menu_append(GTK_MENU (MenuOpt),Mnu1);
	gtk_menu_append(GTK_MENU (MenuOpt),Mnu2);
	gtk_signal_connect(GTK_OBJECT (Mnu1),"activate",GTK_SIGNAL_FUNC (MenuNote),NULL);
	gtk_signal_connect(GTK_OBJECT (Mnu2),"activate",GTK_SIGNAL_FUNC (MenuRelance),NULL);	
	gtk_widget_show(Mnu1);
	gtk_widget_show(Mnu2);
}

void Dialog_EdtPlc(void (*RetFunc) ())
{
  GList *Items;
  GtkWidget *Combo;

  PlanComptable=create_EditPlc();
  gtk_widget_show_all(PlanComptable);
	CreateMenuOpt();
	ReturnFunc=NULL;
  if (DbLcpt!=NULL) {
    Combo=lookup_widget(GTK_WIDGET (PlanComptable),"CptMr");
    ORG_REGL=LoadModRegl();
    Items=NULL;
    Regl=ORG_REGL;
    while (Regl!=NULL) {
      Items=g_list_append(Items,Regl->Lib);
      Regl=Regl->Su;
    }
    gtk_combo_set_popdown_strings(GTK_COMBO (Combo),Items);
    g_list_free(Items);
    /*** Analytique ***/
    Combo=lookup_widget(GTK_WIDGET (PlanComptable),"CptCdeAna");
    ORG_ANA=LoadCdeAna();
    Items=NULL;
    Analyt=ORG_ANA;
    while (Analyt!=NULL) {
      Items=g_list_append(Items,Analyt->Lib);
      Analyt=Analyt->Su;
    }
    gtk_combo_set_popdown_strings(GTK_COMBO (Combo),Items);
    g_list_free(Items);
    EdtPlcRes=NULL;
		ReturnFunc=RetFunc;
    EdtPlc_DispData();
  }
}
