/*******************************************************************/
/* Comptabilit Analytique Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 21/03/02 - Transition GTK->SQL                                  */
/* Fichier source                                                  */
/* Rvision : 28/06/2002 Ajout GetRadioButton,GetOptionMenu        */
/*            15/11/2002 Ajout GTkToDateSql                        */
/*******************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <gtk/gtk.h>
#include <string.h>
#include "common.h"
#include "gtksql.h"
#include "support.h"

/* Recherche d'un Gtk_entry pour stocker sa valeur Dans un chaine Sql ******/
char *GtkToStrSql(char *Str,GtkWidget *button,char *Name)
{
  char Tempo[200];
  GtkWidget *Entrie;

  Entrie=lookup_widget(GTK_WIDGET (button),Name);
  strcpy(Tempo,gtk_entry_get_text(GTK_ENTRY(Entrie)));
  *Str++='\'';
  Str+=mysql_escape_string(Str,Tempo,strlen(Tempo));
  *Str++='\'';
  *Str='\0';
  return (Str);
}

/* Recherche d'un Gtk_entry Date pour stocker sa valeur dans une chaine Sql ******/
char *GtkToDateSql(char *Str,GtkWidget *button,char *Name)
{
  char Tempo[15];
  GtkWidget *Entrie;

  Entrie=lookup_widget(GTK_WIDGET (button),Name);
  DateToIso(Tempo,gtk_entry_get_text(GTK_ENTRY(Entrie)));
  *Str++='\'';
  Str=strmov(Str,Tempo);
  *Str++='\'';
  *Str='\0';
  return (Str);
}

/* Recherche d'un Gtk_entry pour stocker sa valeur ******
  Gtk->Sql */
char *GtkToFloatSql(char *Str,GtkWidget *button,char *Name)
{
  char Tempo[20],*Pt;
  GtkWidget *Entrie;

  Entrie=lookup_widget(GTK_WIDGET (button),Name);
  strcpy(Tempo,gtk_entry_get_text(GTK_ENTRY(Entrie)));
  if (strlen(Tempo)==0) strcpy(Tempo,"0.0");
  Pt=Tempo;
  while (*Pt) {
    *Str=*Pt++;
    if (*Str==',') *Str='.';
    Str++;
  }
  *Str='\0';
  return (Str);
}

void StrSqlToGtk(GtkWidget *Widget,char *Field,char *Str)
{
   GtkWidget *Entry;
	gchar EmptyString[1];

	EmptyString[0]=0;
   Entry=lookup_widget(Widget,Field);
   if (Str!=NULL) gtk_entry_set_text(GTK_ENTRY(Entry),Str);
		else gtk_entry_set_text(GTK_ENTRY(Entry),EmptyString);
}

char *GtkToIntSql(char *Str,GtkWidget *button,char *Name)
{
  char Tempo[20];
  GtkWidget *Entrie;

  Entrie=lookup_widget(GTK_WIDGET (button),Name);
  strcpy(Tempo,gtk_entry_get_text(GTK_ENTRY(Entrie)));
  if (Tempo[0]!='\0') Str+=mysql_escape_string(Str,Tempo,strlen(Tempo));else *Str++='0';
  *Str='\0';
  return (Str);
}

/* ToggleButton *****************************/
char *GtkToBooleanSql(char *Str,GtkWidget *button,char *Name)
{
  GtkWidget *Entry;

  Entry=lookup_widget(GTK_WIDGET (button),Name);
  *Str++='\'';
	if (Entry!=NULL) {
		if (GTK_TOGGLE_BUTTON (Entry)->active) *Str++='Y'; else *Str++='N';  
	}
  *Str++='\'';
  *Str='\0';
  return (Str);
}

void BooleanSqlToGtk(GtkWidget *Widget,char *Field,char *State)
{
  GtkWidget *Entry;
  gint Valor;

  Entry=lookup_widget(Widget,Field);
  if (State!=NULL) {
    if ((*State=='Y') || (*State=='y')) Valor=TRUE;else Valor=FALSE;
  } else Valor=FALSE;
  if (Entry!=NULL) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (Entry),Valor);
}

/* Les radio buttons **********************************************/
int GetRadioButton(GtkWidget *Wdg)
{
  int i,Ret;
  GSList *Child;
  GtkRadioButton *Radio;

  Ret=0;
  if (Wdg!=NULL) {
    Child=gtk_radio_button_group(GTK_RADIO_BUTTON (Wdg));
    if (Child!=NULL) {
      i=0;
      do {
				Radio=GTK_RADIO_BUTTON (Child->data);
				if (GTK_TOGGLE_BUTTON (Radio)->active) Ret=i;
				Child=Child->next;
				i++;
      } while (Child!=NULL);
    }
  }
  return (Ret);
}

void RadioSqlToGtk(GtkWidget *Widget,char *Field,char *Value,char *SValue[])
{
  GSList *Child;
  GtkRadioButton *Radio;
  GtkWidget *Wdg;
  int i,Loc;

  Wdg=lookup_widget(Widget,Field);
  if (Wdg!=NULL) {
    i=0;
    Loc=-1;
    if (Value!=NULL) {
			while (strcmp(SValue[i],"*")!=0) {
				if (strcmp(Value,SValue[i])==0) {
					Loc=i;
					break;
				}
				i++;
			}
    }
    if (Loc==-1) Loc=0;
    Child=gtk_radio_button_group(GTK_RADIO_BUTTON (Wdg));
    i=0;
    do {
			Radio=GTK_RADIO_BUTTON (Child->data);
			if (i==Loc) {
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (Radio),1);
				break;
			};
			i++;
			Child=Child->next;
    } while (Child!=NULL);
  }
}

char *GtkToRadioSql(char *Str,GtkWidget *Widget,char *Name,char *SValue[])
{
  GSList *Child;
  GtkRadioButton *Radio;
  GtkWidget *Wdg;
  int i;

  Wdg=lookup_widget(Widget,Name);
  if (Wdg!=NULL) {
    Child=gtk_radio_button_group(GTK_RADIO_BUTTON (Wdg));
    if (Child!=NULL) {
      i=0;
      do {
				Radio=GTK_RADIO_BUTTON (Child->data);
				if (GTK_TOGGLE_BUTTON (Radio)->active) {
					*Str++='\'';
					Str+=mysql_escape_string(Str,SValue[i],strlen(SValue[i]));
					*Str++='\'';
					*Str='\0';
					break;
				}
				Child=Child->next;
				i++;
      } while (Child!=NULL);
    }
  }
  return (Str);
}

/* Les OptionsMenu ****************************************************/
void MenuSqlToGtk(GtkWidget *widget,gchar *Field,int Value)
{
  GtkWidget *Menu,*OptionMenu;

  OptionMenu=lookup_widget(GTK_WIDGET (widget),Field);
  if (OptionMenu!=NULL) {
    Menu=gtk_option_menu_get_menu(GTK_OPTION_MENU (OptionMenu));
    gtk_option_menu_set_history(GTK_OPTION_MENU (OptionMenu),Value);
  }
}

void GetOptionMenu(GtkWidget *Menu,gchar *Ret)
{
  GtkWidget *Option;
  gchar *text;

  if (GTK_BIN (Menu)->child) {
    Option = GTK_BIN (Menu)->child;
    if (GTK_IS_LABEL (Option)) {
      gtk_label_get (GTK_LABEL (Option), &text);
      strcpy(Ret,text);
    }
  }
}

gchar *GtkToMenuSql(gchar *Str,GtkWidget *widget,gchar *Field,gchar *Value[],gchar *VRet[])
{
  GtkWidget *Menu,*Option;
  gchar *text;
  int i,Ret;

  *Str++='\'';
  Menu=lookup_widget(GTK_WIDGET (widget),Field);
  if (Menu!=NULL) {
    if (GTK_BIN (Menu)->child) {
      Option = GTK_BIN (Menu)->child;
      if (GTK_IS_LABEL (Option)) {
        gtk_label_get (GTK_LABEL (Option), &text);
				i=0;
				Ret=-1;
				while (strcmp(Value[i],"*")!=0) {
					if (strcmp(Value[i],text)==0) {
						Ret=i;
						break;
					}
					i++;
				}
				if (Ret!=-1) Str=strmov(Str,VRet[Ret]);
      }
    }
  }
  *Str++='\'';
  *Str=0;
  return (Str);
}

/* Les ComboBox *******************************************************/
void ComboSqlToGtk(GtkWidget *widget,gchar *Field,gchar *Value)
{
  GtkWidget *Combo,*Entry;
  gchar Vide[2]=" ";

  Combo=lookup_widget(widget,Field);
  if (Combo!=NULL) {
    Entry=GTK_COMBO (Combo)->entry;
    if (Value!=NULL) gtk_entry_set_text(GTK_ENTRY (Entry),Value);
    else gtk_entry_set_text(GTK_ENTRY (Entry),Vide);
  }
}

char *GtkToComboSql(char *Str,GtkWidget *button,char *Name)
{
  char Tempo[100];
  GtkWidget *Entrie,*Combo;

  Combo=lookup_widget(GTK_WIDGET (button),Name);
  if (Combo!=NULL) {
    Entrie=GTK_COMBO (Combo)->entry;
    strcpy(Tempo,gtk_entry_get_text(GTK_ENTRY(Entrie)));
    *Str++='\'';
    Str+=mysql_escape_string(Str,Tempo,strlen(Tempo));
    *Str++='\'';
    *Str='\0';
  };
  return (Str);
}

char *GtkToComboIntSql(char *Str,GtkWidget *button,char *Name)
{
  char Tempo[100];
  GtkWidget *Entrie,*Combo;

  Combo=lookup_widget(GTK_WIDGET (button),Name);
  if (Combo!=NULL) {
    Entrie=GTK_COMBO (Combo)->entry;
    strcpy(Tempo,gtk_entry_get_text(GTK_ENTRY(Entrie)));
    Str=strmov(Str,Tempo);
    *Str='\0';
  };
  return (Str);
}
