/*******************************************************************/
/* Comptabilit Analytique Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 08/07/02 - Impression du balance                                */
/* Fichier source                                                  */
/*******************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <gtk/gtk.h>
#include <gnome.h>
#include <string.h>
#include <ctype.h>
#include <mysql/mysql.h>
#include "support.h"
#include "common.h"
#include "gtksql.h"
#include "select.h"
#include "print.h"

#include "impbal.h"

/* Variables */
GtkWidget *ImpWin;
gchar     DateDeb[11],DateFin[11],CptDeb[3],CptFin[3],CmdRun[64];
gchar     CmdToPrint[128];
int       TpBal,PaperSize,TpPer,MvtOnly,NsOnly,SdOnly,TpJrn;
MYSQL_ROW CptRow;
char      *ChoiseBalance[]={_("Global"),_("Clients"),_("Fournisseurs"),_("Analytique")};
double    Tot_Deb,Tot_Cre,Sol_Deb,Sol_Cre;

/* protos */

GtkWidget* create_ImpBal (void);
void on_ImpBal_BtCancel_clicked(GtkButton *But,gpointer user_data);
void on_ImpBal_BtOk_clicked(GtkButton *But,gpointer user_data);
void on_ImpBal_destroy(GtkObject *object,gpointer user_data);
void on_ImpBal_show(GtkWidget *widget,gpointer user_data);
void PrintTabHeader();
void PrintPageHeader(int Page);
void PrintClasse(char Classe);
void PrintBalance();

/****************************************************************************/
void PrintTabHeader()
{
	PS_justification(CENTER_JUST);
	PS_setTypeface(FNT_BOLD);
	PS_setTextSize(8);
  PS_xprint(117,_("Mouvements"));
  PS_xprint(165,_("Soldes"));
  PS_sendReturn();	
	PS_xprint(20,_("Compte"));
	PS_xprint(45,_("Libell"));
	PS_xprint(105,_("Dbit"));
	PS_xprint(130,_("Crdit"));
	PS_xprint(155,_("Dbit"));
	PS_xprint(180,_("Crdit"));
	PS_sendReturn();	
	PS_setTypeface(FNT_NORMAL);	
}

void PrintPageHeader(int Page)
{
	char TDate1[11],TDate2[11],Tmp[80],TitlePrint[120];
	gint Yp,a;
	
  PS_setFont("Helvetica",14,FNT_BOLD);
  sprintf(TitlePrint,_("BALANCE COMPTES %s"),ChoiseBalance[TpBal]);
	Yp=PS_getYpos();
  PS_justification(CENTER_JUST);
  PS_xprint(100,TitlePrint);
	PS_justification(RIGHT_JUST);
	PS_setTextSize(10);
	sprintf(Tmp,"Page : %03i",Page);
	PS_xprint(200,Tmp);
	PS_setTextSize(14);
	PS_sendReturn();
	IsoToDate(TDate1,DateDeb);
	IsoToDate(TDate2,DateFin);
	if (TpPer==FALSE) sprintf(Tmp,_("Exercice du %s au %s"),TDate1,TDate2);
	else sprintf(Tmp,_("Priode du %s au %s"),TDate1,TDate2);
	PS_justification(CENTER_JUST);
	PS_xprint(100,Tmp);
	PS_down(10);
	a=PS_getStringWidth(Tmp)+5;
	PS_rectangle(5+((190-a)/2),Yp-PS_getFontHeight(),a,PS_getFontHeight()*3,FALSE);
	PrintTabHeader();
}

void PrintTotalBalance()
{
	gchar Tmp[20];
	
	PS_setTypeface(FNT_BOLD);
	PS_justification(LEFT_JUST);
	PS_rectangle(10,280-PS_getFontHeight()-2,190,PS_getFontHeight()+4,FALSE);
	PS_xyprint(30,280,_("Total de la Balance"));
	PS_justification(RIGHT_JUST);
	sprintf(Tmp,"%8.2f",Tot_Deb);
	PS_xprint(115,Tmp);
	sprintf(Tmp,"%8.2f",Tot_Cre);
	PS_xprint(140,Tmp);	
	sprintf(Tmp,"%8.2f",Sol_Deb);
	PS_xprint(165,Tmp);
	sprintf(Tmp,"%8.2f",Sol_Cre);
	PS_xprint(190,Tmp);		
}

// Impression d'une ligne *****************************************************
void PrintLine(char *PsCle,char *Cpt,char *Lib)
{
	gchar *SqlCmd,Tmp[20];
	MYSQL_RES *Result;
  MYSQL_ROW Row;
	double DM,CM,DS,CS;
	int    PASS;

	SqlCmd=g_strdup_printf("Select Sum(EcrDebit),Sum(EcrCredit) From Ecrit where EcrSoc='%s' And EcrCpt='%s' And EcrDate Between '%s' and '%s'",PsCle,Cpt,DateDeb,DateFin);
	if (mysql_query(DbLcpt,SqlCmd)==0) {
		Result=mysql_store_result(DbLcpt);
		if ((Row=mysql_fetch_row(Result))) {
			if (Row[0]!=NULL) DM=atof(Row[0]);else DM=0;
			if (Row[1]!=NULL) CM=atof(Row[1]);else CM=0;
			PASS=FALSE;
			if (((DM==0) && (CM==0)) && (MvtOnly)) PASS=TRUE;
			if (((DM-CM)==0) && (SdOnly)) PASS=TRUE;
			if  (!PASS) {
				DS=0;
				CS=0;
				if ((DM-CM)<0) CS=abs(DM-CM);else DS=abs(CM-DM);
				PS_justification(LEFT_JUST);
				PS_xprint(10,Cpt);
				PS_xprint(30,Lib);
				PS_justification(RIGHT_JUST);
				if (DM!=0) {
					sprintf(Tmp,"%8.2f",DM);
					PS_xprint(115,Tmp);
				}
				if (CM!=0) {
					sprintf(Tmp,"%8.2f",CM);
					PS_xprint(140,Tmp);
				}
				if (CS!=0) {
					sprintf(Tmp,"%8.2f",CS);
					PS_xprint(165,Tmp);
				}
				if (DS!=0) {
					sprintf(Tmp,"%8.2f",DS);
					PS_xprint(190,Tmp);
				}
				Tot_Cre+=CM;
				Tot_Deb+=DM;
				Sol_Cre+=CS;
				Sol_Deb+=DS;
				PS_sendReturn();
			}
		}
		mysql_free_result(Result);
	}
	free(SqlCmd);
}

// Impression par trie des classes -----------------------------
// NON UTILISER POUR LE MOMENT
void PrintClasse(char Classe)
{
	MYSQL_RES *Result;
  MYSQL_ROW Row;
	gchar *SqlCmd,Tmp[50];
	gchar PsCle[LEN_COD_SOC+1];

	GetSocRun(PsCle);
	SqlCmd=g_strdup_printf("Select a.EcrCpt,b.CptLib From Ecrit as a join Comptes as b on b.CptCode=a.EcrCpt where EcrSoc='%s' And EcrDate Between '%s' and '%s' And Left(EcrCpt,1)='%c'",PsCle,DateFin,DateDeb,Classe);
	if (mysql_query(DbLcpt,SqlCmd)==0) {
		Result=mysql_store_result(DbLcpt);
		PS_setFont("Helvetica",10,FNT_NORMAL);
		while ((Row=mysql_fetch_row(Result))) {
			PrintLine(PsCle,Row[1],Row[2]);
		}
		PS_down(6);
		PS_justification(LEFT_JUST);
		PS_setTypeface(FNT_BOLD);
		sprintf(Tmp,"Total classe %c",Classe);
		PS_xprint(7,Tmp);
		sprintf(SqlCmd,"Select Sum(EcrDebit),Sum(EcrCredit) From Ecrit where EcrSoc='%s' And EcrDate Between '%s' and '%s' And Left(EcrCpt,1)='%c'",PsCle,DateFin,DateDeb,Classe);
	}
	free(SqlCmd);
}

// Procdure principale d'impression de balance *******************************
void PrintBalance()
{
	gchar *SqlCmd,PsCle[LEN_COD_SOC+1];
  MYSQL_RES *Result;
  MYSQL_ROW Row;

  PS_beginPrint(PaperSize,_("Impression balance"),&PrintTotalBalance,&PrintPageHeader);
	PrintPageHeader(1);
	GetSocRun(PsCle);
	SqlCmd=NULL;
	switch (TpBal) {
		case 0 : SqlCmd=g_strdup_printf("select * from Comptes Where CptSoc='%s' And CptCode between '%s' and '%s' Order by CptCode",PsCle,CptDeb,CptFin);
			break;
		case 1 : SqlCmd=g_strdup_printf("Select * From Comptes Where CptSoc='%s' And CptCol='4110' And CptCode between '%s' and '%s' Order by CptCode",PsCle,CptDeb,CptFin);
			break;
		case 2 : SqlCmd=g_strdup_printf("Select * From Comptes Where CptSoc='%s' And CptCol='4010' And CptCode between '%s' and '%s' Order by CptCode",PsCle,CptDeb,CptFin);
			break;		
	}
  PS_setFont("Helvetica",8,FNT_NORMAL);
	Tot_Cre=Tot_Deb=0;
	Sol_Cre=Sol_Deb=0;
	if (mysql_query(DbLcpt,SqlCmd)==0) {
		Result=mysql_store_result(DbLcpt);
		while ((Row=mysql_fetch_row(Result))) {
      PrintLine(PsCle,Row[1],Row[2]);
		}
		PrintTotalBalance();
		mysql_free_result(Result);
	}
	free(SqlCmd);
  PS_endPrint(CmdToPrint);	
}

void on_ImpBal_BtCancel_clicked(GtkButton *But,gpointer user_data)
{
  gtk_widget_destroy(ImpWin);
}

void on_ImpBal_BtOk_clicked(GtkButton *But,gpointer user_data)
{
  GtkWidget *widget;
  gchar TDate[15],Format[20],Tmp[30],PsCle[LEN_COD_SOC+1];

  GetSocRun(PsCle);
  widget=lookup_widget(GTK_WIDGET (ImpWin),"SelDate");
  TpPer=(GTK_TOGGLE_BUTTON (widget)->active);
	if (TpPer) {
    widget=lookup_widget(GTK_WIDGET (ImpWin),"DateDeb");
    strcpy(TDate,gtk_entry_get_text(GTK_ENTRY (widget)));
    DateToIso(DateDeb,TDate);
    widget=lookup_widget(GTK_WIDGET (ImpWin),"DateFin");
    strcpy(TDate,gtk_entry_get_text(GTK_ENTRY (widget)));
    DateToIso(DateFin,TDate);
	} else {
	  GetDateExercice(DateDeb,DateFin,PsCle);
	  IsoToDate(TDate,DateDeb);
		strcpy(DateDeb,TDate);
	  IsoToDate(TDate,DateFin);
		strcpy(DateFin,TDate);
	}
  widget=lookup_widget(GTK_WIDGET (ImpWin),"CptDeb");
  strcpy(CptDeb,gtk_entry_get_text(GTK_ENTRY (widget)));
  widget=lookup_widget(GTK_WIDGET (ImpWin),"CptFin");
  strcpy(CptFin,gtk_entry_get_text(GTK_ENTRY (widget)));
  widget=lookup_widget(GTK_WIDGET (ImpWin),"CmdPrint");
  strcpy(CmdToPrint,gtk_entry_get_text(GTK_ENTRY (widget)));
  /***/
  widget=lookup_widget(GTK_WIDGET (ImpWin),"U_Mouvements");
  MvtOnly=(GTK_TOGGLE_BUTTON (widget)->active);
  widget=lookup_widget(GTK_WIDGET (ImpWin),"U_Soldes");
  SdOnly=(GTK_TOGGLE_BUTTON (widget)->active);	
  widget=lookup_widget(GTK_WIDGET (ImpWin),"FormatPage");
  GetOptionMenu(widget,Format);
  if (strcmp(Format,"A4")==0) PaperSize=1;else PaperSize=2;
  widget=lookup_widget(GTK_WIDGET (ImpWin),"BalanceType");
  GetOptionMenu(widget,Tmp);
	TpBal=SearchInArray(ChoiseBalance,4,Tmp);
  PrintBalance();
  gtk_widget_destroy(ImpWin);
}

void on_ImpBal_destroy(GtkObject *object,gpointer user_data)
{
  CloseDbLcpt();
}

void on_ImpBal_show(GtkWidget *widget,gpointer user_data)
{
  OpenDbLcpt();
}

GtkWidget* create_ImpBal (void)
{
  GtkWidget *ImpBal;
  GtkWidget *vbox2;
  GtkWidget *fixed1;
  GtkWidget *DateDeb;
  GtkWidget *DateFin;
  GtkWidget *CptDeb;
  GtkWidget *CptFin;
  GtkWidget *CmdPrint;
  GtkWidget *FormatPage;
  GtkWidget *FormatPage_menu;
  GtkWidget *glade_menuitem;
  GtkWidget *BalanceType;
  GtkWidget *BalanceType_menu;
  GtkWidget *label21;
  GtkWidget *label19;
  GtkWidget *label18;
  GtkWidget *hseparator3;
  GtkWidget *label16;
  GtkWidget *label15;
  GtkWidget *label14;
  GtkWidget *label20;
  GtkWidget *U_Mouvements;
  GtkWidget *U_Soldes;
  GtkWidget *SelDate;
  GtkWidget *fixed2;
  GtkWidget *BtCancel;
  GtkWidget *BtOk;

  ImpBal = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (ImpBal), "ImpBal", ImpBal);
  gtk_window_set_title (GTK_WINDOW (ImpBal), _("Impression Balance"));
  gtk_window_set_position (GTK_WINDOW (ImpBal), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (ImpBal), TRUE);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (ImpBal), vbox2);

  fixed1 = gtk_fixed_new ();
  gtk_widget_ref (fixed1);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "fixed1", fixed1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed1);
  gtk_box_pack_start (GTK_BOX (vbox2), fixed1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (fixed1), 2);

  DateDeb = gtk_entry_new ();
  gtk_widget_ref (DateDeb);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "DateDeb", DateDeb,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (DateDeb);
  gtk_fixed_put (GTK_FIXED (fixed1), DateDeb, 84, 52);
  gtk_widget_set_uposition (DateDeb, 84, 52);
  gtk_widget_set_usize (DateDeb, 76, 20);

  DateFin = gtk_entry_new ();
  gtk_widget_ref (DateFin);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "DateFin", DateFin,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (DateFin);
  gtk_fixed_put (GTK_FIXED (fixed1), DateFin, 196, 52);
  gtk_widget_set_uposition (DateFin, 196, 52);
  gtk_widget_set_usize (DateFin, 80, 20);

  CptDeb = gtk_entry_new_with_max_length (8);
  gtk_widget_ref (CptDeb);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "CptDeb", CptDeb,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptDeb);
  gtk_fixed_put (GTK_FIXED (fixed1), CptDeb, 84, 76);
  gtk_widget_set_uposition (CptDeb, 84, 76);
  gtk_widget_set_usize (CptDeb, 76, 20);
  gtk_entry_set_text (GTK_ENTRY (CptDeb), _(" "));

  CptFin = gtk_entry_new_with_max_length (8);
  gtk_widget_ref (CptFin);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "CptFin", CptFin,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptFin);
  gtk_fixed_put (GTK_FIXED (fixed1), CptFin, 196, 76);
  gtk_widget_set_uposition (CptFin, 196, 76);
  gtk_widget_set_usize (CptFin, 80, 20);
  gtk_entry_set_text (GTK_ENTRY (CptFin), _("ZZZZZZZZ"));

  CmdPrint = gtk_entry_new ();
  gtk_widget_ref (CmdPrint);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "CmdPrint", CmdPrint,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CmdPrint);
  gtk_fixed_put (GTK_FIXED (fixed1), CmdPrint, 172, 160);
  gtk_widget_set_uposition (CmdPrint, 172, 160);
  gtk_widget_set_usize (CmdPrint, 158, 22);

  FormatPage = gtk_option_menu_new ();
  gtk_widget_ref (FormatPage);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "FormatPage", FormatPage,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (FormatPage);
  gtk_fixed_put (GTK_FIXED (fixed1), FormatPage, 76, 184);
  gtk_widget_set_uposition (FormatPage, 76, 184);
  gtk_widget_set_usize (FormatPage, 80, 20);
  FormatPage_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label (_("A4"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (FormatPage_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("Letter"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (FormatPage_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (FormatPage), FormatPage_menu);

  BalanceType = gtk_option_menu_new ();
  gtk_widget_ref (BalanceType);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "BalanceType", BalanceType,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BalanceType);
  gtk_fixed_put (GTK_FIXED (fixed1), BalanceType, 120, 4);
  gtk_widget_set_uposition (BalanceType, 120, 4);
  gtk_widget_set_usize (BalanceType, 108, 24);
  BalanceType_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label (ChoiseBalance[0]);
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (BalanceType_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (ChoiseBalance[1]);
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (BalanceType_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (ChoiseBalance[2]);
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (BalanceType_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (ChoiseBalance[3]);
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (BalanceType_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (BalanceType), BalanceType_menu);

  label21 = gtk_label_new (_("Imprimer balance :"));
  gtk_widget_ref (label21);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "label21", label21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label21);
  gtk_fixed_put (GTK_FIXED (fixed1), label21, 12, 8);
  gtk_widget_set_uposition (label21, 12, 8);
  gtk_widget_set_usize (label21, 112, 16);
  gtk_label_set_justify (GTK_LABEL (label21), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label21), 0, 0.5);

  label19 = gtk_label_new (_("Format :"));
  gtk_widget_ref (label19);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "label19", label19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label19);
  gtk_fixed_put (GTK_FIXED (fixed1), label19, 12, 184);
  gtk_widget_set_uposition (label19, 12, 184);
  gtk_widget_set_usize (label19, 60, 16);

  label18 = gtk_label_new (_("Commande d'impression :"));
  gtk_widget_ref (label18);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "label18", label18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label18);
  gtk_fixed_put (GTK_FIXED (fixed1), label18, 12, 164);
  gtk_widget_set_uposition (label18, 12, 164);
  gtk_widget_set_usize (label18, 160, 16);

  hseparator3 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator3);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "hseparator3", hseparator3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator3);
  gtk_fixed_put (GTK_FIXED (fixed1), hseparator3, 4, 144);
  gtk_widget_set_uposition (hseparator3, 4, 144);
  gtk_widget_set_usize (hseparator3, 344, 16);

  label16 = gtk_label_new (_(""));
  gtk_widget_ref (label16);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "label16", label16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label16);
  gtk_fixed_put (GTK_FIXED (fixed1), label16, 164, 80);
  gtk_widget_set_uposition (label16, 164, 80);
  gtk_widget_set_usize (label16, 24, 16);

  label15 = gtk_label_new (_("Compte de :"));
  gtk_widget_ref (label15);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "label15", label15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label15);
  gtk_fixed_put (GTK_FIXED (fixed1), label15, 0, 80);
  gtk_widget_set_uposition (label15, 0, 80);
  gtk_widget_set_usize (label15, 88, 16);

  label14 = gtk_label_new (_("Date de :"));
  gtk_widget_ref (label14);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "label14", label14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label14);
  gtk_fixed_put (GTK_FIXED (fixed1), label14, 16, 56);
  gtk_widget_set_uposition (label14, 16, 56);
  gtk_widget_set_usize (label14, 72, 16);

  label20 = gtk_label_new (_(""));
  gtk_widget_ref (label20);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "label20", label20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label20);
  gtk_fixed_put (GTK_FIXED (fixed1), label20, 160, 56);
  gtk_widget_set_uposition (label20, 160, 56);
  gtk_widget_set_usize (label20, 34, 16);

  U_Mouvements = gtk_check_button_new_with_label (_("Uniquement les comptes mouvements"));
  gtk_widget_ref (U_Mouvements);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "U_Mouvements", U_Mouvements,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (U_Mouvements);
  gtk_fixed_put (GTK_FIXED (fixed1), U_Mouvements, 84, 100);
  gtk_widget_set_uposition (U_Mouvements, 84, 100);
  gtk_widget_set_usize (U_Mouvements, 256, 24);

  U_Soldes = gtk_check_button_new_with_label (_("Uniquement des comptes non solds"));
  gtk_widget_ref (U_Soldes);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "U_Soldes", U_Soldes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (U_Soldes);
  gtk_fixed_put (GTK_FIXED (fixed1), U_Soldes, 84, 124);
  gtk_widget_set_uposition (U_Soldes, 84, 124);
  gtk_widget_set_usize (U_Soldes, 240, 24);

  SelDate = gtk_check_button_new_with_label (_("Selection par priode"));
  gtk_widget_ref (SelDate);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "SelDate", SelDate,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (SelDate);
  gtk_fixed_put (GTK_FIXED (fixed1), SelDate, 28, 28);
  gtk_widget_set_uposition (SelDate, 28, 28);
  gtk_widget_set_usize (SelDate, 144, 24);

  fixed2 = gtk_fixed_new ();
  gtk_widget_ref (fixed2);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "fixed2", fixed2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed2);
  gtk_box_pack_start (GTK_BOX (vbox2), fixed2, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (fixed2), 2);

  BtCancel = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (BtCancel);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "BtCancel", BtCancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtCancel);
  gtk_fixed_put (GTK_FIXED (fixed2), BtCancel, 268, 8);
  gtk_widget_set_uposition (BtCancel, 268, 8);
  gtk_widget_set_usize (BtCancel, 80, 24);

  BtOk = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (BtOk);
  gtk_object_set_data_full (GTK_OBJECT (ImpBal), "BtOk", BtOk,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtOk);
  gtk_fixed_put (GTK_FIXED (fixed2), BtOk, 184, 8);
  gtk_widget_set_uposition (BtOk, 184, 8);
  gtk_widget_set_usize (BtOk, 76, 24);

  gtk_signal_connect (GTK_OBJECT (ImpBal), "show",
                      GTK_SIGNAL_FUNC (on_ImpBal_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ImpBal), "destroy",
                      GTK_SIGNAL_FUNC (on_ImpBal_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (BtOk), "clicked",
                      GTK_SIGNAL_FUNC (on_ImpBal_BtOk_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (BtCancel), "clicked",
                      GTK_SIGNAL_FUNC (on_ImpBal_BtCancel_clicked),
                      NULL);

  return ImpBal;
}

void Dialog_ImpBal(void)
{
  gchar PsCle[LEN_COD_SOC+1],Printer[9],TDate[15],Tmp[200],SqlCmd[300];
  GtkWidget *widget;

  ImpWin=create_ImpBal();
  gtk_widget_show_all(GTK_WIDGET (ImpWin));
  GetSocRun(PsCle);
  GetDateExercice(DateDeb,DateFin,PsCle);
  strcpy(CptDeb,"        ");
  strcpy(CptFin,"ZZZZZZZZ");
  widget=lookup_widget(GTK_WIDGET (ImpWin),"DateDeb");
  IsoToDate(TDate,DateDeb);
  gtk_entry_set_text(GTK_ENTRY (widget),TDate);
  widget=lookup_widget(GTK_WIDGET (ImpWin),"DateFin");
  IsoToDate(TDate,DateFin);
  gtk_entry_set_text(GTK_ENTRY (widget),TDate);
  sprintf(SqlCmd,"Select PgPrinter From Pgx where PgCle='%s'",PsCle);
  SqlGetString(SqlCmd,Printer);
  if (*Printer)  sprintf(Tmp,"lpr -P%s",Printer);else strcpy(Tmp,"lpr");
  widget=lookup_widget(GTK_WIDGET (ImpWin),"CmdPrint");
  gtk_entry_set_text(GTK_ENTRY (widget),Tmp);
}
