/*******************************************************************/
/* Comptabilit Analytique Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 08/07/02 - Impression du grand livre                            */
/* Fichier source                                                  */
/*******************************************************************/

#include <gtk/gtk.h>
#include <gnome.h>
#include <string.h>
#include <ctype.h>
#include <mysql/mysql.h>
#include "support.h"
#include "common.h"
#include "gtksql.h"
#include "select.h"
#include "print.h"

#include "impgl.h"

/* Variables */
GtkWidget   *ImpWin;
gchar       DateDeb[11],DateFin[11],CptDeb[3],CptFin[3],CmdRun[64];
gchar  			CmdToPrint[128];
int 				TpGL,PaperSize,TpPer,MvtOnly,LetOnly;
MYSQL_ROW 	CptRow;
gchar 			*GLChoice[]={_("Gnrale"),_("Clients"),_("Fournisseurs")};

/* protos */

GtkWidget* create_ImpGL (void);
void on_ImpGL_BtCancel_clicked(GtkButton *But,gpointer user_data);
void on_ImpGL_BtOk_clicked(GtkButton *But,gpointer user_data);
void on_ImpGL_destroy(GtkObject *object,gpointer user_data);
void on_ImpGL_show(GtkWidget *widget,gpointer user_data);

/****************************************************************************/
void GL_PrintTabHeader()
{
	PS_justification(CENTER_JUST);
	PS_setTypeface(FNT_BOLD);
	PS_setTextSize(8);
  PS_xprint(16,_("Date"));
  PS_xprint(30,_("Journal"));
	PS_xprint(44,_("Pice"));
	PS_xprint(65,_("Libell"));
	PS_xprint(112,_("Let."));
	PS_xprint(130,_("Dbit"));
	PS_xprint(154,_("Crdit"));
	PS_xprint(177,_("Solde"));
	PS_sendReturn();	
	PS_setTypeface(FNT_NORMAL);	
}

void GL_PrintPageHeader(int Page)
{
	char TDate1[11],TDate2[11],Tmp[80],TitlePrint[120];
	
  PS_setFont("Helvetica",14,FNT_BOLD);
  sprintf(TitlePrint,_("GRAND LIVRE %s"),GLChoice[TpGL]);
  PS_justification(CENTER_JUST);
  PS_xprint(100,TitlePrint);
	PS_justification(RIGHT_JUST);
	PS_setTextSize(10);
	sprintf(Tmp,"Page : %03i",Page);
	PS_xprint(200,Tmp);
	PS_setTextSize(14);
	PS_sendReturn();
	IsoToDate(TDate1,DateDeb);
	IsoToDate(TDate2,DateFin);
	if (TpPer==FALSE) sprintf(Tmp,_("Exercice du %s au %s"),TDate1,TDate2);
	else sprintf(Tmp,_("Priode du %s au %s"),TDate1,TDate2);
	PS_justification(CENTER_JUST);
	PS_xprint(100,Tmp);
	PS_down(10);
	GL_PrintTabHeader();
}

// Impression d'une ligne *****************************************************
void GL_PrintLine(char *PsCle,char *Cpt,char *Lib)
{
	gchar *SqlCmd,Tmp[20];
	MYSQL_RES *Result;
  MYSQL_ROW Row;
	double DM,CM,Solde;
	int    PASS,FOUND;

	FOUND=FALSE;
	SqlCmd=g_strdup_printf("Select * From Ecrit where EcrSoc='%s' And EcrCpt='%s' And EcrDate Between '%s' and '%s'",PsCle,Cpt,DateDeb,DateFin);
	if (mysql_query(DbLcpt,SqlCmd)==0) {
		Result=mysql_store_result(DbLcpt);
		while ((Row=mysql_fetch_row(Result))) {
			if (Row[19]!=NULL) DM=atof(Row[19]);else DM=0;
			if (Row[20]!=NULL) CM=atof(Row[20]);else CM=0;
			PASS=FALSE;
			if (((DM==0) && (CM==0)) && (MvtOnly)) PASS=TRUE;
			if (((Row[10]==NULL) || (strcmp(Row[10],"  ")==0)) && (LetOnly)) PASS=TRUE;
			if (!PASS) {
				if (!FOUND) {
					PS_setTextSize(10);
					PS_setTypeface(FNT_BOLD);
					PS_down(2);
					PS_justification(LEFT_JUST);
					PS_xprint(10,Cpt);
					PS_xprint(30,Lib);
					PS_sendReturn();
					FOUND=TRUE;
					PS_setTextSize(8);
					PS_setTypeface(FNT_NORMAL);
				}
				PS_justification(LEFT_JUST);
				IsoToDate(Tmp,Row[3]);
				PS_xprint(10,Tmp);
				PS_justification(CENTER_JUST);
				PS_xprint(30,Row[4]);
				PS_justification(LEFT_JUST);
				PS_xprint(38,Row[5]);
				PS_xprint(56,Row[9]);
				PS_xprint(115,Row[10]);
				PS_justification(RIGHT_JUST);
				if (DM!=0) {
   				sprintf(Tmp,"%8.2f",DM);
					PS_xprint(140,Tmp);
				}
				if (CM!=0) {
					sprintf(Tmp,"%8.2f",CM);
					PS_xprint(165,Tmp);
				}
				Solde=abs(DM-CM);
				if (Solde!=0) {
					sprintf(Tmp,"%8.2f",Solde);
					PS_xprint(190,Tmp);
				}				
				PS_sendReturn();
			}
		}
		mysql_free_result(Result);
		free(SqlCmd);
		if (FOUND) {
			SqlCmd=g_strdup_printf("Select Sum(EcrDebit),Sum(EcrCredit) From Ecrit where EcrSoc='%s' And EcrCpt='%s' And EcrDate Between '%s' and '%s'",PsCle,Cpt,DateDeb,DateFin);
	    if (mysql_query(DbLcpt,SqlCmd)==0) {
		    Result=mysql_store_result(DbLcpt);
		    if ((Row=mysql_fetch_row(Result))) {
					if (Row[0]!=NULL) DM=atof(Row[0]);else DM=0;
					if (Row[1]!=NULL) CM=atof(Row[1]);else CM=0;					
					PS_xprint(56,"Total pour le compte :");
					PS_print(Cpt);
					if (DM!=0) {
						sprintf(Tmp,"%8.2f",DM);
						PS_xprint(140,Tmp);
					}
					if (CM!=0) {
						sprintf(Tmp,"%8.2f",CM);
						PS_xprint(165,Tmp);
					}
					Solde=abs(DM-CM);
					if (Solde!=0) {
						sprintf(Tmp,"%8.2f",Solde);
						PS_xprint(190,Tmp);
					}
					PS_down(2);
		    }
		    mysql_free_result(Result);
			}
			free(SqlCmd);
		}
	}
}

void GL_PrintTotal(gchar *PsCle)
{
	gchar *SqlCmd,Tmp[15];
	MYSQL_RES *Result;
  MYSQL_ROW Row;
	double DM,CM,Solde;
	
	SqlCmd=g_strdup_printf("Select Sum(EcrDebit),Sum(EcrCredit) From Ecrit where EcrSoc='%s' And EcrDate Between '%s' and '%s'",PsCle,DateDeb,DateFin);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    Result=mysql_store_result(DbLcpt);
    if ((Row=mysql_fetch_row(Result))) {
			if (Row[0]!=NULL) DM=atof(Row[0]);else DM=0;
			if (Row[1]!=NULL) CM=atof(Row[1]);else CM=0;
			PS_down(5);
			PS_setTextSize(10);
			PS_setTypeface(FNT_BOLD);
			PS_justification(LEFT_JUST);
			PS_xprint(56,"Total du Grand Livre");
			PS_justification(RIGHT_JUST);
			if (DM!=0) {
				sprintf(Tmp,"%8.2f",DM);
				PS_xprint(140,Tmp);
			}
  		if (CM!=0) {
				sprintf(Tmp,"%8.2f",CM);
				PS_xprint(165,Tmp);
			}
			Solde=abs(DM-CM);
			if (Solde!=0) {
				sprintf(Tmp,"%8.2f",Solde);
				PS_xprint(190,Tmp);
			}
			PS_sendReturn();
		}
		mysql_free_result(Result);
	}
	free(SqlCmd);
}

void PrintGL()
{
	gchar *SqlCmd,PsCle[LEN_COD_SOC+1];
  MYSQL_RES *Result;
  MYSQL_ROW Row;

  PS_beginPrint(PaperSize,_("Impression Grand Livre"),NULL,&GL_PrintPageHeader);
	GL_PrintPageHeader(1);
	GetSocRun(PsCle);
	SqlCmd=NULL;
	switch (TpGL) {
		case 0 : SqlCmd=g_strdup_printf("select * from Comptes Where CptSoc='%s' And CptCode between '%s' and '%s' Order by CptCode",PsCle,CptDeb,CptFin);
			break;
		case 1 : SqlCmd=g_strdup_printf("Select * From Comptes Where CptSoc='%s' And CptCol='4110' And CptCode between '%s' and '%s' Order by CptCode",PsCle,CptDeb,CptFin);
			break;
		case 2 : SqlCmd=g_strdup_printf("Select * From Comptes Where CptSoc='%s' And CptCol='4010' And CptCode between '%s' and '%s' Order by CptCode",PsCle,CptDeb,CptFin);
			break;		
	}
  PS_setFont("Helvetica",8,FNT_NORMAL);	
	if (mysql_query(DbLcpt,SqlCmd)==0) {
		Result=mysql_store_result(DbLcpt);
		while ((Row=mysql_fetch_row(Result))) {
      GL_PrintLine(PsCle,Row[1],Row[2]);
		}
//		PrintTotalBalance();
		mysql_free_result(Result);
	}
	free(SqlCmd);
	GL_PrintTotal(PsCle);
  PS_endPrint(CmdToPrint);		
}

void on_ImpGL_BtCancel_clicked(GtkButton *But,gpointer user_data)
{
  gtk_widget_destroy(ImpWin);
}

/* Validation de la demande ****************************************************/
void on_ImpGL_BtOk_clicked(GtkButton *But,gpointer user_data)
{
  GtkWidget *widget;
  gchar TDate[15],Format[20],Tmp[30],PsCle[LEN_COD_SOC+1];

  GetSocRun(PsCle);
  widget=lookup_widget(GTK_WIDGET (ImpWin),"SelDate");
  TpPer=(GTK_TOGGLE_BUTTON (widget)->active);
	if (TpPer) {
    widget=lookup_widget(GTK_WIDGET (ImpWin),"DateDeb");
    strcpy(TDate,gtk_entry_get_text(GTK_ENTRY (widget)));
    DateToIso(DateDeb,TDate);
    widget=lookup_widget(GTK_WIDGET (ImpWin),"DateFin");
    strcpy(TDate,gtk_entry_get_text(GTK_ENTRY (widget)));
    DateToIso(DateFin,TDate);
	} else {
	  GetDateExercice(DateDeb,DateFin,PsCle);
	  //IsoToDate(TDate,DateDeb);
		//strcpy(DateDeb,TDate);
	  //IsoToDate(TDate,DateFin);
		//strcpy(DateFin,TDate);
	}
  widget=lookup_widget(GTK_WIDGET (ImpWin),"CptDeb");
  strcpy(CptDeb,gtk_entry_get_text(GTK_ENTRY (widget)));
  widget=lookup_widget(GTK_WIDGET (ImpWin),"CptFin");
  strcpy(CptFin,gtk_entry_get_text(GTK_ENTRY (widget)));
  widget=lookup_widget(GTK_WIDGET (ImpWin),"CmdPrint");
  strcpy(CmdToPrint,gtk_entry_get_text(GTK_ENTRY (widget)));
  /***/
  widget=lookup_widget(GTK_WIDGET (ImpWin),"TpGL");
  GetOptionMenu(widget,Tmp);
	TpGL=SearchInArray(GLChoice,3,Tmp);
	/***/
  widget=lookup_widget(GTK_WIDGET (ImpWin),"U_Mouvements");
  MvtOnly=(GTK_TOGGLE_BUTTON (widget)->active);
  widget=lookup_widget(GTK_WIDGET (ImpWin),"U_Lettres");
  LetOnly=(GTK_TOGGLE_BUTTON (widget)->active);	
	/***/
  widget=lookup_widget(GTK_WIDGET (ImpWin),"FormatPage");
  GetOptionMenu(widget,Format);
  if (strcmp(Format,"A4")==0) PaperSize=1;else PaperSize=2;	
	PrintGL();
  gtk_widget_destroy(ImpWin);
}

void on_ImpGL_destroy(GtkObject *object,gpointer user_data)
{
  CloseDbLcpt();
}

void on_ImpGL_show(GtkWidget *widget,gpointer user_data)
{
  OpenDbLcpt();
}

GtkWidget* create_ImpGL (void)
{
  GtkWidget *ImpGL;
  GtkWidget *vbox3;
  GtkWidget *fixed3;
  GtkWidget *DateDeb;
  GtkWidget *DateFin;
  GtkWidget *CptDeb;
  GtkWidget *CptFin;
  GtkWidget *CmdPrint;
  GtkWidget *FormatPage;
  GtkWidget *FormatPage_menu;
  GtkWidget *glade_menuitem;
  GtkWidget *TpGL;
  GtkWidget *TpGL_menu;
  GtkWidget *label23;
  GtkWidget *label24;
  GtkWidget *hseparator4;
  GtkWidget *label25;
  GtkWidget *label26;
  GtkWidget *label27;
  GtkWidget *label28;
  GtkWidget *label22;
  GtkWidget *SelDate;
  GtkWidget *U_Mouvements;
  GtkWidget *U_Lettres;
  GtkWidget *fixed4;
  GtkWidget *BtCancel;
  GtkWidget *BtOk;

  ImpGL = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (ImpGL), "ImpGL", ImpGL);
  gtk_window_set_title (GTK_WINDOW (ImpGL), _("Impression Grand Livre"));
  gtk_window_set_position (GTK_WINDOW (ImpGL), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (ImpGL), TRUE);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_container_add (GTK_CONTAINER (ImpGL), vbox3);

  fixed3 = gtk_fixed_new ();
  gtk_widget_ref (fixed3);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "fixed3", fixed3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed3);
  gtk_box_pack_start (GTK_BOX (vbox3), fixed3, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (fixed3), 2);

  DateDeb = gtk_entry_new ();
  gtk_widget_ref (DateDeb);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "DateDeb", DateDeb,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (DateDeb);
  gtk_fixed_put (GTK_FIXED (fixed3), DateDeb, 84, 52);
  gtk_widget_set_uposition (DateDeb, 84, 52);
  gtk_widget_set_usize (DateDeb, 76, 20);

  DateFin = gtk_entry_new ();
  gtk_widget_ref (DateFin);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "DateFin", DateFin,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (DateFin);
  gtk_fixed_put (GTK_FIXED (fixed3), DateFin, 196, 52);
  gtk_widget_set_uposition (DateFin, 196, 52);
  gtk_widget_set_usize (DateFin, 80, 20);

  CptDeb = gtk_entry_new_with_max_length (8);
  gtk_widget_ref (CptDeb);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "CptDeb", CptDeb,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptDeb);
  gtk_fixed_put (GTK_FIXED (fixed3), CptDeb, 84, 76);
  gtk_widget_set_uposition (CptDeb, 84, 76);
  gtk_widget_set_usize (CptDeb, 76, 20);
  gtk_entry_set_text (GTK_ENTRY (CptDeb), _(" "));

  CptFin = gtk_entry_new_with_max_length (8);
  gtk_widget_ref (CptFin);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "CptFin", CptFin,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptFin);
  gtk_fixed_put (GTK_FIXED (fixed3), CptFin, 196, 76);
  gtk_widget_set_uposition (CptFin, 196, 76);
  gtk_widget_set_usize (CptFin, 80, 20);
  gtk_entry_set_text (GTK_ENTRY (CptFin), _("ZZZZZZZZ"));

  CmdPrint = gtk_entry_new ();
  gtk_widget_ref (CmdPrint);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "CmdPrint", CmdPrint,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CmdPrint);
  gtk_fixed_put (GTK_FIXED (fixed3), CmdPrint, 172, 160);
  gtk_widget_set_uposition (CmdPrint, 172, 160);
  gtk_widget_set_usize (CmdPrint, 158, 22);

  FormatPage = gtk_option_menu_new ();
  gtk_widget_ref (FormatPage);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "FormatPage", FormatPage,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (FormatPage);
  gtk_fixed_put (GTK_FIXED (fixed3), FormatPage, 76, 184);
  gtk_widget_set_uposition (FormatPage, 76, 184);
  gtk_widget_set_usize (FormatPage, 80, 20);
  FormatPage_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label (_("A4"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (FormatPage_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("Letter"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (FormatPage_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (FormatPage), FormatPage_menu);

  TpGL = gtk_option_menu_new ();
  gtk_widget_ref (TpGL);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "TpGL", TpGL,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (TpGL);
  gtk_fixed_put (GTK_FIXED (fixed3), TpGL, 140, 4);
  gtk_widget_set_uposition (TpGL, 140, 4);
  gtk_widget_set_usize (TpGL, 108, 24);
  TpGL_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label (GLChoice[0]);
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (TpGL_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (GLChoice[1]);
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (TpGL_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (GLChoice[2]);
  gtk_widget_show (glade_menuitem);
	gtk_menu_append (GTK_MENU (TpGL_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (TpGL), TpGL_menu);

  label23 = gtk_label_new (_("Format :"));
  gtk_widget_ref (label23);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "label23", label23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label23);
  gtk_fixed_put (GTK_FIXED (fixed3), label23, 12, 184);
  gtk_widget_set_uposition (label23, 12, 184);
  gtk_widget_set_usize (label23, 60, 16);

  label24 = gtk_label_new (_("Commande d'impression :"));
  gtk_widget_ref (label24);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "label24", label24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label24);
  gtk_fixed_put (GTK_FIXED (fixed3), label24, 12, 164);
  gtk_widget_set_uposition (label24, 12, 164);
  gtk_widget_set_usize (label24, 160, 16);

  hseparator4 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator4);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "hseparator4", hseparator4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator4);
  gtk_fixed_put (GTK_FIXED (fixed3), hseparator4, 4, 144);
  gtk_widget_set_uposition (hseparator4, 4, 144);
  gtk_widget_set_usize (hseparator4, 344, 16);

  label25 = gtk_label_new (_(""));
  gtk_widget_ref (label25);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "label25", label25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label25);
  gtk_fixed_put (GTK_FIXED (fixed3), label25, 164, 80);
  gtk_widget_set_uposition (label25, 164, 80);
  gtk_widget_set_usize (label25, 24, 16);

  label26 = gtk_label_new (_("Compte de :"));
  gtk_widget_ref (label26);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "label26", label26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label26);
  gtk_fixed_put (GTK_FIXED (fixed3), label26, 0, 80);
  gtk_widget_set_uposition (label26, 0, 80);
  gtk_widget_set_usize (label26, 88, 16);

  label27 = gtk_label_new (_("Date de :"));
  gtk_widget_ref (label27);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "label27", label27,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label27);
  gtk_fixed_put (GTK_FIXED (fixed3), label27, 16, 56);
  gtk_widget_set_uposition (label27, 16, 56);
  gtk_widget_set_usize (label27, 72, 16);

  label28 = gtk_label_new (_(""));
  gtk_widget_ref (label28);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "label28", label28,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label28);
  gtk_fixed_put (GTK_FIXED (fixed3), label28, 160, 56);
  gtk_widget_set_uposition (label28, 160, 56);
  gtk_widget_set_usize (label28, 34, 16);

  label22 = gtk_label_new (_("Imprimer grand livre :"));
  gtk_widget_ref (label22);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "label22", label22,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label22);
  gtk_fixed_put (GTK_FIXED (fixed3), label22, 12, 8);
  gtk_widget_set_uposition (label22, 12, 8);
  gtk_widget_set_usize (label22, 128, 16);
  gtk_label_set_justify (GTK_LABEL (label22), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label22), 0, 0.5);

  SelDate = gtk_check_button_new_with_label (_("Selection par priode"));
  gtk_widget_ref (SelDate);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "SelDate", SelDate,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (SelDate);
  gtk_fixed_put (GTK_FIXED (fixed3), SelDate, 28, 28);
  gtk_widget_set_uposition (SelDate, 28, 28);
  gtk_widget_set_usize (SelDate, 144, 24);

  U_Mouvements = gtk_check_button_new_with_label (_("Uniquement les comptes mouvements"));
  gtk_widget_ref (U_Mouvements);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "U_Mouvements", U_Mouvements,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (U_Mouvements);
  gtk_fixed_put (GTK_FIXED (fixed3), U_Mouvements, 84, 100);
  gtk_widget_set_uposition (U_Mouvements, 84, 100);
  gtk_widget_set_usize (U_Mouvements, 256, 24);

  U_Lettres = gtk_check_button_new_with_label (_("Uniquement des comptes non lettrs"));
  gtk_widget_ref (U_Lettres);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "U_Lettres", U_Lettres,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (U_Lettres);
  gtk_fixed_put (GTK_FIXED (fixed3), U_Lettres, 84, 124);
  gtk_widget_set_uposition (U_Lettres, 84, 124);
  gtk_widget_set_usize (U_Lettres, 240, 24);

  fixed4 = gtk_fixed_new ();
  gtk_widget_ref (fixed4);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "fixed4", fixed4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed4);
  gtk_box_pack_start (GTK_BOX (vbox3), fixed4, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (fixed4), 2);

  BtCancel = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (BtCancel);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "BtCancel", BtCancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtCancel);
  gtk_fixed_put (GTK_FIXED (fixed4), BtCancel, 268, 8);
  gtk_widget_set_uposition (BtCancel, 268, 8);
  gtk_widget_set_usize (BtCancel, 80, 24);

  BtOk = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (BtOk);
  gtk_object_set_data_full (GTK_OBJECT (ImpGL), "BtOk", BtOk,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtOk);
  gtk_fixed_put (GTK_FIXED (fixed4), BtOk, 184, 8);
  gtk_widget_set_uposition (BtOk, 184, 8);
  gtk_widget_set_usize (BtOk, 76, 24);

  gtk_signal_connect (GTK_OBJECT (ImpGL), "show",
                      GTK_SIGNAL_FUNC (on_ImpGL_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ImpGL), "destroy",
                      GTK_SIGNAL_FUNC (on_ImpGL_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (BtOk), "clicked",
                      GTK_SIGNAL_FUNC (on_ImpGL_BtOk_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (BtCancel), "clicked",
                      GTK_SIGNAL_FUNC (on_ImpGL_BtCancel_clicked),
                      NULL);

  return ImpGL;
}

void Dialog_ImpGL(void)
{
  gchar PsCle[LEN_COD_SOC+1],Printer[9],TDate[15],Tmp[200],SqlCmd[200];
	gchar DebExercice[12],FinExercice[12];
  GtkWidget *widget;

  ImpWin=create_ImpGL();
  gtk_widget_show_all(GTK_WIDGET (ImpWin));
  GetSocRun(PsCle);
  GetDateExercice(DebExercice,FinExercice,PsCle);
  strcpy(DateDeb,DebExercice);
  strcpy(DateFin,FinExercice);
  strcpy(CptDeb,"        ");
  strcpy(CptFin,"ZZZZZZZZ");
  widget=lookup_widget(GTK_WIDGET (ImpWin),"DateDeb");
  IsoToDate(TDate,DateDeb);
  gtk_entry_set_text(GTK_ENTRY (widget),TDate);
  widget=lookup_widget(GTK_WIDGET (ImpWin),"DateFin");
	IsoToDate(TDate,DateFin);
	gtk_entry_set_text(GTK_ENTRY (widget),TDate);
  sprintf(SqlCmd,"Select PgPrinter From Pgx where PgCle='%s'",PsCle);
  SqlGetString(SqlCmd,Printer);
  if (*Printer)  sprintf(Tmp,"lpr -P%s",Printer);else strcpy(Tmp,"lpr");
  widget=lookup_widget(GTK_WIDGET (ImpWin),"CmdPrint");
  gtk_entry_set_text(GTK_ENTRY (widget),Tmp);
}
