/*******************************************************************/
/* Comptabilit Analytique Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 08/05/02 - Impression du journal                                */
/* Fichier source                                                  */
/*******************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 



#include <gtk/gtk.h>
#include <gnome.h>
#include <string.h>
#include <ctype.h>
#include <mysql/mysql.h>
#include "support.h"
#include "common.h"
#include "gtksql.h"
#include "select.h"
#include "print.h"

#include "impjrn.h"

/* Variables */
GtkWidget *ImpWin;
gchar DateDeb[11],DateFin[11],JrnDeb[3],JrnFin[3],CmdRun[64],TitlePrint[128];
gchar CmdToPrint[128];
gchar SqlCmd[1024];
int TpJrn,PaperSize,TpPer,Print_Central;
MYSQL_ROW JrnRow;

/* protos */
GtkWidget* create_ImpJrn (void);
void on_ImpJrn_BtCancel_clicked(GtkButton *But,gpointer user_data);
void on_ImpJrn_BtOk_clicked(GtkButton *But,gpointer user_data);
void on_ImpJrn_destroy(GtkObject *object,gpointer user_data);
void on_ImpJrn_show(GtkWidget *widget,gpointer user_data);
void PrintJrn(void);
void CentMonth(char *PsCle,char *Jrn,int Mo);
void MonthSum(char *PsCle,char *Jrn,int Month);
void PrintNewPage(int Page);
void InitCombo(GtkWidget *Combo,int ValFirst);

/*********************************************************************/
void CentMonth(char *PsCle,char *Jrn,int Mo)
{
  MYSQL_RES *Result;
  MYSQL_ROW Row;
  gchar Tmp[255];
	float D,C;

	Print_Central=TRUE;
	D=0;
	C=0;
  PS_justification(LEFT_JUST);
  PS_sendReturn();
  sprintf(Tmp,_("Centralisation du mois :%s"),GetMonthString(Mo));
  PS_print(Tmp);
  PS_down(8);
  PS_justification(CENTER_JUST);
  PS_setTypeface(FNT_BOLD);
  PS_xprint(25,_("Compte"));
  PS_xprint(45,_("Libell"));
  PS_justification(RIGHT_JUST);
  PS_xprint(171,_("Dbit"));
  PS_xprint(194,_("Crdit"));
  PS_sendReturn();
  PS_setTypeface(FNT_NORMAL);
  sprintf(SqlCmd,"select a.EcrCpt,b.CptLib,sum(a.EcrDebit),Sum(a.EcrCredit) from Ecrit as a right join Comptes as b on a.EcrCpt=b.CptCode where a.EcrSoc='%s' and a.EcrJrn='%s' And Month(a.EcrDate)=%i And b.CptCol<>'4010' And a.EcrDate Between '%s' And '%s' Group By a.EcrCpt",PsCle,Jrn,Mo,DateDeb,DateFin);
  //  g_print("%s\n",SqlCmd);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    Result=mysql_store_result(DbLcpt);
    while((Row=mysql_fetch_row(Result))) {
      PS_justification(LEFT_JUST);
      PS_xprint(20,Row[0]);
      PS_xprint(40,Row[1]);
      PS_justification(RIGHT_JUST);
      PS_xprint(171,Row[2]);
      PS_xprint(194,Row[3]);
      PS_sendReturn();
			D=D+atof(Row[2]);
			C=C+atof(Row[3]);
    }
    mysql_free_result(Result);
  }
  PS_justification(LEFT_JUST);
  PS_down(4);
  PS_xprint(20,_("CUMUL CENTRALISATION :"));
  PS_justification(RIGHT_JUST);
  PS_setTypeface(FNT_BOLD);
  sprintf(Tmp,"%-8.2f",D);
  PS_xprint(171,Tmp);
  sprintf(Tmp,"%-8.2f",C);
  PS_xprint(194,Tmp);
  PS_setTypeface(FNT_NORMAL);
  PS_sendReturn();	
	Print_Central=FALSE;	
}

void MonthSum(char *PsCle,char *Jrn,int Month)
{
  MYSQL_RES *Result;
  MYSQL_ROW Row;
  float a,b;
  gchar Tmp[255];

  a=b=0;
  sprintf(SqlCmd,"Select Sum(EcrDebit),Sum(EcrCredit) From Ecrit Where EcrSoc='%s' And EcrJrn='%s' And EcrDate Between '%s' and '%s' And Month(EcrDate)=%i",PsCle,Jrn,DateDeb,DateFin,Month);
  //  g_print("%s\n",SqlCmd);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    Result=mysql_store_result(DbLcpt);
    if ((Row=mysql_fetch_row(Result))) {
      if (Row[0]!=NULL) a=atof(Row[0]);
      if (Row[1]!=NULL) b=atof(Row[1]);
    }
    mysql_free_result(Result);
  }
  PS_justification(LEFT_JUST);
  PS_down(4);
  PS_xprint(20,_("CUMUL MENSUEL :"));
  PS_justification(RIGHT_JUST);
  PS_setTypeface(FNT_BOLD);
  sprintf(Tmp,"%-8.2f",a);
  PS_xprint(171,Tmp);
  sprintf(Tmp,"%-8.2f",b);
  PS_xprint(194,Tmp);
  PS_setTypeface(FNT_NORMAL);
  PS_sendReturn();
  CentMonth(PsCle,Jrn,Month);
}

void PrintNewPage(int Page)
{
  char Tmp[50];

  PS_justification(LEFT_JUST);
	PS_print(TitlePrint);
  sprintf(Tmp,"Page :%3i",Page);
  PS_justification(RIGHT_JUST);
  PS_xprint(200,Tmp);
  PS_down(10);
  /*** Entete de tableau *******/
  PS_justification(CENTER_JUST);
  PS_setTypeface(FNT_BOLD);
	if (!Print_Central) {
		PS_xprint(25,_("Date"));
		PS_xprint(75,_("Libell"));
		PS_xprint(108,_("Pice"));
		PS_xprint(128,_("Compte"));
		PS_justification(RIGHT_JUST);
		PS_xprint(166,_("Dbit"));
		PS_xprint(187,_("Crdit"));
	} else {
		PS_xprint(25,_("Compte"));
		PS_xprint(45,_("Libell"));
		PS_justification(RIGHT_JUST);
		PS_xprint(171,_("Dbit"));
		PS_xprint(194,_("Crdit"));
	}
	PS_sendReturn();
	PS_setTypeface(FNT_NORMAL);
	PS_justification(LEFT_JUST);
}

void PrintJrn(void)
{
  gchar PsCle[LEN_COD_SOC+1],TDate[11],TDate2[11],Tmp[255];
  MYSQL_RES *Result,*EcrRes;
  MYSQL_ROW EcrRow;
  int m,i;

  PS_beginPrint(PaperSize,_("Impression journal"),NULL,&PrintNewPage);
  PS_setFont("Helvetica",10,FNT_NORMAL);
  GetSocRun(PsCle);
  sprintf(SqlCmd,"Select JCode,JLib From Jrn Where JCode Between '%s' And '%s' And JSoc='%s' Order By JCode",JrnDeb,JrnFin,PsCle);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    Result=mysql_store_result(DbLcpt);
    m=0;
    while ((JrnRow=mysql_fetch_row(Result))) {
      PS_setFont("Helvetica",14,FNT_BOLD);
      sprintf(TitlePrint,_("JOURNAL :%s-%s"),JrnRow[0],JrnRow[1]);
      PS_justification(CENTER_JUST);
      PS_xprint(100,TitlePrint);
      PS_justification(RIGHT_JUST);
			PS_setTextSize(10);
      PS_xprint(200,"Page :  1");
			PS_setTextSize(14);
      PS_sendReturn();
      IsoToDate(TDate,DateDeb);
      IsoToDate(TDate2,DateFin);
      if (TpPer==FALSE) sprintf(Tmp,_("Exercice du %s au %s"),TDate,TDate2);
      else sprintf(Tmp,_("Priode du %s au %s"),TDate,TDate2);
      PS_justification(CENTER_JUST);
      PS_xprint(100,Tmp);
      PS_down(10);
      PS_setFont("Helvetica",10,FNT_BOLD);
      PS_justification(LEFT_JUST);
      sprintf(Tmp,_("Mois de %s"),GetMonthString(GetMonth(TDate)));
      PS_xprint(10,Tmp);
      PS_sendReturn();
      /*** Entete de tableau *******/
      PS_setFont("Helvetica",8,FNT_BOLD);
      PS_justification(CENTER_JUST);
      PS_xprint(25,_("Date"));
      PS_xprint(75,_("Libell"));
      PS_xprint(108,_("Pice"));
      PS_xprint(128,_("Compte"));
      PS_justification(RIGHT_JUST);
      PS_xprint(166,_("Dbit"));
      PS_xprint(187,_("Crdit"));
      PS_sendReturn();
      PS_setTypeface(FNT_NORMAL);
      sprintf(SqlCmd,"Select * From Ecrit Where EcrSoc='%s' And EcrDate Between '%s' and '%s' And EcrJrn='%s' Order by EcrDate",PsCle,DateDeb,DateFin,JrnRow[0]);
      if (mysql_query(DbLcpt,SqlCmd)==0) {
				EcrRes=mysql_store_result(DbLcpt);
				while ((EcrRow=mysql_fetch_row(EcrRes))) {
					IsoToDate(TDate,EcrRow[3]);
					i=GetMonth(TDate);
					if (i!=m) {
						if (m!=0) {
							MonthSum(PsCle,JrnRow[0],m);
							PS_sendEOP();
						}
						m=i;
					}
					PS_justification(LEFT_JUST);
					PS_xprint(20,TDate);
					PS_xprint(37,EcrRow[9]);
					PS_xprint(105,EcrRow[5]+2);
					PS_xprint(125,EcrRow[2]);
					PS_justification(RIGHT_JUST);
					PS_xprint(171,EcrRow[19]);
					PS_xprint(194,EcrRow[20]);
					PS_sendReturn();
				}
				MonthSum(PsCle,JrnRow[0],m);
				PS_sendEOP();
				mysql_free_result(EcrRes);
      }
    }
    mysql_free_result(Result);
  }
  PS_endPrint(CmdToPrint);
}

void on_ImpJrn_show(GtkWidget *widget,gpointer user_data)
{
  OpenDbLcpt();
}

void on_ImpJrn_destroy(GtkObject *object,gpointer user_data)
{
  CloseDbLcpt();
}

void on_ImpJrn_BtOk_clicked(GtkButton *But,gpointer user_data)
{
  GtkWidget *widget,*Entry;
  gchar TDate[15],Format[20];

  widget=lookup_widget(GTK_WIDGET (ImpWin),"DateDeb");
  strcpy(TDate,gtk_entry_get_text(GTK_ENTRY (widget)));
  DateToIso(DateDeb,TDate);
  widget=lookup_widget(GTK_WIDGET (ImpWin),"DateFin");
  strcpy(TDate,gtk_entry_get_text(GTK_ENTRY (widget)));
  DateToIso(DateFin,TDate);
  widget=lookup_widget(GTK_WIDGET (ImpWin),"JrnDeb");
  Entry=GTK_COMBO (widget)->entry;
  strcpy(JrnDeb,gtk_entry_get_text(GTK_ENTRY (Entry)));
  widget=lookup_widget(GTK_WIDGET (ImpWin),"JrnFin");
  Entry=GTK_COMBO (widget)->entry;
  strcpy(JrnFin,gtk_entry_get_text(GTK_ENTRY (Entry)));
  widget=lookup_widget(GTK_WIDGET (ImpWin),"PrinterCmd");
  strcpy(CmdToPrint,gtk_entry_get_text(GTK_ENTRY (widget)));
  /***/
  widget=lookup_widget(GTK_WIDGET (ImpWin),"SelDate");
  TpPer=(GTK_TOGGLE_BUTTON (widget)->active);
  widget=lookup_widget(GTK_WIDGET (ImpWin),"RpTpJrn");
  TpJrn=GetRadioButton(widget);
  widget=lookup_widget(GTK_WIDGET (ImpWin),"PaperSize1");
  GetOptionMenu(widget,Format);
  if (strcmp(Format,"A4")==0) PaperSize=1;else PaperSize=2;
  PrintJrn();
  gtk_widget_destroy(ImpWin);
}

void on_ImpJrn_BtCancel_clicked(GtkButton *But,gpointer user_data)
{
  gtk_widget_destroy(ImpWin);
}

GtkWidget* create_ImpJrn (void)
{
  GtkWidget *ImpJrn;
  GtkWidget *DivWindow;
  GtkWidget *FixWindow;
  GtkWidget *DateDeb;
  GtkWidget *DateFin;
  GtkWidget *JrnDeb;
  GtkWidget *JrnFin;
  GtkWidget *PrinterCmd;
  GtkWidget *PaperSize1;
  GtkWidget *PaperSize1_menu;
  GtkWidget *glade_menuitem;
  GtkWidget *label6;
  GtkWidget *SelDate;
  GtkWidget *label8;
  GtkWidget *label9;
  GtkWidget *label10;
  GSList *TpJrn_group = NULL;
  GtkWidget *radiobutton2;
  GtkWidget *hseparator2;
  GtkWidget *label12;
  GtkWidget *label13;
  GtkWidget *RpTpJrn;
  GtkWidget *label7;
  GtkWidget *FixButton;
  GtkWidget *BtCancel;
  GtkWidget *BtOk;

  ImpJrn = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (ImpJrn), "ImpJrn", ImpJrn);
  gtk_window_set_title (GTK_WINDOW (ImpJrn), _("Impression journal"));
  gtk_window_set_position (GTK_WINDOW (ImpJrn), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (ImpJrn), TRUE);

  DivWindow = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (DivWindow);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "DivWindow", DivWindow,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (DivWindow);
  gtk_container_add (GTK_CONTAINER (ImpJrn), DivWindow);

  FixWindow = gtk_fixed_new ();
  gtk_widget_ref (FixWindow);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "FixWindow", FixWindow,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (FixWindow);
  gtk_box_pack_start (GTK_BOX (DivWindow), FixWindow, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (FixWindow), 2);

  DateDeb = gtk_entry_new ();
  gtk_widget_ref (DateDeb);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "DateDeb", DateDeb,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (DateDeb);
  gtk_fixed_put (GTK_FIXED (FixWindow), DateDeb, 84, 28);
  gtk_widget_set_uposition (DateDeb, 84, 28);
  gtk_widget_set_usize (DateDeb, 76, 20);

  DateFin = gtk_entry_new ();
  gtk_widget_ref (DateFin);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "DateFin", DateFin,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (DateFin);
  gtk_fixed_put (GTK_FIXED (FixWindow), DateFin, 196, 28);
  gtk_widget_set_uposition (DateFin, 196, 28);
  gtk_widget_set_usize (DateFin, 80, 20);

  PrinterCmd = gtk_entry_new ();
  gtk_widget_ref (PrinterCmd);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "PrinterCmd", PrinterCmd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PrinterCmd);
  gtk_fixed_put (GTK_FIXED (FixWindow), PrinterCmd, 172, 116);
  gtk_widget_set_uposition (PrinterCmd, 172, 116);
  gtk_widget_set_usize (PrinterCmd, 158, 22);

  /* Taille papier */
  PaperSize1 = gtk_option_menu_new ();
  gtk_widget_ref (PaperSize1);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "PaperSize1", PaperSize1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PaperSize1);
  gtk_fixed_put (GTK_FIXED (FixWindow), PaperSize1, 76, 144);
  gtk_widget_set_uposition (PaperSize1, 76, 144);
  gtk_widget_set_usize (PaperSize1, 80, 20);
  PaperSize1_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label ("A4");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (PaperSize1_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("Letter");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (PaperSize1_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (PaperSize1), PaperSize1_menu);

  label6 = gtk_label_new (_("Date de :"));
  gtk_widget_ref (label6);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "label6", label6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label6);
  gtk_fixed_put (GTK_FIXED (FixWindow), label6, 16, 32);
  gtk_widget_set_uposition (label6, 16, 32);
  gtk_widget_set_usize (label6, 72, 16);

  SelDate = gtk_check_button_new_with_label (_("Selection par priode"));
  gtk_widget_ref (SelDate);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "SelDate", SelDate,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (SelDate);
  gtk_fixed_put (GTK_FIXED (FixWindow), SelDate, 28, 4);
  gtk_widget_set_uposition (SelDate, 28, 4);
  gtk_widget_set_usize (SelDate, 144, 24);
  /* Selection journaux */
  label8 = gtk_label_new (_("Journal de :"));
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_fixed_put (GTK_FIXED (FixWindow), label8, 0, 56);
  gtk_widget_set_uposition (label8, 0, 56);
  gtk_widget_set_usize (label8, 88, 16);

  label9 = gtk_label_new (_(""));
  gtk_widget_ref (label9);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "label9", label9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label9);
  gtk_fixed_put (GTK_FIXED (FixWindow), label9, 128, 56);
  gtk_widget_set_uposition (label9, 136, 56);
  gtk_widget_set_usize (label9, 24, 16);

  JrnDeb = gtk_combo_new();
  gtk_combo_set_value_in_list(GTK_COMBO (JrnDeb),TRUE,FALSE);
  gtk_combo_set_use_arrows(GTK_COMBO (JrnDeb),TRUE);
  gtk_combo_set_case_sensitive(GTK_COMBO(JrnDeb),FALSE);
  gtk_widget_ref (JrnDeb);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "JrnDeb", JrnDeb,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (JrnDeb);
  gtk_fixed_put (GTK_FIXED (FixWindow), JrnDeb, 92, 52);
  gtk_widget_set_uposition (JrnDeb, 92, 52);
  gtk_widget_set_usize (JrnDeb, 48, 20);

  JrnFin = gtk_combo_new();
  gtk_combo_set_value_in_list(GTK_COMBO (JrnFin),TRUE,FALSE);
  gtk_combo_set_use_arrows(GTK_COMBO (JrnFin),TRUE);
  gtk_combo_set_case_sensitive(GTK_COMBO(JrnFin),FALSE);
  gtk_widget_ref (JrnFin);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "JrnFin", JrnFin,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (JrnFin);
  gtk_fixed_put (GTK_FIXED (FixWindow), JrnFin, 160, 52);
  gtk_widget_set_uposition (JrnFin, 170, 52);
  gtk_widget_set_usize (JrnFin, 48, 20);
  /****/
  label10 = gtk_label_new (_("Impression type :"));
  gtk_widget_ref (label10);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "label10", label10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label10);
  gtk_fixed_put (GTK_FIXED (FixWindow), label10, 16, 84);
  gtk_widget_set_uposition (label10, 16, 84);
  gtk_widget_set_usize (label10, 104, 16);

  radiobutton2 = gtk_radio_button_new_with_label (TpJrn_group, _("Brouillard"));
  TpJrn_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton2));
  gtk_widget_ref (radiobutton2);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "radiobutton2", radiobutton2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton2);
  gtk_fixed_put (GTK_FIXED (FixWindow), radiobutton2, 192, 80);
  gtk_widget_set_uposition (radiobutton2, 192, 80);
  gtk_widget_set_usize (radiobutton2, 76, 24);

  hseparator2 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator2);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "hseparator2", hseparator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator2);
  gtk_fixed_put (GTK_FIXED (FixWindow), hseparator2, 4, 100);
  gtk_widget_set_uposition (hseparator2, 4, 100);
  gtk_widget_set_usize (hseparator2, 344, 16);

  label12 = gtk_label_new (_("Commande d'impression :"));
  gtk_widget_ref (label12);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "label12", label12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label12);
  gtk_fixed_put (GTK_FIXED (FixWindow), label12, 12, 120);
  gtk_widget_set_uposition (label12, 12, 120);
  gtk_widget_set_usize (label12, 160, 16);

  label13 = gtk_label_new (_("Format :"));
  gtk_widget_ref (label13);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "label13", label13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label13);
  gtk_fixed_put (GTK_FIXED (FixWindow), label13, 16, 148);
  gtk_widget_set_uposition (label13, 16, 148);
  gtk_widget_set_usize (label13, 60, 16);

  RpTpJrn = gtk_radio_button_new_with_label (TpJrn_group, _("Journal"));
  TpJrn_group = gtk_radio_button_group (GTK_RADIO_BUTTON (RpTpJrn));
  gtk_widget_ref (RpTpJrn);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "RpTpJrn", RpTpJrn,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RpTpJrn);
  gtk_fixed_put (GTK_FIXED (FixWindow), RpTpJrn, 124, 80);
  gtk_widget_set_uposition (RpTpJrn, 124, 80);
  gtk_widget_set_usize (RpTpJrn, 64, 24);

  label7 = gtk_label_new (_(""));
  gtk_widget_ref (label7);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "label7", label7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label7);
  gtk_fixed_put (GTK_FIXED (FixWindow), label7, 160, 32);
  gtk_widget_set_uposition (label7, 160, 32);
  gtk_widget_set_usize (label7, 34, 16);

  FixButton = gtk_fixed_new ();
  gtk_widget_ref (FixButton);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "FixButton", FixButton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (FixButton);
  gtk_box_pack_start (GTK_BOX (DivWindow), FixButton, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (FixButton), 2);

  BtCancel = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (BtCancel);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "BtCancel", BtCancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtCancel);
  gtk_fixed_put (GTK_FIXED (FixButton), BtCancel, 268, 8);
  gtk_widget_set_uposition (BtCancel, 268, 8);
  gtk_widget_set_usize (BtCancel, 76, 22);

  BtOk = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (BtOk);
  gtk_object_set_data_full (GTK_OBJECT (ImpJrn), "BtOk", BtOk,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtOk);
  gtk_fixed_put (GTK_FIXED (FixButton), BtOk, 184, 8);
  gtk_widget_set_uposition (BtOk, 184, 8);
  gtk_widget_set_usize (BtOk, 76, 22);

  gtk_signal_connect (GTK_OBJECT (ImpJrn), "show",
                      GTK_SIGNAL_FUNC (on_ImpJrn_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ImpJrn), "destroy",
                      GTK_SIGNAL_FUNC (on_ImpJrn_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (BtOk), "clicked",
                      GTK_SIGNAL_FUNC (on_ImpJrn_BtOk_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (BtCancel), "clicked",
                      GTK_SIGNAL_FUNC (on_ImpJrn_BtCancel_clicked),
                      NULL);
  return ImpJrn;
}

/* Valfirst 1=First valor 2=Last valor to entry */
void InitCombo(GtkWidget *Combo,int ValFirst)
{
  GList *Items;
  MYSQL_ROW Row;
  MYSQL_RES *Result;
  gchar SqlCmd[120],PsCle[LEN_COD_SOC+1],FirstValor[10];
  gint i;
  my_ulonglong Mx;
  GtkWidget *Entry;

  GetSocRun(PsCle);
  sprintf(SqlCmd,"Select JCode from Jrn Where JSoc='%s'",PsCle);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    Result=mysql_store_result(DbLcpt);
    Mx=mysql_num_rows(Result);
    Items=NULL;
    i=1;
    while ((Row=mysql_fetch_row(Result))) {
      if ((i==1) && (ValFirst==1)) strcpy(FirstValor,Row[0]);
      if ((i==Mx) && (ValFirst==2)) strcpy(FirstValor,Row[0]);
      Items=g_list_append(Items,Row[0]);
      i++;
    }
    gtk_combo_set_popdown_strings(GTK_COMBO (Combo),Items);
    mysql_free_result(Result);
    g_list_free(Items);
    Entry=GTK_COMBO (Combo)->entry;
    gtk_entry_set_text(GTK_ENTRY (Entry),FirstValor);
  }
}

void Dialog_ImpJrn(void)
{
  gchar PsCle[LEN_COD_SOC+1],Printer[9],TDate[15],Tmp[200];
	gchar DebExercice[12],FinExercice[12];
  GtkWidget *widget;

  ImpWin=create_ImpJrn();
  gtk_widget_show_all(GTK_WIDGET (ImpWin));
  GetSocRun(PsCle);
  GetDateExercice(DebExercice,FinExercice,PsCle);
  strcpy(DateDeb,DebExercice);
  strcpy(DateFin,FinExercice);
  strcpy(JrnDeb,"AA");
  strcpy(JrnFin,"ZZ");
  widget=lookup_widget(GTK_WIDGET (ImpWin),"DateDeb");
  IsoToDate(TDate,DateDeb);
  gtk_entry_set_text(GTK_ENTRY (widget),TDate);
  widget=lookup_widget(GTK_WIDGET (ImpWin),"DateFin");
  IsoToDate(TDate,DateFin);
  gtk_entry_set_text(GTK_ENTRY (widget),TDate);
  widget=lookup_widget(GTK_WIDGET (ImpWin),"JrnDeb");
  InitCombo(widget,1);
  widget=lookup_widget(GTK_WIDGET (ImpWin),"JrnFin");
  InitCombo(widget,2);
  sprintf(SqlCmd,"Select PgPrinter From Pgx where PgCle='%s'",PsCle);
  SqlGetString(SqlCmd,Printer);
  if (*Printer)  sprintf(Tmp,"lpr -P%s",Printer);else strcpy(Tmp,"lpr");
  widget=lookup_widget(GTK_WIDGET (ImpWin),"PrinterCmd");
  gtk_entry_set_text(GTK_ENTRY (widget),Tmp);
}
