/*******************************************************************/
/* Comptabilit Standard                                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* Module de gestion du tableau d'affichage des lignes             */
/* 01/03/02                                                        */
/*-----------------------------------------------------------------*/
/* Modification : 07/09/02 (P.C.)                                  */
/*                Controle chaine vide dans lcpt_tab_row_new       */
/*              : 11/11/02 -(.C.)                                  */
/*                Correction adjustement                           */
/*******************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 


#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include "lcpt_tab.h"

#define CELL_MARGING 4

enum {
  LCPT_CHANGE,
  LCPT_INSERT,
  LCPT_CHANGE_COLUMN,
  LCPT_ECART,
  LCPT_CHANGE_ROW,
  LCPT_CHANGE_ROW_AFTER,
  LCPT_INSERT_TEXT,
  LAST_SIGNAL
};

static guint lcpt_tab_signals[LAST_SIGNAL]={0};
gchar *LibTitle[]={"Date","Libell","Pice","Compte","Dbit","Crdit"};
gboolean RetSignal;

/* Pour le tableau **************************************************/
static void lcpt_tab_class_init    (LcptTabClass *klass);
static void lcpt_tab_init          (LcptTab      *LTab);
void lcpt_tab_destroy(GtkObject *Obj,gpointer user_data);
static void lcpt_tab_realize       (GtkWidget       *widget);
void lcpt_tab_size (LcptTab *LTab,gint width,gint height);
static void lcpt_tab_size_allocate (GtkWidget       *widget,
				    GtkAllocation   *allocation);
static void lcpt_tab_send_configure (LcptTab     *LTab);
/** Event ***/
gboolean lcpt_tab_button_press_event   (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

gboolean lcpt_tab_key_press_event      (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

gboolean lcpt_tab_expose_event         (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data);
static void lcpt_tab_set_scroll_adjustments (LcptTab       *LTab,
					    GtkAdjustment *hadjustment,
					     GtkAdjustment *vadjustment);
static void lcpt_tab_value_changed(GtkAdjustment *Adj,gpointer user_data);
float lcpt_tab_calcul_e(LcptTab *LTab,lacc *Account);
void lcpt_tab_calcul_ecart(LcptTab *LTab);
void lcpt_tab_control_move(LcptTab *LTab);
gboolean lcpt_tab_move_cell(LcptTab *LTab,GdkEventKey *event);
void lcpt_tab_move_left(LcptTab *LTab);
void lcpt_tab_move_right(LcptTab *LTab);
void lcpt_tab_move_up(LcptTab *LTab);
void lcpt_tab_move_down(LcptTab *LTab);
gboolean lcpt_tab_move_row(LcptTab *LTab,GdkEventKey *event);
gboolean lcpt_tab_move_text(LcptTab *LTab,GdkEventKey *event);
static void lcpt_tab_adjustment_changed(GtkAdjustment *Adj,gpointer user_data);
void lcpt_tab_delete_data(LcptTab *LTab);
static void SetAdjustments(LcptTab *LTab);
/* marshallers */
void marshal_BOOL__INT(GtkObject *object,GtkSignalFunc func,gpointer func_data,
		       GtkArg* args);
void marshal_BOOL__INT_POINTER_POINTER(GtkObject *object,GtkSignalFunc func,
				       gpointer func_data,GtkArg* args);
/* Pour les lignes **************************************************/
int LaccSearchId(LcptTab *Ltab,int Id);
void LaccInitNum(lacc *Acc);
void LaccInitColumn(LcptTab *LTab);
void LaccClearArea(LcptTab *LTab);
void LaccDrawRow(LcptTab *Ltab);
void LaccDrawCell(LcptTab *Ltab,int Cell,gint Yacc);
void LaccDrawNum(LcptTab *Ltab,gint x,gint y,gint La,char *T);
void LaccDrawText(LcptTab *Ltab,gint x,gint y,gint La,char *T);
void LaccDrawGrid(LcptTab *Ltab);
void LaccResize(LcptTab *Ltab);
void LaccDrawSelectBar(LcptTab *Ltab);
void LaccDrawById(LcptTab *Ltab,int Id);
void LaccDrawSelect(LcptTab *Ltab);
void LaccDrawSelectBar(LcptTab *Ltab);
gint LaccGetRowSelect(LcptTab *Ltab,gint Yacc);
gint LaccGetColumnSelect(LcptTab *Ltab,gint Xacc);
void LaccDrawCellEdit(LcptTab *Ltab,int Cell);
void LaccDrawTitle(LcptTab *LTab);
void LaccDrawTitleStr(LcptTab *LTab,gint Column);
/* Edition **********************************************************/
void lcpt_text_insert(LcptTab *LTab,gchar *str);
void lcpt_text_move_right(LcptTab *LTab);
void lcpt_text_move_left(LcptTab *LTab);
void lcpt_text_move_end(LcptTab *LTab);
void lcpt_text_move_home(LcptTab *LTab);
void lcpt_text_move_to(LcptTab *LTab,int Pos);
void lcpt_text_draw_cursor(LcptTab *LTab);
void lcpt_text_init(LcptTab *LTab);
void lcpt_text_redraw(LcptTab *LTab);
void lcpt_text_delete(LcptTab *LTab,gint Dir);
void lcpt_text_valid(LcptTab *LTab);
gboolean lcpt_text_control_car(LcptTab *LTab,int Car);
void lcpt_text_move_nword(LcptTab *LTab);
void lcpt_text_move_pword(LcptTab *LTab);
gint lcpt_text_count_car(gchar *str,gchar Car);

/***********************************************************************/
/* Le Tableau **********************************************************/
GtkType lcpt_tab_get_type (void)
{
  static GtkType lcpt_tab_type = 0;

  if (!lcpt_tab_type)
    {
      static const GtkTypeInfo lcpt_tab_info =
      {
	"LcptTab",
	sizeof (LcptTab),
	sizeof (LcptTabClass),
	(GtkClassInitFunc) lcpt_tab_class_init,
	(GtkObjectInitFunc) lcpt_tab_init,
	/* reserved_1 */ NULL,
        /* reserved_2 */ NULL,
        (GtkClassInitFunc) NULL,
      };
      lcpt_tab_type = gtk_type_unique (GTK_TYPE_WIDGET, &lcpt_tab_info);
    }
  return lcpt_tab_type;
}

static void lcpt_tab_class_init (LcptTabClass *class)
{
  GtkWidgetClass *widget_class;
  GtkObjectClass *obj_class;

  widget_class = GTK_WIDGET_CLASS (class);
  obj_class=GTK_OBJECT_CLASS (class);

  widget_class->realize = lcpt_tab_realize;
  widget_class->size_allocate = lcpt_tab_size_allocate;
  widget_class->button_press_event = lcpt_tab_button_press_event;
  widget_class->key_press_event = lcpt_tab_key_press_event;
  widget_class->key_release_event = lcpt_tab_key_press_event;
  widget_class->expose_event = lcpt_tab_expose_event;
  obj_class->destroy=lcpt_tab_destroy;
  class->set_scroll_adjustments = lcpt_tab_set_scroll_adjustments;
  widget_class->set_scroll_adjustments_signal =
    gtk_signal_new ("set_scroll_adjustments",
		    GTK_RUN_LAST,
		    obj_class->type,
		    GTK_SIGNAL_OFFSET (LcptTabClass, set_scroll_adjustments),
		    gtk_marshal_NONE__POINTER_POINTER,
		    GTK_TYPE_NONE,
		    2, GTK_TYPE_ADJUSTMENT, GTK_TYPE_ADJUSTMENT);
  lcpt_tab_signals[LCPT_CHANGE]=
    gtk_signal_new("lcpt_change",
		   GTK_RUN_LAST,
		   obj_class->type,
		   GTK_SIGNAL_OFFSET (LcptTabClass,lcpt_change),
		   gtk_marshal_BOOL__NONE,GTK_TYPE_BOOL,0);
  lcpt_tab_signals[LCPT_INSERT]=
    gtk_signal_new("lcpt_insert",
		   GTK_RUN_LAST,
		   obj_class->type,
		   GTK_SIGNAL_OFFSET (LcptTabClass,lcpt_insert),
		   gtk_marshal_BOOL__NONE,GTK_TYPE_BOOL,0);
  lcpt_tab_signals[LCPT_ECART]=
    gtk_signal_new("lcpt_ecart",
		   GTK_RUN_FIRST,
		   obj_class->type,
		   GTK_SIGNAL_OFFSET (LcptTabClass,lcpt_ecart),
		   gtk_marshal_NONE__INT_FLOAT,GTK_TYPE_NONE,
		   2,GTK_TYPE_INT,GTK_TYPE_FLOAT);
  lcpt_tab_signals[LCPT_CHANGE_COLUMN]=
    gtk_signal_new("lcpt_change_column",
		   GTK_RUN_LAST,
		   obj_class->type,
		   GTK_SIGNAL_OFFSET (LcptTabClass,lcpt_change_column),
		   marshal_BOOL__INT,GTK_TYPE_BOOL,
		   1,GTK_TYPE_INT);
  lcpt_tab_signals[LCPT_CHANGE_ROW]=
    gtk_signal_new("lcpt_change_row",
		   GTK_RUN_LAST,
		   obj_class->type,
		   GTK_SIGNAL_OFFSET (LcptTabClass,lcpt_change_row),
		   gtk_marshal_BOOL__NONE,GTK_TYPE_BOOL,0);
  lcpt_tab_signals[LCPT_CHANGE_ROW_AFTER]=
    gtk_signal_new("lcpt_change_row_after",
		   GTK_RUN_LAST,
		   obj_class->type,
		   GTK_SIGNAL_OFFSET (LcptTabClass,lcpt_change_row_after),
		   gtk_marshal_BOOL__NONE,GTK_TYPE_BOOL,0);
  lcpt_tab_signals[LCPT_INSERT_TEXT]=
    gtk_signal_new("lcpt_insert_text",
		   GTK_RUN_LAST,
		   obj_class->type,
		   GTK_SIGNAL_OFFSET (LcptTabClass,lcpt_insert_text),
		   marshal_BOOL__INT_POINTER_POINTER,GTK_TYPE_BOOL,
		   3,GTK_TYPE_INT,GTK_TYPE_STRING,GTK_TYPE_STRING);
  gtk_object_class_add_signals (obj_class,lcpt_tab_signals,LAST_SIGNAL);
  class->lcpt_change=NULL;
  class->lcpt_insert=NULL;
  class->lcpt_ecart=NULL;
  class->lcpt_change_column=NULL;
  class->lcpt_change_row=NULL;
  class->lcpt_change_row_after=NULL;
  class->lcpt_insert_text=NULL;
}

/* Marshallers ************************************************/
typedef gboolean (*GtkSignal_BOOL__INT)(GtkObject *object,gint,gpointer user_data);

void marshal_BOOL__INT(GtkObject *object,GtkSignalFunc func,gpointer func_data,
		       GtkArg* args)
{
  GtkSignal_BOOL__INT rfunc;
  gboolean *return_val;

  return_val = GTK_RETLOC_BOOL(args[1]);
  rfunc = (GtkSignal_BOOL__INT) func;
  *return_val = (*rfunc)(object,GTK_VALUE_INT(args[0]),func_data);
}

typedef gboolean (*GtkSignal_BOOL__INT_POINTER_POINTER)(GtkObject *object,
							gint arg1,
							gpointer arg2,
							gpointer arg3,
							gpointer user_data);

void marshal_BOOL__INT_POINTER_POINTER(GtkObject *object,GtkSignalFunc func,
				       gpointer func_data,GtkArg* args)
{
  GtkSignal_BOOL__INT_POINTER_POINTER rfunc;
  gboolean *return_val;

  return_val = GTK_RETLOC_BOOL(args[3]);
  rfunc = (GtkSignal_BOOL__INT_POINTER_POINTER) func;
  *return_val = (*rfunc)(object,GTK_VALUE_INT(args[0]),
	   GTK_VALUE_POINTER(args[1]),GTK_VALUE_POINTER(args[2]),
	   func_data);
}

static void lcpt_tab_set_scroll_adjustments (LcptTab       *LTab,
					     GtkAdjustment *hadjustment,
					     GtkAdjustment *vadjustment)
{
  if (LTab->VAdj!=vadjustment) {
    LTab->VAdj=vadjustment;
    gtk_signal_connect(GTK_OBJECT (LTab->VAdj),"changed",
		       (GtkSignalFunc) lcpt_tab_adjustment_changed,
		       (gpointer) LTab);
    gtk_signal_connect(GTK_OBJECT (LTab->VAdj),"value_changed",
		       (GtkSignalFunc) lcpt_tab_value_changed,
		       (gpointer) LTab);
  }
}

static void lcpt_tab_init (LcptTab *LTab)
{
  gchar car;
  GtkWidget *widget;

  widget=GTK_WIDGET (LTab);
  GTK_WIDGET_UNSET_FLAGS(LTab,GTK_NO_WINDOW);
  GTK_WIDGET_SET_FLAGS(LTab,GTK_CAN_FOCUS);
  GTK_WIDGET_SET_FLAGS(LTab,GTK_HAS_FOCUS);
  LTab->ORG_ACC = NULL;
  LTab->VAdj=NULL;
  LTab->Fonte=gdk_font_load("-adobe-helvetica-medium-r-normal-*-12-*-*-*-*-*-*-*");
  LTab->Up=0;
  LTab->RowSel=0;
  LTab->ColumnSel=0;
  LTab->MaxRow=0;
  LTab->Freeze=FALSE;
  LTab->E.str[0]='\0';
  LTab->E.Xoffset=0;
  LTab->E.length_txt=0;
  LTab->E.max_length=0;
  LTab->E.Modify=FALSE;
  car='A';
  LTab->RowHeight=gdk_char_height(LTab->Fonte,car);
  LTab->RowHeight+=CELL_MARGING*2;
  LTab->Down=widget->allocation.height/LTab->RowHeight;
  if ((widget->allocation.height % LTab->RowHeight)!=0) LTab->Down++;
  LTab->AsMoved=FALSE;
  LaccInitColumn(LTab);
}


GtkWidget* lcpt_tab_new (void)
{
  return GTK_WIDGET (gtk_type_new (lcpt_tab_get_type ()));
}

void lcpt_tab_destroy(GtkObject *Obj,gpointer user_data)
{
  LcptTab *LTab;

  LTab=LCPT_TAB(Obj);
  lcpt_tab_delete_data(LTab);
  gdk_gc_destroy(LTab->Crayon);
  gdk_font_unref(LTab->Fonte);
  gdk_window_destroy(LTab->Title);
  gdk_window_destroy(LTab->Row);
}

void lcpt_tab_size (LcptTab *LTab,gint width,gint height)
{
  g_return_if_fail (IS_LCPT_TAB (LTab));

  GTK_WIDGET (LTab)->requisition.width = width;
  GTK_WIDGET (LTab)->requisition.height = height;

  gtk_widget_queue_resize (GTK_WIDGET (LTab));
}

static void lcpt_tab_realize (GtkWidget *widget)
{
  LcptTab *LTab;
  GdkWindowAttr attributes;
  gint attributes_mask;

  g_return_if_fail (widget != NULL);
  g_return_if_fail (IS_LCPT_TAB (widget));

  LTab = LCPT_TAB (widget);
  GTK_WIDGET_SET_FLAGS (widget, GTK_REALIZED);

  attributes.window_type = GDK_WINDOW_CHILD;
  attributes.x = widget->allocation.x;
  attributes.y = widget->allocation.y;
  attributes.width = widget->allocation.width;
  attributes.height = widget->allocation.height;
  attributes.wclass = GDK_INPUT_OUTPUT;
  attributes.visual = gtk_widget_get_visual (widget);
  attributes.colormap = gtk_widget_get_colormap (widget);
  attributes.event_mask = (GDK_EXPOSURE_MASK |
                           GDK_BUTTON_PRESS_MASK |
                           GDK_BUTTON_RELEASE_MASK |
                           GDK_KEY_PRESS_MASK |
			   GDK_KEY_RELEASE_MASK);

  attributes_mask = GDK_WA_X | GDK_WA_Y | GDK_WA_VISUAL | GDK_WA_COLORMAP;
  widget->window = gdk_window_new (gtk_widget_get_parent_window (widget), &attributes, attributes_mask);
  gdk_window_set_user_data (widget->window, LTab);

  widget->style = gtk_style_attach (widget->style, widget->window);
  gtk_style_set_background (widget->style, widget->window, GTK_STATE_NORMAL);

  /* ligne de titre */
  attributes.x = 0;
  attributes.y = 0;
  attributes.width=LTab->Title_width=widget->allocation.width;
  attributes.height=LTab->Title_height=20;
  LTab->Title = gdk_window_new(widget->window,&attributes,attributes_mask);
  gdk_window_set_user_data(LTab->Title,LTab);
  gtk_style_set_background (widget->style, LTab->Title,GTK_STATE_NORMAL);
  gdk_window_show(LTab->Title);
  /* les lignes */
  attributes.x = 0;
  attributes.y = LTab->Title_height;
  attributes.width=LTab->List_width=widget->allocation.width;
  attributes.height=LTab->List_height=widget->allocation.height-LTab->Title_height;
  attributes.cursor = gdk_cursor_new (GDK_XTERM);
  attributes_mask |= GDK_WA_CURSOR;
  LTab->Row = gdk_window_new (widget->window,&attributes,attributes_mask);
  gdk_window_set_user_data(LTab->Row,LTab);
  gtk_style_set_background (widget->style, LTab->Row,GTK_STATE_NORMAL);
  gdk_window_show(LTab->Row);
  LaccResize(LCPT_TAB (widget));
  LTab->Crayon=gdk_gc_new(widget->window);
  lcpt_tab_send_configure (LCPT_TAB (widget));
}

static void lcpt_tab_size_allocate (GtkWidget     *widget,
				    GtkAllocation *allocation)
{
  LcptTab *LTab;
  GdkWindow *Win;

  g_return_if_fail (widget != NULL);
  g_return_if_fail (IS_LCPT_TAB (widget));
  g_return_if_fail (allocation != NULL);

  LTab=LCPT_TAB (widget);
  widget->allocation = *allocation;
  widget->allocation.width = MAX (1, widget->allocation.width);
  widget->allocation.height = MAX (1, widget->allocation.height);

  if (GTK_WIDGET_REALIZED (widget)) {
    gdk_window_move_resize (widget->window,
			    allocation->x, allocation->y,
			    allocation->width, allocation->height);
    Win=LTab->Title;
    LTab->Title_width=allocation->width;
    gdk_window_move_resize (Win,
			    0, 0,
			    LTab->Title_width, LTab->Title_height);
    Win=LTab->Row;
    LTab->List_width=allocation->width;
    LTab->List_height=allocation->height-LTab->Title_height;
    gdk_window_move_resize (Win,
			    0,LTab->Title_height,
			    LTab->List_width, LTab->List_height);
    LaccResize(LCPT_TAB (widget));
    LaccDrawTitle(LTab);
    lcpt_tab_send_configure (LCPT_TAB (widget));
  }
}

static void lcpt_tab_send_configure (LcptTab *LTab)
{
  GtkWidget *widget;
  GdkEventConfigure event;

  widget=GTK_WIDGET (LTab);
  event.type = GDK_CONFIGURE;
  event.window = widget->window;
  event.send_event = TRUE;
  event.x = widget->allocation.x;
  event.y = widget->allocation.y;
  event.width = widget->allocation.width;
  event.height = widget->allocation.height;
  
  gtk_widget_event (widget, (GdkEvent*) &event);
}

static void lcpt_tab_value_changed(GtkAdjustment *Adj,gpointer user_data)
{
  LcptTab *LTab;
  lacc *Acc;

  LTab=LCPT_TAB(user_data);
  Acc=LTab->Selection;
  LaccDrawRow(LTab);
  lcpt_tab_control_move(LTab);
  LTab->RowSel=(int) Adj->value;
  if (LTab->RowSel<LTab->Up) {
    LTab->Down=LTab->Up;
    LTab->Up-=LTab->NbRowDisplay-1;
    if (LTab->Up<0){
      LTab->Up=0;
      LTab->Down=LTab->NbRowDisplay-1;
      if (LTab->Down>LTab->MaxRow) LTab->Up=LTab->MaxRow-1;
    }
    LaccDrawGrid(LTab);
  }
  if (LTab->RowSel>LTab->Down) {
    LTab->Up=LTab->Down;
    LTab->Down=LTab->Up+LTab->NbRowDisplay-1;
    if (LTab->Down>=LTab->MaxRow) LTab->Up=LTab->MaxRow-1;
    LaccDrawGrid(LTab);
  }
  if ((LTab->RowSel>=LTab->Up) && (LTab->RowSel<=LTab->Down)) {
    LaccSearchId(LTab,LTab->RowSel);
    LaccDrawSelect(LTab);
    LaccDrawCellEdit(LTab,LTab->ColumnSel);
  }
  if (strcmp(Acc->D.Piece,LTab->Selection->D.Piece)!=0) lcpt_tab_calcul_ecart(LTab);
}

static void lcpt_tab_adjustment_changed(GtkAdjustment *Adj,gpointer user_data)
{
  LcptTab *LTab;

  LTab=LCPT_TAB(user_data);
}

static void SetAdjustments(LcptTab *LTab)
{
  GtkWidget *Widget;

  Widget=GTK_WIDGET (LTab);
  if (GTK_WIDGET_REALIZED (Widget)) {
    if ((LTab->VAdj) && ((LTab->Down-LTab->Up)!=0)) {
      LTab->VAdj->page_size=LTab->NbRowDisplay;
      LTab->VAdj->page_increment=LTab->NbRowDisplay;
      LTab->VAdj->lower=0;
      LTab->VAdj->upper=LTab->MaxRow;
      LTab->VAdj->step_increment=1;
      LTab->VAdj->value=LTab->RowSel;
    }
  }
}

void lcpt_tab_row_new(LcptTab *LTab,char *Cde,char *D,char *L,char *P,char *C,double Deb,double Cre)
{
  lacc *Old,*Account;

  Old=LTab->ORG_ACC;
  if (Old!=NULL) while (Old->Su!=NULL) Old=Old->Su;
  Account=(lacc *) malloc(sizeof(lacc));
  if (LTab->ORG_ACC==NULL) LTab->ORG_ACC=Account;
  if (Old!=NULL) Old->Su=Account;
  if (Old!=NULL) Account->Id=Old->Id+1; else Account->Id=0;
  Account->Su=NULL;
  Account->Pr=Old;
  LTab->MaxRow++;
  if (Cde!=NULL) strcpy(Account->D.Code,Cde);else *Account->D.Code=0;
  if (D!=NULL)   strcpy(Account->D.Date,D);else *Account->D.Date=0;
  if (L!=NULL)   strcpy(Account->D.Lib,L);else *Account->D.Lib=0;
  if (P!=NULL)   strcpy(Account->D.Piece,P);else *Account->D.Piece=0;
  if (C!=NULL)   strcpy(Account->D.Compte,C);else *Account->D.Compte=0;
  Account->D.Debit=Deb;
  Account->D.Credit=Cre;
  Account->EmptyRow=FALSE;
  LaccInitNum(Account);
  /****/
  LTab->Selection=Account;
  LTab->RowSel=Account->Id;
  LTab->Down=Account->Id;
  LTab->Up=LTab->Down-LTab->NbRowDisplay+1;
  if ((LTab->List_height % LTab->RowHeight)!=0) LTab->Up++;
  if (LTab->Up<0) LTab->Up=0;
  SetAdjustments(LTab);
  if (!LTab->Freeze) LaccDrawGrid(LTab);
}

void lcpt_tab_row_empty_new(LcptTab *LTab)
{
  lacc *Old,*Account;

  Old=LTab->ORG_ACC;
  if (Old!=NULL) while (Old->Su!=NULL) Old=Old->Su;
  Account=(lacc *) malloc(sizeof(lacc));
  if (LTab->ORG_ACC==NULL) LTab->ORG_ACC=Account;
  if (Old!=NULL) Old->Su=Account;
  if (Old!=NULL) Account->Id=Old->Id+1; else Account->Id=0;
  Account->Su=NULL;
  Account->Pr=Old;
  LTab->MaxRow++;
  *Account->D.Code='\0';
  *Account->D.Date='\0';
  *Account->D.Lib='\0';
  *Account->D.Piece='\0';
  *Account->D.Compte='\0';
  Account->D.Debit=0;
  Account->D.Credit=0;
  *Account->D.DebTxt='\0';
  *Account->D.CreTxt='\0';
  Account->EmptyRow=TRUE;
  /****/
  LTab->Selection=Account;
  LTab->RowSel=Account->Id;
  LTab->Down=Account->Id;
  LTab->Up=LTab->Down-LTab->NbRowDisplay+1;
  *LTab->E.str=0;
  LTab->E.max_length=0;
  LTab->E.Xoffset=0;
  LTab->E.current_pos=0;
  LTab->E.length_txt=0;
  LTab->E.PosCur=0;
  LTab->E.Modify=FALSE;
  /***/
  if ((LTab->List_height % LTab->RowHeight)!=0) LTab->Up++;
  if (LTab->Up<0) LTab->Up=0;
  SetAdjustments(LTab);
  if (!LTab->Freeze) LaccDrawGrid(LTab);
}

void lcpt_tab_insert_text(LcptTab *LTab,gchar *Str)
{
  lcpt_text_insert(LTab,Str);
}

void lcpt_tab_delete_text(LcptTab *LTab,gint Sens,gint NbCar)
{
  while ((NbCar>0) && (LTab->E.length_txt>0)) {
    lcpt_text_delete(LTab,Sens);
    NbCar--;
  }
}

/**************************************************************************/
/* PROCEDURES INTERNES ****************************************************/

/* Les Evnements ********************************************************/
gboolean lcpt_tab_button_press_event(GtkWidget *widget,GdkEventButton *event,gpointer user_data)
{
  LcptTab *LTab;
  gint a,b;

  LTab=LCPT_TAB(widget);
  LaccDrawRow(LTab);
  LTab->RowSel=LaccGetRowSelect(LTab,event->y);
	if (LTab->RowSel!=NULL) {
		LaccSearchId(LTab,LTab->RowSel);
		LTab->ColumnSel=LaccGetColumnSelect(LTab,event->x);
		lcpt_text_init(LTab);
		a=event->x-LTab->Cell[LTab->ColumnSel].PTxt;
		b=0;
		while ((gdk_text_width(LTab->Fonte,LTab->E.str,b)<a) && (b<LTab->E.length_txt)) b++;
		if (b!=0) b--;
		LaccDrawSelect(LTab);
		LaccDrawCellEdit(LTab,LTab->ColumnSel);
		lcpt_text_move_to(LTab,b);
	}
  return FALSE;
}

void lcpt_tab_change_column(LcptTab *LTab,int Column)
{
  RetSignal=TRUE;
  if (LTab->E.Modify) {
    lcpt_text_valid(LTab);
    gtk_signal_emit(GTK_OBJECT (LTab),lcpt_tab_signals[LCPT_CHANGE_COLUMN],
		    LTab->ColumnSel,&RetSignal);
  }
  if (RetSignal) {
    LaccDrawRow(LTab);
    LTab->ColumnSel=Column;
    if (LTab->ColumnSel==LCPT_TAB_COLUMN_PIECE) LTab->ColumnSel--;
    if ((LTab->Selection->D.Credit+LTab->Selection->D.Debit)!=0) {
      if ((LTab->ColumnSel==LCPT_TAB_COLUMN_DEBIT) && (LTab->Selection->D.Credit!=0)) LTab->ColumnSel--;
      if ((LTab->ColumnSel==LCPT_TAB_COLUMN_CREDIT) && (LTab->Selection->D.Debit!=0)) LTab->ColumnSel--;
    }
    LaccDrawSelect(LTab);
    LaccDrawCellEdit(LTab,LTab->ColumnSel);
    LTab->AsMoved=TRUE;
  }
}

void lcpt_tab_move_left(LcptTab *LTab)
{
  RetSignal=TRUE;
  if (LTab->E.Modify) {
    lcpt_text_valid(LTab);
    gtk_signal_emit(GTK_OBJECT (LTab),lcpt_tab_signals[LCPT_CHANGE_COLUMN],
		    LTab->ColumnSel*-1,&RetSignal);
  }
  if (RetSignal) { 
    if (!LTab->AsMoved) {
      LaccDrawRow(LTab);
      LTab->ColumnSel--;
      if (LTab->ColumnSel<0) LTab->ColumnSel=LCPT_TAB_COLUMN_CREDIT;
      if (LTab->ColumnSel==LCPT_TAB_COLUMN_PIECE) LTab->ColumnSel--;
      if ((LTab->Selection->D.Credit+LTab->Selection->D.Debit)!=0) {
	if ((LTab->ColumnSel==LCPT_TAB_COLUMN_DEBIT) && (LTab->Selection->D.Credit!=0)) LTab->ColumnSel--;
	if ((LTab->ColumnSel==LCPT_TAB_COLUMN_CREDIT) && (LTab->Selection->D.Debit!=0)) LTab->ColumnSel--;
      }
      LaccDrawSelect(LTab);
      LaccDrawCellEdit(LTab,LTab->ColumnSel);
    }
  }
}

void lcpt_tab_move_right(LcptTab *LTab)
{
  RetSignal=TRUE;
  if (LTab->E.Modify) {
    lcpt_text_valid(LTab);
    gtk_signal_emit(GTK_OBJECT (LTab),lcpt_tab_signals[LCPT_CHANGE_COLUMN],
		    LTab->ColumnSel,(gpointer) &RetSignal);
  }
  if (RetSignal) { 
    if (!LTab->AsMoved) {
      LaccDrawRow(LTab);
      LTab->ColumnSel++;
      if (LTab->ColumnSel>LCPT_TAB_COLUMN_CREDIT) LTab->ColumnSel=0;
      if (LTab->ColumnSel==LCPT_TAB_COLUMN_PIECE) LTab->ColumnSel++;
      if ((LTab->Selection->D.Credit+LTab->Selection->D.Debit)!=0) {
	if ((LTab->ColumnSel==LCPT_TAB_COLUMN_DEBIT) && (LTab->Selection->D.Credit!=0)) LTab->ColumnSel++;
	if ((LTab->ColumnSel==LCPT_TAB_COLUMN_CREDIT) && (LTab->Selection->D.Debit!=0)) LTab->ColumnSel=0;
      }
      LaccDrawSelect(LTab);
      LaccDrawCellEdit(LTab,LTab->ColumnSel);
    }
  }
}

gboolean lcpt_tab_move_cell(LcptTab *LTab,GdkEventKey *event)
{
  gboolean Ok;
  gint a;

  Ok=TRUE;
  switch (event->keyval)
    {
    case GDK_Return :
      if (LTab->Selection->EmptyRow) LTab->E.Modify=TRUE;
      a=LTab->ColumnSel;
      lcpt_tab_move_right(LTab);
      if (!LTab->AsMoved) {
	if (a==LCPT_TAB_COLUMN_DEBIT) { 
	  if ((LTab->Selection->D.Debit+LTab->Selection->D.Credit)!=0) {
	    lcpt_tab_move_down(LTab);
	    lcpt_tab_row_valid(LTab);
	  }
	}
	if (a==LCPT_TAB_COLUMN_CREDIT) {
	  if ((LTab->Selection->D.Debit+LTab->Selection->D.Credit)!=0) {
	    lcpt_tab_move_down(LTab);
	    lcpt_tab_row_valid(LTab);
	  } else {
	    lcpt_tab_move_left(LTab);
	    lcpt_tab_move_left(LTab);
	  }
	}
      }
      break;
    case GDK_Tab :
      lcpt_tab_move_right(LTab);
      break;
    case GDK_ISO_Left_Tab :
      lcpt_tab_move_left(LTab);
      break;
    default : Ok=FALSE;
      break;
    }
    if (Ok) LTab->AsMoved=FALSE;
  return (Ok);
}

void lcpt_tab_row_valid(LcptTab *LTab)
{
  float Ecart;
  lacc *AccOrg,*AccDest;

  gtk_signal_emit(GTK_OBJECT (LTab),lcpt_tab_signals[LCPT_CHANGE_ROW],
		  &RetSignal);
  if (RetSignal) {
    lcpt_tab_move_down(LTab);
    SetAdjustments(LTab);
    gtk_signal_emit(GTK_OBJECT (LTab),lcpt_tab_signals[LCPT_CHANGE_ROW_AFTER],
		    &RetSignal);
    lcpt_tab_calcul_ecart(LTab);
    LTab->ColumnSel=0;
    if (LTab->Selection->EmptyRow) {
      AccOrg=LTab->Selection->Pr;
      AccDest=LTab->Selection;
      Ecart=lcpt_tab_calcul_e(LTab,AccOrg);
      if (Ecart!=0) {
	LTab->ColumnSel=LCPT_TAB_COLUMN_COMPTE;
	if (*AccDest->D.Date==0) strcpy(AccDest->D.Date,AccOrg->D.Date);
	if (*AccDest->D.Lib==0) strcpy(AccDest->D.Lib,AccOrg->D.Lib);
	if (*AccDest->D.Piece==0) strcpy(AccDest->D.Piece,AccOrg->D.Piece);
      }
    }
    LaccDrawSelect(LTab);
    LaccDrawCellEdit(LTab,LTab->ColumnSel);
  }
}

void lcpt_tab_control_move(LcptTab *LTab)
{
  lacc *Account;

  if (LTab->E.Modify) {
    Account=LTab->Selection;
    lcpt_text_valid(LTab);
    if (Account->EmptyRow) {
      gtk_signal_emit(GTK_OBJECT (LTab),lcpt_tab_signals[LCPT_INSERT],&RetSignal);
    } else gtk_signal_emit(GTK_OBJECT (LTab),lcpt_tab_signals[LCPT_CHANGE],&RetSignal);
    Account->EmptyRow=FALSE;
    LTab->E.Modify=FALSE;
  }
}

/* Contrle Vertical ***********************************************/
void lcpt_tab_move_down(LcptTab *LTab)
{
  gboolean a;

  gtk_signal_emit(GTK_OBJECT (LTab),lcpt_tab_signals[LCPT_CHANGE_ROW],
		  &RetSignal);
  if (RetSignal) {
    a=LTab->Selection->EmptyRow;
    lcpt_tab_control_move(LTab);
    if (!a) {
      LaccDrawRow(LTab);
      LTab->RowSel++;
      LTab->Selection=LTab->Selection->Su;
    }
    LaccDrawSelect(LTab);
    LaccDrawCellEdit(LTab,LTab->ColumnSel);
  }
}

void lcpt_tab_move_up(LcptTab *LTab)
{
  gtk_signal_emit(GTK_OBJECT (LTab),lcpt_tab_signals[LCPT_CHANGE_ROW],
		  &RetSignal);
  if (RetSignal) {
    lcpt_tab_control_move(LTab);
    LaccDrawRow(LTab);
    LTab->RowSel--;
    LTab->Selection=LTab->Selection->Pr;
    LaccDrawSelect(LTab);
    LaccDrawCellEdit(LTab,LTab->ColumnSel);
  }
}

gboolean lcpt_tab_move_row(LcptTab *LTab,GdkEventKey *event)
{
  gboolean Ok;
  lacc *Acc;

  Ok=TRUE;
  Acc=LTab->Selection;
  switch (event->keyval)
    {
    case GDK_Up :
      if (LTab->RowSel>0) lcpt_tab_move_up(LTab);
      break;
    case GDK_Down : 
      if (LTab->RowSel<(LTab->MaxRow-1)) lcpt_tab_move_down(LTab);
      break;
    case GDK_Page_Up :
      if ((LTab->Up!=0) && (LTab->MaxRow>LTab->NbRowDisplay)) {
	gtk_signal_emit(GTK_OBJECT (LTab),lcpt_tab_signals[LCPT_CHANGE_ROW],
			&RetSignal);
	if (RetSignal) {
	  lcpt_tab_control_move(LTab);
	  LTab->Down=LTab->Up;
	  LTab->Up-=LTab->NbRowDisplay-1;
	  if (LTab->Up<0){
	    LTab->Up=0;
	    LTab->Down=LTab->NbRowDisplay-1;
	    if (LTab->Down>LTab->MaxRow) LTab->Up=LTab->MaxRow-1;
	}
	  LTab->RowSel=LTab->Up;
	  LaccDrawGrid(LTab);
	}
      }
      break;
    case GDK_Page_Down :
      if (LTab->Down<(LTab->MaxRow-1)) {
	gtk_signal_emit(GTK_OBJECT (LTab),lcpt_tab_signals[LCPT_CHANGE_ROW],
			&RetSignal);
	if (RetSignal) {
	  lcpt_tab_control_move(LTab);
	  LTab->Up=LTab->Down;
	  LTab->Down=LTab->Up+LTab->NbRowDisplay-1;
	  if (LTab->Down>=LTab->MaxRow) LTab->Up=LTab->MaxRow-1;
	  LTab->RowSel=LTab->Up;
	  LaccDrawGrid(LTab);
	}
      }
      break;
    case GDK_Home :
      if ((event->state & GDK_CONTROL_MASK)) {
	gtk_signal_emit(GTK_OBJECT (LTab),lcpt_tab_signals[LCPT_CHANGE_ROW],
			&RetSignal);
	if (RetSignal) {
	  lcpt_tab_control_move(LTab);
	  LTab->Up=0;
	  LTab->Down=LTab->NbRowDisplay-1;
	  if (LTab->Down>=LTab->MaxRow) LTab->Down=LTab->MaxRow-1;
	  LTab->RowSel=0;
	  LaccDrawGrid(LTab);
	}
      } else Ok=FALSE;
      break;
    case GDK_End :
      if ((event->state & GDK_CONTROL_MASK)) {
	gtk_signal_emit(GTK_OBJECT (LTab),lcpt_tab_signals[LCPT_CHANGE_ROW],
			&RetSignal);
	if (RetSignal) {
	  lcpt_tab_control_move(LTab);
	  LTab->Down=LTab->MaxRow-1;
	  LTab->Up=LTab->Down-LTab->NbRowDisplay+1;
	  if ((LTab->List_height % LTab->RowHeight)!=0) LTab->Up++;
	  if (LTab->Down>=LTab->MaxRow) LTab->Down=LTab->MaxRow-1;
	  LTab->RowSel=LTab->Down;
	  LaccDrawGrid(LTab);
	}
      } else Ok=FALSE;
      break;
    default : Ok=FALSE;
    }
  if (Ok) {
    SetAdjustments(LTab);
    gtk_signal_emit(GTK_OBJECT (LTab),lcpt_tab_signals[LCPT_CHANGE_ROW_AFTER],
		    &RetSignal);
    if (strcmp(Acc->D.Piece,LTab->Selection->D.Piece)!=0) lcpt_tab_calcul_ecart(LTab);
  }
  return (Ok);
}

gboolean lcpt_tab_move_text(LcptTab *LTab,GdkEventKey *event)
{
  gboolean Ok;

  Ok=TRUE;
  switch (event->keyval)
    {
    case GDK_Left : if ((event->state & GDK_CONTROL_MASK)) lcpt_text_move_pword(LTab);else lcpt_text_move_left(LTab);
      break;
    case GDK_Home : if (!(event->state & (GDK_SHIFT_MASK | GDK_CONTROL_MASK))) lcpt_text_move_home(LTab);else Ok=FALSE;
      break;
    case GDK_End : if (!(event->state & (GDK_SHIFT_MASK | GDK_CONTROL_MASK))) lcpt_text_move_end(LTab);else Ok=FALSE;
      break;
    case GDK_Right : if ((event->state & GDK_CONTROL_MASK)) lcpt_text_move_nword(LTab);else lcpt_text_move_right(LTab);
      break;
    case GDK_BackSpace : lcpt_text_delete(LTab,-1);
      break;
    case GDK_Delete : lcpt_text_delete(LTab,1);
      break;
    default : Ok=FALSE;
    }
  return (Ok);
}

gboolean lcpt_tab_key_press_event      (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  LcptTab *LTab;

  LTab=LCPT_TAB(widget);
  if (event->type==GDK_KEY_PRESS) {
    if (!lcpt_tab_move_cell(LCPT_TAB (widget),event))
      if (!lcpt_tab_move_row(LCPT_TAB (widget),event))
	if (!lcpt_tab_move_text(LCPT_TAB (widget),event))
	  if ((event->state & GDK_CONTROL_MASK)==0) lcpt_text_insert(LTab,event->string);
    return TRUE;
  }
  return FALSE;
}

gboolean lcpt_tab_expose_event                 (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
  if (GTK_WIDGET_REALIZED (widget)) {
    LaccDrawGrid(LCPT_TAB(widget));
    LaccDrawTitle(LCPT_TAB(widget));
  }
  return FALSE;
}

float lcpt_tab_calcul_e(LcptTab *LTab,lacc *Account)
{
  gchar Piece[11];
  double e;

  e=0;
  if (Account!=NULL) {
    strcpy(Piece,Account->D.Piece);
    while (Account) {
      if (strcmp(Piece,Account->D.Piece)!=0) break;
      Account=Account->Pr;
    }
    if (Account!=NULL) Account=Account->Su;else Account=LTab->ORG_ACC;
    while (strcmp(Piece,Account->D.Piece)==0) {
      e=e+(Account->D.Debit-Account->D.Credit);
      Account=Account->Su;
      if (!Account) break;
    }
  }
  return (e);
}

void lcpt_tab_calcul_ecart(LcptTab *LTab)
{

  lacc *Account;
  double e;
  gint NewPiece;

  e=0;
  NewPiece=FALSE;
  Account=LTab->Selection;
  if (Account->EmptyRow) {
    if (Account->Pr!=NULL) e=lcpt_tab_calcul_e(LTab,Account->Pr);
    if (e==0) NewPiece=TRUE;
    e=e+(Account->D.Debit-Account->D.Credit);
  } else e=lcpt_tab_calcul_e(LTab,Account);
  gtk_signal_emit(GTK_OBJECT (LTab),lcpt_tab_signals[LCPT_ECART],NewPiece,e);
}

/******************************************************************/
/* L'dition ******************************************************/
void lcpt_text_init(LcptTab *LTab)
{
  switch (LTab->ColumnSel)
    {
    case 0 : strcpy(LTab->E.str,LTab->Selection->D.Date);
             LTab->E.max_length=10;
             break;
    case 1 : strcpy(LTab->E.str,LTab->Selection->D.Lib);
             LTab->E.max_length=30;
             break;
    case 2 : strcpy(LTab->E.str,LTab->Selection->D.Piece);
             LTab->E.max_length=10;
             break;
    case 3 : strcpy(LTab->E.str,LTab->Selection->D.Compte);
             LTab->E.max_length=10;
             break;
    case 4 : strcpy(LTab->E.str,LTab->Selection->D.DebTxt);
             LTab->E.max_length=20;
	     lcpt_text_redraw(LTab);
             break;
    case 5 : strcpy(LTab->E.str,LTab->Selection->D.CreTxt);
             LTab->E.max_length=20;
	     lcpt_text_redraw(LTab);
             break;
    }
  LTab->E.Xoffset=0;
  LTab->E.current_pos=0;
  LTab->E.length_txt=strlen(LTab->E.str);
  LTab->E.PosCur=0;
}

void lcpt_text_valid(LcptTab *LTab)
{
  switch (LTab->ColumnSel)
    {
    case 0 : strcpy(LTab->Selection->D.Date,LTab->E.str);
             break;
    case 1 : strcpy(LTab->Selection->D.Lib,LTab->E.str);
             break;
    case 2 : strcpy(LTab->Selection->D.Piece,LTab->E.str);
             break;
    case 3 : strcpy(LTab->Selection->D.Compte,LTab->E.str);
             break;
    case 4 : strcpy(LTab->Selection->D.DebTxt,LTab->E.str);
             LTab->Selection->D.Debit=atof(LTab->Selection->D.DebTxt);
	     LaccInitNum(LTab->Selection);
	     strcpy(LTab->E.str,LTab->Selection->D.DebTxt);
	     lcpt_tab_calcul_ecart(LTab);
             break;
    case 5 : strcpy(LTab->Selection->D.CreTxt,LTab->E.str);
             LTab->Selection->D.Credit=atof(LTab->Selection->D.CreTxt);
	     LaccInitNum(LTab->Selection);
	     strcpy(LTab->E.str,LTab->Selection->D.CreTxt);
	     lcpt_tab_calcul_ecart(LTab);
             break;
    }
}

void lcpt_text_redraw(LcptTab *LTab)
{
  GdkColor Col;
  GdkColormap *CMap;
  gint Yacc;
  GtkWidget *WdgArea;

  WdgArea=GTK_WIDGET(LTab);
  CMap=gdk_window_get_colormap(WdgArea->window);
  Yacc=(LTab->Selection->Id-LTab->Up)*LTab->RowHeight;
  Col.red=65535;
  Col.green=65535;
  Col.blue=65535;
  gdk_color_alloc(CMap,&Col);
  gdk_gc_set_background(LTab->Crayon,&Col);
  gdk_gc_set_foreground(LTab->Crayon,&Col);
  gdk_draw_rectangle(LTab->Row,LTab->Crayon,TRUE,
LTab->Cell[LTab->ColumnSel].Px,Yacc,LTab->Cell[LTab->ColumnSel].Ta,LTab->RowHeight);
  /***/
  Col.red=0;
  Col.green=0;
  Col.blue=0;
  gdk_color_alloc(CMap,&Col);
  gdk_gc_set_foreground(LTab->Crayon,&Col);
  LaccDrawText(LTab,LTab->Cell[LTab->ColumnSel].Px,Yacc,LTab->Cell[LTab->ColumnSel].Ta-(CELL_MARGING*2),LTab->E.str);
  lcpt_text_draw_cursor(LTab);
}

void lcpt_text_draw_cursor(LcptTab *LTab)
{
  GtkWidget *widget;
  gint Yacc,Xcur;
  char T[2];
  GdkColormap *CMap;
  GdkColor Col;
  GdkGC *Crayon;

  widget=GTK_WIDGET (LTab);
  Yacc=((LTab->RowSel-LTab->Up)*LTab->RowHeight)+LTab->RowHeight;
  T[0]=LTab->E.str[LTab->E.PosCur];
  T[1]='\0';
  Xcur=gdk_text_width(LTab->Fonte,LTab->E.str,LTab->E.PosCur);
  Xcur+=LTab->Cell[LTab->ColumnSel].PTxt;
  /***/
  CMap=gdk_window_get_colormap(GTK_WIDGET (LTab)->window);
  Crayon=gdk_gc_new(GTK_WIDGET (LTab)->window);
  gdk_gc_set_line_attributes(Crayon,1,GDK_LINE_SOLID,GDK_CAP_BUTT,GDK_JOIN_BEVEL);
  Col.red=Col.green=Col.blue=65535;
  gdk_color_alloc(CMap,&Col);
  gdk_gc_set_foreground(Crayon,&Col);
  gdk_draw_rectangle(LTab->Row,Crayon,TRUE,
		     Xcur,Yacc-LTab->RowHeight,
		     gdk_char_width(LTab->Fonte,T[0]),LTab->RowHeight);
  /****/
  gdk_gc_set_font(LTab->Crayon,LTab->Fonte);
  gdk_draw_string(LTab->Row,LTab->Fonte,LTab->Crayon,Xcur,Yacc-CELL_MARGING,T);
  /****/
  gdk_draw_line (LTab->Row, widget->style->fg_gc[GTK_STATE_NORMAL], 
		 LTab->Cell[LTab->ColumnSel].PTxt+LTab->E.Xoffset,Yacc,
		 LTab->Cell[LTab->ColumnSel].PTxt+LTab->E.Xoffset,Yacc-LTab->RowHeight);
  LTab->E.PosCur=LTab->E.current_pos;
  gdk_gc_destroy(Crayon);
}

void lcpt_text_move_to(LcptTab *LTab,int Pos)
{
  if (Pos<0) Pos=0;
  if (Pos>LTab->E.length_txt) Pos=LTab->E.length_txt;
  LTab->E.current_pos=Pos;
  if (Pos==0) LTab->E.Xoffset=0;else LTab->E.Xoffset=gdk_text_width(LTab->Fonte,LTab->E.str,LTab->E.current_pos);
  lcpt_text_draw_cursor(LTab);
}

void lcpt_text_move_nword(LcptTab *LTab)
{
  gint a;

  a=LTab->E.current_pos;
  while ((LTab->E.str[a]!=32) && (a<LTab->E.length_txt)) a++;
  if (a<LTab->E.length_txt) {
    while ((LTab->E.str[a]==32) && (a<LTab->E.length_txt)) a++;
  }
  lcpt_text_move_to(LTab,a);
}

void lcpt_text_move_pword(LcptTab *LTab)
{
  gint a;

  a=LTab->E.current_pos-1;
  if (a<0) a=0;
  while ((LTab->E.str[a]==32) && (a>0)) a--;
  if (a>0) {
    while ((LTab->E.str[a]!=32) && (a>0)) a--;
    if (a!=0) a++;
  }
  lcpt_text_move_to(LTab,a);
}

void lcpt_text_move_home(LcptTab *LTab)
{
  lcpt_text_move_to(LTab,0);
}

void lcpt_text_move_end(LcptTab *LTab)
{
  lcpt_text_move_to(LTab,LTab->E.length_txt);
}

void lcpt_text_move_left(LcptTab *LTab)
{
 lcpt_text_move_to(LTab,LTab->E.current_pos-1);
}

void lcpt_text_move_right(LcptTab *LTab)
{
 lcpt_text_move_to(LTab,LTab->E.current_pos+1);
}

gint lcpt_text_count_car(gchar *str,gchar Car)
{
  gint i;

  i=0;
  while (*str) {
    if (*str==Car) i++;
    str++;
  }
  return (i);
}

gboolean lcpt_text_control_car(LcptTab *LTab,int Car)
{
  gboolean Ok;
  gint i;

  Ok=TRUE;
  switch (LTab->ColumnSel)
    {
    case 0 : if (((Car>='0') && (Car<='9')) || (Car=='/'))
      {
	i=lcpt_text_count_car(LTab->E.str,'/');
	if ((i==2) && (Car=='/')) Ok=FALSE;
      } else Ok=FALSE;
    break;
    case 1 :
    case 2 :
    case 3 : if ((Car<32) || ((Car>127) && (strchr("",Car)==NULL))) Ok=FALSE;
      break;
    case 4 :
    case 5 : if (((Car<'0') || (Car>'9')) || ((Car=='.') && (strchr(LTab->E.str,'.')!=NULL))) Ok=FALSE;
      break;
    }
  return (Ok);
}

void lcpt_text_insert(LcptTab *LTab,gchar *str)
{
  gint a,b;

  RetSignal=TRUE;
  gtk_signal_emit(GTK_OBJECT (LTab),lcpt_tab_signals[LCPT_INSERT_TEXT],LTab->ColumnSel,str,LTab->E.str,&RetSignal);
  if (RetSignal) {
    if (LTab->E.current_pos==LTab->E.length_txt) {
      a=LTab->E.current_pos;
      while (*str) {
	if (LTab->E.length_txt<LTab->E.max_length) {
	  if (lcpt_text_control_car(LTab,*str)) {
	    LTab->E.str[a++]=*str;
	    LTab->E.Xoffset+=gdk_char_width_wc(LTab->Fonte,*str);
	    LTab->E.length_txt++;
	    if (((a==2) || (a==5)) && LTab->ColumnSel==0) {
	      if (lcpt_text_count_car(LTab->E.str,'/')<2) {
		LTab->E.str[a++]='/';
		LTab->E.Xoffset+=gdk_char_width_wc(LTab->Fonte,'/');
		LTab->E.length_txt++;
	      }
	    }
	  } else gdk_beep();
	} else gdk_beep();
	str++;
      }
      LTab->E.str[a]='\0';
      LTab->E.current_pos=a;
    } else {
      a=LTab->E.current_pos;
      while (*str) {
	if (LTab->E.length_txt<LTab->E.max_length) {
	  if (lcpt_text_control_car(LTab,*str)) {
	    b=LTab->E.length_txt+1;
	    while (b>a) {
	      LTab->E.str[b]=LTab->E.str[b-1];
	      b--;
	    }
	    LTab->E.str[a++]=*str;
	    LTab->E.Xoffset+=gdk_char_width_wc(LTab->Fonte,*str);
	    LTab->E.length_txt++;
	  } else gdk_beep();
	}
	str++;
      }
      LTab->E.current_pos=a;
    }
    lcpt_text_redraw(LTab);
    LTab->E.Modify=TRUE;
  }
}

void lcpt_text_delete(LcptTab *LTab,gint Dir)
{
  gint a;

  if (((LTab->E.current_pos<LTab->E.length_txt) && (Dir==1)) || ((LTab->E.current_pos>0) && (Dir<1))) {
    a=LTab->E.current_pos;
    if (Dir<1) a--;
    do {
      LTab->E.str[a]=LTab->E.str[a+1];
      a++;
    } while (LTab->E.str[a]!=0);
    LTab->E.length_txt--;
    if (Dir<1) lcpt_text_move_left(LTab);
    lcpt_text_redraw(LTab);
    LTab->E.Modify=TRUE;
  }
}

/*******************************************************************/
/* Les lignes ******************************************************/

int LaccSearchId(LcptTab *LTab,int Id)
{
  LTab->Selection=LTab->ORG_ACC;
  while ((LTab->Selection!=NULL) && (LTab->Selection->Id!=Id)) LTab->Selection=LTab->Selection->Su;
  return (LTab->Selection!=NULL);
}

void LaccInitNum(lacc *Acc)
{
  if (Acc->D.Debit!=0) sprintf(Acc->D.DebTxt,"%8.2f",Acc->D.Debit);else *Acc->D.DebTxt=0;
  if (Acc->D.Credit!=0) sprintf(Acc->D.CreTxt,"%8.2f",Acc->D.Credit);else *Acc->D.CreTxt=0;
  g_strchug(Acc->D.DebTxt);
  g_strchug(Acc->D.CreTxt);
}

void lcpt_tab_freeze(LcptTab *LTab)
{
  LTab->Freeze=TRUE;
}

void lcpt_tab_thaw(LcptTab *LTab)
{
	LaccDrawGrid(LTab);
	LTab->Freeze=FALSE;
	gtk_adjustment_changed(LTab->VAdj);
}

void lcpt_tab_row_get_data(LcptTab *LTab,char *Cde,char *D,char *L,char *P,char *C,double *Deb,double *Cre)
{
  lacc *Account;

  Account=LTab->Selection;
  if (Cde!=NULL) strcpy(Cde,Account->D.Code);
  if (D!=NULL) strcpy(D,Account->D.Date);
  if (L!=NULL) strcpy(L,Account->D.Lib);
  if (P!=NULL) strcpy(P,Account->D.Piece);
  if (C!=NULL) strcpy(C,Account->D.Compte);
  if (Deb!=NULL) *Deb=Account->D.Debit;
  if (Cre!=NULL) *Cre=Account->D.Credit;
}

void lcpt_tab_row_set_data(LcptTab *LTab,char *Cde,char *D,char *L,char *P,char *C,double *Deb,double *Cre)
{
  lacc *Account;

  Account=LTab->Selection;
  if (Cde!=NULL) strcpy(Account->D.Code,Cde);
  if (D!=NULL) strcpy(Account->D.Date,D);
  if (L!=NULL) strcpy(Account->D.Lib,L);
  if (P!=NULL) strcpy(Account->D.Piece,P);
  if (C!=NULL) strcpy(Account->D.Compte,C);
  if (Deb!=NULL) Account->D.Debit=*Deb;
  if (Cre!=NULL) Account->D.Credit=*Cre;
  if (Account->EmptyRow) LTab->E.Modify=TRUE;
  if (((*Account->D.Code+*Account->D.Date+*Account->D.Lib+*Account->D.Piece+*Account->D.Compte)==0) && ((Account->D.Credit+Account->D.Debit)==0)) {
    Account->EmptyRow=TRUE;
    LTab->E.Modify=FALSE;
  }
  LaccInitNum(Account);
  LaccDrawSelect(LTab);
  LaccDrawCellEdit(LTab,LTab->ColumnSel);
}

void lcpt_tab_delete_data(LcptTab *LTab)
{
 lacc *Next,*Account;

  Account=LTab->ORG_ACC;
  while (Account!=NULL) {
    Next=Account->Su;
    free(Account);
    Account=Next;
  }
  LTab->ORG_ACC=NULL;
  LTab->Up=0;
  LTab->RowSel=0;
  LTab->ColumnSel=0;
  LTab->MaxRow=0;
  LTab->Freeze=FALSE;
  LTab->E.str[0]='\0';
  LTab->E.Xoffset=0;
  LTab->E.length_txt=0;
  LTab->E.max_length=0;
}

void lcpt_tab_row_delete_all(LcptTab *LTab)
{
  lcpt_tab_delete_data(LTab);
  LaccClearArea(LTab);
  LaccDrawTitle(LTab);
}

void lcpt_tab_row_delete(LcptTab *LTab)
{
  lacc *Prec,*Suiv,*Account;
  gint i;

  if (!LTab->Selection->EmptyRow) {
    Prec=LTab->Selection->Pr;
    Suiv=LTab->Selection->Su;
    if (Prec!=NULL) Prec->Su=Suiv;else LTab->ORG_ACC=Suiv;
    if (Suiv!=NULL) Suiv->Pr=Prec;
    free(LTab->Selection);
    if (Suiv!=NULL) LTab->Selection=Suiv;else LTab->Selection=Prec;
    if (Suiv==NULL) LTab->MaxRow--;
    if (LTab->Down>LTab->MaxRow) {
      if (LTab->Up>0) LTab->Up--;
      LTab->Down--;
    }
    Account=LTab->Selection;
    if (Prec!=NULL) i=Prec->Id+1;else i=0;
    while (Account){
      Account->Id=i++;
      Account=Account->Su;
    }
    if (LTab->Selection!=NULL) LTab->RowSel=LTab->Selection->Id;else LTab->RowSel=-1;
  } else {
    Account=LTab->Selection;
    *Account->D.Code='\0';
    *Account->D.Date='\0';
    *Account->D.Lib='\0';
    *Account->D.Piece='\0';
    *Account->D.Compte='\0';
    Account->D.Debit=0;
    Account->D.Credit=0;
    *Account->D.DebTxt='\0';
    *Account->D.CreTxt='\0';
    /****/
    *LTab->E.str=0;
    LTab->E.max_length=0;
    LTab->E.Xoffset=0;
    LTab->E.current_pos=0;
    LTab->E.length_txt=0;
    LTab->E.PosCur=0;
    LTab->E.Modify=FALSE;
  }
  if (!LTab->Freeze) LaccDrawGrid(LTab);
}

gboolean lcpt_tab_row_search(LcptTab *LTab,gint Column,gchar *Value)
{
  lacc *Account;
  gboolean Ok=0;

  Account=LTab->ORG_ACC;
  while (Account) {
    switch (Column)
      {
      case LCPT_TAB_COLUMN_CODE : Ok=g_strcasecmp(Account->D.Code,Value);
	break;
      case LCPT_TAB_COLUMN_LIBELLE : Ok=g_strcasecmp(Account->D.Lib,Value);
	break;
      case LCPT_TAB_COLUMN_PIECE : Ok=g_strcasecmp(Account->D.Piece,Value);
	break;
      default : Ok=-1;
      }
    if (Ok==0) break;
    Account=Account->Su;
  }
  if (Ok==0) {
    lcpt_tab_control_move(LTab);
    LTab->Selection=Account;
    LTab->RowSel=Account->Id;
    LTab->ColumnSel=0;
    LTab->Up=LTab->RowSel-3;
    if (LTab->Up<0) LTab->Up=0;
    LTab->Down=LTab->Up+LTab->NbRowDisplay-1;
    if (!LTab->Freeze) LaccDrawGrid(LTab);
  }
  return (Ok==0);
}

void LaccInitColumn(LcptTab *LTab)
{
  gint w,i;
  gchar Car;

  Car='A';
  w=gdk_char_width(LTab->Fonte,Car);
  LTab->Cell[0].Ta=gdk_string_width(LTab->Fonte,"99/99/9999")+(CELL_MARGING*2);
  LTab->Cell[2].Ta=gdk_string_width(LTab->Fonte,"99999999")+(CELL_MARGING*2);
  LTab->Cell[3].Ta=(10*w)+(CELL_MARGING*2);
  LTab->Cell[4].Ta=gdk_string_width(LTab->Fonte,"99999999.99")+(CELL_MARGING*2);
  LTab->Cell[5].Ta=gdk_string_width(LTab->Fonte,"99999999.99")+(CELL_MARGING*2);
  LTab->Cell[1].Ta=LTab->List_width-(LTab->Cell[0].Ta+LTab->Cell[2].Ta+LTab->Cell[3].Ta+LTab->Cell[4].Ta+LTab->Cell[5].Ta);
  LTab->Cell[0].Px=0;
  LTab->Cell[0].PTxt=CELL_MARGING;
  for (i=1;i<6;i++) {
    LTab->Cell[i].Px=LTab->Cell[i-1].Px+LTab->Cell[i-1].Ta;
    LTab->Cell[i].PTxt=LTab->Cell[i].Px+CELL_MARGING;
  }
}

void LaccClearArea(LcptTab *LTab)
{
  GdkColormap *CMap;
  GdkColor Col;
  GdkGC *Crayon;

  CMap=gdk_window_get_colormap(GTK_WIDGET (LTab)->window);
  Crayon=gdk_gc_new(GTK_WIDGET (LTab)->window);
  gdk_gc_set_line_attributes(Crayon,1,GDK_LINE_SOLID,GDK_CAP_BUTT,GDK_JOIN_BEVEL);
  Col.red=65535;
  Col.green=65535;
  Col.blue=65535;
  gdk_color_alloc(CMap,&Col);
  gdk_gc_set_foreground(Crayon,&Col);
  gdk_draw_rectangle(LTab->Row,Crayon,TRUE,0,0,LTab->List_width,LTab->List_height);
  gdk_gc_destroy(Crayon);
}

/* Affichage d'une ligne ********************************************/
void LaccDrawText(LcptTab *LTab,gint x,gint y,gint La,char *T)
{
  gint Ta,Xp;

  Ta=gdk_string_width(LTab->Fonte,T);
  Xp=x+CELL_MARGING;
  y=y+LTab->RowHeight-CELL_MARGING;
  gdk_gc_set_font(LTab->Crayon,LTab->Fonte);
  gdk_draw_string(LTab->Row,LTab->Fonte,LTab->Crayon,Xp,y,T);
}

void LaccDrawNum(LcptTab *LTab,gint x,gint y,gint La,char *T)
{
  gint Ta,Xp;

  Ta=gdk_string_width(LTab->Fonte,T);
  Xp=(x+La)-(Ta+CELL_MARGING);
  y=y+LTab->RowHeight-CELL_MARGING;
  gdk_gc_set_font(LTab->Crayon,LTab->Fonte);
  gdk_draw_string(LTab->Row,LTab->Fonte,LTab->Crayon,Xp,y,T);
}

void LaccDrawCell(LcptTab *LTab,int Cell,gint Yacc)
{
  switch (Cell)
    {
    case 0 : LaccDrawText(LTab,LTab->Cell[Cell].Px,Yacc,LTab->Cell[Cell].Ta-(CELL_MARGING*2),LTab->Selection->D.Date);
      break;
    case 1 : LaccDrawText(LTab,LTab->Cell[Cell].Px,Yacc,LTab->Cell[Cell].Ta-(CELL_MARGING*2),LTab->Selection->D.Lib);
      break;
    case 2 : LaccDrawText(LTab,LTab->Cell[Cell].Px,Yacc,LTab->Cell[Cell].Ta-(CELL_MARGING*2),LTab->Selection->D.Piece);
      break;
    case 3 : LaccDrawText(LTab,LTab->Cell[Cell].Px,Yacc,LTab->Cell[Cell].Ta-(CELL_MARGING*2),LTab->Selection->D.Compte);
      break;
    case 4 : LaccDrawNum(LTab,LTab->Cell[Cell].Px,Yacc,LTab->Cell[Cell].Ta-(CELL_MARGING*2),LTab->Selection->D.DebTxt);
      break;
    case 5 : LaccDrawNum(LTab,LTab->Cell[Cell].Px,Yacc,LTab->Cell[Cell].Ta-(CELL_MARGING*2),LTab->Selection->D.CreTxt);
      break;
    }
}

void LaccDrawRow(LcptTab *LTab)
{
  GdkColormap *CMap;
  GdkColor Col;
  gint Yacc,i;
  GtkWidget *WdgArea;

  WdgArea=GTK_WIDGET(LTab);
  CMap=gdk_window_get_colormap(WdgArea->window);
  gdk_gc_set_line_attributes(LTab->Crayon,1,GDK_LINE_SOLID,
			     GDK_CAP_BUTT,GDK_JOIN_BEVEL);
  if (((LTab->Selection->D.Piece[7]-48) & 1)!=0) {
    Col.red=32000;
    Col.green=50000;
    Col.blue=28000;
  } else {
    Col.red=100;
    Col.green=40000;
    Col.blue=28000;
  }
  gdk_color_alloc(CMap,&Col);
  gdk_gc_set_background(LTab->Crayon,&Col);
  gdk_gc_set_foreground(LTab->Crayon,&Col);
  Yacc=(LTab->Selection->Id-LTab->Up)*LTab->RowHeight;
  gdk_draw_rectangle(LTab->Row,LTab->Crayon,TRUE,
		     0,Yacc,LTab->List_width,LTab->RowHeight);
  /*** Affichage des lignes ****/
  Col.red=0;
  Col.green=0;
  Col.blue=50000;
  gdk_color_alloc(CMap,&Col);
  gdk_gc_set_foreground(LTab->Crayon,&Col);
  gdk_draw_rectangle(LTab->Row,LTab->Crayon,FALSE,
		     0,Yacc,LTab->List_width-2,LTab->RowHeight);
  for (i=0;i<6;i++)
    gdk_draw_line(LTab->Row,LTab->Crayon,
		  LTab->Cell[i].Px,Yacc,LTab->Cell[i].Px,Yacc+LTab->RowHeight);
  /*** Affichage des textes ***/
  Col.red=0;
  Col.green=0;
  Col.blue=0;
  gdk_color_alloc(CMap,&Col);
  gdk_gc_set_foreground(LTab->Crayon,&Col);
  for (i=0;i<6;i++) LaccDrawCell(LTab,i,Yacc);
}

/* Affichage driv */
void LaccDrawCellEdit(LcptTab *LTab,int Cell)
{
  GdkColor Col;
  GdkColormap *CMap;
  gint Yacc;
  GtkWidget *WdgArea;

  WdgArea=GTK_WIDGET(LTab);
  CMap=gdk_window_get_colormap(WdgArea->window);
  Yacc=(LTab->Selection->Id-LTab->Up)*LTab->RowHeight;
  Col.red=65535;
  Col.green=65535;
  Col.blue=65535;
  gdk_color_alloc(CMap,&Col);
  gdk_gc_set_background(LTab->Crayon,&Col);
  gdk_gc_set_foreground(LTab->Crayon,&Col);
  gdk_draw_rectangle(LTab->Row,LTab->Crayon,TRUE,
		LTab->Cell[Cell].Px,Yacc,LTab->Cell[Cell].Ta,LTab->RowHeight);
  /***/
  Col.red=0;
  Col.green=0;
  Col.blue=0;
  gdk_color_alloc(CMap,&Col);
  gdk_gc_set_foreground(LTab->Crayon,&Col);
  LaccDrawCell(LTab,Cell,Yacc);
  lcpt_text_init(LTab);
  lcpt_text_draw_cursor(LTab);
}
/* Affichage des titres *************************************************/
void LaccDrawTitleStr(LcptTab *LTab,gint Column)
{
  gint Ta,Xp,Ha,Yp;

  Ha=gdk_string_height(LTab->Fonte,LibTitle[Column]);
  Ta=gdk_string_width(LTab->Fonte,LibTitle[Column]);
  Xp=LTab->Cell[Column].Px+((LTab->Cell[Column].Ta-Ta)/2);
  Yp=LTab->Title_height-((LTab->Title_height-Ha)/2);
  gdk_gc_set_font(LTab->Crayon,LTab->Fonte);
  gdk_draw_string(LTab->Title,LTab->Fonte,LTab->Crayon,Xp,Yp,LibTitle[Column]);
}

void LaccDrawTitle(LcptTab *LTab)
{
  GdkColormap *CMap;
  GdkColor Col;
  gint i;
  GtkWidget *WdgArea;

  WdgArea=GTK_WIDGET(LTab);
  CMap=gdk_window_get_colormap(WdgArea->window);
  LTab->Crayon=gdk_gc_new(WdgArea->window);
  gdk_gc_set_line_attributes(LTab->Crayon,1,GDK_LINE_SOLID,GDK_CAP_BUTT,GDK_JOIN_BEVEL);
  Col.red=100;
  Col.green=5000;
  Col.blue=2000;
  gdk_color_alloc(CMap,&Col);
  gdk_gc_set_background(LTab->Crayon,&Col);
  gdk_gc_set_foreground(LTab->Crayon,&Col);

  gdk_draw_rectangle(LTab->Title,LTab->Crayon,TRUE,0,0,LTab->Title_width,LTab->Title_height);
  /*** Affichage des lignes ****/
  Col.red=65535;
  Col.green=0;
  Col.blue=0;
  gdk_color_alloc(CMap,&Col);
  gdk_gc_set_foreground(LTab->Crayon,&Col);
  gdk_draw_rectangle(LTab->Title,LTab->Crayon,FALSE,0,0,LTab->Title_width,LTab->Title_height);
  for (i=0;i<6;i++) gdk_draw_line(LTab->Title,LTab->Crayon,LTab->Cell[i].Px,0,LTab->Cell[i].Px,LTab->Title_height);
  /*** Affichage des textes ***/
  Col.red=65535;
  Col.green=65535;
  Col.blue=65535;
  gdk_color_alloc(CMap,&Col);
  gdk_gc_set_foreground(LTab->Crayon,&Col);
  for (i=0;i<6;i++) LaccDrawTitleStr(LTab,i);
}

/* Affichage des slections *********************************************/
void LaccDrawSelectBar(LcptTab *LTab)
{
  GdkColormap *CMap;
  GdkColor Col;
  gint Yacc,i;
  GtkWidget *WdgArea;

  WdgArea=GTK_WIDGET(LTab);
  CMap=gdk_window_get_colormap(WdgArea->window);
  gdk_gc_set_line_attributes(LTab->Crayon,1,GDK_LINE_SOLID,GDK_CAP_BUTT,GDK_JOIN_BEVEL);
  Col.red=0;
  Col.green=0;
  Col.blue=40000;
  gdk_color_alloc(CMap,&Col);
  gdk_gc_set_background(LTab->Crayon,&Col);
  gdk_gc_set_foreground(LTab->Crayon,&Col);
  Yacc=(LTab->Selection->Id-LTab->Up)*LTab->RowHeight;
  gdk_draw_rectangle(LTab->Row,LTab->Crayon,TRUE,
		     0,Yacc,LTab->List_width,LTab->RowHeight);
  /*** Affichage des lignes ****/
  Col.red=65535;
  Col.green=0;
  Col.blue=0;
  gdk_color_alloc(CMap,&Col);
  gdk_gc_set_foreground(LTab->Crayon,&Col);
  gdk_draw_rectangle(LTab->Row,LTab->Crayon,FALSE,
		     0,Yacc,LTab->List_width-2,LTab->RowHeight);
  for (i=0;i<6;i++)
    gdk_draw_line(LTab->Row,LTab->Crayon,
		  LTab->Cell[i].Px,Yacc,LTab->Cell[i].Px,Yacc+LTab->RowHeight);
  /*** Affichage des textes ***/
  Col.red=65535;
  Col.green=65535;
  Col.blue=65535;
  gdk_color_alloc(CMap,&Col);
  gdk_gc_set_foreground(LTab->Crayon,&Col);
  for (i=0;i<6;i++) LaccDrawCell(LTab,i,Yacc);
}

void LaccDrawSelect(LcptTab *LTab)
{
  if ((LTab->Selection->Id>=LTab->Up) && (LTab->Selection->Id<=LTab->Down)) LaccDrawSelectBar(LTab);
}

gint LaccGetRowSelect(LcptTab *LTab,gint Yacc)
{
  gint Ret;

  Ret=LTab->Up+(Yacc/LTab->RowHeight);
  return (Ret);
}

gint LaccGetColumnSelect(LcptTab *LTab,gint Xacc)
{
  int i,Ret;

  Ret=-1;
  for (i=0;i<6;i++) {
    if ((Xacc>=LTab->Cell[i].Px) && (Xacc<(LTab->Cell[i].Px+LTab->Cell[i].Ta))) Ret=i;
  }
  return (Ret);
}

void LaccDrawById(LcptTab *LTab,int Id)
{
  if (LaccSearchId(LTab,Id)) LaccDrawRow(LTab);
}

void LaccDrawGrid(LcptTab *LTab)
{
  int Suiv;

  LaccClearArea(LTab);
  if (LaccSearchId(LTab,LTab->Up)) {
    Suiv=LTab->Up;
    do {
      LaccDrawRow(LTab);
      LTab->Selection=LTab->Selection->Su;
      Suiv++;
    } while ((LTab->Selection!=NULL) && (Suiv<(LTab->Down+1)));
    LaccSearchId(LTab,LTab->RowSel);
    LaccDrawSelect(LTab);
    LaccDrawCellEdit(LTab,LTab->ColumnSel);
    lcpt_tab_calcul_ecart(LTab);
  }
}

void LaccResize(LcptTab *LTab)
{
  if (LTab->Fonte!=NULL) {
    LTab->NbRowDisplay=LTab->List_height/LTab->RowHeight;
    if ((LTab->List_height % LTab->RowHeight)!=0) LTab->NbRowDisplay++;
    LTab->Down=LTab->Up+LTab->NbRowDisplay-1;
    LaccInitColumn(LTab);
    SetAdjustments(LTab);
  }
}
