/*******************************************************************/
/* Comptabilit Analytique Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 07/04/02 - Chargement de la configuration                       */
/* Fichier source                                                  */
/*******************************************************************/

#include <stdio.h>
#include <glib.h>
#include <string.h>
#include <ctype.h>
#include <sys/stat.h>
#include "common.h"
#include "ldconf.h"

/* Protos */
void GetPathLincomptarc(char *path);
gboolean ReadConfig(gchar *Name);
gboolean WriteConfig(gchar *Name);

/******************************************************************/
void GetPathLincomptarc(char *path)
{
  strcpy(path,g_get_home_dir());
  strcat(path,"/.lincomptarc");
}

/* Lecture d'un fichier de config - version simple - */
gboolean ReadConfig(gchar *Name)
{
  FILE *Fp;
  char Line[120],*Ps,*Pd,*PVar,Ins[40];
  gboolean Ok;
  
  if ((Fp=fopen(Name,"rt"))!=NULL) {
    Ok=TRUE;
    while (!feof(Fp)) {
      fgets(Line,119,Fp);
      Ps=Line;
      Pd=Ins;
      while (*Ps==32) Ps++;
      if (*Ps!='\n' && *Ps!='#' && *Ps!='\0') {
	while (isalpha(*Ps)) *Pd++=*Ps++;
	*Pd='\0';
	PVar=NULL;
	g_strup(Ins);
	if (strcasecmp(Ins,"USER")==0) PVar=MySqlUser;
	if (strcasecmp(Ins,"PASSWORD")==0) PVar=MySqlPassword;
	if (strcasecmp(Ins,"SERVER")==0) PVar=MySqlServer;
	if (strcasecmp(Ins,"AFMDIR")==0) PVar=AfmDir;
	if (PVar==NULL) {
	  puts("lincomptarc : commande inconnue !\n");
	  exit(1);
	}
	while (*Ps==32) Ps++;
	if (*Ps=='=') {
	  Ps++;
	  while (*Ps==32) Ps++;
	  if (*Ps==34) {
	    Ps++;
	    while (*Ps!=34 && *Ps!='\n') *PVar++=*Ps++;
	  }  else while (isalnum(*Ps) || ((*Ps=='/') || (*Ps=='_') || (*Ps=='.') || (*Ps==':'))) *PVar++=*Ps++;
	  *PVar='\0';
	}
      }
    }
    fclose(Fp);
  } else Ok=FALSE;
  return (Ok);
}

gboolean ReadLinComptaRc(void)
{
  char path[250];
  gboolean Ok;

  strcpy(AfmDir,"/usr/share/fonts/afms/adobe");
  GetPathLincomptarc(path);
  Ok=ReadConfig(path);
  return (Ok);
}

gboolean WriteConfig(gchar *Name)
{
  FILE *Fp;
  gboolean Ok;
  gchar Tmp[120];
  mode_t curmsk;

  curmsk=umask(~(S_IRUSR | S_IWUSR));
  if ((Fp=fopen(Name,"wt"))!=NULL) {
    Ok=TRUE;
    fputs("#Fichier de configuration de lincompta !\n",Fp);
    fputs("#---------------------------------------\n",Fp);
    fputs("\n",Fp);
    sprintf(Tmp,"User = %s\n",MySqlUser);
    fputs(Tmp,Fp);
    sprintf(Tmp,"Password = %s\n",MySqlPassword);
    fputs(Tmp,Fp);
    sprintf(Tmp,"Server = \"%s\"\n",MySqlServer);
    fputs(Tmp,Fp);
    sprintf(Tmp,"AfmDir = \"%s\"\n",AfmDir);
    fputs(Tmp,Fp);
    fclose(Fp);
  } else Ok=FALSE;
  umask(curmsk);
  return (Ok);
}

gboolean WriteLinComptaRc(void)
{
  char path[250];
  gboolean Ok;

  GetPathLincomptarc(path);
  Ok=WriteConfig(path);
  return (Ok);
}
