/*******************************************************************/
/* Comptabilit Analityque Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 21/03/02 - Lettrage des comptes                                 */
/* Fichier source                                                  */
/*******************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 


#include <gtk/gtk.h>
#include <gnome.h>
#include <string.h>
#include <ctype.h>
#include <mysql/mysql.h>
#include "support.h"
#include "common.h"
#include "lettrage.h"
#include "gtksql.h"
#include "select.h"

/* Variables */
GtkWidget *WinLet;
MYSQL_RES *EdtPlcRes;
gboolean  AFFICHE_NORMAL,OPERATION_RUN;
double    Ecart;
my_ulonglong MysqlPtr;
select_list *ORG_SELECT,*SelList;

/* Protos */
GtkWidget* create_Lettrage (void);
void LetPrintEcart(void);
void LetCalculEcart(GtkCList *List,gint Row);
void EdtLet_DispTab(void);
void EdtLet_DispData(void);
void ValidLettrage(GtkCList *List);
/* Events */
void
on_Lettrage_show                       (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_Lettrage_destroy                    (GtkObject       *object,
                                        gpointer         user_data);

void
on_Let_BtPrec_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_Let_BtSel_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_Let_BtSuiv_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
Let_ListEcrit_select_row               (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
Let_ListEcrit_start_selection          (GtkCList        *clist,
                                        gpointer         user_data);

void
Let_ListEcrit_unselect_row             (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void on_Let_BtChange_clicked(GtkButton *button,gpointer user_data);

void Let_BtSelAll_clicked(GtkButton *button,gpointer user_data);

void Let_BtUnselAll_clicked(GtkButton *button,gpointer user_data);

/*************************************************************************/

/* Affichage du letttrage ************************************************/
void LetPrintEcart(void)
{
  GtkWidget *Widget;
  char Tmp[15];

  Widget=lookup_widget(GTK_WIDGET (WinLet),"Let_Ecart");
  sprintf(Tmp,"%-8.2f",Ecart);
  gtk_entry_set_text(GTK_ENTRY (Widget),Tmp);
}

/* Calcul de l'cart de lettrage ****************************************/
void LetCalculEcart(GtkCList *List,gint Row)
{
  gchar *P;
  double a,b;

  gtk_clist_get_text(List,Row,5,&P);
  a=atof(P);
  gtk_clist_get_text(List,Row,6,&P);
  b=atof(P);
  Ecart=Ecart+(a-b);
}

/* Affichage du tableau **********************************************************/
void EdtLet_DispTab(void)
{
  GtkWidget *ListHis,*Entry;
  gchar *Ptr[10],PsCle[LEN_COD_SOC+1],SqlCmd[200],Tmp[15],CptCode[11],Tmp2[15];
  MYSQL_RES *Result;
  MYSQL_ROW Row;
  gint Ligne;

  GetSocRun(PsCle);
  Entry=lookup_widget(GTK_WIDGET (WinLet),"CptCode");
  strcpy(CptCode,gtk_entry_get_text(GTK_ENTRY (Entry)));
  ListHis=lookup_widget(GTK_WIDGET (WinLet),"ListEcrit");
  gtk_clist_freeze(GTK_CLIST (ListHis));
  gtk_clist_clear(GTK_CLIST (ListHis));
  if (AFFICHE_NORMAL)
    sprintf(SqlCmd,"Select * From Ecrit Where EcrSoc='%s' And EcrCpt='%s' And EcrLet='' Order By EcrDate",PsCle,CptCode);
  else sprintf(SqlCmd,"Select * From Ecrit Where EcrSoc='%s' And EcrCpt='%s' And EcrLet<>'' Order By EcrDate",PsCle,CptCode);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    Result=mysql_store_result(DbLcpt);
    while ((Row=mysql_fetch_row(Result))) {
      IsoToDate(Tmp,Row[3]);
      Ptr[0]=Tmp;
      Ptr[1]=Row[9];
      Ptr[2]=Row[4];
      Ptr[3]=Row[5]+2;
      if (AFFICHE_NORMAL) IsoToDate(Tmp2,Row[14]);else IsoToDate(Tmp2,Row[18]);
      Ptr[4]=Tmp2;
      Ptr[5]=Row[19];
      Ptr[6]=Row[20];
      Ptr[7]=Row[10];
      Ligne=gtk_clist_append(GTK_CLIST (ListHis),Ptr);
      gtk_clist_set_row_data(GTK_CLIST (ListHis),Ligne,(gpointer) Row[1]);
    }
    gtk_clist_thaw(GTK_CLIST (ListHis));
  }
}

void EdtLet_DispData(void)
{
  gchar SqlCmd[250],PsCle[LEN_COD_SOC+1];
  int Valid;
  MYSQL_ROW Row;
  GtkWidget *Widget;

  GetSocRun(PsCle);
  if (EdtPlcRes==NULL) {
    Valid=FALSE;
    MysqlPtr=0;
    sprintf(SqlCmd,"Select CptCode,CptLib From Comptes Where CptSoc='%s'",PsCle);
    if (!mysql_query(DbLcpt,SqlCmd)) {
      EdtPlcRes=mysql_store_result(DbLcpt);
      if (EdtPlcRes)  {
	if (mysql_num_rows(EdtPlcRes)==0) {
	  Widget=lookup_widget(GTK_WIDGET (WinLet),"Let_BtPrec");
	  if (Widget!=NULL) gtk_widget_set_sensitive(Widget,FALSE);
	  Widget=lookup_widget(GTK_WIDGET (WinLet),"Let_BtSuiv");
	  if (Widget!=NULL) gtk_widget_set_sensitive(Widget,FALSE);
	  Widget=lookup_widget(GTK_WIDGET (WinLet),"Let_BtSel");
	  if (Widget!=NULL) gtk_widget_set_sensitive(Widget,FALSE);
	} else Valid=TRUE;
      }
    }
  } else Valid=TRUE;
  if (Valid) {
    Row=mysql_fetch_row(EdtPlcRes);
    StrSqlToGtk(GTK_WIDGET (WinLet),"CptCode",Row[0]);
    StrSqlToGtk(GTK_WIDGET (WinLet),"CptLib",Row[1]);
    EdtLet_DispTab();
  }
  Ecart=0;
  if (ORG_SELECT!=NULL) {
    Select_DeleteAll(ORG_SELECT);
    ORG_SELECT=NULL;
  }
  LetPrintEcart();
}

void ValidLettrage(GtkCList *List)
{
  gchar SqlCmd[120],PsCle[LEN_COD_SOC+1],PVal[3],CptCode[11],*C1,*C2,Msg[50];
  GtkWidget *Widget;
  MYSQL_RES *Result;
  MYSQL_ROW Row;

  gtk_signal_handler_block_by_func(GTK_OBJECT (List),(GtkSignalFunc) Let_ListEcrit_select_row,NULL);
  gtk_signal_handler_block_by_func(GTK_OBJECT (List),(GtkSignalFunc) Let_ListEcrit_unselect_row,NULL);
  if (AFFICHE_NORMAL) strcpy(Msg,_("Confirmez vous le Lettrage ?"));else strcpy(Msg,_("Confirmez vous le Delettrage ?"));
  if (MsgQuestion(Msg)==MR_OK) {
    GetSocRun(PsCle);
    if (AFFICHE_NORMAL) {
      Widget=lookup_widget(GTK_WIDGET (List),"CptCode");
      strcpy(CptCode,gtk_entry_get_text(GTK_ENTRY (Widget)));
      strcpy(SqlCmd,"Lock Tables LettCount Write");
      mysql_query(DbLcpt,SqlCmd);
      sprintf(SqlCmd,"Select LetValeur From LettCount Where LetSoc='%s' And LetCpt='%s'",PsCle,CptCode);
      strcpy(PVal,"AA");
      if (mysql_query(DbLcpt,SqlCmd)==0) {
	Result=mysql_use_result(DbLcpt);
	if ((Row=mysql_fetch_row(Result))) {
	  if (Row[0]!=NULL) {
	    strcpy(PVal,Row[0]);
	    C1=PVal;
	    C2=C1+1;
	    *C2=*C2+1;
	    if (*C2>'Z') {
	      *C1=*C1+1;
	      *C2='A';
	    }
	  }
	}
	mysql_free_result(Result);
	sprintf(SqlCmd,"Update LettCount Set LetValeur='%s' Where LetSoc='%s' And LetCpt='%s'",PVal,PsCle,CptCode);
	mysql_query(DbLcpt,SqlCmd);
      }
      strcpy(SqlCmd,"Unlock Tables");
      mysql_query(DbLcpt,SqlCmd);
    } else *PVal='\0';
    SelList=ORG_SELECT;
    OPERATION_RUN=TRUE;
    gtk_clist_unselect_all(GTK_CLIST (List));
    while (SelList!=NULL) {
      sprintf(SqlCmd,"Update Ecrit Set EcrLet='%s' Where EcrSoc='%s' And EcrCode='%s'",PVal,PsCle,SelList->Code);
      if (mysql_query(DbLcpt,SqlCmd)!=0) g_print("Erreur Sql sur code '%s'\n",SelList->Code);
      gtk_clist_remove(List,SelList->Row);
      SelList=SelList->Su;
    }
    OPERATION_RUN=FALSE;
    Ecart=0;
    LetPrintEcart();
    Select_DeleteAll(ORG_SELECT);
    ORG_SELECT=NULL;
  }
  gtk_signal_handler_unblock_by_func(GTK_OBJECT (List),(GtkSignalFunc) Let_ListEcrit_select_row,NULL);
  gtk_signal_handler_unblock_by_func(GTK_OBJECT (List),(GtkSignalFunc) Let_ListEcrit_unselect_row,NULL);
}

/* Affichage du lettrage ********************************************/
void on_Lettrage_show(GtkWidget *widget,gpointer user_data)
{
  GtkWidget *Lst;
  gint i;

  WinLet=widget;
  OpenDbLcpt();
  Lst=lookup_widget(GTK_WIDGET (widget),"ListEcrit");
  for (i=0;i<8;i++) gtk_clist_set_column_resizeable(GTK_CLIST (Lst),i,FALSE);
  gtk_clist_set_column_justification(GTK_CLIST (Lst),5,GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_justification(GTK_CLIST (Lst),6,GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_justification(GTK_CLIST (Lst),7,GTK_JUSTIFY_CENTER);
  AFFICHE_NORMAL=TRUE;
  OPERATION_RUN=FALSE;
  ORG_SELECT=NULL;
}

/* Fin du lettrage ***********************************************/
void on_Lettrage_destroy(GtkObject *object,gpointer user_data)
{
  Select_DeleteAll(ORG_SELECT);
  mysql_free_result(EdtPlcRes);
  CloseDbLcpt();
}

/*Compte prcdent ************************************************/
void on_Let_BtPrec_clicked(GtkButton *button,gpointer user_data)
{
  if (MysqlPtr>0) {
    MysqlPtr--;
    mysql_data_seek(EdtPlcRes,MysqlPtr);
    EdtLet_DispData();
  }
}

/*Selection d'un compte ********************************************/
void on_Let_BtSel_clicked(GtkButton *button,gpointer user_data)
{
  gchar CptRet[11];

  if (ListSelect(CptRet,"Comptes","CptSoc","CptCode","CptLib",NULL)==MR_OK) {
    if ((MysqlPtr = SearchCode(EdtPlcRes, CptRet, 0)) != -1)
      EdtLet_DispData();
    else
      if (verbose) g_print("Code %s non retrouv !!!\n", CptRet);
  }
}


/* Compte suivant **************************************************/
void on_Let_BtSuiv_clicked(GtkButton *button,gpointer user_data)
{
  if (MysqlPtr<mysql_num_rows(EdtPlcRes)-1) {
    EdtLet_DispData();
    MysqlPtr++;
  }
}

/* Selection d'une ligne sur le lettrage ****************************/
void Let_ListEcrit_select_row           (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gchar *P,PsCle[LEN_COD_SOC+1],*SqlCmd;
  float EcartMini;

  GetSocRun(PsCle);
  P=gtk_clist_get_row_data(clist,row);
  ORG_SELECT=Select_Append(ORG_SELECT,row,P);
  LetCalculEcart(clist,row);
  LetPrintEcart();
  SqlCmd=g_strdup_printf("Select PgSLett from Pgx Where PgCle='%s'",PsCle);
  EcartMini=SqlGetFloat(SqlCmd);
  free(SqlCmd);
  if (Ecart<=EcartMini) ValidLettrage(clist);
}


void Let_ListEcrit_start_selection(GtkCList *clist,gpointer user_data)
{
  if (!OPERATION_RUN) {
    Select_DeleteAll(ORG_SELECT);
    ORG_SELECT=NULL;
    Ecart=0;
    LetPrintEcart();
  }
}

void Let_ListEcrit_unselect_row(GtkCList *clist,gint row,gint column,GdkEvent *event,gpointer user_data)
{
  gchar *P;
  double a,b;

  if (!OPERATION_RUN) {
    ORG_SELECT=Select_Delete(ORG_SELECT,row);
    gtk_clist_get_text(clist,row,5,&P);
    a=atof(P);
    gtk_clist_get_text(clist,row,6,&P);
    b=atof(P);
    Ecart=Ecart-(a-b);
    LetPrintEcart();
  }
}

void on_Let_BtChange_clicked(GtkButton *button,gpointer user_data)
{
  gchar *text;
  GtkWidget *Option,*Menu;
  gboolean Old;

  Menu=lookup_widget(GTK_WIDGET (button),"Let_TypeOper");
  if (GTK_BIN (Menu)->child) {
    Option = GTK_BIN (Menu)->child;
    if (GTK_IS_LABEL (Option)) {
      gtk_label_get (GTK_LABEL (Option), &text);
      Old=AFFICHE_NORMAL;
      if (strcmp(text,"Lettrage")==0) AFFICHE_NORMAL=TRUE;else AFFICHE_NORMAL=FALSE;
      if (Old!=AFFICHE_NORMAL) EdtLet_DispTab();
    }
  }
}


void Let_BtSelAll_clicked(GtkButton *button,gpointer user_data)
{
  GtkWidget *Widget;

  Widget=lookup_widget(GTK_WIDGET (button),"ListEcrit");
  gtk_clist_select_all(GTK_CLIST (Widget));
}


void Let_BtUnselAll_clicked(GtkButton *button,gpointer user_data)
{
  GtkWidget *Widget;

  Widget=lookup_widget(GTK_WIDGET (button),"ListEcrit");
  gtk_clist_unselect_all(GTK_CLIST (Widget));
}

/* Cration de la boite de dialogue ********************************************/
GtkWidget* create_Lettrage (void)
{
  GtkWidget *Lettrage;
  GtkWidget *vbox18;
  GtkWidget *hbox24;
  GtkWidget *hbox25;
  GtkWidget *label168;
  GtkWidget *CptCode;
  GtkWidget *CptLib;
  GtkWidget *hbox26;
  GtkWidget *Let_BtPrec;
  GtkWidget *Let_BtSel;
  GtkWidget *Let_BtSuiv;
  GtkWidget *fixed18;
  GtkWidget *scrolledwindow12;
  GtkWidget *ListEcrit;
  GtkWidget *label169;
  GtkWidget *label170;
  GtkWidget *label171;
  GtkWidget *label172;
  GtkWidget *label173;
  GtkWidget *label174;
  GtkWidget *label175;
  GtkWidget *LetLab1;
  GtkWidget *fixed19;
  GtkWidget *button22;
  GtkWidget *Let_Ecart;
  GtkWidget *vseparator12;
  GtkWidget *Let_TypeOper;
  GtkWidget *Let_TypeOper_menu;
  GtkWidget *glade_menuitem;
  GtkWidget *Let_BtChange;
  GtkWidget *label177;
  GtkWidget *Let_BtSelAll;
  GtkWidget *Let_BtUnselAll;
  GtkWidget *vseparator13;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  Lettrage = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (Lettrage), "Lettrage", Lettrage);
  gtk_widget_set_usize (Lettrage, -2, 347);
  gtk_window_set_title (GTK_WINDOW (Lettrage), _("Lettrage des Comptes"));
  gtk_window_set_position (GTK_WINDOW (Lettrage), GTK_WIN_POS_CENTER);

  vbox18 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox18);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "vbox18", vbox18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox18);
  gtk_container_add (GTK_CONTAINER (Lettrage), vbox18);

  hbox24 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox24);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "hbox24", hbox24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox24);
  gtk_box_pack_start (GTK_BOX (vbox18), hbox24, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox24), 2);

  hbox25 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox25);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "hbox25", hbox25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox25);
  gtk_box_pack_start (GTK_BOX (hbox24), hbox25, FALSE, TRUE, 0);

  label168 = gtk_label_new (_("Compte :"));
  gtk_widget_ref (label168);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "label168", label168,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label168);
  gtk_box_pack_start (GTK_BOX (hbox25), label168, FALSE, FALSE, 0);

  CptCode = gtk_entry_new_with_max_length (10);
  gtk_widget_ref (CptCode);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "CptCode", CptCode,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptCode);
  gtk_box_pack_start (GTK_BOX (hbox25), CptCode, TRUE, TRUE, 0);
  gtk_widget_set_usize (CptCode, 90, -2);

  CptLib = gtk_entry_new ();
  gtk_widget_ref (CptLib);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "CptLib", CptLib,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptLib);
  gtk_box_pack_start (GTK_BOX (hbox25), CptLib, TRUE, TRUE, 0);
  gtk_widget_set_usize (CptLib, 226, -2);
  gtk_widget_set_sensitive (CptLib, FALSE);
  gtk_entry_set_editable (GTK_ENTRY (CptLib), FALSE);

  hbox26 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox26);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "hbox26", hbox26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox26);
  gtk_box_pack_start (GTK_BOX (hbox24), hbox26, FALSE, TRUE, 0);

  Let_BtPrec = gnome_stock_button (GNOME_STOCK_BUTTON_PREV);
  gtk_widget_ref (Let_BtPrec);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "Let_BtPrec", Let_BtPrec,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Let_BtPrec);
  gtk_box_pack_start (GTK_BOX (hbox26), Let_BtPrec, FALSE, FALSE, 0);
  gtk_widget_add_accelerator (Let_BtPrec, "clicked", accel_group,
                              GDK_Page_Up, 0,
                              GTK_ACCEL_VISIBLE);

  Let_BtSel = gtk_button_new_with_label (_("Sl."));
  gtk_widget_ref (Let_BtSel);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "Let_BtSel", Let_BtSel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Let_BtSel);
  gtk_box_pack_start (GTK_BOX (hbox26), Let_BtSel, FALSE, FALSE, 0);
  gtk_widget_add_accelerator (Let_BtSel, "clicked", accel_group,
                              GDK_F5, 0,
                              GTK_ACCEL_VISIBLE);

  Let_BtSuiv = gnome_stock_button (GNOME_STOCK_BUTTON_NEXT);
  gtk_widget_ref (Let_BtSuiv);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "Let_BtSuiv", Let_BtSuiv,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Let_BtSuiv);
  gtk_box_pack_start (GTK_BOX (hbox26), Let_BtSuiv, FALSE, FALSE, 0);
  gtk_widget_add_accelerator (Let_BtSuiv, "clicked", accel_group,
                              GDK_Page_Down, 0,
                              GTK_ACCEL_VISIBLE);

  fixed18 = gtk_fixed_new ();
  gtk_widget_ref (fixed18);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "fixed18", fixed18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed18);
  gtk_box_pack_start (GTK_BOX (hbox24), fixed18, TRUE, TRUE, 0);

  scrolledwindow12 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow12);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "scrolledwindow12", scrolledwindow12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow12);
  gtk_box_pack_start (GTK_BOX (vbox18), scrolledwindow12, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow12), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  ListEcrit = gtk_clist_new (8);
  gtk_widget_ref (ListEcrit);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "ListEcrit", ListEcrit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ListEcrit);
  gtk_container_add (GTK_CONTAINER (scrolledwindow12), ListEcrit);
  gtk_container_set_border_width (GTK_CONTAINER (ListEcrit), 2);
  gtk_clist_set_column_width (GTK_CLIST (ListEcrit), 0, 70);
  gtk_clist_set_column_width (GTK_CLIST (ListEcrit), 1, 265);
  gtk_clist_set_column_width (GTK_CLIST (ListEcrit), 2, 30);
  gtk_clist_set_column_width (GTK_CLIST (ListEcrit), 3, 80);
  gtk_clist_set_column_width (GTK_CLIST (ListEcrit), 4, 68);
  gtk_clist_set_column_width (GTK_CLIST (ListEcrit), 5, 80);
  gtk_clist_set_column_width (GTK_CLIST (ListEcrit), 6, 80);
  gtk_clist_set_column_width (GTK_CLIST (ListEcrit), 7, 50);
  gtk_clist_set_selection_mode (GTK_CLIST (ListEcrit), GTK_SELECTION_MULTIPLE);
  gtk_clist_column_titles_show (GTK_CLIST (ListEcrit));

  label169 = gtk_label_new (_("Date"));
  gtk_widget_ref (label169);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "label169", label169,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label169);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcrit), 0, label169);

  label170 = gtk_label_new (_("Libell"));
  gtk_widget_ref (label170);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "label170", label170,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label170);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcrit), 1, label170);

  label171 = gtk_label_new (_("Jrn"));
  gtk_widget_ref (label171);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "label171", label171,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label171);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcrit), 2, label171);

  label172 = gtk_label_new (_("Pice"));
  gtk_widget_ref (label172);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "label172", label172,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label172);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcrit), 3, label172);

  label173 = gtk_label_new (_("Echance"));
  gtk_widget_ref (label173);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "label173", label173,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label173);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcrit), 4, label173);

  label174 = gtk_label_new (_("Dbit"));
  gtk_widget_ref (label174);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "label174", label174,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label174);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcrit), 5, label174);

  label175 = gtk_label_new (_("Crdit"));
  gtk_widget_ref (label175);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "label175", label175,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label175);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcrit), 6, label175);

  LetLab1 = gtk_label_new (_("Lett."));
  gtk_widget_ref (LetLab1);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "LetLab1", LetLab1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (LetLab1);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcrit), 7, LetLab1);

  fixed19 = gtk_fixed_new ();
  gtk_widget_ref (fixed19);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "fixed19", fixed19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed19);
  gtk_box_pack_start (GTK_BOX (vbox18), fixed19, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (fixed19), 2);

  button22 = gnome_stock_button (GNOME_STOCK_BUTTON_CLOSE);
  gtk_widget_ref (button22);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "button22", button22,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button22);
  gtk_fixed_put (GTK_FIXED (fixed19), button22, 700, 4);
  gtk_widget_set_uposition (button22, 700, 4);
  gtk_widget_set_usize (button22, 76, 26);

  Let_Ecart = gtk_entry_new ();
  gtk_widget_ref (Let_Ecart);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "Let_Ecart", Let_Ecart,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Let_Ecart);
  gtk_fixed_put (GTK_FIXED (fixed19), Let_Ecart, 120, 8);
  gtk_widget_set_uposition (Let_Ecart, 120, 8);
  gtk_widget_set_usize (Let_Ecart, 80, 20);
  gtk_widget_set_sensitive (Let_Ecart, FALSE);
  gtk_entry_set_editable (GTK_ENTRY (Let_Ecart), FALSE);

  vseparator12 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator12);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "vseparator12", vseparator12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator12);
  gtk_fixed_put (GTK_FIXED (fixed19), vseparator12, 216, 4);
  gtk_widget_set_uposition (vseparator12, 216, 4);
  gtk_widget_set_usize (vseparator12, 16, 24);

  Let_TypeOper = gtk_option_menu_new ();
  gtk_widget_ref (Let_TypeOper);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "Let_TypeOper", Let_TypeOper,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Let_TypeOper);
  gtk_fixed_put (GTK_FIXED (fixed19), Let_TypeOper, 476, 4);
  gtk_widget_set_uposition (Let_TypeOper, 476, 4);
  gtk_widget_set_usize (Let_TypeOper, 124, 24);
  Let_TypeOper_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label (_("Lettrage"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (Let_TypeOper_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("Delettrage"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (Let_TypeOper_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (Let_TypeOper), Let_TypeOper_menu);

  Let_BtChange = gtk_button_new_with_label (_("Change"));
  gtk_widget_ref (Let_BtChange);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "Let_BtChange", Let_BtChange,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Let_BtChange);
  gtk_fixed_put (GTK_FIXED (fixed19), Let_BtChange, 608, 4);
  gtk_widget_set_uposition (Let_BtChange, 608, 4);
  gtk_widget_set_usize (Let_BtChange, 54, 22);

  label177 = gtk_label_new (_("Ecart de lettrage :"));
  gtk_widget_ref (label177);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "label177", label177,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label177);
  gtk_fixed_put (GTK_FIXED (fixed19), label177, 8, 12);
  gtk_widget_set_uposition (label177, 8, 12);
  gtk_widget_set_usize (label177, 112, 16);
  gtk_misc_set_alignment (GTK_MISC (label177), 0, 0.5);

  Let_BtSelAll = gtk_button_new_with_label (_("Tous"));
  gtk_widget_ref (Let_BtSelAll);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "Let_BtSelAll", Let_BtSelAll,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Let_BtSelAll);
  gtk_fixed_put (GTK_FIXED (fixed19), Let_BtSelAll, 244, 8);
  gtk_widget_set_uposition (Let_BtSelAll, 244, 8);
  gtk_widget_set_usize (Let_BtSelAll, 54, 22);

  Let_BtUnselAll = gtk_button_new_with_label (_("Aucun"));
  gtk_widget_ref (Let_BtUnselAll);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "Let_BtUnselAll", Let_BtUnselAll,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Let_BtUnselAll);
  gtk_fixed_put (GTK_FIXED (fixed19), Let_BtUnselAll, 324, 8);
  gtk_widget_set_uposition (Let_BtUnselAll, 324, 8);
  gtk_widget_set_usize (Let_BtUnselAll, 54, 22);

  vseparator13 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator13);
  gtk_object_set_data_full (GTK_OBJECT (Lettrage), "vseparator13", vseparator13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator13);
  gtk_fixed_put (GTK_FIXED (fixed19), vseparator13, 452, 4);
  gtk_widget_set_uposition (vseparator13, 452, 4);
  gtk_widget_set_usize (vseparator13, 16, 24);

  gtk_signal_connect (GTK_OBJECT (Lettrage), "show",
                      GTK_SIGNAL_FUNC (on_Lettrage_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Lettrage), "destroy",
                      GTK_SIGNAL_FUNC (on_Lettrage_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Let_BtPrec), "clicked",
                      GTK_SIGNAL_FUNC (on_Let_BtPrec_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Let_BtSel), "clicked",
                      GTK_SIGNAL_FUNC (on_Let_BtSel_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Let_BtSuiv), "clicked",
                      GTK_SIGNAL_FUNC (on_Let_BtSuiv_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ListEcrit), "select_row",
                      GTK_SIGNAL_FUNC (Let_ListEcrit_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ListEcrit), "start_selection",
                      GTK_SIGNAL_FUNC (Let_ListEcrit_start_selection),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ListEcrit), "unselect_row",
                      GTK_SIGNAL_FUNC (Let_ListEcrit_unselect_row),
                      NULL);
  gtk_signal_connect_object (GTK_OBJECT (button22), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (Lettrage));
  gtk_signal_connect (GTK_OBJECT (Let_BtChange), "clicked",
                      GTK_SIGNAL_FUNC (on_Let_BtChange_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Let_BtSelAll), "clicked",
                      GTK_SIGNAL_FUNC (Let_BtSelAll_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Let_BtUnselAll), "clicked",
                      GTK_SIGNAL_FUNC (Let_BtUnselAll_clicked),
                      NULL);

  gtk_window_add_accel_group (GTK_WINDOW (Lettrage), accel_group);

  return Lettrage;
}

void Dialog_Lettrage(void)
{
  GtkWidget *Lettrage;

  Lettrage=create_Lettrage();
  gtk_widget_show_all(Lettrage);
  EdtPlcRes=NULL;
  EdtLet_DispData();
}
