/*******************************************************************/
/* Comptabilit Analytique Professionnel                           */
/* 01/01/2002 - Version 0.3.4                                      */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 22/03/02 - Fichier principal                                    */
/*******************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <mysql/mysql.h>

#include "compta.h"
#include "support.h"
#include "common.h"

int verbose = 0;

void SearchPrefixDir(char *path)
{
	char *d,*s;
	
	d=PREFIX;
	s=path;
	while (*d++=*s++);
	while (*d!='/') d--;
	d--;
	if (*d!='.') {
	  while (*d!='/') d--;		
  	*d=0;
	} else strcpy(PREFIX,"..");
}

int main (int argc, char *argv[])
{
  GtkWidget *Compta;
  struct poptOption PopTab[] = {
    { "verbose", 'v', POPT_ARG_NONE, &verbose, 0, "Mode verbeux", NULL
    },
    {NULL, 0, 0, NULL, 0}
  };


#ifdef ENABLE_NLS
  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain (PACKAGE);
#endif
  SearchPrefixDir(argv[0]);
	gnome_init_with_popt_table ("lincompta",VERSION,argc,argv,PopTab,0,NULL);
	if (verbose) {
	    g_print("mode verbeux (%d)\n", verbose);
	 }
  Compta = create_Compta ();
  gtk_widget_show (Compta);
  gtk_main ();
  return 0;
}
