/*******************************************************************/
/* Comptabilit Analytique Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 22/03/02 - Edition des paramtres gnraux                      */
/* Fichier source                                                  */
/*******************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 


#include <gtk/gtk.h>
#include <gnome.h>
#include <string.h>
#include <ctype.h>
#include <mysql/mysql.h>
#include "support.h"
#include "common.h"
#include "gtksql.h"
#include "select.h"

#include "paramgenx.h"

/* Variables */
GtkWidget    *ParamGenx;
gint         RowSel;
gboolean     CREATE_MODE;
listidlib    *Analyt,*ORG_ANA;
/* Protos */
GtkWidget* create_ParamGenx (void);
GtkWidget* create_EdtCdeAna (void);
void EdtPgx_DispData(GtkWidget *PlanComptable);
void EdtPgx_AjoAna_clicked             (GtkButton       *button,
                                        gpointer         user_data);
void EdtPgx_SuppAna_clicked            (GtkButton       *button,
                                        gpointer         user_data);
void on_LstAna_select_row              (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);
gboolean on_LstAna_button_press_event  (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);
void on_PgAna_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data);
void EdtPgx_BtOdd_clicked              (GtkButton       *button,
                                        gpointer         user_data);
void EdtPgx_BtEven_clicked             (GtkButton       *button,
                                        gpointer         user_data);
void EdtPgx_BtSel_clicked              (GtkButton       *button,
                                        gpointer         user_data);
void EdtPgx_BtColFont_clicked          (GtkButton       *button,
                                        gpointer         user_data);

void EdtPgx_SelFont_clicked            (GtkButton       *button,
                                        gpointer         user_data);
void on_PlcAna_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data);
void EdtCdeAna_BtOk_clicked            (GtkButton       *button,
                                        gpointer         user_data);
void PG_BtOk_Clicked                   (GtkButton       *button,
                                        gpointer         user_data);
void PG_BtAnnul_clicked                (GtkButton       *button,
                                        gpointer         user_data);
void on_ParamGenx_show                 (GtkWidget       *widget,
                                        gpointer         user_data);

void on_ParamGenx_destroy              (GtkObject        *widget,
                                        gpointer         user_data);
void EdtPgx_ActiveAna(gboolean Active);
void
EdtPgx_Ajouter_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
EdtPgx_BtOk_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
EdtPgx_BtCancel_clicked                (GtkButton       *button,
                                        gpointer         user_data);

void
EdtPgx_Supprimer_clicked               (GtkButton       *button,
                                        gpointer         user_data);

/* Edition analytique **************************************************/
GtkWidget* create_EdtCdeAna (void)
{
  GtkWidget *EdtCdeAna;
  GtkWidget *vbox13;
  GtkWidget *fixed11;
  GtkWidget *AnaCode;
  GtkWidget *label138;
  GtkWidget *AnaLib;
  GtkWidget *label139;
  GtkWidget *hseparator15;
  GtkWidget *hbox20;
  GtkWidget *EdtCdeAna_BtOk;
  GtkWidget *EdtCdeAna_BtCancel;

  EdtCdeAna = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (EdtCdeAna), "EdtCdeAna", EdtCdeAna);
  gtk_container_set_border_width (GTK_CONTAINER (EdtCdeAna), 4);
  gtk_window_set_title (GTK_WINDOW (EdtCdeAna), _("Code analytique"));
  gtk_window_set_position (GTK_WINDOW (EdtCdeAna), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (EdtCdeAna), TRUE);

  vbox13 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox13);
  gtk_object_set_data_full (GTK_OBJECT (EdtCdeAna), "vbox13", vbox13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox13);
  gtk_container_add (GTK_CONTAINER (EdtCdeAna), vbox13);

  fixed11 = gtk_fixed_new ();
  gtk_widget_ref (fixed11);
  gtk_object_set_data_full (GTK_OBJECT (EdtCdeAna), "fixed11", fixed11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed11);
  gtk_box_pack_start (GTK_BOX (vbox13), fixed11, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (fixed11), 3);

  AnaCode = gtk_entry_new_with_max_length (2);
  gtk_widget_ref (AnaCode);
  gtk_object_set_data_full (GTK_OBJECT (EdtCdeAna), "AnaCode", AnaCode,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (AnaCode);
  gtk_fixed_put (GTK_FIXED (fixed11), AnaCode, 64, 8);
  gtk_widget_set_uposition (AnaCode, 64, 8);
  gtk_widget_set_usize (AnaCode, 28, 20);

  label138 = gtk_label_new (_("Libell :"));
  gtk_widget_ref (label138);
  gtk_object_set_data_full (GTK_OBJECT (EdtCdeAna), "label138", label138,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label138);
  gtk_fixed_put (GTK_FIXED (fixed11), label138, 4, 40);
  gtk_widget_set_uposition (label138, 4, 40);
  gtk_widget_set_usize (label138, 60, 16);

  AnaLib = gtk_entry_new_with_max_length (25);
  gtk_widget_ref (AnaLib);
  gtk_object_set_data_full (GTK_OBJECT (EdtCdeAna), "AnaLib", AnaLib,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (AnaLib);
  gtk_fixed_put (GTK_FIXED (fixed11), AnaLib, 64, 36);
  gtk_widget_set_uposition (AnaLib, 64, 36);
  gtk_widget_set_usize (AnaLib, 158, 22);

  label139 = gtk_label_new (_("Code :"));
  gtk_widget_ref (label139);
  gtk_object_set_data_full (GTK_OBJECT (EdtCdeAna), "label139", label139,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label139);
  gtk_fixed_put (GTK_FIXED (fixed11), label139, 8, 12);
  gtk_widget_set_uposition (label139, 8, 12);
  gtk_widget_set_usize (label139, 41, 16);

  hseparator15 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator15);
  gtk_object_set_data_full (GTK_OBJECT (EdtCdeAna), "hseparator15", hseparator15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator15);
  gtk_fixed_put (GTK_FIXED (fixed11), hseparator15, 8, 60);
  gtk_widget_set_uposition (hseparator15, 8, 60);
  gtk_widget_set_usize (hseparator15, 232, 16);

  hbox20 = gtk_hbox_new (TRUE, 4);
  gtk_widget_ref (hbox20);
  gtk_object_set_data_full (GTK_OBJECT (EdtCdeAna), "hbox20", hbox20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox20);
  gtk_box_pack_start (GTK_BOX (vbox13), hbox20, FALSE, FALSE, 0);

  EdtCdeAna_BtOk = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (EdtCdeAna_BtOk);
  gtk_object_set_data_full (GTK_OBJECT (EdtCdeAna), "EdtCdeAna_BtOk", EdtCdeAna_BtOk,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtCdeAna_BtOk);
  gtk_box_pack_start (GTK_BOX (hbox20), EdtCdeAna_BtOk, FALSE, FALSE, 0);

  EdtCdeAna_BtCancel = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (EdtCdeAna_BtCancel);
  gtk_object_set_data_full (GTK_OBJECT (EdtCdeAna), "EdtCdeAna_BtCancel", EdtCdeAna_BtCancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtCdeAna_BtCancel);
  gtk_box_pack_start (GTK_BOX (hbox20), EdtCdeAna_BtCancel, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (EdtCdeAna_BtOk), "clicked",
                      GTK_SIGNAL_FUNC (EdtCdeAna_BtOk_clicked),
                      NULL);
  gtk_signal_connect_object (GTK_OBJECT (EdtCdeAna_BtCancel), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (EdtCdeAna));

  return EdtCdeAna;
}

/*** Validation d'un code analytique ***/
void
EdtCdeAna_BtOk_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *Entry,*Wcall;
  GtkCList *CList;
  char Code[3],Lib[25],SqlCmd[120],PsCle[LEN_COD_SOC+1];
  gchar *Gr[2];

  Entry=lookup_widget(GTK_WIDGET (button),"AnaCode");
  strcpy(Code,gtk_entry_get_text(GTK_ENTRY (Entry)));
  Entry=lookup_widget(GTK_WIDGET (button),"AnaLib");
  strcpy(Lib,gtk_entry_get_text(GTK_ENTRY (Entry)));
  GetSocRun(PsCle);
  if (CREATE_MODE==TRUE)
    sprintf(SqlCmd,"Insert into Analytique (AnaSoc,AnaCode,AnaLib) Values ('%s','%s','%s')",PsCle,Code,Lib);
  else sprintf(SqlCmd,"Update Analytique Set AnaLib='%s' where AnaSoc='%s' and AnaCode='%s'",Lib,PsCle,Code);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    CList=GTK_CLIST (lookup_widget(GTK_WIDGET (ParamGenx),"LstAna"));
    if ((DbLcpt!=NULL) && (CList!=NULL)) {
      FreeCdeAna(ORG_ANA);
      ORG_ANA=LoadCdeAna();
      Analyt=ORG_ANA;
      gtk_clist_clear(CList);
      while (Analyt!=NULL) {
	Gr[0]=Analyt->ID;
	Gr[1]=Analyt->Lib;
	gtk_clist_append(CList,Gr);
	Analyt=Analyt->Su;
      }
    }
  } else MessageErreur("Echec commande SQL !");
  Wcall=lookup_widget(GTK_WIDGET (button),"EdtCdeAna");
  gtk_widget_destroy(Wcall);
}

void
on_LstAna_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  RowSel=row;
}

/*** Modification d'un code analytique ***/
gboolean
on_LstAna_button_press_event           (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  GtkWidget *EdtAna,*Entry;
  gchar *Text;

  if (event->type==GDK_2BUTTON_PRESS) {
    CREATE_MODE=FALSE;
    EdtAna=create_EdtCdeAna();
    gtk_widget_show(EdtAna);
    Entry=lookup_widget(GTK_WIDGET (EdtAna),"AnaCode");
    gtk_clist_get_text(GTK_CLIST (widget),RowSel,0,&Text);
    gtk_entry_set_text(GTK_ENTRY (Entry),Text);
    gtk_widget_set_sensitive(GTK_WIDGET(Entry),FALSE);
    Entry=lookup_widget(GTK_WIDGET (EdtAna),"AnaLib");
    gtk_clist_get_text(GTK_CLIST (widget),RowSel,1,&Text);
    gtk_entry_set_text(GTK_ENTRY (Entry),Text);
  }
  return FALSE;
}

/*** Ajouter un code analityque ***/
void
EdtPgx_AjoAna_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *EdtAna,*Widget;

  CREATE_MODE=TRUE;
  EdtAna=create_EdtCdeAna();
  Widget=lookup_widget(GTK_WIDGET(EdtAna),"AnaCode");
  gtk_widget_set_sensitive(GTK_WIDGET (Widget),TRUE);
  gtk_widget_show_all(EdtAna);
}

/*** Supprimer un code analytiqe ***/
void
EdtPgx_SuppAna_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *CList;
  gchar SqlCmd[120],*Text,*Gr[2],PsCle[LEN_COD_SOC+1];

  if (MsgQuestion("Suppression de ce code \nanalytique ?")==1) {
    CList=lookup_widget(GTK_WIDGET (ParamGenx),"LstAna");
    if ((DbLcpt!=NULL) && (CList!=NULL)) {
      GetSocRun(PsCle);
      gtk_clist_get_text(GTK_CLIST (CList),RowSel,0,&Text);
      sprintf(SqlCmd,"Delete From Analytique where AnaCode='%s' And AnaSoc='%s'",Text,PsCle);
      mysql_query(DbLcpt,SqlCmd);
      FreeCdeAna(ORG_ANA);
      ORG_ANA=LoadCdeAna();
      Analyt=ORG_ANA;
      gtk_clist_clear(GTK_CLIST (CList));
      while (Analyt!=NULL) {
	Gr[0]=Analyt->ID;
	Gr[1]=Analyt->Lib;
	gtk_clist_append(GTK_CLIST (CList),Gr);
	Analyt=Analyt->Su;
      }
    }
  }
}
/* La fentre principale ****************************************/
void EdtPgx_DispData(GtkWidget *ParamGenx)
{
  char SqlCmd[250],PsCle[LEN_COD_SOC+1];
  MYSQL_RES *MyRes;
  MYSQL_ROW Row;
  GtkWidget *CList;
  gchar *Gr[2];

  GetSocRun(PsCle);
  if (DbLcpt!=NULL) {
    sprintf(SqlCmd,"SELECT * FROM Pgx WHERE PgCle='%s'",PsCle);
    mysql_query(DbLcpt,SqlCmd);
    MyRes=mysql_store_result(DbLcpt);
    if (MyRes!=NULL) {
      Row=mysql_fetch_row(MyRes);
      StrSqlToGtk(GTK_WIDGET (ParamGenx),"PgSLett",Row[1]);
      StrSqlToGtk(GTK_WIDGET (ParamGenx),"PgSRel",Row[2]);
      BooleanSqlToGtk(GTK_WIDGET (ParamGenx),"PgLett",Row[3]);
      StrSqlToGtk(GTK_WIDGET (ParamGenx),"PgCdgc",Row[4]);
      StrSqlToGtk(GTK_WIDGET (ParamGenx),"PgPdgc",Row[5]);
      StrSqlToGtk(GTK_WIDGET (ParamGenx),"PgAtt",Row[6]);
      StrSqlToGtk(GTK_WIDGET (ParamGenx),"PgResul",Row[7]);
      StrSqlToGtk(GTK_WIDGET (ParamGenx),"PgResb",Row[8]);
      StrSqlToGtk(GTK_WIDGET (ParamGenx),"PgResp",Row[9]);
      StrSqlToGtk(GTK_WIDGET (ParamGenx),"PgJo",Row[10]);
      StrSqlToGtk(GTK_WIDGET (ParamGenx),"PgJc",Row[11]);
      StrSqlToGtk(GTK_WIDGET (ParamGenx),"PgOd",Row[12]);
      StrSqlToGtk(GTK_WIDGET (ParamGenx),"PgNoBo",Row[13]);
      BooleanSqlToGtk(GTK_WIDGET (ParamGenx),"PgAna",Row[14]);
      if (Row[14]!=NULL) {
	if (strcmp(Row[14],"Y")==0) EdtPgx_ActiveAna(TRUE); else EdtPgx_ActiveAna(FALSE);
      } else EdtPgx_ActiveAna(FALSE);
      StrSqlToGtk(GTK_WIDGET (ParamGenx),"PgPrinter",Row[16]);
      mysql_free_result(MyRes);
    } else MessageErreur("Sql erreur !");
    CList=lookup_widget(GTK_WIDGET (ParamGenx),"LstAna");
    if (CList!=NULL) {
      ORG_ANA=LoadCdeAna();
      Analyt=ORG_ANA;
      gtk_clist_clear(GTK_CLIST(CList));
      while (Analyt!=NULL) {
	Gr[0]=Analyt->ID;
	Gr[1]=Analyt->Lib;
	gtk_clist_append(GTK_CLIST(CList),Gr);
	Analyt=Analyt->Su;
      }
    }
  }
}
/* Validation Paramtres gnraux *******************************/
void
PG_BtOk_Clicked (GtkButton       *button,
                 gpointer         user_data)
{
  char SqlCmd[1000],*End,PsCle[LEN_COD_SOC+1];
  GtkWidget *Wcall;

  GetSocRun(PsCle);
  End=strmov(SqlCmd,"UPDATE Pgx Set PgSLett=");
  End=GtkToFloatSql(End,GTK_WIDGET (button),"PgSLett");
  End=strmov(End,",PgSRel=");
  End=GtkToFloatSql(End,GTK_WIDGET (button),"PgSRel");
  End=strmov(End,",PgLett=");
  End=GtkToBooleanSql(End,GTK_WIDGET (button),"PgLett");
  End=strmov(End,",PgCdgc=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"PgCdgc");
  End=strmov(End,",PgPdgc=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"PgPdgc");
  End=strmov(End,",PgAtt=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"PgAtt");
  End=strmov(End,",PgResul=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"PgResul");
  End=strmov(End,",PgResb=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"PgResb");
  End=strmov(End,",PgResp=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"PgResp");
  End=strmov(End,",PgJo=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"PgJo");
  End=strmov(End,",PgJc=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"PgJc");
  End=strmov(End,",PgOd=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"PgOd");
  End=strmov(End,",PgNoBo=");
  End=GtkToIntSql(End,GTK_WIDGET (button),"PgNoBo");
  End=strmov(End,",PgAna=");
  End=GtkToBooleanSql(End,GTK_WIDGET (button),"PgAna");
  End=strmov(End,",PgPrinter=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"PgPrinter");
  End=strmov(End," WHERE PgCle=");
  *End++='\'';
  End=strmov(End,PsCle);
  *End++='\'';
  *End='\0';
  if (mysql_query(DbLcpt,SqlCmd)!=0) MessageErreur("Modification praramtres impossible !");
  CloseDbLcpt();
  Wcall=lookup_widget(GTK_WIDGET (button),"ParamGenx");
  gtk_widget_destroy(GTK_WIDGET(Wcall));
}


void
PG_BtAnnul_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *Wcall;

  Wcall=lookup_widget(GTK_WIDGET (button),"ParamGenx");
  gtk_widget_destroy(GTK_WIDGET(Wcall));
  CloseDbLcpt();
}

void on_ParamGenx_show                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
  ParamGenx=widget;
  ORG_ANA=NULL;
}

void on_ParamGenx_destroy              (GtkObject        *widget,
                                        gpointer         user_data)
{
  FreeCdeAna(ORG_ANA);
}

void
EdtPgx_BtOdd_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  char Color[13];

  SelectColor(Color);
}


void
EdtPgx_BtEven_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  char Color[13];

  SelectColor(Color);
}


void
EdtPgx_BtSel_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  char Color[13];

  SelectColor(Color);
}


void
EdtPgx_BtColFont_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  char Color[13];

  SelectColor(Color);
}


void EdtPgx_SelFont_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  gchar Fonte[128];
  GtkWidget *Entry;

  if (SelectFont(Fonte)==MR_OK) {
    Entry=lookup_widget(GTK_WIDGET(ParamGenx),"EdtPgx_TextFont");
    gtk_entry_set_text(GTK_ENTRY (Entry),Fonte);
  }
}

void EdtPgx_ActiveAna(gboolean Active)
{
  GtkWidget *Widget;

  Widget=lookup_widget(GTK_WIDGET(ParamGenx),"LstAna");
  gtk_widget_set_sensitive(GTK_WIDGET(Widget),Active);
  Widget=lookup_widget(GTK_WIDGET(ParamGenx),"EdtPgx_AjoAna");
  gtk_widget_set_sensitive(GTK_WIDGET(Widget),Active);
  Widget=lookup_widget(GTK_WIDGET(ParamGenx),"EdtPgx_SuppAna");
  gtk_widget_set_sensitive(GTK_WIDGET(Widget),Active);
}

void
on_PgAna_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  EdtPgx_ActiveAna(togglebutton->active);
}

GtkWidget* create_ParamGenx (void)
{
  GtkWidget *ParamGenx;
  GtkWidget *fixed1;
  GtkWidget *PgSLett;
  GtkWidget *PgSRel;
  GtkWidget *BtOk;
  GtkWidget *BtAnnul;
  GtkWidget *PgCdgc;
  GtkWidget *PgPdgc;
  GtkWidget *PgAtt;
  GtkWidget *PgResul;
  GtkWidget *PgResb;
  GtkWidget *PgResp;
  GtkWidget *PgJo;
  GtkWidget *PgJc;
  GtkWidget *PgOd;
  GtkWidget *PgNoBo;
  GtkWidget *PgPrinter;
  GtkWidget *label21;
  GtkWidget *label22;
  GtkWidget *label23;
  GtkWidget *label26;
  GtkWidget *label25;
  GtkWidget *label24;
  GtkWidget *label27;
  GtkWidget *label28;
  GtkWidget *label29;
  GtkWidget *hseparator12;
  GtkWidget *label19;
  GtkWidget *label20;
  GtkWidget *label30;
  GtkWidget *label132;
  GtkWidget *PgLett;
  GtkWidget *vseparator6;
  GtkWidget *hseparator14;
  GtkWidget *hseparator13;
  GtkWidget *EdtPgx_AjoAna;
  GtkWidget *EdtPgx_SuppAna;
  GtkWidget *scrolledwindow8;
  GtkWidget *LstAna;
  GtkWidget *label130;
  GtkWidget *label131;
  GtkWidget *ColorOdd;
  GtkWidget *ColorEven;
  GtkWidget *ColorSel;
  GtkWidget *PgAna;
  GtkWidget *EdtPgx_TextFont;
  GtkWidget *label31;
  GtkWidget *EdtPgx_BtOdd;
  GtkWidget *label133;
  GtkWidget *EdtPgx_BtEven;
  GtkWidget *EdtPgx_BtSel;
  GtkWidget *EdtPgx_BtColFont;
  GtkWidget *FonteColor;
  GtkWidget *EdtPgx_SelFont;
  GtkWidget *hseparator7;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  ParamGenx = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (ParamGenx), "ParamGenx", ParamGenx);
  gtk_container_set_border_width (GTK_CONTAINER (ParamGenx), 4);
  gtk_window_set_title (GTK_WINDOW (ParamGenx), _("Paramtres gnraux"));
  gtk_window_set_position (GTK_WINDOW (ParamGenx), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (ParamGenx), TRUE);

  fixed1 = gtk_fixed_new ();
  gtk_widget_ref (fixed1);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "fixed1", fixed1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed1);
  gtk_container_add (GTK_CONTAINER (ParamGenx), fixed1);
  gtk_tooltips_set_tip (tooltips, fixed1, _("Supprimer code analytique"), NULL);

  PgSLett = gtk_entry_new ();
  gtk_widget_ref (PgSLett);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "PgSLett", PgSLett,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PgSLett);
  gtk_fixed_put (GTK_FIXED (fixed1), PgSLett, 112, 164);
  gtk_widget_set_uposition (PgSLett, 112, 164);
  gtk_widget_set_usize (PgSLett, 68, 20);

  PgSRel = gtk_entry_new ();
  gtk_widget_ref (PgSRel);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "PgSRel", PgSRel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PgSRel);
  gtk_fixed_put (GTK_FIXED (fixed1), PgSRel, 112, 192);
  gtk_widget_set_uposition (PgSRel, 112, 192);
  gtk_widget_set_usize (PgSRel, 68, 20);

  BtOk = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (BtOk);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "BtOk", BtOk,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtOk);
  gtk_fixed_put (GTK_FIXED (fixed1), BtOk, 308, 332);
  gtk_widget_set_uposition (BtOk, 308, 332);
  gtk_widget_set_usize (BtOk, 88, 24);

  BtAnnul = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (BtAnnul);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "BtAnnul", BtAnnul,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtAnnul);
  gtk_fixed_put (GTK_FIXED (fixed1), BtAnnul, 408, 332);
  gtk_widget_set_uposition (BtAnnul, 408, 332);
  gtk_widget_set_usize (BtAnnul, 88, 24);

  PgCdgc = gtk_entry_new ();
  gtk_widget_ref (PgCdgc);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "PgCdgc", PgCdgc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PgCdgc);
  gtk_fixed_put (GTK_FIXED (fixed1), PgCdgc, 156, 4);
  gtk_widget_set_uposition (PgCdgc, 156, 4);
  gtk_widget_set_usize (PgCdgc, 128, 20);

  PgPdgc = gtk_entry_new ();
  gtk_widget_ref (PgPdgc);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "PgPdgc", PgPdgc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PgPdgc);
  gtk_fixed_put (GTK_FIXED (fixed1), PgPdgc, 156, 28);
  gtk_widget_set_uposition (PgPdgc, 156, 28);
  gtk_widget_set_usize (PgPdgc, 128, 20);

  PgAtt = gtk_entry_new ();
  gtk_widget_ref (PgAtt);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "PgAtt", PgAtt,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PgAtt);
  gtk_fixed_put (GTK_FIXED (fixed1), PgAtt, 156, 52);
  gtk_widget_set_uposition (PgAtt, 156, 52);
  gtk_widget_set_usize (PgAtt, 128, 20);

  PgResul = gtk_entry_new ();
  gtk_widget_ref (PgResul);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "PgResul", PgResul,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PgResul);
  gtk_fixed_put (GTK_FIXED (fixed1), PgResul, 156, 76);
  gtk_widget_set_uposition (PgResul, 156, 76);
  gtk_widget_set_usize (PgResul, 128, 20);

  PgResb = gtk_entry_new ();
  gtk_widget_ref (PgResb);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "PgResb", PgResb,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PgResb);
  gtk_fixed_put (GTK_FIXED (fixed1), PgResb, 156, 100);
  gtk_widget_set_uposition (PgResb, 156, 100);
  gtk_widget_set_usize (PgResb, 128, 20);

  PgResp = gtk_entry_new ();
  gtk_widget_ref (PgResp);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "PgResp", PgResp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PgResp);
  gtk_fixed_put (GTK_FIXED (fixed1), PgResp, 156, 124);
  gtk_widget_set_uposition (PgResp, 156, 124);
  gtk_widget_set_usize (PgResp, 128, 20);

  PgJo = gtk_entry_new ();
  gtk_widget_ref (PgJo);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "PgJo", PgJo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PgJo);
  gtk_fixed_put (GTK_FIXED (fixed1), PgJo, 432, 4);
  gtk_widget_set_uposition (PgJo, 432, 4);
  gtk_widget_set_usize (PgJo, 32, 20);

  PgJc = gtk_entry_new ();
  gtk_widget_ref (PgJc);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "PgJc", PgJc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PgJc);
  gtk_fixed_put (GTK_FIXED (fixed1), PgJc, 432, 28);
  gtk_widget_set_uposition (PgJc, 432, 28);
  gtk_widget_set_usize (PgJc, 32, 20);

  PgOd = gtk_entry_new ();
  gtk_widget_ref (PgOd);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "PgOd", PgOd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PgOd);
  gtk_fixed_put (GTK_FIXED (fixed1), PgOd, 432, 52);
  gtk_widget_set_uposition (PgOd, 432, 52);
  gtk_widget_set_usize (PgOd, 32, 20);

  PgNoBo = gtk_entry_new ();
  gtk_widget_ref (PgNoBo);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "PgNoBo", PgNoBo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PgNoBo);
  gtk_fixed_put (GTK_FIXED (fixed1), PgNoBo, 432, 88);
  gtk_widget_set_uposition (PgNoBo, 432, 88);
  gtk_widget_set_usize (PgNoBo, 56, 20);

  PgPrinter = gtk_entry_new ();
  gtk_widget_ref (PgPrinter);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "PgPrinter", PgPrinter,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PgPrinter);
  gtk_fixed_put (GTK_FIXED (fixed1), PgPrinter, 76, 300);
  gtk_widget_set_uposition (PgPrinter, 76, 300);
  gtk_widget_set_usize (PgPrinter, 80, 20);

  label21 = gtk_label_new (_("Compte de rgul. Charge :"));
  gtk_widget_ref (label21);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "label21", label21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label21);
  gtk_fixed_put (GTK_FIXED (fixed1), label21, 4, 8);
  gtk_widget_set_uposition (label21, 4, 8);
  gtk_widget_set_usize (label21, 160, 16);
  gtk_misc_set_alignment (GTK_MISC (label21), 0, 0.5);

  label22 = gtk_label_new (_("Compte de rgul. Produit :"));
  gtk_widget_ref (label22);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "label22", label22,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label22);
  gtk_fixed_put (GTK_FIXED (fixed1), label22, 4, 32);
  gtk_widget_set_uposition (label22, 4, 32);
  gtk_widget_set_usize (label22, 160, 16);
  gtk_misc_set_alignment (GTK_MISC (label22), 0, 0.5);

  label23 = gtk_label_new (_("Compte d'attente :"));
  gtk_widget_ref (label23);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "label23", label23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label23);
  gtk_fixed_put (GTK_FIXED (fixed1), label23, 4, 56);
  gtk_widget_set_uposition (label23, 4, 56);
  gtk_widget_set_usize (label23, 104, 16);
  gtk_label_set_justify (GTK_LABEL (label23), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label23), 1.93715e-07, 0.5);

  label26 = gtk_label_new (_("Compte de perte :"));
  gtk_widget_ref (label26);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "label26", label26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label26);
  gtk_fixed_put (GTK_FIXED (fixed1), label26, 4, 128);
  gtk_widget_set_uposition (label26, 4, 128);
  gtk_widget_set_usize (label26, 112, 16);
  gtk_misc_set_alignment (GTK_MISC (label26), 0, 0.5);

  label25 = gtk_label_new (_("Compte de bnfice :"));
  gtk_widget_ref (label25);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "label25", label25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label25);
  gtk_fixed_put (GTK_FIXED (fixed1), label25, 4, 104);
  gtk_widget_set_uposition (label25, 4, 104);
  gtk_widget_set_usize (label25, 120, 16);
  gtk_misc_set_alignment (GTK_MISC (label25), 0, 0.5);

  label24 = gtk_label_new (_("Compte de rsultat :"));
  gtk_widget_ref (label24);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "label24", label24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label24);
  gtk_fixed_put (GTK_FIXED (fixed1), label24, 4, 80);
  gtk_widget_set_uposition (label24, 4, 80);
  gtk_widget_set_usize (label24, 120, 16);
  gtk_misc_set_alignment (GTK_MISC (label24), 0, 0.5);

  label27 = gtk_label_new (_("Journal d'ouverture :"));
  gtk_widget_ref (label27);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "label27", label27,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label27);
  gtk_fixed_put (GTK_FIXED (fixed1), label27, 304, 8);
  gtk_widget_set_uposition (label27, 304, 8);
  gtk_widget_set_usize (label27, 128, 16);
  gtk_misc_set_alignment (GTK_MISC (label27), 0, 0.5);

  label28 = gtk_label_new (_("Journal de clotre :"));
  gtk_widget_ref (label28);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "label28", label28,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label28);
  gtk_fixed_put (GTK_FIXED (fixed1), label28, 304, 32);
  gtk_widget_set_uposition (label28, 304, 32);
  gtk_widget_set_usize (label28, 128, 16);
  gtk_misc_set_alignment (GTK_MISC (label28), 0, 0.5);

  label29 = gtk_label_new (_("Journal d'OD"));
  gtk_widget_ref (label29);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "label29", label29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label29);
  gtk_fixed_put (GTK_FIXED (fixed1), label29, 304, 56);
  gtk_widget_set_uposition (label29, 304, 56);
  gtk_widget_set_usize (label29, 112, 16);
  gtk_misc_set_alignment (GTK_MISC (label29), 0, 0.5);

  hseparator12 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator12);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "hseparator12", hseparator12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator12);
  gtk_fixed_put (GTK_FIXED (fixed1), hseparator12, 0, 152);
  gtk_widget_set_uposition (hseparator12, 0, 152);
  gtk_widget_set_usize (hseparator12, 292, 16);

  label19 = gtk_label_new (_("Seuil de lettrage :"));
  gtk_widget_ref (label19);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "label19", label19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label19);
  gtk_fixed_put (GTK_FIXED (fixed1), label19, 0, 168);
  gtk_widget_set_uposition (label19, 0, 168);
  gtk_widget_set_usize (label19, 112, 16);

  label20 = gtk_label_new (_("Seuil de relance :"));
  gtk_widget_ref (label20);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "label20", label20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label20);
  gtk_fixed_put (GTK_FIXED (fixed1), label20, 4, 192);
  gtk_widget_set_uposition (label20, 4, 192);
  gtk_widget_set_usize (label20, 104, 16);

  label30 = gtk_label_new (_("Dernier numro de bordereau :"));
  gtk_widget_ref (label30);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "label30", label30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label30);
  gtk_fixed_put (GTK_FIXED (fixed1), label30, 304, 84);
  gtk_widget_set_uposition (label30, 304, 84);
  gtk_widget_set_usize (label30, 112, 32);
  gtk_label_set_line_wrap (GTK_LABEL (label30), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label30), 0, 0.5);

  label132 = gtk_label_new (_("Analytique"));
  gtk_widget_ref (label132);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "label132", label132,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label132);
  gtk_fixed_put (GTK_FIXED (fixed1), label132, 216, 164);
  gtk_widget_set_uposition (label132, 216, 164);
  gtk_widget_set_usize (label132, 80, 16);

  PgLett = gtk_check_button_new_with_label (_("Lettrage en saisie"));
  gtk_widget_ref (PgLett);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "PgLett", PgLett,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PgLett);
  gtk_fixed_put (GTK_FIXED (fixed1), PgLett, 304, 120);
  gtk_widget_set_uposition (PgLett, 304, 120);
  gtk_widget_set_usize (PgLett, 144, 16);

  vseparator6 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator6);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "vseparator6", vseparator6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator6);
  gtk_fixed_put (GTK_FIXED (fixed1), vseparator6, 284, 0);
  gtk_widget_set_uposition (vseparator6, 284, 0);
  gtk_widget_set_usize (vseparator6, 16, 160);

  hseparator14 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator14);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "hseparator14", hseparator14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator14);
  gtk_fixed_put (GTK_FIXED (fixed1), hseparator14, 288, 152);
  gtk_widget_set_uposition (hseparator14, 288, 152);
  gtk_widget_set_usize (hseparator14, 220, 16);

  hseparator13 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator13);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "hseparator13", hseparator13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator13);
  gtk_fixed_put (GTK_FIXED (fixed1), hseparator13, 292, 68);
  gtk_widget_set_uposition (hseparator13, 292, 68);
  gtk_widget_set_usize (hseparator13, 220, 16);

  EdtPgx_AjoAna = gtk_button_new_with_label (_("Ajouter"));
  gtk_widget_ref (EdtPgx_AjoAna);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "EdtPgx_AjoAna", EdtPgx_AjoAna,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtPgx_AjoAna);
  gtk_fixed_put (GTK_FIXED (fixed1), EdtPgx_AjoAna, 252, 296);
  gtk_widget_set_uposition (EdtPgx_AjoAna, 252, 296);
  gtk_widget_set_usize (EdtPgx_AjoAna, 72, 16);
  gtk_widget_set_sensitive (EdtPgx_AjoAna, FALSE);
  gtk_tooltips_set_tip (tooltips, EdtPgx_AjoAna, _("Ajouter code analytique"), NULL);

  EdtPgx_SuppAna = gtk_button_new_with_label (_("Supprimer"));
  gtk_widget_ref (EdtPgx_SuppAna);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "EdtPgx_SuppAna", EdtPgx_SuppAna,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtPgx_SuppAna);
  gtk_fixed_put (GTK_FIXED (fixed1), EdtPgx_SuppAna, 360, 296);
  gtk_widget_set_uposition (EdtPgx_SuppAna, 360, 296);
  gtk_widget_set_usize (EdtPgx_SuppAna, 80, 16);
  gtk_widget_set_sensitive (EdtPgx_SuppAna, FALSE);

  scrolledwindow8 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow8);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "scrolledwindow8", scrolledwindow8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow8);
  gtk_fixed_put (GTK_FIXED (fixed1), scrolledwindow8, 216, 180);
  gtk_widget_set_uposition (scrolledwindow8, 216, 180);
  gtk_widget_set_usize (scrolledwindow8, 292, 112);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow8), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  LstAna = gtk_clist_new (2);
  gtk_widget_ref (LstAna);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "LstAna", LstAna,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (LstAna);
  gtk_container_add (GTK_CONTAINER (scrolledwindow8), LstAna);
  gtk_widget_set_sensitive (LstAna, FALSE);
  gtk_clist_set_column_width (GTK_CLIST (LstAna), 0, 32);
  gtk_clist_set_column_width (GTK_CLIST (LstAna), 1, 80);
  gtk_clist_column_titles_show (GTK_CLIST (LstAna));

  label130 = gtk_label_new (_("Code"));
  gtk_widget_ref (label130);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "label130", label130,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label130);
  gtk_clist_set_column_widget (GTK_CLIST (LstAna), 0, label130);

  label131 = gtk_label_new (_("Libell"));
  gtk_widget_ref (label131);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "label131", label131,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label131);
  gtk_clist_set_column_widget (GTK_CLIST (LstAna), 1, label131);

  ColorOdd = gtk_drawing_area_new ();
  gtk_widget_ref (ColorOdd);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "ColorOdd", ColorOdd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ColorOdd);
  gtk_fixed_put (GTK_FIXED (fixed1), ColorOdd, 12, 252);
  gtk_widget_set_uposition (ColorOdd, 12, 252);
  gtk_widget_set_usize (ColorOdd, 20, 20);

  ColorEven = gtk_drawing_area_new ();
  gtk_widget_ref (ColorEven);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "ColorEven", ColorEven,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ColorEven);
  gtk_fixed_put (GTK_FIXED (fixed1), ColorEven, 64, 252);
  gtk_widget_set_uposition (ColorEven, 64, 252);
  gtk_widget_set_usize (ColorEven, 20, 20);

  ColorSel = gtk_drawing_area_new ();
  gtk_widget_ref (ColorSel);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "ColorSel", ColorSel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ColorSel);
  gtk_fixed_put (GTK_FIXED (fixed1), ColorSel, 108, 252);
  gtk_widget_set_uposition (ColorSel, 108, 252);
  gtk_widget_set_usize (ColorSel, 20, 20);

  PgAna = gtk_check_button_new_with_label (_("Comptabilit Analytique"));
  gtk_widget_ref (PgAna);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "PgAna", PgAna,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PgAna);
  gtk_fixed_put (GTK_FIXED (fixed1), PgAna, 304, 136);
  gtk_widget_set_uposition (PgAna, 304, 136);
  gtk_widget_set_usize (PgAna, 160, 24);

  EdtPgx_TextFont = gtk_entry_new ();
  gtk_widget_ref (EdtPgx_TextFont);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "EdtPgx_TextFont", EdtPgx_TextFont,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtPgx_TextFont);
  gtk_fixed_put (GTK_FIXED (fixed1), EdtPgx_TextFont, 52, 276);
  gtk_widget_set_uposition (EdtPgx_TextFont, 52, 276);
  gtk_widget_set_usize (EdtPgx_TextFont, 156, 20);
  gtk_entry_set_editable (GTK_ENTRY (EdtPgx_TextFont), FALSE);

  label31 = gtk_label_new (_("Imprimante :"));
  gtk_widget_ref (label31);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "label31", label31,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label31);
  gtk_fixed_put (GTK_FIXED (fixed1), label31, 0, 304);
  gtk_widget_set_uposition (label31, 0, 304);
  gtk_widget_set_usize (label31, 80, 16);

  EdtPgx_BtOdd = gtk_button_new_with_label (_("Pair"));
  gtk_widget_ref (EdtPgx_BtOdd);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "EdtPgx_BtOdd", EdtPgx_BtOdd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtPgx_BtOdd);
  gtk_fixed_put (GTK_FIXED (fixed1), EdtPgx_BtOdd, 4, 228);
  gtk_widget_set_uposition (EdtPgx_BtOdd, 4, 228);
  gtk_widget_set_usize (EdtPgx_BtOdd, 36, 20);

  label133 = gtk_label_new (_("Couleur de la grille de saisie :"));
  gtk_widget_ref (label133);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "label133", label133,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label133);
  gtk_fixed_put (GTK_FIXED (fixed1), label133, 4, 212);
  gtk_widget_set_uposition (label133, 4, 212);
  gtk_widget_set_usize (label133, 176, 16);
  gtk_misc_set_alignment (GTK_MISC (label133), 0, 0.5);

  EdtPgx_BtEven = gtk_button_new_with_label (_("Impair"));
  gtk_widget_ref (EdtPgx_BtEven);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "EdtPgx_BtEven", EdtPgx_BtEven,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtPgx_BtEven);
  gtk_fixed_put (GTK_FIXED (fixed1), EdtPgx_BtEven, 52, 228);
  gtk_widget_set_uposition (EdtPgx_BtEven, 52, 228);
  gtk_widget_set_usize (EdtPgx_BtEven, 40, 20);

  EdtPgx_BtSel = gtk_button_new_with_label (_("Sel."));
  gtk_widget_ref (EdtPgx_BtSel);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "EdtPgx_BtSel", EdtPgx_BtSel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtPgx_BtSel);
  gtk_fixed_put (GTK_FIXED (fixed1), EdtPgx_BtSel, 100, 228);
  gtk_widget_set_uposition (EdtPgx_BtSel, 100, 228);
  gtk_widget_set_usize (EdtPgx_BtSel, 36, 20);

  EdtPgx_BtColFont = gtk_button_new_with_label (_("Fonte"));
  gtk_widget_ref (EdtPgx_BtColFont);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "EdtPgx_BtColFont", EdtPgx_BtColFont,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtPgx_BtColFont);
  gtk_fixed_put (GTK_FIXED (fixed1), EdtPgx_BtColFont, 144, 228);
  gtk_widget_set_uposition (EdtPgx_BtColFont, 144, 228);
  gtk_widget_set_usize (EdtPgx_BtColFont, 36, 20);

  FonteColor = gtk_drawing_area_new ();
  gtk_widget_ref (FonteColor);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "FonteColor", FonteColor,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (FonteColor);
  gtk_fixed_put (GTK_FIXED (fixed1), FonteColor, 148, 252);
  gtk_widget_set_uposition (FonteColor, 148, 252);
  gtk_widget_set_usize (FonteColor, 24, 20);

  EdtPgx_SelFont = gtk_button_new_with_label (_("Fonte"));
  gtk_widget_ref (EdtPgx_SelFont);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "EdtPgx_SelFont", EdtPgx_SelFont,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtPgx_SelFont);
  gtk_fixed_put (GTK_FIXED (fixed1), EdtPgx_SelFont, 4, 280);
  gtk_widget_set_uposition (EdtPgx_SelFont, 4, 280);
  gtk_widget_set_usize (EdtPgx_SelFont, 44, 16);

  hseparator7 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator7);
  gtk_object_set_data_full (GTK_OBJECT (ParamGenx), "hseparator7", hseparator7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator7);
  gtk_fixed_put (GTK_FIXED (fixed1), hseparator7, 0, 316);
  gtk_widget_set_uposition (hseparator7, 0, 316);
  gtk_widget_set_usize (hseparator7, 508, 16);

  gtk_signal_connect (GTK_OBJECT (ParamGenx), "show",
                      GTK_SIGNAL_FUNC (on_ParamGenx_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ParamGenx), "destroy",
                      GTK_SIGNAL_FUNC (on_ParamGenx_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (BtOk), "clicked",
                      GTK_SIGNAL_FUNC (PG_BtOk_Clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (BtAnnul), "clicked",
                      GTK_SIGNAL_FUNC (PG_BtAnnul_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtPgx_AjoAna), "clicked",
                      GTK_SIGNAL_FUNC (EdtPgx_AjoAna_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtPgx_SuppAna), "clicked",
                      GTK_SIGNAL_FUNC (EdtPgx_SuppAna_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (LstAna), "select_row",
                      GTK_SIGNAL_FUNC (on_LstAna_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (LstAna), "button_press_event",
                      GTK_SIGNAL_FUNC (on_LstAna_button_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (PgAna), "toggled",
                      GTK_SIGNAL_FUNC (on_PgAna_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtPgx_BtOdd), "clicked",
                      GTK_SIGNAL_FUNC (EdtPgx_BtOdd_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtPgx_BtEven), "clicked",
                      GTK_SIGNAL_FUNC (EdtPgx_BtEven_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtPgx_BtSel), "clicked",
                      GTK_SIGNAL_FUNC (EdtPgx_BtSel_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtPgx_BtColFont), "clicked",
                      GTK_SIGNAL_FUNC (EdtPgx_BtColFont_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtPgx_SelFont), "clicked",
                      GTK_SIGNAL_FUNC (EdtPgx_SelFont_clicked),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (ParamGenx), "tooltips", tooltips);

  return ParamGenx;
}

void Dialog_ParamGenx(void)
{
  ParamGenx=create_ParamGenx();
  gtk_widget_show_all(ParamGenx);
  OpenDbLcpt();
  EdtPgx_DispData(ParamGenx);
}
