/*******************************************************************/
/* Comptabilit Analytique Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 22/03/02 - Edition des paramtres socits                      */
/* Fichier source                                                  */
/*******************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 


#include <gtk/gtk.h>
#include <gnome.h>
#include <string.h>
#include <ctype.h>
#include <mysql/mysql.h>
#include "support.h"
#include "common.h"
#include "gtksql.h"
#include "select.h"

#include "paramsoc.h"

/* Variables */
GtkWidget    *ParamSoc,*WinCompl;
listidlib    *ORG_REGL,*Regl;
gint         RowSel,ModalResult;
gboolean     CREATE_MODE;
/* Protos */
GtkWidget* create_ParamSoc (void);
void EdtPSoc_DispData(GtkWidget *ParamSoc);

void on_ParamSoc_show                  (GtkWidget       *widget,
                                        gpointer         user_data);

void on_ParamSoc_destroy               (GtkObject       *widget,
                                        gpointer         user_data);

void on_OkParamSoc_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void on_CancelParamSoc_clicked         (GtkButton       *button,
                                        gpointer         user_data);

void EdtSoc_AjoMr_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void EdtSoc_SuppMr_clicked             (GtkButton       *button,
                                        gpointer         user_data);
GtkWidget* create_EdtModeRegl (void);

void EdtSoc_MR_select_row              (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);
void
on_ModeRegl_show                       (GtkWidget       *widget,
                                        gpointer         user_data);
void
EdtMR_BtOk_clicked                     (GtkButton       *button,
                                        gpointer         user_data);

void
EdtMR_BtCancel_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
EdtPgx_MR_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);
gboolean
ModeRegl_button_press_event            (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

/*******/
GtkWidget* create_EdtSocCompl (void);
void Compl_BtApply(GtkButton *button,gpointer user_data);
void Compl_BtCancel(GtkButton *button,gpointer user_data);
void Compl_Periode(GtkEditable *Ed,gpointer user_data);
void Compl_DebutEx(GtkEditable *Ed,gpointer user_data);

/* MODE DE REGLEMENT ****************************************************/
GtkWidget* create_EdtModeRegl (void)
{
  GtkWidget *EdtModeRegl;
  GtkWidget *vbox9;
  GtkWidget *fixed8;
  GtkWidget *EdtMR_Code;
  GtkWidget *label79;
  GtkWidget *EdtMR_Lib;
  GtkWidget *label78;
  GtkWidget *hseparator6;
  GtkWidget *hbox10;
  GtkWidget *EdtMR_BtOk;
  GtkWidget *EdtPgx_BtCancel;

  EdtModeRegl = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (EdtModeRegl), "EdtModeRegl", EdtModeRegl);
  gtk_container_set_border_width (GTK_CONTAINER (EdtModeRegl), 4);
  gtk_window_set_title (GTK_WINDOW (EdtModeRegl), _("Mode de rglement"));
  gtk_window_set_position (GTK_WINDOW (EdtModeRegl), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (EdtModeRegl), TRUE);

  vbox9 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox9);
  gtk_object_set_data_full (GTK_OBJECT (EdtModeRegl), "vbox9", vbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox9);
  gtk_container_add (GTK_CONTAINER (EdtModeRegl), vbox9);

  fixed8 = gtk_fixed_new ();
  gtk_widget_ref (fixed8);
  gtk_object_set_data_full (GTK_OBJECT (EdtModeRegl), "fixed8", fixed8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed8);
  gtk_box_pack_start (GTK_BOX (vbox9), fixed8, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (fixed8), 3);

  EdtMR_Code = gtk_entry_new_with_max_length (2);
  gtk_widget_ref (EdtMR_Code);
  gtk_object_set_data_full (GTK_OBJECT (EdtModeRegl), "EdtMR_Code", EdtMR_Code,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtMR_Code);
  gtk_fixed_put (GTK_FIXED (fixed8), EdtMR_Code, 64, 8);
  gtk_widget_set_uposition (EdtMR_Code, 64, 8);
  gtk_widget_set_usize (EdtMR_Code, 28, 20);

  label79 = gtk_label_new (_("Libell :"));
  gtk_widget_ref (label79);
  gtk_object_set_data_full (GTK_OBJECT (EdtModeRegl), "label79", label79,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label79);
  gtk_fixed_put (GTK_FIXED (fixed8), label79, 4, 40);
  gtk_widget_set_uposition (label79, 4, 40);
  gtk_widget_set_usize (label79, 60, 16);

  EdtMR_Lib = gtk_entry_new_with_max_length (25);
  gtk_widget_ref (EdtMR_Lib);
  gtk_object_set_data_full (GTK_OBJECT (EdtModeRegl), "EdtMR_Lib", EdtMR_Lib,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtMR_Lib);
  gtk_fixed_put (GTK_FIXED (fixed8), EdtMR_Lib, 64, 36);
  gtk_widget_set_uposition (EdtMR_Lib, 64, 36);
  gtk_widget_set_usize (EdtMR_Lib, 158, 22);

  label78 = gtk_label_new (_("Code :"));
  gtk_widget_ref (label78);
  gtk_object_set_data_full (GTK_OBJECT (EdtModeRegl), "label78", label78,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label78);
  gtk_fixed_put (GTK_FIXED (fixed8), label78, 8, 12);
  gtk_widget_set_uposition (label78, 8, 12);
  gtk_widget_set_usize (label78, 41, 16);

  hseparator6 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator6);
  gtk_object_set_data_full (GTK_OBJECT (EdtModeRegl), "hseparator6", hseparator6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator6);
  gtk_fixed_put (GTK_FIXED (fixed8), hseparator6, 8, 60);
  gtk_widget_set_uposition (hseparator6, 8, 60);
  gtk_widget_set_usize (hseparator6, 232, 16);

  hbox10 = gtk_hbox_new (TRUE, 4);
  gtk_widget_ref (hbox10);
  gtk_object_set_data_full (GTK_OBJECT (EdtModeRegl), "hbox10", hbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox10);
  gtk_box_pack_start (GTK_BOX (vbox9), hbox10, FALSE, FALSE, 0);

  EdtMR_BtOk = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (EdtMR_BtOk);
  gtk_object_set_data_full (GTK_OBJECT (EdtModeRegl), "EdtMR_BtOk", EdtMR_BtOk,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtMR_BtOk);
  gtk_box_pack_start (GTK_BOX (hbox10), EdtMR_BtOk, FALSE, FALSE, 0);

  EdtPgx_BtCancel = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (EdtPgx_BtCancel);
  gtk_object_set_data_full (GTK_OBJECT (EdtModeRegl), "EdtPgx_BtCancel", EdtPgx_BtCancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtPgx_BtCancel);
  gtk_box_pack_start (GTK_BOX (hbox10), EdtPgx_BtCancel, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (EdtMR_BtOk), "clicked",
                      GTK_SIGNAL_FUNC (EdtMR_BtOk_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtPgx_BtCancel), "clicked",
                      GTK_SIGNAL_FUNC (EdtMR_BtCancel_clicked),
                      NULL);

  return EdtModeRegl;
}

gboolean
ModeRegl_button_press_event          (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  GtkWidget *EdtMr,*Entry;
  gchar *Text;

  if (event->type==GDK_2BUTTON_PRESS) {
    /*    if (gtk_clist_get_selection_info(GTK_CLIST (widget),event->x,event->y,&Row,&Column)) { */
    CREATE_MODE=FALSE;
    EdtMr=create_EdtModeRegl();
    gtk_widget_show(EdtMr);
    Entry=lookup_widget(GTK_WIDGET (EdtMr),"EdtMR_Code");
    gtk_clist_get_text(GTK_CLIST (widget),RowSel,0,&Text);
    gtk_entry_set_text(GTK_ENTRY (Entry),Text);
    gtk_widget_set_sensitive(GTK_WIDGET(Entry),FALSE);
    Entry=lookup_widget(GTK_WIDGET (EdtMr),"EdtMR_Lib");
    gtk_clist_get_text(GTK_CLIST (widget),RowSel,1,&Text);
    gtk_entry_set_text(GTK_ENTRY (Entry),Text);
  }
  return FALSE;
}

void EdtSoc_AjoMr_clicked(GtkButton *button,gpointer user_data)
{
  GtkWidget *EdtMr;

  CREATE_MODE=TRUE;
  EdtMr=create_EdtModeRegl();
  gtk_widget_show_all(EdtMr);
}

void EdtSoc_SuppMr_clicked(GtkButton *button,gpointer user_data)
{
  GtkWidget *CList;
  gchar SqlCmd[120],*Text,*Gr[2],PsCle[LEN_COD_SOC+1];

  if (MsgQuestion(_("Suppression de ce mode \nde rglement ?"))==1) {
    CList=lookup_widget(GTK_WIDGET (ParamSoc),"ModeRegl");
    if ((DbLcpt!=NULL) && (CList!=NULL)) {
      GetSocRun(PsCle);
      gtk_clist_get_text(GTK_CLIST (CList),RowSel,0,&Text);
      sprintf(SqlCmd,"Delete From ModeRegl where Code='%s' And Soc='%s'",Text,PsCle);
      if (mysql_query(DbLcpt,SqlCmd)!=0) MessageAlerte(_("Suppression impossible !"));
      FreeModRegl(ORG_REGL);
      LoadModRegl();
      Regl=ORG_REGL;
      gtk_clist_clear(GTK_CLIST (CList));
      while (Regl!=NULL) {
	Gr[0]=Regl->ID;
	Gr[1]=Regl->Lib;
	gtk_clist_append(GTK_CLIST (CList),Gr);
	Regl=Regl->Su;
      }
    }
  }
}

void EdtSoc_MR_select_row              (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  RowSel=row;
}

void
EdtMR_BtOk_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *Entry,*Wcall;
  GtkCList *CList;
  char Code[3],Lib[25],SqlCmd[120],PsCle[LEN_COD_SOC+1];
  gchar *Gr[2];

  Entry=lookup_widget(GTK_WIDGET (button),"EdtMR_Code");
  strcpy(Code,gtk_entry_get_text(GTK_ENTRY (Entry)));
  Entry=lookup_widget(GTK_WIDGET (button),"EdtMR_Lib");
  strcpy(Lib,gtk_entry_get_text(GTK_ENTRY (Entry)));
  GetSocRun(PsCle);
  if (CREATE_MODE==TRUE)
    sprintf(SqlCmd,"Insert into ModeRegl (Soc,Code,Libelle) Values ('%s','%s','%s')",PsCle,Code,Lib);
  else sprintf(SqlCmd,"Update ModeRegl Set Libelle='%s' where Soc='%s' and Code='%s'",Lib,PsCle,Code);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    CList=GTK_CLIST (lookup_widget(GTK_WIDGET (ParamSoc),"ModeRegl"));
    if ((DbLcpt!=NULL) && (CList!=NULL)) {
      FreeModRegl(ORG_REGL);
      LoadModRegl();
      Regl=ORG_REGL;
      gtk_clist_clear(CList);
      while (Regl!=NULL) {
	Gr[0]=Regl->ID;
	Gr[1]=Regl->Lib;
	gtk_clist_append(CList,Gr);
	Regl=Regl->Su;
      }
    }
  } else MessageErreur(_("Echec commande SQL !"));
  Wcall=lookup_widget(GTK_WIDGET (button),"EdtModeRegl");
  gtk_widget_destroy(Wcall);
}

void
EdtMR_BtCancel_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *Wcall;

  Wcall=lookup_widget(GTK_WIDGET (button),"EdtModeRegl");
  gtk_widget_destroy(GTK_WIDGET(Wcall));
}

/*************/
void EdtPSoc_DispData(GtkWidget *ParamSoc)
{
  char SqlCmd[250],PsCle[LEN_COD_SOC+1],Tmp[15];
  gchar *Gr2[2],*Gr6[6];
  MYSQL_RES *MyRes;
  MYSQL_ROW Row;
  GtkCList *CList;

  CList=GTK_CLIST (lookup_widget(GTK_WIDGET (ParamSoc),"ModeRegl"));
  if (DbLcpt!=NULL) {
    ORG_REGL=LoadModRegl();
    gtk_clist_clear(CList);
    Regl=ORG_REGL;
    while (Regl!=NULL) {
      Gr2[0]=Regl->ID;
      Gr2[1]=Regl->Lib;
      gtk_clist_append(CList,Gr2);
      Regl=Regl->Su;
    }
    /****/
    GetSocRun(PsCle);
    sprintf(SqlCmd,"SELECT * FROM Societe WHERE PsCle='%s'",PsCle);
    mysql_query(DbLcpt,SqlCmd);
    MyRes=mysql_store_result(DbLcpt);
    Row=mysql_fetch_row(MyRes);
    StrSqlToGtk(GTK_WIDGET (ParamSoc),"PsNom",Row[1]);
    StrSqlToGtk(GTK_WIDGET (ParamSoc),"PsAdr1",Row[2]);
    StrSqlToGtk(GTK_WIDGET (ParamSoc),"PsAdr2",Row[3]);
    StrSqlToGtk(GTK_WIDGET (ParamSoc),"PsTel",Row[4]);
    StrSqlToGtk(GTK_WIDGET (ParamSoc),"PsFax",Row[5]);
    StrSqlToGtk(GTK_WIDGET (ParamSoc),"PsTetCp",Row[6]);
    StrSqlToGtk(GTK_WIDGET (ParamSoc),"PsTetVil",Row[7]);
    StrSqlToGtk(GTK_WIDGET (ParamSoc),"PsDivers",Row[8]);
    BooleanSqlToGtk(GTK_WIDGET (ParamSoc),"PsRel",Row[9]);
    StrSqlToGtk(GTK_WIDGET (ParamSoc),"PsSiret",Row[10]);
    StrSqlToGtk(GTK_WIDGET (ParamSoc),"PsEuro",Row[17]);
    ComboSqlToGtk(GTK_WIDGET (ParamSoc),"PsDevise",Row[18]);
    BooleanSqlToGtk(GTK_WIDGET (ParamSoc),"PsLiaEch",Row[19]);
    mysql_free_result(MyRes);
    /****/
    CList=GTK_CLIST (lookup_widget(GTK_WIDGET (ParamSoc),"Histo"));
    sprintf(SqlCmd,"Select * From Histo Where HisSoc='%s'",PsCle);
    mysql_query(DbLcpt,SqlCmd);
    MyRes=mysql_store_result(DbLcpt);
    gtk_clist_clear(CList);
    while ((Row=mysql_fetch_row(MyRes))) {
      Gr6[0]=IsoToDate(Tmp,Row[2]);
      Gr6[1]=IsoToDate(Tmp,Row[3]);
      Gr6[2]=Row[4];
      Gr6[3]=Row[5];
      Gr6[4]=Row[6];
      Gr6[5]=Row[7];
      gtk_clist_append(CList,Gr6);
    }
    mysql_free_result(MyRes);
  }
}

/* Validation paramtres ***************************************/
void on_OkParamSoc_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  char SqlCmd[1000],*End,PsCle[LEN_COD_SOC+1];

  GetSocRun(PsCle);
  End=strmov(SqlCmd,"UPDATE Societe Set PsNom=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"PsNom");
  End=strmov(End,",PsAdr1=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"PsAdr1");
  End=strmov(End,",PsAdr2=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"PsAdr2");
  End=strmov(End,",PsTel=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"PsTel");
  End=strmov(End,",PsFax=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"PsFax");
  End=strmov(End,",PsTetCp=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"PsTetCp");
  End=strmov(End,",PsTetVil=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"PsTetVil");
  End=strmov(End,",PsDivers=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"PsDivers");
  End=strmov(End,",PsSiret=");
  End=GtkToStrSql(End,GTK_WIDGET (button),"PsSiret");
  End=strmov(End,",PsRel=");
  End=GtkToBooleanSql(End,GTK_WIDGET (button),"PsRel");
  End=strmov(End,",PsEuro=");
  End=GtkToFloatSql(End,GTK_WIDGET (button),"PsEuro");
  End=strmov(End,",PsDevise=");
  End=GtkToComboSql(End,GTK_WIDGET (button),"PsDevise");
  End=strmov(End,",PsLiaEch=");
  End=GtkToBooleanSql(End,GTK_WIDGET (button),"PsLiaEch");
  End=strmov(End," WHERE PsCle=");
  *End++='\'';
  End=strmov(End,PsCle);
  *End++='\'';
  *End='\0';
  if (mysql_query(DbLcpt,SqlCmd)!=0) MessageErreur(_("Modification des paramtres impossible !"));
  ModalResult=MR_OK;
  gtk_widget_destroy(GTK_WIDGET(ParamSoc));
}


void
on_CancelParamSoc_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  ModalResult=MR_CANCEL;
  gtk_widget_destroy(GTK_WIDGET(ParamSoc));
}


void on_ParamSoc_show                  (GtkWidget       *widget,
                                        gpointer         user_data)
{
  OpenDbLcpt();
}

void on_ParamSoc_destroy               (GtkObject       *widget,
                                        gpointer         user_data)
{
  FreeModRegl(ORG_REGL);
  CloseDbLcpt();
}

GtkWidget* create_ParamSoc (void)
{
  GtkWidget *ParamSoc;
  GtkWidget *Grille;
  GtkWidget *PsNom;
  GtkWidget *OkParamSoc;
  GtkWidget *CancelParamSoc;
  GtkWidget *PsAdr1;
  GtkWidget *PsTetCp;
  GtkWidget *PsTetVil;
  GtkWidget *PsEuro;
  GtkWidget *PsTel;
  GtkWidget *PsDivers;
  GtkWidget *Histo;
  GtkWidget *label5;
  GtkWidget *label6;
  GtkWidget *label7;
  GtkWidget *label8;
  GtkWidget *label9;
  GtkWidget *label10;
  GtkWidget *PsSiret;
  GtkWidget *hseparator4;
  GtkWidget *hseparator5;
  GtkWidget *PsRel;
  GtkWidget *vseparator3;
  GtkWidget *label18;
  GtkWidget *EdtSoc_AjoMr;
  GtkWidget *EdtSoc_SuppMr;
  GtkWidget *scrolledwindow3;
  GtkWidget *ModeRegl;
  GtkWidget *label15;
  GtkWidget *label16;
  GtkWidget *label13;
  GtkWidget *label11;
  GtkWidget *label36;
  GtkWidget *label37;
  GtkWidget *PsAdr2;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *PsFax;
  GtkWidget *label125;
  GtkWidget *label12;
  GtkWidget *PsDevise;
  GList *PsDevise_items = NULL;
  GtkWidget *combo_entry5;
  GtkWidget *PsLiaEch;
  GtkAccelGroup *accel_group;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  accel_group = gtk_accel_group_new ();

  ParamSoc = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (ParamSoc), "ParamSoc", ParamSoc);
  gtk_container_set_border_width (GTK_CONTAINER (ParamSoc), 8);
  gtk_window_set_title (GTK_WINDOW (ParamSoc), _("Paramtres socit"));
  gtk_window_set_position (GTK_WINDOW (ParamSoc), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (ParamSoc), TRUE);

  Grille = gtk_fixed_new ();
  gtk_widget_ref (Grille);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "Grille", Grille,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Grille);
  gtk_container_add (GTK_CONTAINER (ParamSoc), Grille);

  PsNom = gtk_entry_new ();
  gtk_widget_ref (PsNom);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "PsNom", PsNom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PsNom);
  gtk_fixed_put (GTK_FIXED (Grille), PsNom, 64, 0);
  gtk_widget_set_uposition (PsNom, 64, 0);
  gtk_widget_set_usize (PsNom, 216, 20);

  OkParamSoc = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (OkParamSoc);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "OkParamSoc", OkParamSoc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (OkParamSoc);
  gtk_fixed_put (GTK_FIXED (Grille), OkParamSoc, 320, 360);
  gtk_widget_set_uposition (OkParamSoc, 320, 360);
  gtk_widget_set_usize (OkParamSoc, 80, 24);

  CancelParamSoc = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (CancelParamSoc);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "CancelParamSoc", CancelParamSoc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CancelParamSoc);
  gtk_fixed_put (GTK_FIXED (Grille), CancelParamSoc, 416, 360);
  gtk_widget_set_uposition (CancelParamSoc, 416, 360);
  gtk_widget_set_usize (CancelParamSoc, 80, 24);

  PsAdr1 = gtk_entry_new ();
  gtk_widget_ref (PsAdr1);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "PsAdr1", PsAdr1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PsAdr1);
  gtk_fixed_put (GTK_FIXED (Grille), PsAdr1, 64, 24);
  gtk_widget_set_uposition (PsAdr1, 64, 24);
  gtk_widget_set_usize (PsAdr1, 216, 24);

  PsTetCp = gtk_entry_new_with_max_length (5);
  gtk_widget_ref (PsTetCp);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "PsTetCp", PsTetCp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PsTetCp);
  gtk_fixed_put (GTK_FIXED (Grille), PsTetCp, 64, 80);
  gtk_widget_set_uposition (PsTetCp, 64, 80);
  gtk_widget_set_usize (PsTetCp, 48, 20);

  PsTetVil = gtk_entry_new ();
  gtk_widget_ref (PsTetVil);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "PsTetVil", PsTetVil,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PsTetVil);
  gtk_fixed_put (GTK_FIXED (Grille), PsTetVil, 120, 80);
  gtk_widget_set_uposition (PsTetVil, 120, 80);
  gtk_widget_set_usize (PsTetVil, 152, 20);

  PsEuro = gtk_entry_new ();
  gtk_widget_ref (PsEuro);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "PsEuro", PsEuro,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PsEuro);
  gtk_fixed_put (GTK_FIXED (Grille), PsEuro, 216, 220);
  gtk_widget_set_uposition (PsEuro, 216, 220);
  gtk_widget_set_usize (PsEuro, 68, 20);

  PsTel = gtk_entry_new ();
  gtk_widget_ref (PsTel);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "PsTel", PsTel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PsTel);
  gtk_fixed_put (GTK_FIXED (Grille), PsTel, 64, 104);
  gtk_widget_set_uposition (PsTel, 64, 104);
  gtk_widget_set_usize (PsTel, 104, 20);

  PsDivers = gtk_entry_new ();
  gtk_widget_ref (PsDivers);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "PsDivers", PsDivers,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PsDivers);
  gtk_fixed_put (GTK_FIXED (Grille), PsDivers, 64, 128);
  gtk_widget_set_uposition (PsDivers, 64, 128);
  gtk_widget_set_usize (PsDivers, 216, 20);

  Histo = gtk_clist_new (6);
  gtk_widget_ref (Histo);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "Histo", Histo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Histo);
  gtk_fixed_put (GTK_FIXED (Grille), Histo, 32, 248);
  gtk_widget_set_uposition (Histo, 32, 248);
  gtk_widget_set_usize (Histo, 416, 96);
  gtk_clist_set_column_width (GTK_CLIST (Histo), 0, 74);
  gtk_clist_set_column_width (GTK_CLIST (Histo), 1, 72);
  gtk_clist_set_column_width (GTK_CLIST (Histo), 2, 38);
  gtk_clist_set_column_width (GTK_CLIST (Histo), 3, 55);
  gtk_clist_set_column_width (GTK_CLIST (Histo), 4, 66);
  gtk_clist_set_column_width (GTK_CLIST (Histo), 5, 70);
  gtk_clist_column_titles_show (GTK_CLIST (Histo));

  label5 = gtk_label_new (_("Dbut"));
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_clist_set_column_widget (GTK_CLIST (Histo), 0, label5);

  label6 = gtk_label_new (_("Fin"));
  gtk_widget_ref (label6);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "label6", label6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label6);
  gtk_clist_set_column_widget (GTK_CLIST (Histo), 1, label6);

  label7 = gtk_label_new (_("Pr."));
  gtk_widget_ref (label7);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "label7", label7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label7);
  gtk_clist_set_column_widget (GTK_CLIST (Histo), 2, label7);

  label8 = gtk_label_new (_("Eff. moyen"));
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_clist_set_column_widget (GTK_CLIST (Histo), 3, label8);

  label9 = gtk_label_new (_("Taux IS"));
  gtk_widget_ref (label9);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "label9", label9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label9);
  gtk_clist_set_column_widget (GTK_CLIST (Histo), 4, label9);

  label10 = gtk_label_new (_("Exo. IS"));
  gtk_widget_ref (label10);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "label10", label10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label10);
  gtk_clist_set_column_widget (GTK_CLIST (Histo), 5, label10);

  PsSiret = gtk_entry_new ();
  gtk_widget_ref (PsSiret);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "PsSiret", PsSiret,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PsSiret);
  gtk_fixed_put (GTK_FIXED (Grille), PsSiret, 64, 152);
  gtk_widget_set_uposition (PsSiret, 64, 152);
  gtk_widget_set_usize (PsSiret, 136, 20);

  hseparator4 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator4);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "hseparator4", hseparator4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator4);
  gtk_fixed_put (GTK_FIXED (Grille), hseparator4, 12, 344);
  gtk_widget_set_uposition (hseparator4, 12, 344);
  gtk_widget_set_usize (hseparator4, 480, 16);

  hseparator5 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator5);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "hseparator5", hseparator5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator5);
  gtk_fixed_put (GTK_FIXED (Grille), hseparator5, 8, 168);
  gtk_widget_set_uposition (hseparator5, 8, 168);
  gtk_widget_set_usize (hseparator5, 280, 16);

  PsRel = gtk_check_button_new_with_label (_("Entte sur relance"));
  gtk_widget_ref (PsRel);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "PsRel", PsRel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PsRel);
  gtk_fixed_put (GTK_FIXED (Grille), PsRel, 24, 180);
  gtk_widget_set_uposition (PsRel, 24, 180);
  gtk_widget_set_usize (PsRel, 144, 16);

  vseparator3 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator3);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "vseparator3", vseparator3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator3);
  gtk_fixed_put (GTK_FIXED (Grille), vseparator3, 280, 0);
  gtk_widget_set_uposition (vseparator3, 280, 0);
  gtk_widget_set_usize (vseparator3, 16, 240);

  label18 = gtk_label_new (_("Modes de rglement :"));
  gtk_widget_ref (label18);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "label18", label18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label18);
  gtk_fixed_put (GTK_FIXED (Grille), label18, 296, 0);
  gtk_widget_set_uposition (label18, 296, 0);
  gtk_widget_set_usize (label18, 120, 16);
  gtk_label_set_justify (GTK_LABEL (label18), GTK_JUSTIFY_LEFT);

  EdtSoc_AjoMr = gtk_button_new_with_label (_("Ajouter"));
  gtk_widget_ref (EdtSoc_AjoMr);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "EdtSoc_AjoMr", EdtSoc_AjoMr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtSoc_AjoMr);
  gtk_fixed_put (GTK_FIXED (Grille), EdtSoc_AjoMr, 320, 208);
  gtk_widget_set_uposition (EdtSoc_AjoMr, 320, 208);
  gtk_widget_set_usize (EdtSoc_AjoMr, 56, 20);
  gtk_tooltips_set_tip (tooltips, EdtSoc_AjoMr, _("Ajouter un mode de rglement."), NULL);
  gtk_widget_add_accelerator (EdtSoc_AjoMr, "clicked", accel_group,
                              GDK_F2, 0,
                              GTK_ACCEL_VISIBLE);

  EdtSoc_SuppMr = gtk_button_new_with_label (_("Supp."));
  gtk_widget_ref (EdtSoc_SuppMr);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "EdtSoc_SuppMr", EdtSoc_SuppMr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtSoc_SuppMr);
  gtk_fixed_put (GTK_FIXED (Grille), EdtSoc_SuppMr, 416, 208);
  gtk_widget_set_uposition (EdtSoc_SuppMr, 416, 208);
  gtk_widget_set_usize (EdtSoc_SuppMr, 54, 22);
  gtk_tooltips_set_tip (tooltips, EdtSoc_SuppMr, _("Supprimer un mode de rglement."), NULL);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow3);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "scrolledwindow3", scrolledwindow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_fixed_put (GTK_FIXED (Grille), scrolledwindow3, 296, 16);
  gtk_widget_set_uposition (scrolledwindow3, 296, 16);
  gtk_widget_set_usize (scrolledwindow3, 200, 184);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  ModeRegl = gtk_clist_new (2);
  gtk_widget_ref (ModeRegl);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "ModeRegl", ModeRegl,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ModeRegl);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), ModeRegl);
  gtk_widget_set_usize (ModeRegl, 200, 80);
  gtk_tooltips_set_tip (tooltips, ModeRegl, _("Double cliquer pour modifier."), NULL);
  gtk_clist_set_column_width (GTK_CLIST (ModeRegl), 0, 31);
  gtk_clist_set_column_width (GTK_CLIST (ModeRegl), 1, 80);
  gtk_clist_column_titles_show (GTK_CLIST (ModeRegl));

  label15 = gtk_label_new (_("Code"));
  gtk_widget_ref (label15);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "label15", label15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label15);
  gtk_clist_set_column_widget (GTK_CLIST (ModeRegl), 0, label15);

  label16 = gtk_label_new (_("Libell"));
  gtk_widget_ref (label16);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "label16", label16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label16);
  gtk_clist_set_column_widget (GTK_CLIST (ModeRegl), 1, label16);

  label13 = gtk_label_new (_("Tl/Fax :"));
  gtk_widget_ref (label13);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "label13", label13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label13);
  gtk_fixed_put (GTK_FIXED (Grille), label13, 0, 108);
  gtk_widget_set_uposition (label13, 0, 108);
  gtk_widget_set_usize (label13, 56, 16);

  label11 = gtk_label_new (_("CP/Ville :"));
  gtk_widget_ref (label11);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "label11", label11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label11);
  gtk_fixed_put (GTK_FIXED (Grille), label11, 0, 84);
  gtk_widget_set_uposition (label11, 0, 84);
  gtk_widget_set_usize (label11, 56, 16);

  label36 = gtk_label_new (_("Divers :"));
  gtk_widget_ref (label36);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "label36", label36,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label36);
  gtk_fixed_put (GTK_FIXED (Grille), label36, 8, 132);
  gtk_widget_set_uposition (label36, 8, 132);
  gtk_widget_set_usize (label36, 49, 16);

  label37 = gtk_label_new (_("Siret :"));
  gtk_widget_ref (label37);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "label37", label37,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label37);
  gtk_fixed_put (GTK_FIXED (Grille), label37, 8, 156);
  gtk_widget_set_uposition (label37, 8, 156);
  gtk_widget_set_usize (label37, 49, 16);

  PsAdr2 = gtk_entry_new ();
  gtk_widget_ref (PsAdr2);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "PsAdr2", PsAdr2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PsAdr2);
  gtk_fixed_put (GTK_FIXED (Grille), PsAdr2, 64, 52);
  gtk_widget_set_uposition (PsAdr2, 64, 52);
  gtk_widget_set_usize (PsAdr2, 216, 24);

  label1 = gtk_label_new (_("Nom :"));
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_fixed_put (GTK_FIXED (Grille), label1, 24, 4);
  gtk_widget_set_uposition (label1, 24, 4);
  gtk_widget_set_usize (label1, 34, 16);

  label2 = gtk_label_new (_("Adresse :"));
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_fixed_put (GTK_FIXED (Grille), label2, 0, 28);
  gtk_widget_set_uposition (label2, 0, 28);
  gtk_widget_set_usize (label2, 56, 16);

  PsFax = gtk_entry_new ();
  gtk_widget_ref (PsFax);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "PsFax", PsFax,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PsFax);
  gtk_fixed_put (GTK_FIXED (Grille), PsFax, 172, 104);
  gtk_widget_set_uposition (PsFax, 172, 104);
  gtk_widget_set_usize (PsFax, 104, 20);

  label125 = gtk_label_new (_("Devise :"));
  gtk_widget_ref (label125);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "label125", label125,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label125);
  gtk_fixed_put (GTK_FIXED (Grille), label125, 16, 224);
  gtk_widget_set_uposition (label125, 16, 224);
  gtk_widget_set_usize (label125, 48, 16);

  label12 = gtk_label_new (_("Valeur de l'euro :"));
  gtk_widget_ref (label12);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "label12", label12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label12);
  gtk_fixed_put (GTK_FIXED (Grille), label12, 112, 224);
  gtk_widget_set_uposition (label12, 112, 224);
  gtk_widget_set_usize (label12, 108, 16);
  gtk_label_set_justify (GTK_LABEL (label12), GTK_JUSTIFY_LEFT);

  PsDevise = gtk_combo_new ();
  gtk_widget_ref (PsDevise);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "PsDevise", PsDevise,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PsDevise);
  gtk_fixed_put (GTK_FIXED (Grille), PsDevise, 64, 220);
  gtk_widget_set_uposition (PsDevise, 64, 220);
  gtk_widget_set_usize (PsDevise, 44, 20);
  gtk_combo_set_value_in_list (GTK_COMBO (PsDevise), TRUE, TRUE);
  PsDevise_items = g_list_append (PsDevise_items, (gpointer) _("FR"));
  gtk_combo_set_popdown_strings (GTK_COMBO (PsDevise), PsDevise_items);
  g_list_free (PsDevise_items);

  combo_entry5 = GTK_COMBO (PsDevise)->entry;
  gtk_widget_ref (combo_entry5);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "combo_entry5", combo_entry5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_entry5);
  gtk_entry_set_text (GTK_ENTRY (combo_entry5), _("FR"));

  PsLiaEch = gtk_check_button_new_with_label (_("Liaison chancier"));
  gtk_widget_ref (PsLiaEch);
  gtk_object_set_data_full (GTK_OBJECT (ParamSoc), "PsLiaEch", PsLiaEch,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (PsLiaEch);
  gtk_fixed_put (GTK_FIXED (Grille), PsLiaEch, 24, 200);
  gtk_widget_set_uposition (PsLiaEch, 24, 200);
  gtk_widget_set_usize (PsLiaEch, 136, 16);

  gtk_signal_connect (GTK_OBJECT (ParamSoc), "show",
                      GTK_SIGNAL_FUNC (on_ParamSoc_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ParamSoc), "destroy",
                      GTK_SIGNAL_FUNC (on_ParamSoc_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (OkParamSoc), "clicked",
                      GTK_SIGNAL_FUNC (on_OkParamSoc_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (CancelParamSoc), "clicked",
                      GTK_SIGNAL_FUNC (on_CancelParamSoc_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtSoc_AjoMr), "clicked",
                      GTK_SIGNAL_FUNC (EdtSoc_AjoMr_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdtSoc_SuppMr), "clicked",
                      GTK_SIGNAL_FUNC (EdtSoc_SuppMr_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ModeRegl), "select_row",
                      GTK_SIGNAL_FUNC (EdtSoc_MR_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ModeRegl), "button_press_event",
                      GTK_SIGNAL_FUNC (ModeRegl_button_press_event),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (ParamSoc), "tooltips", tooltips);

  gtk_window_add_accel_group (GTK_WINDOW (ParamSoc), accel_group);

  return ParamSoc;
}

void Dialog_ParamSoc(void)
{
  ORG_REGL=NULL;
  ParamSoc=create_ParamSoc();
  gtk_widget_show_all(ParamSoc);
  EdtPSoc_DispData(ParamSoc);
  ModalResult=MR_NONE;
  while (ModalResult==MR_NONE)
    if (gtk_events_pending()) gtk_main_iteration();
}

/**********************************************************************/
/* Paramtres complmentaires socit *********************************/

GtkWidget* create_EdtSocCompl (void)
{
  GtkWidget *EdtSocCompl;
  GtkWidget *MainVBox;
  GtkWidget *EntryFixed;
  GtkWidget *label1;
  GtkWidget *DebExercice;
  GtkWidget *label2;
  GtkWidget *FinExercice;
  GtkWidget *label4;
  GtkWidget *label3;
  GtkObject *Periode_adj;
  GtkWidget *Periode;
  GtkWidget *label5;
  GtkWidget *Effectif;
  GtkWidget *hseparator1;
  GtkWidget *ButtonFixed;
  GtkWidget *BtApply;
  GtkWidget *BtCancel;

  EdtSocCompl = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (EdtSocCompl), "EdtSocCompl", EdtSocCompl);
  gtk_window_set_title (GTK_WINDOW (EdtSocCompl), _("Paramtres complmentaires"));
  gtk_window_set_position (GTK_WINDOW (EdtSocCompl), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (EdtSocCompl), TRUE);

  MainVBox = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (MainVBox);
  gtk_object_set_data_full (GTK_OBJECT (EdtSocCompl), "MainVBox", MainVBox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (MainVBox);
  gtk_container_add (GTK_CONTAINER (EdtSocCompl), MainVBox);

  EntryFixed = gtk_fixed_new ();
  gtk_widget_ref (EntryFixed);
  gtk_object_set_data_full (GTK_OBJECT (EdtSocCompl), "EntryFixed", EntryFixed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EntryFixed);
  gtk_box_pack_start (GTK_BOX (MainVBox), EntryFixed, TRUE, TRUE, 0);

  label1 = gtk_label_new (_("Dbut exercice :"));
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (EdtSocCompl), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_fixed_put (GTK_FIXED (EntryFixed), label1, 12, 12);
  gtk_widget_set_uposition (label1, 12, 12);
  gtk_widget_set_usize (label1, 100, 16);
  gtk_misc_set_alignment (GTK_MISC (label1), 0, 0.5);

  DebExercice = gtk_entry_new ();
  gtk_widget_ref (DebExercice);
  gtk_object_set_data_full (GTK_OBJECT (EdtSocCompl), "DebExercice", DebExercice,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (DebExercice);
  gtk_fixed_put (GTK_FIXED (EntryFixed), DebExercice, 112, 8);
  gtk_widget_set_uposition (DebExercice, 112, 8);
  gtk_widget_set_usize (DebExercice, 96, 20);

  label2 = gtk_label_new (_("Fin d'exercice :"));
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (EdtSocCompl), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_fixed_put (GTK_FIXED (EntryFixed), label2, 220, 12);
  gtk_widget_set_uposition (label2, 220, 12);
  gtk_widget_set_usize (label2, 96, 16);
  gtk_misc_set_alignment (GTK_MISC (label2), 0, 0.5);

  FinExercice = gtk_entry_new ();
  gtk_widget_ref (FinExercice);
  gtk_object_set_data_full (GTK_OBJECT (EdtSocCompl), "FinExercice", FinExercice,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (FinExercice);
  gtk_fixed_put (GTK_FIXED (EntryFixed), FinExercice, 312, 8);
  gtk_widget_set_uposition (FinExercice, 312, 8);
  gtk_widget_set_usize (FinExercice, 96, 20);

  label4 = gtk_label_new (_("Priode :"));
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (EdtSocCompl), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_fixed_put (GTK_FIXED (EntryFixed), label4, 12, 36);
  gtk_widget_set_uposition (label4, 12, 36);
  gtk_widget_set_usize (label4, 60, 16);
  gtk_misc_set_alignment (GTK_MISC (label4), 0, 0.5);

  label3 = gtk_label_new (_("Effectif moyen :"));
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (EdtSocCompl), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_fixed_put (GTK_FIXED (EntryFixed), label3, 12, 64);
  gtk_widget_set_uposition (label3, 12, 64);
  gtk_widget_set_usize (label3, 92, 16);
  gtk_misc_set_alignment (GTK_MISC (label3), 0, 0.5);

  Periode_adj = gtk_adjustment_new (12, 1, 12, 1, 5, 5);
  Periode = gtk_spin_button_new (GTK_ADJUSTMENT (Periode_adj), 1, 0);
  gtk_widget_ref (Periode);
  gtk_object_set_data_full (GTK_OBJECT (EdtSocCompl), "Periode", Periode,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Periode);
  gtk_fixed_put (GTK_FIXED (EntryFixed), Periode, 64, 32);
  gtk_widget_set_uposition (Periode, 64, 32);
  gtk_widget_set_usize (Periode, 45, 22);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (Periode), TRUE);

  label5 = gtk_label_new (_("mois"));
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (EdtSocCompl), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_fixed_put (GTK_FIXED (EntryFixed), label5, 112, 36);
  gtk_widget_set_uposition (label5, 112, 36);
  gtk_widget_set_usize (label5, 34, 16);

  Effectif = gtk_entry_new_with_max_length (2);
  gtk_widget_ref (Effectif);
  gtk_object_set_data_full (GTK_OBJECT (EdtSocCompl), "Effectif", Effectif,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Effectif);
  gtk_fixed_put (GTK_FIXED (EntryFixed), Effectif, 104, 60);
  gtk_widget_set_uposition (Effectif, 104, 60);
  gtk_widget_set_usize (Effectif, 44, 20);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (EdtSocCompl), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator1);
  gtk_fixed_put (GTK_FIXED (EntryFixed), hseparator1, 8, 88);
  gtk_widget_set_uposition (hseparator1, 8, 88);
  gtk_widget_set_usize (hseparator1, 412, 16);

  ButtonFixed = gtk_fixed_new ();
  gtk_widget_ref (ButtonFixed);
  gtk_object_set_data_full (GTK_OBJECT (EdtSocCompl), "ButtonFixed", ButtonFixed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ButtonFixed);
  gtk_box_pack_start (GTK_BOX (MainVBox), ButtonFixed, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (ButtonFixed), 2);

  BtApply = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (BtApply);
  gtk_object_set_data_full (GTK_OBJECT (EdtSocCompl), "BtApply", BtApply,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtApply);
  gtk_fixed_put (GTK_FIXED (ButtonFixed), BtApply, 248, 8);
  gtk_widget_set_uposition (BtApply, 248, 8);
  gtk_widget_set_usize (BtApply, 80, 28);

  BtCancel = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (BtCancel);
  gtk_object_set_data_full (GTK_OBJECT (EdtSocCompl), "BtCancel", BtCancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtCancel);
  gtk_fixed_put (GTK_FIXED (ButtonFixed), BtCancel, 348, 8);
  gtk_widget_set_uposition (BtCancel, 348, 8);
  gtk_widget_set_usize (BtCancel, 76, 28);

  gtk_signal_connect (GTK_OBJECT (DebExercice), "insert_text",
                      GTK_SIGNAL_FUNC (ControleSaisieDate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (FinExercice), "insert_text",
                      GTK_SIGNAL_FUNC (ControleSaisieDate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Effectif), "insert_text",
                      GTK_SIGNAL_FUNC (ControleSaisieInteger),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (BtApply), "clicked",
                      GTK_SIGNAL_FUNC (Compl_BtApply),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (BtCancel), "clicked",
                      GTK_SIGNAL_FUNC (Compl_BtCancel),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Periode), "changed",
                      GTK_SIGNAL_FUNC (Compl_Periode),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (DebExercice), "changed",
                      GTK_SIGNAL_FUNC (Compl_DebutEx),
                      NULL);

  return EdtSocCompl;
}

void Compl_BtApply(GtkButton *button,gpointer user_data)
{
  gchar SqlCmd[250],Tmp[15],PsCle[LEN_COD_SOC+1],*End;
  GtkWidget *widget;
  gint Max,Per;
  gboolean CloseDB;

  if (DbLcpt==NULL) {
    OpenDbLcpt();
    CloseDB=TRUE;
  } else CloseDB=FALSE;
  GetSocRun(PsCle);
  sprintf(SqlCmd,"Select Max(HisNumEx) From Histo Where HisSoc='%s'",PsCle);
  Max=SqlGetNumber(SqlCmd);
  Max++;
  End=strmov(SqlCmd,"Insert into Histo (HisSoc,HisNumEx,HisDebEx,HisFinEx,HisPeriode,HisEffectif) Values (");
  End=StrSql(End,PsCle);
  *End++=',';
  sprintf(Tmp,"%i",Max);
  End=strmov(End,Tmp);
  *End++=',';
  widget=lookup_widget(GTK_WIDGET (button),"DebExercice");
  DateToIso(Tmp,gtk_entry_get_text(GTK_ENTRY (widget)));
  End=StrSql(End,Tmp);
  *End++=',';
  widget=lookup_widget(GTK_WIDGET (button),"FinExercice");
  DateToIso(Tmp,gtk_entry_get_text(GTK_ENTRY (widget)));
  End=StrSql(End,Tmp);
  *End++=',';
  widget=lookup_widget(GTK_WIDGET (button),"Periode");
  Per=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON (widget));
  sprintf(Tmp,"%i",Per);
  End=strmov(End,Tmp);
  *End++=',';
  widget=lookup_widget(GTK_WIDGET (button),"Effectif");
  End=StrSql(End,gtk_entry_get_text(GTK_ENTRY (widget)));
  *End++=')';
  *End=0;
  if (mysql_query(DbLcpt,SqlCmd)!=0) MessageAlerte(mysql_error(DbLcpt));
  if (CloseDB) CloseDbLcpt();
  ModalResult=MR_OK;
  gtk_widget_destroy(GTK_WIDGET(WinCompl));
}

void Compl_BtCancel(GtkButton *button,gpointer user_data)
{
  ModalResult=MR_CANCEL;
  gtk_widget_destroy(GTK_WIDGET(WinCompl));
}

void Compl_Periode(GtkEditable *Ed,gpointer user_data)
{
  int Per;
  gchar *P;
  GDate *Dte;
  gchar Tmp[15];
  gint d,m,y;
  GtkWidget *widget;

  P=gtk_editable_get_chars(Ed,0,2);
  Per=strval(P);
  g_free(P);
  widget=lookup_widget(GTK_WIDGET (Ed),"DebExercice");
  strcpy(Tmp,gtk_entry_get_text(GTK_ENTRY (widget)));
  ExplodeDate(Tmp,&d,&m,&y);
  Dte=g_date_new_dmy(d,m,y);
  g_date_add_months(Dte,Per);
  g_date_strftime(Tmp,10,"%d/%m/%y",Dte);
  widget=lookup_widget(GTK_WIDGET (WinCompl),"FinExercice");
  gtk_entry_set_text(GTK_ENTRY (widget),Tmp);
  g_date_free(Dte);
}

void Compl_DebutEx(GtkEditable *Ed,gpointer user_data)
{
  int Per;
  gchar *P;
  GDate *Dte;
  gchar Tmp[15];
  gint d,m,y;
  GtkWidget *widget;

  P=gtk_editable_get_chars(Ed,0,10);
  strcpy(Tmp,P);
  if (ControleDate(Tmp)) {
    widget=lookup_widget(GTK_WIDGET (Ed),"Periode");
    Per=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON (widget));
    widget=lookup_widget(GTK_WIDGET (WinCompl),"FinExercice");
    ExplodeDate(Tmp,&d,&m,&y);
    Dte=g_date_new_dmy(g_date_days_in_month(m,y),m,y);
    g_date_add_months(Dte,Per);
    g_date_strftime(Tmp,10,"%d/%m/%y",Dte);
    gtk_entry_set_text(GTK_ENTRY (widget),Tmp);
    g_date_free(Dte);
  }
  g_free(P);
}

int SaisieComplements(void)
{
  GtkWidget *widget;
  gchar Tmp[15];
  GDate *Deb,*Fin;
  time_t timer;
  struct tm *tblock;

  WinCompl=create_EdtSocCompl();
  gtk_widget_show_all(WinCompl);
  timer = time(NULL);
  tblock = localtime(&timer);
  Deb=g_date_new_dmy(tblock->tm_mday,tblock->tm_mon+1,tblock->tm_year);
  Fin=g_date_new_dmy(g_date_days_in_month(tblock->tm_mon+1,tblock->tm_year+1900),tblock->tm_mon+1,tblock->tm_year);
  g_date_add_months(Fin,12);
  g_date_strftime(Tmp,10,"%d/%m/%y",Deb);
  widget=lookup_widget(GTK_WIDGET (WinCompl),"DebExercice");
  gtk_entry_set_text(GTK_ENTRY (widget),Tmp);
  g_date_strftime(Tmp,10,"%d/%m/%y",Fin);
  widget=lookup_widget(GTK_WIDGET (WinCompl),"FinExercice");
  gtk_entry_set_text(GTK_ENTRY (widget),Tmp);
  g_date_free(Deb);
  g_date_free(Fin);
  ModalResult=MR_NONE;
  while (ModalResult==MR_NONE)
    if (gtk_events_pending()) gtk_main_iteration();
  return (ModalResult);
}
