/*******************************************************************/
/* Comptabilit Analityque Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 21/03/02 - Pointage des comptes                                 */
/* Fichier source                                                  */
/*******************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 


#include <gtk/gtk.h>
#include <gnome.h>
#include <string.h>
#include <ctype.h>
#include <mysql/mysql.h>
#include "support.h"
#include "common.h"
#include "pointage.h"
#include "gtksql.h"
#include "select.h"

/* Variables */
GtkWidget *WinPtg;
MYSQL_RES *EdtPlcRes;
gboolean  AFFICHE_NORMAL,OPERATION_RUN;
double    Ecart;
my_ulonglong MysqlPtr;
select_list *ORG_SELECT,*SelList;

/* Protos */
void PrintEcart(gchar *Name);
void CalculEcart(GtkCList *List,gint Row);
void EdtPtg_DispTab(void);
void EdtPtg_DispData(void);
void ValidPointage(GtkCList *List);
GtkWidget* create_Pointage (void);
/* Event */
void
on_Pointage_show                       (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_Pointage_destroy                    (GtkObject       *object,
                                        gpointer         user_data);

void
on_ListEcrit_select_row                (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

gboolean
on_ListEcrit_button_press_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

void
on_Ptg_BtPrec_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_Ptg_BtSel_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_Ptg_BtSuiv_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_ListEcrit_unselect_row              (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_ListEcrit_start_selection           (GtkCList        *clist,
                                        gpointer         user_data);

void
on_Ptg_BtFermer_clicked                (GtkButton       *button,
                                        gpointer         user_data);

void
on_Ptg_Change_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

gboolean
on_DateReleve_key_press_event          (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

/*******/
void EdtPtg_DispTab(void)
{
  GtkWidget *ListHis,*Entry;
  gchar *Ptr[10],PsCle[LEN_COD_SOC+1],SqlCmd[200],Tmp[15],CptCode[11],Tmp2[15];
  MYSQL_RES *Result;
  MYSQL_ROW Row;
  gint Ligne;

  GetSocRun(PsCle);
  Entry=lookup_widget(GTK_WIDGET (WinPtg),"CptCode");
  strcpy(CptCode,gtk_entry_get_text(GTK_ENTRY (Entry)));
  ListHis=lookup_widget(GTK_WIDGET (WinPtg),"ListEcrit");
  gtk_clist_freeze(GTK_CLIST (ListHis));
  gtk_clist_clear(GTK_CLIST (ListHis));
  if (AFFICHE_NORMAL) gtk_clist_set_column_title(GTK_CLIST (ListHis),4,"Echance");else gtk_clist_set_column_title(GTK_CLIST (ListHis),4,"Pointage");
  if (AFFICHE_NORMAL)
    sprintf(SqlCmd,"Select * From Ecrit Where EcrSoc='%s' And EcrCpt='%s' And EcrCtrl=' ' Order By EcrDate",PsCle,CptCode);
  else sprintf(SqlCmd,"Select * From Ecrit Where EcrSoc='%s' And EcrCpt='%s' And EcrCtrl='P' Order By EcrDate",PsCle,CptCode);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    Result=mysql_store_result(DbLcpt);
    while ((Row=mysql_fetch_row(Result))) {
      IsoToDate(Tmp,Row[3]);
      Ptr[0]=Tmp;
      Ptr[1]=Row[9];
      Ptr[2]=Row[4];
      Ptr[3]=Row[5]+2;
      if (AFFICHE_NORMAL) IsoToDate(Tmp2,Row[14]);else IsoToDate(Tmp2,Row[18]);
      Ptr[4]=Tmp2;
      Ptr[5]=Row[19];
      Ptr[6]=Row[20];
      Ligne=gtk_clist_append(GTK_CLIST (ListHis),Ptr);
      gtk_clist_set_row_data(GTK_CLIST (ListHis),Ligne,(gpointer) Row[1]);
    }
    gtk_clist_thaw(GTK_CLIST (ListHis));
  }
}

void EdtPtg_DispData(void)
{
  gchar SqlCmd[250],PsCle[LEN_COD_SOC+1];
  int Valid;
  MYSQL_ROW Row;
  GtkWidget *Widget;

  GetSocRun(PsCle);
  if (EdtPlcRes==NULL) {
    Valid=FALSE;
    MysqlPtr=0;
    sprintf(SqlCmd,"Select CptCode,CptLib From Comptes Where CptSoc='%s'",PsCle);
    if (!mysql_query(DbLcpt,SqlCmd)) {
      EdtPlcRes=mysql_store_result(DbLcpt);
      if (EdtPlcRes) {
	if (mysql_num_rows(EdtPlcRes)==0) {
	  Widget=lookup_widget(GTK_WIDGET (WinPtg),"Ptg_BtPrec");
	  if (Widget!=NULL) gtk_widget_set_sensitive(Widget,FALSE);
	  Widget=lookup_widget(GTK_WIDGET (WinPtg),"Ptg_BtSuiv");
	  if (Widget!=NULL) gtk_widget_set_sensitive(Widget,FALSE);
	  Widget=lookup_widget(GTK_WIDGET (WinPtg),"Ptg_BtSel");
	  if (Widget!=NULL) gtk_widget_set_sensitive(Widget,FALSE);
	 } else  Valid=TRUE;
      }
    }
  } else Valid=TRUE;
  if (Valid) {
    Row=mysql_fetch_row(EdtPlcRes);
    StrSqlToGtk(GTK_WIDGET (WinPtg),"CptCode",Row[0]);
    StrSqlToGtk(GTK_WIDGET (WinPtg),"CptLib",Row[1]);
    EdtPtg_DispTab();
  }
  Ecart=0;
  if (ORG_SELECT!=NULL) {
    Select_DeleteAll(ORG_SELECT);
    ORG_SELECT=NULL;
  }
  PrintEcart("Ptg_Ecart");
}

void on_Pointage_show(GtkWidget *widget,gpointer user_data)
{
  GtkWidget *Widget;
  gchar Date[11];

  OpenDbLcpt();
  AFFICHE_NORMAL=TRUE;
  OPERATION_RUN=FALSE;
  ORG_SELECT=NULL;
  GetDate(Date);
  Widget=lookup_widget(GTK_WIDGET (widget),"DateReleve");
  gtk_entry_set_text(GTK_ENTRY (Widget),Date);
}


void on_Pointage_destroy(GtkObject *object,gpointer user_data)
{
  Select_DeleteAll(ORG_SELECT);
  ORG_SELECT=NULL;
  mysql_free_result(EdtPlcRes);
  CloseDbLcpt();
}

void PrintEcart(gchar *Name)
{
  GtkWidget *Widget;
  char Tmp[15];

  Widget=lookup_widget(GTK_WIDGET (WinPtg),Name);
  sprintf(Tmp,"%-8.2f",Ecart);
  gtk_entry_set_text(GTK_ENTRY (Widget),Tmp);
}

void CalculEcart(GtkCList *List,gint Row)
{
  gchar *P;
  double a,b;

  gtk_clist_get_text(List,Row,5,&P);
  a=atof(P);
  gtk_clist_get_text(List,Row,6,&P);
  b=atof(P);
  Ecart=Ecart+(a-b);
}

void ValidPointage(GtkCList *List)
{
  gchar SqlCmd[120],PsCle[LEN_COD_SOC+1],PVal,Date[11],Tmp[20],Msg[50];
  GtkWidget *Widget;

  gtk_signal_handler_block_by_func(GTK_OBJECT (List),(GtkSignalFunc) on_ListEcrit_select_row,NULL);
  gtk_signal_handler_block_by_func(GTK_OBJECT (List),(GtkSignalFunc) on_ListEcrit_unselect_row,NULL);
  Widget=lookup_widget(GTK_WIDGET (List),"DateReleve");
  strcpy(Date,gtk_entry_get_text(GTK_ENTRY (Widget)));
  if (ControleDate(Date)) {
    DateToIso(Tmp,Date);
    if (AFFICHE_NORMAL) PVal='P';else PVal=' ';
    GetSocRun(PsCle);
    if (AFFICHE_NORMAL) strcpy(Msg,"Confirmez vous le pointage ?");else strcpy(Msg,"Confirmez vous le Depointage ?");
    if (MsgQuestion(Msg)==MR_OK) {
      SelList=ORG_SELECT;
      OPERATION_RUN=TRUE;
      gtk_clist_unselect_all(GTK_CLIST (List));
      while (SelList!=NULL) {
	sprintf(SqlCmd,"Update Ecrit Set EcrCtrl='%c',EcrDatePtg='%s' Where EcrSoc='%s' And EcrCode='%s'",PVal,Tmp,PsCle,SelList->Code);
	if (mysql_query(DbLcpt,SqlCmd)!=0) g_print("Erreur Sql sur code '%s'",SelList->Code);
	gtk_clist_remove(List,SelList->Row);
	SelList=SelList->Su;
      }
      OPERATION_RUN=FALSE;
      Ecart=0;
      PrintEcart("Ptg_Ecart");
      Select_DeleteAll(ORG_SELECT);
      ORG_SELECT=NULL;
    }
  } else MessageAlerte("Date de relev fausse !");
  gtk_signal_handler_unblock_by_func(GTK_OBJECT (List),(GtkSignalFunc) on_ListEcrit_select_row,NULL);
  gtk_signal_handler_unblock_by_func(GTK_OBJECT (List),(GtkSignalFunc) on_ListEcrit_unselect_row,NULL);
}

void
on_ListEcrit_select_row                (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gchar *P;

  P=gtk_clist_get_row_data(clist,row);
  ORG_SELECT=Select_Append(ORG_SELECT,row,P);
  CalculEcart(clist,row);
  PrintEcart("Ptg_Ecart");
  if (Ecart==0) ValidPointage(clist);
}

void
on_ListEcrit_unselect_row              (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gchar *P;
  double a,b;

  if (!OPERATION_RUN) {
    ORG_SELECT=Select_Delete(ORG_SELECT,row);
    gtk_clist_get_text(clist,row,5,&P);
    a=atof(P);
    gtk_clist_get_text(clist,row,6,&P);
    b=atof(P);
    Ecart=Ecart-(a-b);
    PrintEcart("Ptg_Ecart");
  }
}


void
on_ListEcrit_start_selection           (GtkCList        *clist,
                                        gpointer         user_data)
{
  if (!OPERATION_RUN) {
    Select_DeleteAll(ORG_SELECT);
    Ecart=0;
    ORG_SELECT=NULL;
    PrintEcart("Ptg_Ecart");
  }
}

void
on_Ptg_BtPrec_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  if (MysqlPtr>0) {
    MysqlPtr--;
    mysql_data_seek(EdtPlcRes,MysqlPtr);
    EdtPtg_DispData();
  }
}


void
on_Ptg_BtSel_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  gchar CptRet[11];

  if (ListSelect(CptRet,"Comptes","CptSoc","CptCode","CptLib",NULL)==MR_OK) {
    if ((MysqlPtr = SearchCode(EdtPlcRes, CptRet, 0)) != -1)
      EdtPtg_DispData();
    else
      if (verbose) g_print("Code %s non retrouv !!!\n", CptRet);
  }
}

void
on_Ptg_BtSuiv_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  if (MysqlPtr<mysql_num_rows(EdtPlcRes)-1) {
    EdtPtg_DispData();
    MysqlPtr++;
  }
}

void
on_Ptg_Change_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  gchar *text;
  GtkWidget *Option,*Menu;
  gboolean Old;

  Menu=lookup_widget(GTK_WIDGET (button),"EdtPtg_SelPoint");
  if (GTK_BIN (Menu)->child) {
    Option = GTK_BIN (Menu)->child;
    if (GTK_IS_LABEL (Option)) {
      gtk_label_get (GTK_LABEL (Option), &text);
      Old=AFFICHE_NORMAL;
      if (strcmp(text,"Pointage")==0) AFFICHE_NORMAL=TRUE;else AFFICHE_NORMAL=FALSE;
      if (Old!=AFFICHE_NORMAL) EdtPtg_DispTab();
    }
  }
}

gboolean
on_DateReleve_key_press_event          (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  gchar *T,Ret[11];

  if (event->type==GDK_KEY_PRESS) {
    if (event->keyval==GDK_F5) {
      T=gtk_entry_get_text(GTK_ENTRY (widget));
      if (SelectDate(Ret,T)==MR_OK) {
	gtk_entry_set_text(GTK_ENTRY(widget),Ret);
	gtk_signal_emit_stop_by_name(GTK_OBJECT (widget),"key_press_event");
      }
    }
  }
  return FALSE;
}

GtkWidget* create_Pointage (void)
{
  GtkWidget *Pointage;
  GtkWidget *vbox16;
  GtkWidget *hbox21;
  GtkWidget *hbox22;
  GtkWidget *label149;
  GtkWidget *CptCode;
  GtkWidget *CptLib;
  GtkWidget *hbox23;
  GtkWidget *Ptg_BtPrec;
  GtkWidget *Ptg_BtSel;
  GtkWidget *Ptg_BtSuiv;
  GtkWidget *fixed15;
  GtkWidget *scrolledwindow10;
  GtkWidget *ListEcrit;
  GtkWidget *label154;
  GtkWidget *label155;
  GtkWidget *label156;
  GtkWidget *label157;
  GtkWidget *label158;
  GtkWidget *label159;
  GtkWidget *label160;
  GtkWidget *fixed14;
  GtkWidget *Ptg_BtFermer;
  GtkWidget *Ptg_Ecart;
  GtkWidget *DateReleve;
  GtkWidget *vseparator10;
  GtkWidget *label167;
  GtkWidget *label162;
  GtkWidget *EdtPtg_SelPoint;
  GtkWidget *EdtPtg_SelPoint_menu;
  GtkWidget *glade_menuitem;
  GtkWidget *Ptg_Change;
  GtkWidget *vseparator11;
  GtkAccelGroup *accel_group;
  int i;

  accel_group = gtk_accel_group_new ();

  Pointage = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (Pointage), "Pointage", Pointage);
  gtk_widget_set_usize (Pointage, -2, 347);
  gtk_window_set_title (GTK_WINDOW (Pointage), _("Pointage des Comptes"));
  gtk_window_set_position (GTK_WINDOW (Pointage), GTK_WIN_POS_CENTER);

  vbox16 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox16);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "vbox16", vbox16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox16);
  gtk_container_add (GTK_CONTAINER (Pointage), vbox16);

  hbox21 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox21);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "hbox21", hbox21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox21);
  gtk_box_pack_start (GTK_BOX (vbox16), hbox21, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox21), 2);

  hbox22 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox22);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "hbox22", hbox22,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox22);
  gtk_box_pack_start (GTK_BOX (hbox21), hbox22, FALSE, TRUE, 0);

  label149 = gtk_label_new (_("Compte :"));
  gtk_widget_ref (label149);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "label149", label149,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label149);
  gtk_box_pack_start (GTK_BOX (hbox22), label149, FALSE, FALSE, 0);

  CptCode = gtk_entry_new_with_max_length (10);
  gtk_widget_ref (CptCode);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "CptCode", CptCode,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptCode);
  gtk_box_pack_start (GTK_BOX (hbox22), CptCode, TRUE, TRUE, 0);
  gtk_widget_set_usize (CptCode, 90, -2);

  CptLib = gtk_entry_new ();
  gtk_widget_ref (CptLib);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "CptLib", CptLib,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CptLib);
  gtk_box_pack_start (GTK_BOX (hbox22), CptLib, TRUE, TRUE, 0);
  gtk_widget_set_usize (CptLib, 226, -2);
  gtk_widget_set_sensitive (CptLib, FALSE);
  gtk_entry_set_editable (GTK_ENTRY (CptLib), FALSE);

  hbox23 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox23);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "hbox23", hbox23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox23);
  gtk_box_pack_start (GTK_BOX (hbox21), hbox23, FALSE, TRUE, 0);

  Ptg_BtPrec = gnome_stock_button (GNOME_STOCK_BUTTON_PREV);
  gtk_widget_ref (Ptg_BtPrec);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "Ptg_BtPrec", Ptg_BtPrec,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Ptg_BtPrec);
  gtk_box_pack_start (GTK_BOX (hbox23), Ptg_BtPrec, FALSE, FALSE, 0);
  gtk_widget_add_accelerator (Ptg_BtPrec, "clicked", accel_group,
                              GDK_Page_Up, 0,
                              GTK_ACCEL_VISIBLE);

  Ptg_BtSel = gtk_button_new_with_label (_("Sl."));
  gtk_widget_ref (Ptg_BtSel);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "Ptg_BtSel", Ptg_BtSel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Ptg_BtSel);
  gtk_box_pack_start (GTK_BOX (hbox23), Ptg_BtSel, FALSE, FALSE, 0);
  gtk_widget_add_accelerator (Ptg_BtSel, "clicked", accel_group,
                              GDK_F5, 0,
                              GTK_ACCEL_VISIBLE);

  Ptg_BtSuiv = gnome_stock_button (GNOME_STOCK_BUTTON_NEXT);
  gtk_widget_ref (Ptg_BtSuiv);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "Ptg_BtSuiv", Ptg_BtSuiv,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Ptg_BtSuiv);
  gtk_box_pack_start (GTK_BOX (hbox23), Ptg_BtSuiv, FALSE, FALSE, 0);
  gtk_widget_add_accelerator (Ptg_BtSuiv, "clicked", accel_group,
                              GDK_Page_Down, 0,
                              GTK_ACCEL_VISIBLE);

  fixed15 = gtk_fixed_new ();
  gtk_widget_ref (fixed15);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "fixed15", fixed15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed15);
  gtk_box_pack_start (GTK_BOX (hbox21), fixed15, TRUE, TRUE, 0);

  scrolledwindow10 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow10);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "scrolledwindow10", scrolledwindow10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow10);
  gtk_box_pack_start (GTK_BOX (vbox16), scrolledwindow10, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow10), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  ListEcrit = gtk_clist_new (7);
  gtk_widget_ref (ListEcrit);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "ListEcrit", ListEcrit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ListEcrit);
  gtk_container_add (GTK_CONTAINER (scrolledwindow10), ListEcrit);
  gtk_container_set_border_width (GTK_CONTAINER (ListEcrit), 2);
  gtk_clist_set_column_width (GTK_CLIST (ListEcrit), 0, 70);
  gtk_clist_set_column_width (GTK_CLIST (ListEcrit), 1, 265);
  gtk_clist_set_column_width (GTK_CLIST (ListEcrit), 2, 30);
  gtk_clist_set_column_width (GTK_CLIST (ListEcrit), 3, 80);
  gtk_clist_set_column_width (GTK_CLIST (ListEcrit), 4, 68);
  gtk_clist_set_column_width (GTK_CLIST (ListEcrit), 5, 80);
  gtk_clist_set_column_width (GTK_CLIST (ListEcrit), 6, 80);
  gtk_clist_set_selection_mode (GTK_CLIST (ListEcrit), GTK_SELECTION_MULTIPLE);
  gtk_clist_column_titles_show (GTK_CLIST (ListEcrit));
  for (i=0;i<8;i++) gtk_clist_set_column_resizeable(GTK_CLIST (ListEcrit),i,FALSE);
  gtk_clist_set_column_justification(GTK_CLIST (ListEcrit),5,GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_justification(GTK_CLIST (ListEcrit),6,GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_justification(GTK_CLIST (ListEcrit),7,GTK_JUSTIFY_CENTER);

  label154 = gtk_label_new (_("Date"));
  gtk_widget_ref (label154);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "label154", label154,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label154);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcrit), 0, label154);

  label155 = gtk_label_new (_("Libell"));
  gtk_widget_ref (label155);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "label155", label155,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label155);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcrit), 1, label155);

  label156 = gtk_label_new (_("Jrn"));
  gtk_widget_ref (label156);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "label156", label156,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label156);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcrit), 2, label156);

  label157 = gtk_label_new (_("Pice"));
  gtk_widget_ref (label157);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "label157", label157,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label157);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcrit), 3, label157);

  label158 = gtk_label_new (_("Echance"));
  gtk_widget_ref (label158);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "label158", label158,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label158);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcrit), 4, label158);

  label159 = gtk_label_new (_("Dbit"));
  gtk_widget_ref (label159);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "label159", label159,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label159);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcrit), 5, label159);

  label160 = gtk_label_new (_("Crdit"));
  gtk_widget_ref (label160);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "label160", label160,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label160);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcrit), 6, label160);

  fixed14 = gtk_fixed_new ();
  gtk_widget_ref (fixed14);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "fixed14", fixed14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed14);
  gtk_box_pack_start (GTK_BOX (vbox16), fixed14, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (fixed14), 2);

  Ptg_BtFermer = gnome_stock_button (GNOME_STOCK_BUTTON_CLOSE);
  gtk_widget_ref (Ptg_BtFermer);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "Ptg_BtFermer", Ptg_BtFermer,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Ptg_BtFermer);
  gtk_fixed_put (GTK_FIXED (fixed14), Ptg_BtFermer, 668, 4);
  gtk_widget_set_uposition (Ptg_BtFermer, 668, 4);
  gtk_widget_set_usize (Ptg_BtFermer, 76, 26);

  Ptg_Ecart = gtk_entry_new ();
  gtk_widget_ref (Ptg_Ecart);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "Ptg_Ecart", Ptg_Ecart,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Ptg_Ecart);
  gtk_fixed_put (GTK_FIXED (fixed14), Ptg_Ecart, 120, 8);
  gtk_widget_set_uposition (Ptg_Ecart, 120, 8);
  gtk_widget_set_usize (Ptg_Ecart, 80, 20);
  gtk_widget_set_sensitive (Ptg_Ecart, FALSE);
  gtk_entry_set_editable (GTK_ENTRY (Ptg_Ecart), FALSE);

  DateReleve = gtk_entry_new_with_max_length (10);
  gtk_widget_ref (DateReleve);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "DateReleve", DateReleve,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (DateReleve);
  gtk_fixed_put (GTK_FIXED (fixed14), DateReleve, 308, 8);
  gtk_widget_set_uposition (DateReleve, 308, 8);
  gtk_widget_set_usize (DateReleve, 80, 20);

  vseparator10 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator10);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "vseparator10", vseparator10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator10);
  gtk_fixed_put (GTK_FIXED (fixed14), vseparator10, 216, 4);
  gtk_widget_set_uposition (vseparator10, 216, 4);
  gtk_widget_set_usize (vseparator10, 16, 24);

  label167 = gtk_label_new (_("Date relev :"));
  gtk_widget_ref (label167);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "label167", label167,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label167);
  gtk_fixed_put (GTK_FIXED (fixed14), label167, 232, 12);
  gtk_widget_set_uposition (label167, 232, 12);
  gtk_widget_set_usize (label167, 80, 16);
  gtk_misc_set_alignment (GTK_MISC (label167), 0, 0.5);

  label162 = gtk_label_new (_("Ecart de pointage :"));
  gtk_widget_ref (label162);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "label162", label162,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label162);
  gtk_fixed_put (GTK_FIXED (fixed14), label162, 8, 12);
  gtk_widget_set_uposition (label162, 8, 12);
  gtk_widget_set_usize (label162, 112, 16);
  gtk_misc_set_alignment (GTK_MISC (label162), 0, 0.5);

  EdtPtg_SelPoint = gtk_option_menu_new ();
  gtk_widget_ref (EdtPtg_SelPoint);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "EdtPtg_SelPoint", EdtPtg_SelPoint,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EdtPtg_SelPoint);
  gtk_fixed_put (GTK_FIXED (fixed14), EdtPtg_SelPoint, 420, 4);
  gtk_widget_set_uposition (EdtPtg_SelPoint, 420, 4);
  gtk_widget_set_usize (EdtPtg_SelPoint, 124, 24);
  EdtPtg_SelPoint_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label (_("Pointage"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (EdtPtg_SelPoint_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("Dpointage"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (EdtPtg_SelPoint_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (EdtPtg_SelPoint), EdtPtg_SelPoint_menu);

  Ptg_Change = gtk_button_new_with_label (_("Change"));
  gtk_widget_ref (Ptg_Change);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "Ptg_Change", Ptg_Change,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Ptg_Change);
  gtk_fixed_put (GTK_FIXED (fixed14), Ptg_Change, 560, 4);
  gtk_widget_set_uposition (Ptg_Change, 560, 4);
  gtk_widget_set_usize (Ptg_Change, 54, 22);

  vseparator11 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator11);
  gtk_object_set_data_full (GTK_OBJECT (Pointage), "vseparator11", vseparator11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator11);
  gtk_fixed_put (GTK_FIXED (fixed14), vseparator11, 396, 4);
  gtk_widget_set_uposition (vseparator11, 396, 4);
  gtk_widget_set_usize (vseparator11, 16, 24);

  gtk_signal_connect (GTK_OBJECT (Pointage), "show",
                      GTK_SIGNAL_FUNC (on_Pointage_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Pointage), "destroy",
                      GTK_SIGNAL_FUNC (on_Pointage_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Ptg_BtPrec), "clicked",
                      GTK_SIGNAL_FUNC (on_Ptg_BtPrec_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Ptg_BtSel), "clicked",
                      GTK_SIGNAL_FUNC (on_Ptg_BtSel_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Ptg_BtSuiv), "clicked",
                      GTK_SIGNAL_FUNC (on_Ptg_BtSuiv_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ListEcrit), "select_row",
                      GTK_SIGNAL_FUNC (on_ListEcrit_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ListEcrit), "unselect_row",
                      GTK_SIGNAL_FUNC (on_ListEcrit_unselect_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ListEcrit), "start_selection",
                      GTK_SIGNAL_FUNC (on_ListEcrit_start_selection),
                      NULL);
  gtk_signal_connect_object (GTK_OBJECT (Ptg_BtFermer), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (Pointage));
  gtk_signal_connect (GTK_OBJECT (DateReleve), "insert_text",
                      GTK_SIGNAL_FUNC (ControleSaisieDate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (DateReleve), "key_press_event",
                      GTK_SIGNAL_FUNC (on_DateReleve_key_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Ptg_Change), "clicked",
                      GTK_SIGNAL_FUNC (on_Ptg_Change_clicked),
                      NULL);

  gtk_window_add_accel_group (GTK_WINDOW (Pointage), accel_group);

  return Pointage;
}

void Dialog_Pointage(void)
{
  WinPtg=create_Pointage();
  gtk_widget_show_all(WinPtg);
  EdtPlcRes=NULL;
  EdtPtg_DispData();
}
