/*******************************************************************/
/* Comptabilit Analytique Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 10/07/02 - Gestion des relances clients                         */
/* Fichier source                                                  */
/*******************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 


#include <gtk/gtk.h>
#include <gnome.h>
#include <string.h>
#include <ctype.h>
#include <mysql/mysql.h>
#include "support.h"
#include "common.h"
#include "gtksql.h"
#include "print.h"

#include "relance.h"

/* Variables *********************************************************/
GtkWidget    *Relance;
int          Rel_CodeDisplay,ConfMode;
gchar	  		 CptCodeRel[11];

/* Protos */
GtkWidget* create_Relance (void);
void TestExist(void);
void EmptyForm(void);
void Relance_show(GtkWidget *widget,gpointer user_data);
void Relance_destroy(GtkObject *object,gpointer user_data);
void Rel_BtNew_clicked(GtkButton *button,gpointer  user_data);
void Rel_BtModify_clicked(GtkButton *button,gpointer  user_data);
void Rel_BtDelete_clicked(GtkButton *button,gpointer  user_data);
void Rel_BtQuit_clicked(GtkButton *button,gpointer  user_data);
void on_NumLettre_changed(GtkEditable *editable,gpointer user_data);
void RelanceDisplay(void);
/****/
void Rel_PrintHeader(gchar *PsCle);
void PrintRelance(gchar *Code);
void DoAppendComment(gchar *PsCle,gchar *Txt);
void AppendComment(char *Dte);
GtkWidget* create_RelanceEdit(void);
void Rel_BtSave_clicked(GtkButton *button,gpointer  user_data);

/*********************************************************************/

void Relance_show(GtkWidget *widget,gpointer user_data)
{
  if (ConfMode) OpenDbLcpt();
}

/* Teste du nombre de relance prsente ***********************************************/
void TestExist(void)
{
	gchar SqlCmd[200],PsCle[LEN_COD_SOC+1];
	GtkWidget *Wdg;
	MYSQL_RES *Res;
	MYSQL_ROW Row;
	int Actif,NbL,RelSel;
	
	Actif=FALSE;
	GetSocRun(PsCle);
	Wdg=lookup_widget(GTK_WIDGET (Relance),"NumLettre");
	RelSel=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON (Wdg));	
	sprintf(SqlCmd,"Select Count(*) From RelConf Where RelSoc='%s' and RelCode='%02i'",PsCle,RelSel);
	if (mysql_query(DbLcpt,SqlCmd)==0) {
		Res=mysql_store_result(DbLcpt);
		if (Res!=NULL) {
			Row=mysql_fetch_row(Res);
			if (Row[0]!=NULL) {			
				NbL=atoi(Row[0]);
				if (NbL!=0) Actif=TRUE;
			}
			mysql_free_result(Res);
		}
	}
	if (ConfMode) {
		Wdg=lookup_widget(GTK_WIDGET (Relance),"BtModify");
		gtk_widget_set_sensitive(Wdg,Actif);
		Wdg=lookup_widget(GTK_WIDGET (Relance),"BtDelete");	
		gtk_widget_set_sensitive(Wdg,Actif);
	} else {
		Wdg=lookup_widget(GTK_WIDGET (Relance),"BtSave");
		gtk_widget_set_sensitive(Wdg,Actif);
	}
}

void EmptyForm(void)
{
	GtkWidget *Wdg;
	
	StrSqlToGtk(GTK_WIDGET (Relance),"RelVille",NULL);
	StrSqlToGtk(GTK_WIDGET (Relance),"RelObject",NULL);
	BooleanSqlToGtk(GTK_WIDGET (Relance),"RelIsTextUp","Y");
	BooleanSqlToGtk(GTK_WIDGET (Relance),"RelIsTextDown","Y");
	BooleanSqlToGtk(GTK_WIDGET (Relance),"RelIsTab","Y");
	Wdg=lookup_widget(GTK_WIDGET (Relance),"RelTextUp");
	if (gtk_text_get_length(GTK_TEXT (Wdg))) {
		gtk_text_set_point(GTK_TEXT (Wdg),0);
		gtk_text_forward_delete(GTK_TEXT (Wdg),gtk_text_get_length(GTK_TEXT (Wdg)));
	}
	Wdg=lookup_widget(GTK_WIDGET (Relance),"RelTextDown");
	if (gtk_text_get_length(GTK_TEXT (Wdg))) {
		gtk_text_set_point(GTK_TEXT (Wdg),0);
		gtk_text_forward_delete(GTK_TEXT (Wdg),gtk_text_get_length(GTK_TEXT (Wdg)));
	}
	StrSqlToGtk(GTK_WIDGET (Relance),"RelEmet",NULL);
}

/* Fermeture des relances ***********************************************************/
void Relance_destroy(GtkObject *object,gpointer user_data)
{
  if (ConfMode) CloseDbLcpt();
}

void Rel_BtNew_clicked(GtkButton *button,gpointer  user_data)
{
	char SqlCmd[200],PsCle[LEN_COD_SOC+1];
	int MaxCode;
	GtkWidget *Wdg;
	
	GetSocRun(PsCle);
	sprintf(SqlCmd,"select max(RelCode) From RelConf Where RelSoc='%s'",PsCle);
	MaxCode=SqlGetNumber(SqlCmd);
	MaxCode++;
	GetSocRun(PsCle);
	sprintf(SqlCmd,"Insert into RelConf (RelSoc,RelCode,RelIsTextUp,RelIsTextDown,RelIsTab) values ('%s','%02i','Y','Y','Y')",PsCle,MaxCode);
   if (verbose) g_print(SqlCmd);	
	if (mysql_query(DbLcpt,SqlCmd)==0) {
		Wdg=lookup_widget(GTK_WIDGET (button),"NumLettre");
		gtk_spin_button_set_value(GTK_SPIN_BUTTON (Wdg),(float) MaxCode);
		EmptyForm();
	} else MessageAlerte("Insertion impossible !");
}

/* Modification d'une relance ***********************************************************/
void Rel_BtModify_clicked(GtkButton *button,gpointer  user_data)
{
	gchar SqlCmd[2048],PsCle[LEN_COD_SOC+1],*End,CodeRel[3],*Ptr;
	GtkWidget *Wdg;
	int CodeSel;
	
	Wdg=lookup_widget(GTK_WIDGET (button),"NumLettre");
	CodeSel=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON (Wdg));			
	GetSocRun(PsCle);
	End=strmov(SqlCmd,"Update RelConf Set RelVille=");
	End=GtkToStrSql(End,GTK_WIDGET (button),"RelVille");
	End=strmov(End,",RelObject=");
	End=GtkToStrSql(End,GTK_WIDGET (button),"RelObject");
	End=strmov(End,",RelIsTextUp=");
	End=GtkToBooleanSql(End,GTK_WIDGET (button),"RelIsTextUp");
	End=strmov(End,",RelIsTextDown=");
	End=GtkToBooleanSql(End,GTK_WIDGET (button),"RelIsTextDown");
	End=strmov(End,",RelIsTab=");
	End=GtkToBooleanSql(End,GTK_WIDGET (button),"RelIsTab");
	/* Texte Haut */
	End=strmov(End,",RelTextUp='");
	Wdg=lookup_widget(GTK_WIDGET (button),"RelTextUp");
	Ptr=gtk_editable_get_chars(GTK_EDITABLE (Wdg),0,-1);
	if (Ptr!=NULL)	End+=mysql_escape_string(End,Ptr,strlen(Ptr));
	*End++='\'';
	/* Texte Bas */
	End=strmov(End,",RelTextDown='");
	Wdg=lookup_widget(GTK_WIDGET (button),"RelTextDown");
	Ptr=gtk_editable_get_chars(GTK_EDITABLE (Wdg),0,-1);
	if (Ptr!=NULL) End+=mysql_escape_string(End,Ptr,strlen(Ptr));	
	*End++='\'';
   /*****/
   End=strmov(End,",RelEmet=");
	End=GtkToStrSql(End,GTK_WIDGET (button),"RelEmet");
	End=strmov(End," Where RelSoc='");
	End=strmov(End,PsCle);
	End=strmov(End,"' And RelCode='");
	sprintf(CodeRel,"%02i",CodeSel);
	End=strmov(End,CodeRel);
	*End++='\'';
	*End=0;
	if (verbose) g_print(SqlCmd);
	if (mysql_query(DbLcpt,SqlCmd)!=0) MessageAlerte("Impossible de modifier cette lettre de relance !");
}

void Rel_BtDelete_clicked(GtkButton *button,gpointer  user_data)
{
	char SqlCmd[200],PsCle[LEN_COD_SOC+1];
	int CodeDel;
	GtkWidget *Wdg;
		
	if (MsgQuestion("Supprimer cette lettre de relance ?")==1) {
		Wdg=lookup_widget(GTK_WIDGET (button),"NumLettre");
		CodeDel=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON (Wdg));
		GetSocRun(PsCle);
		sprintf(SqlCmd,"Delete From RelConf Where RelSoc='%s' And RelCode='%02i'",PsCle,CodeDel);
		if (mysql_query(DbLcpt,SqlCmd)==0) {
			RelanceDisplay();
		} else MessageAlerte("Suppression impossible !");
		TestExist();
	}
}

void Rel_BtQuit_clicked(GtkButton *button,gpointer  user_data)
{
	gtk_widget_destroy(Relance);
}

void on_NumLettre_changed(GtkEditable *editable,gpointer user_data)
{
	RelanceDisplay();
}

void RelanceDisplay(void)
{
	GtkWidget *Wdg;
	gchar SqlCmd[512],PsCle[LEN_COD_SOC+1],RelDate[12];
	int Valid;
	MYSQL_RES *Res;
	MYSQL_ROW Row;

	Valid=FALSE;
	TestExist();
	GetSocRun(PsCle);
	Wdg=lookup_widget(GTK_WIDGET (Relance),"NumLettre");
	Rel_CodeDisplay=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON (Wdg));	
	sprintf(SqlCmd,"select * From RelConf Where RelSoc='%s' And RelCode='%02i'",PsCle,Rel_CodeDisplay);
	if (!mysql_query(DbLcpt,SqlCmd)) {
		Res=mysql_store_result(DbLcpt);
		if (Res) {
			if ((Row=mysql_fetch_row(Res))) {
				Valid=TRUE;
				StrSqlToGtk(GTK_WIDGET (Relance),"RelVille",Row[2]);
				StrSqlToGtk(GTK_WIDGET (Relance),"RelObject",Row[3]);
				if (ConfMode) {
					BooleanSqlToGtk(GTK_WIDGET (Relance),"RelIsTextUp",Row[4]);
					BooleanSqlToGtk(GTK_WIDGET (Relance),"RelIsTextDown",Row[5]);
					BooleanSqlToGtk(GTK_WIDGET (Relance),"RelIsTab",Row[6]);
				}
				if (!ConfMode) {
					GetDate(RelDate);
					StrSqlToGtk(GTK_WIDGET (Relance),"RelDate",RelDate);
				}
				/* Texte haut */
				Wdg=lookup_widget(GTK_WIDGET (Relance),"RelTextUp");
				if (gtk_text_get_length(GTK_TEXT (Wdg))!=0) {
					gtk_text_set_point(GTK_TEXT (Wdg),0);
					gtk_text_forward_delete(GTK_TEXT (Wdg),gtk_text_get_length(GTK_TEXT (Wdg)));
				}
				if (Row[7]!=NULL) gtk_text_insert(GTK_TEXT (Wdg),NULL,NULL,NULL,Row[7],-1);
				/* Texte bas */
				Wdg=lookup_widget(GTK_WIDGET (Relance),"RelTextDown");
				if (gtk_text_get_length(GTK_TEXT (Wdg))!=0) {
					gtk_text_set_point(GTK_TEXT (Wdg),0);
					gtk_text_forward_delete(GTK_TEXT (Wdg),gtk_text_get_length(GTK_TEXT (Wdg)));
				}		
				if (Row[8]!=NULL) gtk_text_insert(GTK_TEXT (Wdg),NULL,NULL,NULL,Row[8],-1);
				StrSqlToGtk(GTK_WIDGET (Relance),"RelEmet",Row[9]);
			}
		}	
	}
	if (!Valid) EmptyForm();
}

GtkWidget* create_Relance (void)
{
  GtkWidget *Relance;
  GtkWidget *vbox4;
  GtkWidget *toolbar1;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *BtNew;
  GtkWidget *BtModify;
  GtkWidget *BtDelete;
  GtkWidget *BtQuit;
  GtkWidget *fixed5;
  GtkObject *NumLettre_adj;
  GtkWidget *NumLettre;
  GtkWidget *RelVille;
  GtkWidget *RelEmet;
  GtkWidget *RelObject;
  GtkWidget *RelTextUp;
  GtkWidget *label31;
  GtkWidget *label32;
  GtkWidget *RelTextDown;
  GtkWidget *label34;
  GtkWidget *label29;
  GtkWidget *label30;
  GtkWidget *label35;
  GtkWidget *label33;
  GtkWidget *hseparator6;
  GtkWidget *RelIsTextDown;
  GtkWidget *RelIsTab;
  GtkWidget *RelIsTextUp;
  GtkWidget *vseparator1;
  GtkWidget *vseparator2;
  GtkWidget *hseparator5;

  Relance = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (Relance), "Relance", Relance);
  gtk_window_set_title (GTK_WINDOW (Relance), _("Lettres de relance"));

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox4);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "vbox4", vbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (Relance), vbox4);

  toolbar1 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_toolbar_set_button_relief(GTK_TOOLBAR (toolbar1),GTK_RELIEF_NONE);
  gtk_widget_ref (toolbar1);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "toolbar1", toolbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar1);
  gtk_box_pack_start (GTK_BOX (vbox4), toolbar1, FALSE, FALSE, 4);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (Relance, GNOME_STOCK_PIXMAP_NEW);
  BtNew = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Nouveau"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (BtNew);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "BtNew", BtNew,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtNew);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (Relance, GNOME_STOCK_PIXMAP_SAVE);
  BtModify = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Modifier"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (BtModify);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "BtModify", BtModify,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtModify);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (Relance, GNOME_STOCK_PIXMAP_TRASH);
  BtDelete = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Supprimer"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (BtDelete);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "BtDelete", BtDelete,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtDelete);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (Relance, GNOME_STOCK_PIXMAP_EXIT);
  BtQuit = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Quitter"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (BtQuit);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "BtQuit", BtQuit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtQuit);

  fixed5 = gtk_fixed_new ();
  gtk_widget_ref (fixed5);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "fixed5", fixed5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed5);
  gtk_box_pack_start (GTK_BOX (vbox4), fixed5, TRUE, TRUE, 0);

  NumLettre_adj = gtk_adjustment_new (1,1, 100, 1, 1, 1);
  NumLettre = gtk_spin_button_new (GTK_ADJUSTMENT (NumLettre_adj),1,0);
  gtk_widget_ref (NumLettre);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "NumLettre", NumLettre,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (NumLettre);
  gtk_fixed_put (GTK_FIXED (fixed5), NumLettre, 136, 12);
  gtk_widget_set_uposition (NumLettre, 136, 12);
  gtk_widget_set_usize (NumLettre, 45, 22);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (NumLettre), TRUE);

  RelVille = gtk_entry_new_with_max_length (40);
  gtk_widget_ref (RelVille);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "RelVille", RelVille,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RelVille);
  gtk_fixed_put (GTK_FIXED (fixed5), RelVille, 56, 40);
  gtk_widget_set_uposition (RelVille, 56, 40);
  gtk_widget_set_usize (RelVille, 158, 22);

  RelObject = gtk_entry_new_with_max_length (60);
  gtk_widget_ref (RelObject);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "RelObject", RelObject,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RelObject);
  gtk_fixed_put (GTK_FIXED (fixed5), RelObject, 56, 64);
  gtk_widget_set_uposition (RelObject, 56, 64);
  gtk_widget_set_usize (RelObject, 240, 24);

  /* Texte haut */
  RelTextUp = gtk_text_new (NULL, NULL);
  gtk_widget_ref (RelTextUp);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "RelTextUp", RelTextUp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RelTextUp);
  gtk_fixed_put (GTK_FIXED (fixed5), RelTextUp, 20, 112);
  gtk_widget_set_uposition (RelTextUp, 20, 112);
  gtk_widget_set_usize (RelTextUp, 472, 72);
  gtk_text_set_editable (GTK_TEXT (RelTextUp), TRUE);
  gtk_text_set_word_wrap(GTK_TEXT (RelTextUp), TRUE);

  label31 = gtk_label_new (_("Objet :"));
  gtk_widget_ref (label31);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "label31", label31,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label31);
  gtk_fixed_put (GTK_FIXED (fixed5), label31, 12, 68);
  gtk_widget_set_uposition (label31, 12, 68);
  gtk_widget_set_usize (label31, 41, 16);
  gtk_misc_set_alignment (GTK_MISC (label31), 0, 0.5);

  /* Texte bas */
  label32 = gtk_label_new (_("Haut de lettre :"));
  gtk_widget_ref (label32);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "label32", label32,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label32);
  gtk_fixed_put (GTK_FIXED (fixed5), label32, 12, 96);
  gtk_widget_set_uposition (label32, 12, 96);
  gtk_widget_set_usize (label32, 92, 16);
  gtk_misc_set_alignment (GTK_MISC (label32), 0, 0.5);

  RelTextDown = gtk_text_new (NULL, NULL);
  gtk_widget_ref (RelTextDown);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "RelTextDown", RelTextDown,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RelTextDown);
  gtk_fixed_put (GTK_FIXED (fixed5), RelTextDown, 20, 212);
  gtk_widget_set_uposition (RelTextDown, 20, 212);
  gtk_widget_set_usize (RelTextDown, 472, 76);
  gtk_text_set_editable (GTK_TEXT (RelTextDown), TRUE);
  gtk_text_set_word_wrap(GTK_TEXT (RelTextDown), TRUE);

  label34 = gtk_label_new (_("Bas de lettre :"));
  gtk_widget_ref (label34);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "label34", label34,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label34);
  gtk_fixed_put (GTK_FIXED (fixed5), label34, 12, 196);
  gtk_widget_set_uposition (label34, 12, 196);
  gtk_widget_set_usize (label34, 88, 16);
  gtk_misc_set_alignment (GTK_MISC (label34), 0, 0.5);

  label29 = gtk_label_new (_("Lettre de relance n :"));
  gtk_widget_ref (label29);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "label29", label29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label29);
  gtk_fixed_put (GTK_FIXED (fixed5), label29, 12, 16);
  gtk_widget_set_uposition (label29, 12, 16);
  gtk_widget_set_usize (label29, 124, 16);
  gtk_label_set_justify (GTK_LABEL (label29), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label29), 0, 0.5);

  label30 = gtk_label_new (_("Ville :"));
  gtk_widget_ref (label30);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "label30", label30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label30);
  gtk_fixed_put (GTK_FIXED (fixed5), label30, 12, 44);
  gtk_widget_set_uposition (label30, 12, 44);
  gtk_widget_set_usize (label30, 41, 16);
  gtk_misc_set_alignment (GTK_MISC (label30), 0, 0.5);
  
  label35 = gtk_label_new (_("Emetteur :"));
  gtk_widget_ref (label35);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "label35", label35,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label35);
  gtk_fixed_put (GTK_FIXED (fixed5), label35, 12, 300);
  gtk_widget_set_uposition (label35, 12, 300);
  gtk_widget_set_usize (label35, 72, 16);
  gtk_misc_set_alignment (GTK_MISC (label35), 0, 0.5);

  label33 = gtk_label_new (_("Dans le cas ou vous voulez ajoutez la somme dans le texte, remplacez sa valeur par $$Valeur."));
  gtk_widget_ref (label33);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "label33", label33,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label33);
  gtk_fixed_put (GTK_FIXED (fixed5), label33, 16, 328);
  gtk_widget_set_uposition (label33, 16, 328);
  gtk_widget_set_usize (label33, 320, 36);
  gtk_label_set_line_wrap (GTK_LABEL (label33), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label33), 0, 0);

  RelEmet = gtk_entry_new_with_max_length (60);
  gtk_widget_ref (RelEmet);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "RelEmet", RelEmet,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RelEmet);
  gtk_fixed_put (GTK_FIXED (fixed5), RelEmet, 68, 296);
  gtk_widget_set_uposition (RelEmet, 68, 296);
  gtk_widget_set_usize (RelEmet, 228, 24);

  hseparator6 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator6);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "hseparator6", hseparator6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator6);
  gtk_fixed_put (GTK_FIXED (fixed5), hseparator6, 304, 84);
  gtk_widget_set_uposition (hseparator6, 304, 84);
  gtk_widget_set_usize (hseparator6, 180, 16);

  RelIsTextDown = gtk_check_button_new_with_label (_("Inclure texte aprs tableau"));
  gtk_widget_ref (RelIsTextDown);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "RelIsTextDown", RelIsTextDown,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RelIsTextDown);
  gtk_fixed_put (GTK_FIXED (fixed5), RelIsTextDown, 312, 52);
  gtk_widget_set_uposition (RelIsTextDown, 312, 52);
  gtk_widget_set_usize (RelIsTextDown, 168, 24);

  RelIsTab = gtk_check_button_new_with_label (_("Inclure tableau"));
  gtk_widget_ref (RelIsTab);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "RelIsTab", RelIsTab,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RelIsTab);
  gtk_fixed_put (GTK_FIXED (fixed5),RelIsTab, 312, 32);
  gtk_widget_set_uposition (RelIsTab, 312, 32);
  gtk_widget_set_usize (RelIsTab, 124, 24);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (RelIsTab), TRUE);

  RelIsTextUp = gtk_check_button_new_with_label (_("Inclure texte avant tableau"));
  gtk_widget_ref (RelIsTextUp);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "RelIsTextUp", RelIsTextUp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RelIsTextUp);
  gtk_fixed_put (GTK_FIXED (fixed5), RelIsTextUp, 312, 12);
  gtk_widget_set_uposition (RelIsTextUp, 312, 12);
  gtk_widget_set_usize (RelIsTextUp, 168, 24);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (RelIsTextUp), TRUE);

  vseparator1 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator1);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "vseparator1", vseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator1);
  gtk_fixed_put (GTK_FIXED (fixed5), vseparator1, 296, 8);
  gtk_widget_set_uposition (vseparator1, 296, 8);
  gtk_widget_set_usize (vseparator1, 16, 84);

  vseparator2 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator2);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "vseparator2", vseparator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator2);
  gtk_fixed_put (GTK_FIXED (fixed5), vseparator2, 476, 8);
  gtk_widget_set_uposition (vseparator2, 476, 8);
  gtk_widget_set_usize (vseparator2, 16, 84);

  hseparator5 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator5);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "hseparator5", hseparator5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator5);
  gtk_fixed_put (GTK_FIXED (fixed5), hseparator5, 304, 0);
  gtk_widget_set_uposition (hseparator5, 304, 0);
  gtk_widget_set_usize (hseparator5, 180, 16);

  gtk_signal_connect (GTK_OBJECT (Relance), "show",
                      GTK_SIGNAL_FUNC (Relance_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Relance), "destroy",
                      GTK_SIGNAL_FUNC (Relance_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (NumLettre), "changed",
                      GTK_SIGNAL_FUNC (on_NumLettre_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (BtNew), "clicked",
                      GTK_SIGNAL_FUNC (Rel_BtNew_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (BtModify), "clicked",
                      GTK_SIGNAL_FUNC (Rel_BtModify_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (BtDelete), "clicked",
                      GTK_SIGNAL_FUNC (Rel_BtDelete_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (BtQuit), "clicked",
                      GTK_SIGNAL_FUNC (Rel_BtQuit_clicked),
                      NULL);
  return Relance;
}

void Dialog_Relance(void)
{
	ConfMode=TRUE;
	Relance=create_Relance();
	gtk_widget_show_all(Relance);
	RelanceDisplay();
}

/****************************************************************************************/
/* SAISIE D'UNE LETTRE DE RELANCE                                                       */
/****************************************************************************************/
/* Recupration de la valeur de la relance *************************************/
int GetValor(float *Val)
{
	gchar *SqlCmd,PsCle[LEN_COD_SOC+1];
	MYSQL_RES *Result;
	MYSQL_ROW Row;
	float Sum;
	int Ok;

	GetSocRun(PsCle);
	Sum=0;
	Ok=FALSE;
  SqlCmd=g_strdup_printf("Select Sum(EcrDebit)-Sum(EcrCredit) From Ecrit Where EcrSoc='%s' And EcrCpt='%s'",PsCle,CptCodeRel);	
	if (mysql_query(DbLcpt,SqlCmd)==0) {
    Result=mysql_store_result(DbLcpt);
    if ((Row=mysql_fetch_row(Result))) {
			if (Row[0]!=NULL) {
				Sum=atof(Row[0]);
				Ok=TRUE;
			}
		}
		mysql_free_result(Result);
	}
	*Val=Sum;
	return (Ok);
}

/* Recherche la chaine $$valeur et la remplace par la valeur de la relance ****/
gchar *ReplaceValor(gchar *Txt)
{
	float Sum;
	gchar *Num,*PtNum,*Dest,*Pd,*Ps;
	
	Dest=NULL;
	if (GetValor(&Sum)) {
		Num=g_strdup_printf("%7.2f",Sum);
		Dest=(gchar *) malloc(strlen(Txt)+strlen(Num)+5);
		Pd=Dest;
		Ps=Txt;
		while (*Ps) {
			if ((*Ps=='$') && (*(Ps+1)=='$')) {
				if (strncasecmp(Ps+2,"valeur",6)==0) {
					PtNum=Num;
					while (*PtNum) *Pd++=*PtNum++;
					Ps+=8;
				}
			} else *Pd++=*Ps++;
		}
		*Pd=0;
		free(Num);
	}
	return (Dest);
}

/* Impression entete socit ***************************************************/
void Rel_PrintHeader(gchar *PsCle)
{
	gchar *SqlCmd;
	MYSQL_RES *Result;
	MYSQL_ROW Row;
	
	SqlCmd=g_strdup_printf("Select PsNom,PsAdr1,PsAdr2,PsTel,PsFax,PsTetCp,PsTetVil,PsSiret From Societe where PsCle='%s'",PsCle);
	if (mysql_query(DbLcpt,SqlCmd)==0) {
		Result=mysql_store_result(DbLcpt);
		if ((Row=mysql_fetch_row(Result))) {
			PS_setFont("Helvetica",14,FNT_BOLD);
			PS_print(Row[0]);
			PS_sendReturn();
			PS_setFont("Helvetica",12,FNT_NORMAL);
			PS_print(Row[1]);
			PS_sendReturn();
      PS_print(Row[2]);
			PS_sendReturn();			
      PS_print(Row[5]);
			PS_print(" ");
			PS_print(Row[6]);
			PS_sendReturn();
			PS_print("Sirect :");
			PS_print(Row[7]);
			PS_sendReturn();
			PS_print("Tl :");
			PS_print(Row[3]);
			PS_sendReturn();
			PS_print("Fax :");
			PS_print(Row[4]);
			PS_sendReturn();
		}
		mysql_free_result(Result);
	}
	free(SqlCmd);
}

void PrintRelance(gchar *Code)
{
	gchar *SqlCmd,PsCle[LEN_COD_SOC+1],*Txt;
	MYSQL_RES *Result;
	MYSQL_ROW Row;
	
	GetSocRun(PsCle);
	SqlCmd=g_strdup_printf("Select * From Relance where RcCode='%s' And RcSoc='%s'",Code,PsCle);
	if (mysql_query(DbLcpt,SqlCmd)==0) {
		PS_beginPrint(1,"Lettre de relance",NULL,NULL);
		Result=mysql_store_result(DbLcpt);
		if ((Row=mysql_fetch_row(Result))) {
			Rel_PrintHeader(PsCle);
			PS_xyprint(25,75,"Objet :");
			PS_print(Row[4]);
			PS_xyprint(110,75,Row[3]);
			PS_print(" le ");
			PS_print(Row[2]);
			if (*Row[5]=='Y') {
				Txt=ReplaceValor(Row[8]);
				PS_blockPrint(10,90,Txt);
				free(Txt);
			}
			if (*Row[6]=='Y') {
				Txt=ReplaceValor(Row[9]);
				PS_blockPrint(10,90,Txt);
				free(Txt);
			}
			PS_xyprint(130,75,Row[10]);
		}
		mysql_free_result(Result);
		PS_endPrint("lpr");
	} else MessageAlerte(_("Impression erreur\nLettre de relance introuvable !"));
	free(SqlCmd);
}

void DoAppendComment(gchar *PsCle,gchar *Txt)
{
	gchar *SqlCmd,*NewTxt,*NewTxt2;
	MYSQL_RES *Result;
	MYSQL_ROW Row;

  SqlCmd=g_strdup_printf("Select Count(*) From Comment Where CSoc='%s' And CCpt='%s'",PsCle,CptCodeRel);
	if (SqlGetNumber(SqlCmd)!=0) {
		free(SqlCmd);
    SqlCmd=g_strdup_printf("Select CComment From Comment Where CSoc='%s' And CCpt='%s'",PsCle,CptCodeRel);
		if (mysql_query(DbLcpt,SqlCmd)==0) {
			Result=mysql_store_result(DbLcpt);
			if ((Row=mysql_fetch_row(Result))) {
				free(SqlCmd);
				NewTxt=g_strdup_printf("%s\n%s",Row[0],Txt);
				NewTxt2=(gchar *) malloc(strlen(NewTxt)+100);
				mysql_escape_string(NewTxt2,NewTxt,strlen(NewTxt));
				SqlCmd=g_strdup_printf("Update Comment Set CComment='%s' Where CSoc='%s' And CCpt='%s'",NewTxt2,PsCle,CptCodeRel);
				if (mysql_query(DbLcpt,SqlCmd)!=0) MessageAlerte(_("Impossible d'ajouter un commentaire !"));
				free(SqlCmd);
				free(NewTxt);
				free(NewTxt2);
			}
		}
	} else {
		free(SqlCmd);
		SqlCmd=g_strdup_printf("Insert into Comment (CSoc,CCpt,CComment) values ('%s','%s','%s')",PsCle,CptCodeRel,Txt);
  	if (mysql_query(DbLcpt,SqlCmd)!=0) MessageAlerte(_("Impossible d'ajouter un commentaire !"));
	  free(SqlCmd);		
	}
}

void AppendComment(char *Dte)
{
	gchar *Txt,PsCle[LEN_COD_SOC+1];
	float Sum;
	
	GetSocRun(PsCle);
  if (GetValor(&Sum)) {
		if (Sum!=0)	{	
	  	Txt=g_strdup_printf("Lettre de relance pour la somme de %7.2f Euros le %s",Sum,Dte);
			DoAppendComment(PsCle,Txt);
			free(Txt);
		}
	}
}

void Rel_BtSave_clicked(GtkButton *button,gpointer  user_data)
{
	GtkWidget *Wdg;
	gchar SqlCmd[2048],PsCle[LEN_COD_SOC+1],CodeRel[11],*End,*Ptr,DateForComment[15];
	MYSQL_RES *Res;
	MYSQL_ROW Row;
	int MaxCode;

	GetSocRun(PsCle);
	Wdg=lookup_widget(GTK_WIDGET (Relance),"NumLettre");
	Rel_CodeDisplay=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON (Wdg));
	sprintf(SqlCmd,"Select Max(right(RcCode,2)) From Relance Where RelSoc='%s' and Left(RcCode,8)=Left('%s',8)",PsCle,CptCodeRel);
	MaxCode=SqlGetNumber(SqlCmd);
	sprintf(SqlCmd,"Select * From RelConf Where RelSoc='%s' and RelCode='%02i'",PsCle,Rel_CodeDisplay);
	if (!mysql_query(DbLcpt,SqlCmd)) {
		Res=mysql_store_result(DbLcpt);
		Row=mysql_fetch_row(Res);
		sprintf(CodeRel,"%s%02i",CptCodeRel,MaxCode+1);
		End=strmov(SqlCmd,"Insert into Relance (RcCode,RcSoc,RcDate,RcVille,RcObject,RcIsTextUp,RcIsTextDown,RcIsTab,RcTextUp,RcTextDown,RcEmet) values (");
		End=StrSql(End,CodeRel);
		*End++=',';
		End=StrSql(End,PsCle);
		*End++=',';
		End=GtkToDateSql(End,GTK_WIDGET (Relance),"RelDate");
		*End++=',';
		End=GtkToStrSql(End,GTK_WIDGET (Relance),"RelVille");
		*End++=',';
		End=GtkToStrSql(End,GTK_WIDGET (Relance),"RelObject");
		*End++=',';
		*End++='\'';
		End=strmov(End,Row[4]);
		*End++='\'';		
		*End++=',';
		*End++='\'';		
		End=strmov(End,Row[5]);
		*End++='\'';		
		*End++=',';
		*End++='\'';		
		End=strmov(End,Row[6]);
		*End++='\'';		
		*End++=',';
		/* Texte Haut */
		*End++='\'';
    Wdg=lookup_widget(GTK_WIDGET (button),"RelTextUp");
		Ptr=gtk_editable_get_chars(GTK_EDITABLE (Wdg),0,-1);
		if (Ptr!=NULL) End+=mysql_escape_string(End,Ptr,strlen(Ptr));	
		*End++='\'';
		*End++=',';
		/* Texte Bas */
		*End++='\'';
    Wdg=lookup_widget(GTK_WIDGET (button),"RelTextDown");
		Ptr=gtk_editable_get_chars(GTK_EDITABLE (Wdg),0,-1);
		if (Ptr!=NULL) End+=mysql_escape_string(End,Ptr,strlen(Ptr));	
		*End++='\'';
		*End++=',';
		End=GtkToStrSql(End,GTK_WIDGET (Relance),"RelEmet");
		*End++=')';
		*End='\0';
		if (verbose) g_print("%s\n",SqlCmd);
		if (mysql_query(DbLcpt,SqlCmd)==0) {
			PrintRelance(CodeRel);
	    Wdg=lookup_widget(GTK_WIDGET (button),"RelDate");
			strcpy(DateForComment,gtk_entry_get_text(GTK_ENTRY(Wdg)));
			AppendComment(DateForComment);
			gtk_widget_destroy(Relance);
		} else MessageAlerte(_("Impossible d'ajouter cette lettre de relance !"));
	} else MessageAlerte(_("Impossible de crer cette lettre de relance !"));
}

GtkWidget* create_RelanceEdit(void)
{
  GtkWidget *Relance;
  GtkWidget *vbox4;
  GtkWidget *toolbar1;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *BtSave;
  GtkWidget *BtQuit;
  GtkWidget *fixed5;
  GtkObject *NumLettre_adj;
  GtkWidget *NumLettre;
  GtkWidget *RelVille;
  GtkWidget *RelObject;
  GtkWidget *RelTextUp;
  GtkWidget *label31;
  GtkWidget *label32;
  GtkWidget *RelTextDown;
  GtkWidget *label34;
  GtkWidget *label29;
  GtkWidget *label30;
  GtkWidget *label35;
  GtkWidget *labeldate;	
  GtkWidget *RelDate;
  GtkWidget *RelEmet;
  
  Relance = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (Relance), "Relance", Relance);
  gtk_window_set_title (GTK_WINDOW (Relance), _("Lettres de relance"));
	gtk_window_set_modal(GTK_WINDOW (Relance),TRUE);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox4);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "vbox4", vbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (Relance), vbox4);
  
  toolbar1 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_toolbar_set_button_relief(GTK_TOOLBAR (toolbar1),GTK_RELIEF_NONE);
  gtk_widget_ref (toolbar1);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "toolbar1", toolbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar1);
  gtk_box_pack_start (GTK_BOX (vbox4), toolbar1, FALSE, FALSE, 4);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (Relance, GNOME_STOCK_PIXMAP_SAVE);
  BtSave = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Enregistrer"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (BtSave);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "BtSave", BtSave,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtSave);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (Relance, GNOME_STOCK_PIXMAP_QUIT);
  BtQuit = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Quitter"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (BtQuit);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "BtQuit", BtQuit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (BtQuit);

	/****/  

  fixed5 = gtk_fixed_new ();
  gtk_widget_ref (fixed5);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "fixed5", fixed5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed5);
  gtk_box_pack_start (GTK_BOX (vbox4), fixed5, TRUE, TRUE, 6);

  NumLettre_adj = gtk_adjustment_new (1,1, 100, 1, 1, 1);
  NumLettre = gtk_spin_button_new (GTK_ADJUSTMENT (NumLettre_adj),1,0);
  gtk_widget_ref (NumLettre);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "NumLettre", NumLettre,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (NumLettre);
  gtk_fixed_put (GTK_FIXED (fixed5), NumLettre, 136, 12);
  gtk_widget_set_uposition (NumLettre, 136, 12);
  gtk_widget_set_usize (NumLettre, 45, 22);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (NumLettre), TRUE);

  RelVille = gtk_entry_new_with_max_length (40);
  gtk_widget_ref (RelVille);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "RelVille", RelVille,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RelVille);
  gtk_fixed_put (GTK_FIXED (fixed5), RelVille, 56, 40);
  gtk_widget_set_uposition (RelVille, 56, 40);
  gtk_widget_set_usize (RelVille, 158, 22);

  RelObject = gtk_entry_new_with_max_length (60);
  gtk_widget_ref (RelObject);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "RelObject", RelObject,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RelObject);
  gtk_fixed_put (GTK_FIXED (fixed5), RelObject, 56, 64);
  gtk_widget_set_uposition (RelObject, 56, 64);
  gtk_widget_set_usize (RelObject, 240, 24);

  /* Texte haut */
  RelTextUp = gtk_text_new (NULL, NULL);
  gtk_widget_ref (RelTextUp);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "RelTextUp", RelTextUp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RelTextUp);
  gtk_fixed_put (GTK_FIXED (fixed5), RelTextUp, 20, 112);
  gtk_widget_set_uposition (RelTextUp, 20, 112);
  gtk_widget_set_usize (RelTextUp, 472, 72);
  gtk_text_set_editable (GTK_TEXT (RelTextUp), TRUE);
  gtk_text_set_word_wrap(GTK_TEXT (RelTextUp), TRUE);

  label31 = gtk_label_new (_("Objet :"));
  gtk_widget_ref (label31);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "label31", label31,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label31);
  gtk_fixed_put (GTK_FIXED (fixed5), label31, 12, 68);
  gtk_widget_set_uposition (label31, 12, 68);
  gtk_widget_set_usize (label31, 41, 16);
  gtk_misc_set_alignment (GTK_MISC (label31), 0, 0.5);

  /* Texte bas */
  label32 = gtk_label_new (_("Haut de lettre :"));
  gtk_widget_ref (label32);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "label32", label32,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label32);
  gtk_fixed_put (GTK_FIXED (fixed5), label32, 12, 96);
  gtk_widget_set_uposition (label32, 12, 96);
  gtk_widget_set_usize (label32, 92, 16);
  gtk_misc_set_alignment (GTK_MISC (label32), 0, 0.5);

  RelTextDown = gtk_text_new (NULL, NULL);
  gtk_widget_ref (RelTextDown);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "RelTextDown", RelTextDown,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RelTextDown);
  gtk_fixed_put (GTK_FIXED (fixed5), RelTextDown, 20, 212);
  gtk_widget_set_uposition (RelTextDown, 20, 212);
  gtk_widget_set_usize (RelTextDown, 472, 76);
  gtk_text_set_editable (GTK_TEXT (RelTextDown), TRUE);
  gtk_text_set_word_wrap(GTK_TEXT (RelTextDown), TRUE);

  label34 = gtk_label_new (_("Bas de lettre :"));
  gtk_widget_ref (label34);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "label34", label34,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label34);
  gtk_fixed_put (GTK_FIXED (fixed5), label34, 12, 196);
  gtk_widget_set_uposition (label34, 12, 196);
  gtk_widget_set_usize (label34, 88, 16);
  gtk_misc_set_alignment (GTK_MISC (label34), 0, 0.5);

  label29 = gtk_label_new (_("Lettre de relance n :"));
  gtk_widget_ref (label29);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "label29", label29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label29);
  gtk_fixed_put (GTK_FIXED (fixed5), label29, 12, 16);
  gtk_widget_set_uposition (label29, 12, 16);
  gtk_widget_set_usize (label29, 124, 16);
  gtk_label_set_justify (GTK_LABEL (label29), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label29), 0, 0.5);

  label30 = gtk_label_new (_("Ville :"));
  gtk_widget_ref (label30);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "label30", label30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label30);
  gtk_fixed_put (GTK_FIXED (fixed5), label30, 12, 44);
  gtk_widget_set_uposition (label30, 12, 44);
  gtk_widget_set_usize (label30, 41, 16);
  gtk_misc_set_alignment (GTK_MISC (label30), 0, 0.5);
  
  labeldate = gtk_label_new (_("Date :"));
  gtk_widget_ref (labeldate);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "labeldate", labeldate,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (labeldate);
  gtk_fixed_put (GTK_FIXED (fixed5), labeldate, 245, 44);
  gtk_widget_set_uposition (labeldate, 245, 44);
  gtk_widget_set_usize (labeldate, 41, 16);
  gtk_misc_set_alignment (GTK_MISC (labeldate), 0, 0.5);
  
  RelDate = gtk_entry_new_with_max_length (12);
  gtk_widget_ref (RelDate);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "RelDate", RelDate,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RelDate);
  gtk_fixed_put (GTK_FIXED (fixed5), RelDate, 290, 40);
  gtk_widget_set_uposition (RelDate, 290, 40);
  gtk_widget_set_usize (RelDate, 75, 24);

  label35 = gtk_label_new (_("Emetteur :"));
  gtk_widget_ref (label35);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "label35", label35,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label35);
  gtk_fixed_put (GTK_FIXED (fixed5), label35, 12, 300);
  gtk_widget_set_uposition (label35, 12, 300);
  gtk_widget_set_usize (label35, 72, 16);
  gtk_misc_set_alignment (GTK_MISC (label35), 0, 0.5);

  RelEmet = gtk_entry_new_with_max_length (60);
  gtk_widget_ref (RelEmet);
  gtk_object_set_data_full (GTK_OBJECT (Relance), "RelEmet", RelEmet,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RelEmet);
  gtk_fixed_put (GTK_FIXED (fixed5), RelEmet, 68, 296);
  gtk_widget_set_uposition (RelEmet, 68, 296);
  gtk_widget_set_usize (RelEmet, 228, 24);

  gtk_signal_connect (GTK_OBJECT (Relance), "show",
                      GTK_SIGNAL_FUNC (Relance_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Relance), "destroy",
                      GTK_SIGNAL_FUNC (Relance_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (NumLettre), "changed",
                      GTK_SIGNAL_FUNC (on_NumLettre_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (BtSave), "clicked",
                      GTK_SIGNAL_FUNC (Rel_BtSave_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (BtQuit), "clicked",
                      GTK_SIGNAL_FUNC (Rel_BtQuit_clicked),
                      NULL);
/*  gtk_signal_connect (GTK_OBJECT (RelDate), "changed",
                      GTK_SIGNAL_FUNC (ControleSaisieDate),
                      NULL);*/
  return Relance;
}

void Dialog_RelanceNew(gchar *Cpt)
{
	strcpy(CptCodeRel,Cpt);
	ConfMode=FALSE;
	Relance=create_RelanceEdit();
	gtk_widget_show_all(Relance);
	RelanceDisplay();
}
