/*******************************************************************/
/* Comptabilit Analytique Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 28/04/02 - Visualisation de la recherche                        */
/* Fichier source                                                  */
/*******************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 


#include <gtk/gtk.h>
#include <gnome.h>
#include <string.h>
#include <ctype.h>
#include <mysql/mysql.h>
#include "support.h"
#include "common.h"
#include "gtksql.h"
#include "select.h"

#include "result.h"

/* Variables */
MYSQL_RES    *ResSearch;
GtkWidget    *Consult;
/* Protos */
GtkWidget* create_ResultSearch (void);
void Dialog_ResultSearch(MYSQL_RES *Re);
void ResSearch_DispData(void);
void ResSearch_DispTab(void);
void on_ResSearch_BtFermer_clicked        (GtkButton       *button,
                                        gpointer         user_data);
void on_ResSearch_destroy(GtkObject *object,gpointer user_data);
void on_ResSearch_show(GtkWidget *widget,gpointer user_data);
/********************************************************************/
/* Fenetre principale ***********************************************/
void ResSearch_DispTab(void)
{
  GtkWidget *ListHis;
  gchar *Ptr[11],Tmp[15];
  MYSQL_ROW Row;
  gint Ligne;

  ListHis=lookup_widget(GTK_WIDGET (Consult),"ListEcr");
  gtk_clist_freeze(GTK_CLIST (ListHis));
  gtk_clist_clear(GTK_CLIST (ListHis));
  while ((Row=mysql_fetch_row(ResSearch))) {
    IsoToDate(Tmp,Row[3]);
    Ptr[0]=Tmp;
    Ptr[1]=Row[9];
    Ptr[2]=Row[4];
    Ptr[3]=Row[2];
    Ptr[4]=Row[5]+2;
    Ptr[5]=Row[13];
    Ptr[6]=Row[14];
    Ptr[7]=Row[19];
    Ptr[8]=Row[20];
    Ptr[9]=Row[12];
    Ptr[10]=Row[10];
    Ligne=gtk_clist_append(GTK_CLIST (ListHis),Ptr);
    gtk_clist_set_row_data(GTK_CLIST (ListHis),Ligne,(gpointer) Row[1]);
  }
  gtk_clist_thaw(GTK_CLIST (ListHis));
}

void on_ResSearch_BtFermer_clicked(GtkButton *button,gpointer user_data)
{
  gtk_widget_destroy(GTK_WIDGET(Consult));
}

void on_ResSearch_show(GtkWidget *widget,gpointer user_data)
{
}

void on_ResSearch_destroy(GtkObject *object,gpointer user_data)
{
}

GtkWidget* create_ResultSearch(void)
{
  GtkWidget *ResultSearch;
  GtkWidget *vbox11;
  GtkWidget *scrolledwindow6;
  GtkWidget *ListEcr;
  GtkWidget *label110;
  GtkWidget *label111;
  GtkWidget *label112;
  GtkWidget *label112b;
  GtkWidget *label113;
  GtkWidget *label114;
  GtkWidget *label115;
  GtkWidget *label116;
  GtkWidget *label117;
  GtkWidget *label118;
  GtkWidget *label119;
  GtkWidget *Fixed;
  GtkWidget *VisCpt_BtFermer;
  gint i;

  ResultSearch = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (ResultSearch), "ResultSearch", ResultSearch);
  gtk_window_set_title (GTK_WINDOW (ResultSearch), _("Resultat des recherches"));
  gtk_window_set_position (GTK_WINDOW (ResultSearch), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (ResultSearch), TRUE);

  vbox11 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox11);
  gtk_object_set_data_full (GTK_OBJECT (ResultSearch), "vbox11", vbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox11);
  gtk_container_add (GTK_CONTAINER (ResultSearch), vbox11);
  gtk_widget_set_usize (vbox11, 819, 362);
  gtk_container_set_border_width (GTK_CONTAINER (vbox11), 4);

  scrolledwindow6 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow6);
  gtk_object_set_data_full (GTK_OBJECT (ResultSearch), "scrolledwindow6", scrolledwindow6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow6);
  gtk_box_pack_start (GTK_BOX (vbox11), scrolledwindow6, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow6), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  /*** Dbut du tableau ***/
  ListEcr = gtk_clist_new (11);
  gtk_widget_ref (ListEcr);
  gtk_object_set_data_full (GTK_OBJECT (ResultSearch), "ListEcr", ListEcr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ListEcr);
  gtk_container_add (GTK_CONTAINER (scrolledwindow6), ListEcr);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 0, 72);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 1, 163);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 2, 21);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 3, 59);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 4, 59);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 5, 19);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 6, 80);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 7, 80);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 8, 80);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr), 9, 17);
  gtk_clist_set_column_width (GTK_CLIST (ListEcr),10, 21);
  gtk_clist_column_titles_show (GTK_CLIST (ListEcr));
  for (i=0;i<11;i++) gtk_clist_set_column_resizeable(GTK_CLIST (ListEcr),i,FALSE);
  gtk_clist_set_column_justification(GTK_CLIST (ListEcr),7,GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_justification(GTK_CLIST (ListEcr),8,GTK_JUSTIFY_RIGHT);

  label110 = gtk_label_new (_("Date"));
  gtk_widget_ref (label110);
  gtk_object_set_data_full (GTK_OBJECT (ResultSearch), "label110", label110,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label110);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 0, label110);

  label111 = gtk_label_new (_("Libell"));
  gtk_widget_ref (label111);
  gtk_object_set_data_full (GTK_OBJECT (ResultSearch), "label111", label111,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label111);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 1, label111);

  label112 = gtk_label_new (_("Jrn"));
  gtk_widget_ref (label112);
  gtk_object_set_data_full (GTK_OBJECT (ResultSearch), "label112", label112,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label112);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 2, label112);

  label112b = gtk_label_new (_("Compte"));
  gtk_widget_ref (label110);
  gtk_object_set_data_full (GTK_OBJECT (ResultSearch), "label112b", label112b,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label112b);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 3, label112b);

  label113 = gtk_label_new (_("Pice"));
  gtk_widget_ref (label113);
  gtk_object_set_data_full (GTK_OBJECT (ResultSearch), "label113", label113,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label113);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 4, label113);

  label114 = gtk_label_new (_("Rg"));
  gtk_widget_ref (label114);
  gtk_object_set_data_full (GTK_OBJECT (ResultSearch), "label114", label114,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label114);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 5, label114);

  label115 = gtk_label_new (_("Echance"));
  gtk_widget_ref (label115);
  gtk_object_set_data_full (GTK_OBJECT (ResultSearch), "label115", label115,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label115);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 6, label115);

  label116 = gtk_label_new (_("Dbit"));
  gtk_widget_ref (label116);
  gtk_object_set_data_full (GTK_OBJECT (ResultSearch), "label116", label116,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label116);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 7, label116);

  label117 = gtk_label_new (_("Crdit"));
  gtk_widget_ref (label117);
  gtk_object_set_data_full (GTK_OBJECT (ResultSearch), "label117", label117,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label117);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 8, label117);

  label118 = gtk_label_new (_("P"));
  gtk_widget_ref (label118);
  gtk_object_set_data_full (GTK_OBJECT (ResultSearch), "label118", label118,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label118);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr), 9, label118);

  label119 = gtk_label_new (_("Lett."));
  gtk_widget_ref (label119);
  gtk_object_set_data_full (GTK_OBJECT (ResultSearch), "label119", label119,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label119);
  gtk_clist_set_column_widget (GTK_CLIST (ListEcr),10, label119);
  /*** Fin du tableau ***/

  Fixed=gtk_fixed_new();
  gtk_box_pack_start(GTK_BOX (vbox11),Fixed,FALSE,FALSE,0);

  VisCpt_BtFermer = gnome_stock_button (GNOME_STOCK_BUTTON_CLOSE);
  gtk_widget_ref (VisCpt_BtFermer);
  gtk_object_set_data_full (GTK_OBJECT (ResultSearch), "VisCpt_BtFermer", VisCpt_BtFermer,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (VisCpt_BtFermer);
  gtk_fixed_put(GTK_FIXED (Fixed),VisCpt_BtFermer,730,10);

  gtk_signal_connect (GTK_OBJECT (ResultSearch), "show",
                      GTK_SIGNAL_FUNC (on_ResSearch_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ResultSearch), "destroy",
                      GTK_SIGNAL_FUNC (on_ResSearch_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (VisCpt_BtFermer), "clicked",
                      GTK_SIGNAL_FUNC (on_ResSearch_BtFermer_clicked),
                      NULL);

  return ResultSearch;
}

void Dialog_ResSearch(MYSQL_RES *Re)
{
  Consult=create_ResultSearch();
  gtk_widget_show_all(Consult);
  ResSearch=Re;
  ResSearch_DispTab();
}
