/*******************************************************************/
/* Comptabilit Analytique Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* Procdures de recherche                                         */
/* Fichier source                                                  */
/*******************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 


#include <gtk/gtk.h>
#include <gnome.h>
#include <mysql/mysql.h>

#include "support.h"
#include "common.h"
#include "search.h"

int       ModalResult;
MYSQL_RES *Retour;
GtkWidget *WinSearch;
gchar     Journal[3];

/*** protos ***/
GtkWidget* create_SearchOp (void);
void on_Search_BtOk_clicked(GtkButton *button,gpointer user_data);
void on_OptionSearch_clicked(GtkWidget *button,GtkStateType state,gpointer user_data);
void Search_BtCancel_clicked(GtkButton *button,gpointer user_data);

/****************************************************************/
/* Recherche ****************************************************/
void on_Search_BtOk_clicked(GtkButton *button,gpointer user_data)
{
  GtkWidget *Menu,*Option,*WTx1,*WTx2,*WInc;
  gint Ts,Or;
  gchar *text,Txt1[25],Txt2[25],PsCle[LEN_COD_SOC+1],SqlCmd[260],V1[15],V2[15],*End;
  double a,b,c;

  Ts=Or=1;
  Menu=lookup_widget(GTK_WIDGET (button),"TypeSearch");
  if (GTK_BIN (Menu)->child) {
    Option = GTK_BIN (Menu)->child;
    if (GTK_IS_LABEL (Option)) {
      gtk_label_get (GTK_LABEL (Option), &text);
      if (strcmp(text,"Rechercher un montant")==0) Ts=1;else Ts=2;
    }
  }
  Menu=lookup_widget(GTK_WIDGET (button),"OptionSearch");
  if (GTK_BIN (Menu)->child) {
    Option = GTK_BIN (Menu)->child;
    if (GTK_IS_LABEL (Option)) {
      gtk_label_get (GTK_LABEL (Option), &text);
      if (strcmp(text,"Exacte")==0) Or=1;
      else if (strcmp(text,"Approximative")==0) Or=2;
      else Or=3;
    }
  }
  GetSocRun(PsCle);
  WTx1=lookup_widget(GTK_WIDGET (button),"Search_Txt1");
  WTx2=lookup_widget(GTK_WIDGET (button),"Search_Txt2");
  if (Ts==1) {
    WInc=lookup_widget(GTK_WIDGET (button),"Search_Approx");
    a=atof(gtk_entry_get_text(GTK_ENTRY (WTx1)));
    b=atof(gtk_entry_get_text(GTK_ENTRY (WTx2)));
    c=gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON (WInc));
    switch (Or)
      {
      case 1 : 
	sprintf(V1,"%8.2f",a);
	End=strmov(SqlCmd,"Select * From Ecrit Where (EcrDebit=");
	End=NumSql(End,V1);
	End=strmov(End," Or EcrCredit=");
	End=NumSql(End,V1);
	End=strmov(End,") And EcrSoc=");
	End=StrSql(End,PsCle);
	if (*Journal) {
	  End=strmov(End," And EcrJrn=");
	  End=StrSql(End,Journal);
	}
	break;
      case 2 :
	sprintf(V1,"%8.2f",a-c);
	sprintf(V2,"%8.2f",a+c);
	End=strmov(SqlCmd,"Select * From Ecrit Where (EcrDebit Between ");
	End=NumSql(End,V1);
	End=strmov(End," And ");
	End=NumSql(End,V2);
	End=strmov(End," Or EcrCredit Between ");
	End=NumSql(End,V1);
	End=strmov(End," And ");
	End=NumSql(End,V2);
	End=strmov(End,") And EcrSoc=");
	End=StrSql(End,PsCle);
	if (*Journal) {
	  End=strmov(End," And EcrJrn=");
	  End=StrSql(End,Journal);
	}
	break;
      case 3 : 
	sprintf(V1,"%8.2f",a);
	sprintf(V2,"%8.2f",b);
	End=strmov(SqlCmd,"Select * From Ecrit Where (EcrDebit Between ");
	End=NumSql(End,V1);
	End=strmov(End," And ");
	End=NumSql(End,V2);
	End=strmov(End," Or EcrCredit Between ");
	End=NumSql(End,V1);
	End=strmov(End," And ");
	End=NumSql(End,V2);
	End=strmov(End,") And EcrSoc=");
	End=StrSql(End,PsCle);
	if (*Journal) {
	  End=strmov(End," And EcrJrn=");
	  End=StrSql(End,Journal);
	}
	break;
      }
  } else {
    strcpy(Txt1,gtk_entry_get_text(GTK_ENTRY (WTx1)));
    strcpy(Txt2,gtk_entry_get_text(GTK_ENTRY (WTx2)));
    switch (Or)
      {
      case 1 : sprintf(SqlCmd,"Select * From Ecrit Where EcrLib='%s' And EcrSoc='%s'",Txt1,PsCle);
	break;
      case 2 : sprintf(SqlCmd,"Select * From Ecrit Where EcrLib Like '%%%s%%' And EcrSoc='%s'",Txt1,PsCle);
	break;
      case 3 : sprintf(SqlCmd,"Select * From Ecrit Where EcrLib Between '%s' And '%s' And EcrSoc='%s'",Txt1,Txt2,PsCle);
	break;
      }
  }
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    Retour=mysql_store_result(DbLcpt);
    if (mysql_num_rows(Retour)==0) {
      MessageInfo(_("Pas d'criture(s) correspondante(s) !"));
    } else {
      ModalResult=MR_OK;
      gtk_widget_destroy(WinSearch);
    }
  } else MessageAlerte(_("Erreur sur requte !"));
}

void on_OptionSearch_clicked(GtkWidget *button,GtkStateType state,gpointer user_data)
{
  GtkWidget *Menu,*Option,*Widget;
  gint Or;
  gchar *text;

  Or=1;
  Menu=lookup_widget(GTK_WIDGET (button),"OptionSearch");
  if (GTK_BIN (Menu)->child) {
    Option = GTK_BIN (Menu)->child;
    if (GTK_IS_LABEL (Option)) {
      gtk_label_get (GTK_LABEL (Option), &text);
      if (strcmp(text,"Exacte")==0) Or=1;
      else if (strcmp(text,"Approximative")==0) Or=2;
      else Or=3;
    }
  }
  switch (Or)
    {
    case 1 : Widget=lookup_widget(GTK_WIDGET (button),"Search_Txt2");
             gtk_widget_set_sensitive(Widget,FALSE);
	     gtk_entry_set_editable(GTK_ENTRY (Widget),FALSE);
	     Widget=lookup_widget(GTK_WIDGET (button),"Search_Approx");
	     gtk_widget_set_sensitive(Widget,FALSE);
	     break;
    case 2 : Widget=lookup_widget(GTK_WIDGET (button),"Search_Txt2");
             gtk_widget_set_sensitive(Widget,FALSE);
	     gtk_entry_set_editable(GTK_ENTRY (Widget),FALSE);
	     Widget=lookup_widget(GTK_WIDGET (button),"Search_Approx");
	     gtk_widget_set_sensitive(Widget,TRUE);
	     break;
    case 3 : Widget=lookup_widget(GTK_WIDGET (button),"Search_Txt2");
             gtk_widget_set_sensitive(Widget,TRUE);
	     gtk_entry_set_editable(GTK_ENTRY (Widget),TRUE);
	     Widget=lookup_widget(GTK_WIDGET (button),"Search_Approx");
	     gtk_widget_set_sensitive(Widget,FALSE);
	     break;
    }
}

void Search_BtCancel_clicked(GtkButton *button,gpointer user_data)
{
  Retour=NULL;
  ModalResult=MR_CANCEL;
  gtk_widget_destroy(GTK_WIDGET (button));
}

GtkWidget* create_SearchOp (void)
{
  GtkWidget *SearchOp;
  GtkWidget *vbox15;
  GtkWidget *fixed13;
  GtkWidget *TypeSearch;
  GtkWidget *TypeSearch_menu;
  GtkWidget *glade_menuitem;
  GtkWidget *label145;
  GtkWidget *OptionSearch;
  GtkWidget *OptionSearch_menu;
  GtkWidget *Search_Txt1;
  GtkWidget *Search_Txt2;
  GtkObject *Search_Approx_adj;
  GtkWidget *Search_Approx;
  GtkWidget *label147;
  GtkWidget *hseparator16;
  GtkWidget *vseparator8;
  GtkWidget *hseparator18;
  GtkWidget *vseparator9;
  GtkWidget *label148;
  GtkWidget *label146;
  GtkWidget *fixed12;
  GtkWidget *Search_BtOk;
  GtkWidget *Search_BtCancel;
  GtkWidget *hseparator17;

  SearchOp = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (SearchOp), "SearchOp", SearchOp);
  gtk_window_set_title (GTK_WINDOW (SearchOp), _("Recherche Ecriture"));
  gtk_window_set_position (GTK_WINDOW (SearchOp), GTK_WIN_POS_CENTER);

  vbox15 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox15);
  gtk_object_set_data_full (GTK_OBJECT (SearchOp), "vbox15", vbox15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox15);
  gtk_container_add (GTK_CONTAINER (SearchOp), vbox15);

  fixed13 = gtk_fixed_new ();
  gtk_widget_ref (fixed13);
  gtk_object_set_data_full (GTK_OBJECT (SearchOp), "fixed13", fixed13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed13);
  gtk_box_pack_start (GTK_BOX (vbox15), fixed13, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (fixed13), 3);

  TypeSearch = gtk_option_menu_new ();
  gtk_widget_ref (TypeSearch);
  gtk_object_set_data_full (GTK_OBJECT (SearchOp), "TypeSearch", TypeSearch,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (TypeSearch);
  gtk_fixed_put (GTK_FIXED (fixed13), TypeSearch, 52, 28);
  gtk_widget_set_uposition (TypeSearch, 52, 28);
  gtk_widget_set_usize (TypeSearch, 172, 24);
  TypeSearch_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label (_("Rechercher un montant"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (TypeSearch_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("Rechercher un libell"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (TypeSearch_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (TypeSearch), TypeSearch_menu);

  label145 = gtk_label_new (_("Type de recherche :"));
  gtk_widget_ref (label145);
  gtk_object_set_data_full (GTK_OBJECT (SearchOp), "label145", label145,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label145);
  gtk_fixed_put (GTK_FIXED (fixed13), label145, 48, 8);
  gtk_widget_set_uposition (label145, 48, 8);
  gtk_widget_set_usize (label145, 124, 16);
  gtk_misc_set_alignment (GTK_MISC (label145), 0, 0.5);

  OptionSearch = gtk_option_menu_new ();
  gtk_widget_ref (OptionSearch);
  gtk_object_set_data_full (GTK_OBJECT (SearchOp), "OptionSearch", OptionSearch,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (OptionSearch);
  gtk_fixed_put (GTK_FIXED (fixed13), OptionSearch, 52, 76);
  gtk_widget_set_uposition (OptionSearch, 52, 76);
  gtk_widget_set_usize (OptionSearch, 172, 24);
  OptionSearch_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label (_("Exacte"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (OptionSearch_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("Approximative"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (OptionSearch_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("Borne"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (OptionSearch_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (OptionSearch), OptionSearch_menu);

  Search_Txt1 = gtk_entry_new_with_max_length (25);
  gtk_widget_ref (Search_Txt1);
  gtk_object_set_data_full (GTK_OBJECT (SearchOp), "Search_Txt1", Search_Txt1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Search_Txt1);
  gtk_fixed_put (GTK_FIXED (fixed13), Search_Txt1, 60, 140);
  gtk_widget_set_uposition (Search_Txt1, 60, 140);
  gtk_widget_set_usize (Search_Txt1, 76, 20);

  Search_Txt2 = gtk_entry_new_with_max_length (25);
  gtk_widget_ref (Search_Txt2);
  gtk_object_set_data_full (GTK_OBJECT (SearchOp), "Search_Txt2", Search_Txt2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Search_Txt2);
  gtk_fixed_put (GTK_FIXED (fixed13), Search_Txt2, 152, 140);
  gtk_widget_set_uposition (Search_Txt2, 152, 140);
  gtk_widget_set_usize (Search_Txt2, 76, 20);
  gtk_widget_set_sensitive (Search_Txt2, FALSE);

  Search_Approx_adj = gtk_adjustment_new (1, 0, 100, 1, 10, 10);
  Search_Approx = gtk_spin_button_new (GTK_ADJUSTMENT (Search_Approx_adj), 1, 0);
  gtk_widget_ref (Search_Approx);
  gtk_object_set_data_full (GTK_OBJECT (SearchOp), "Search_Approx", Search_Approx,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Search_Approx);
  gtk_fixed_put (GTK_FIXED (fixed13), Search_Approx, 316, 140);
  gtk_widget_set_uposition (Search_Approx, 316, 140);
  gtk_widget_set_usize (Search_Approx, 45, 22);
  gtk_widget_set_sensitive (Search_Approx, FALSE);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (Search_Approx), TRUE);

  label147 = gtk_label_new (_("Texte/Montant :"));
  gtk_widget_ref (label147);
  gtk_object_set_data_full (GTK_OBJECT (SearchOp), "label147", label147,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label147);
  gtk_fixed_put (GTK_FIXED (fixed13), label147, 48, 116);
  gtk_widget_set_uposition (label147, 48, 116);
  gtk_widget_set_usize (label147, 96, 16);
  gtk_misc_set_alignment (GTK_MISC (label147), 0, 0.5);

  hseparator16 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator16);
  gtk_object_set_data_full (GTK_OBJECT (SearchOp), "hseparator16", hseparator16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator16);
  gtk_fixed_put (GTK_FIXED (fixed13), hseparator16, 16, 104);
  gtk_widget_set_uposition (hseparator16, 16, 104);
  gtk_widget_set_usize (hseparator16, 360, 16);

  vseparator8 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator8);
  gtk_object_set_data_full (GTK_OBJECT (SearchOp), "vseparator8", vseparator8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator8);
  gtk_fixed_put (GTK_FIXED (fixed13), vseparator8, 368, 112);
  gtk_widget_set_uposition (vseparator8, 368, 112);
  gtk_widget_set_usize (vseparator8, 16, 60);

  hseparator18 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator18);
  gtk_object_set_data_full (GTK_OBJECT (SearchOp), "hseparator18", hseparator18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator18);
  gtk_fixed_put (GTK_FIXED (fixed13), hseparator18, 16, 164);
  gtk_widget_set_uposition (hseparator18, 16, 164);
  gtk_widget_set_usize (hseparator18, 360, 16);

  vseparator9 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator9);
  gtk_object_set_data_full (GTK_OBJECT (SearchOp), "vseparator9", vseparator9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator9);
  gtk_fixed_put (GTK_FIXED (fixed13), vseparator9, 8, 112);
  gtk_widget_set_uposition (vseparator9, 8, 112);
  gtk_widget_set_usize (vseparator9, 16, 60);

  label148 = gtk_label_new (_("Aprox.  :"));
  gtk_widget_ref (label148);
  gtk_object_set_data_full (GTK_OBJECT (SearchOp), "label148", label148,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label148);
  gtk_fixed_put (GTK_FIXED (fixed13), label148, 256, 144);
  gtk_widget_set_uposition (label148, 256, 144);
  gtk_widget_set_usize (label148, 56, 16);
  gtk_misc_set_alignment (GTK_MISC (label148), 0, 0.5);

  label146 = gtk_label_new (_("La recherche doit tre :"));
  gtk_widget_ref (label146);
  gtk_object_set_data_full (GTK_OBJECT (SearchOp), "label146", label146,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label146);
  gtk_fixed_put (GTK_FIXED (fixed13), label146, 48, 56);
  gtk_widget_set_uposition (label146, 48, 56);
  gtk_widget_set_usize (label146, 124, 16);
  gtk_misc_set_alignment (GTK_MISC (label146), 0, 0.5);

  fixed12 = gtk_fixed_new ();
  gtk_widget_ref (fixed12);
  gtk_object_set_data_full (GTK_OBJECT (SearchOp), "fixed12", fixed12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed12);
  gtk_box_pack_start (GTK_BOX (vbox15), fixed12, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (fixed12), 5);

  Search_BtOk = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (Search_BtOk);
  gtk_object_set_data_full (GTK_OBJECT (SearchOp), "Search_BtOk", Search_BtOk,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Search_BtOk);
  gtk_fixed_put (GTK_FIXED (fixed12), Search_BtOk, 208, 16);
  gtk_widget_set_uposition (Search_BtOk, 208, 16);
  gtk_widget_set_usize (Search_BtOk, 80, 28);

  Search_BtCancel = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (Search_BtCancel);
  gtk_object_set_data_full (GTK_OBJECT (SearchOp), "Search_BtCancel", Search_BtCancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Search_BtCancel);
  gtk_fixed_put (GTK_FIXED (fixed12), Search_BtCancel, 300, 16);
  gtk_widget_set_uposition (Search_BtCancel, 300, 16);
  gtk_widget_set_usize (Search_BtCancel, 76, 28);

  hseparator17 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator17);
  gtk_object_set_data_full (GTK_OBJECT (SearchOp), "hseparator17", hseparator17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator17);
  gtk_fixed_put (GTK_FIXED (fixed12), hseparator17, 4, 0);
  gtk_widget_set_uposition (hseparator17, 4, 0);
  gtk_widget_set_usize (hseparator17, 380, 16);

  gtk_signal_connect (GTK_OBJECT (OptionSearch), "state-changed",
                      GTK_SIGNAL_FUNC (on_OptionSearch_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Search_BtOk), "clicked",
                      GTK_SIGNAL_FUNC (on_Search_BtOk_clicked),
                      NULL);
  gtk_signal_connect_object (GTK_OBJECT (Search_BtCancel), "clicked",
                             GTK_SIGNAL_FUNC (Search_BtCancel_clicked),
                             GTK_OBJECT (SearchOp));

  return SearchOp;
}

MYSQL_RES *Dialog_Search(gchar *Jrn)
{
  if (Jrn!=NULL) strcpy(Journal,Jrn);else *Journal=0;
  WinSearch=create_SearchOp();
  gtk_widget_show_all(WinSearch);
  ModalResult=MR_NONE;
  while (ModalResult==MR_NONE)
    if (gtk_events_pending()) gtk_main_iteration();
  return (Retour);
}
