/*******************************************************************/
/* Comptabilit Analityque Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 21/03/02 - Boite de slection d'une ligne sur Sql               */
/* Fichier source                                                  */
/* 09/04/2001 - Amlioration et passage valeur init                */
/* 13/09/2002 - Correction ListSelecvt, ajout trie des colonnes    */
/*              Marc DILASSIER                                     */
/*******************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 


#include <gtk/gtk.h>
#include <gnome.h>
#include <string.h>
#include <ctype.h>
#include <mysql/mysql.h>
#include "support.h"
#include "common.h"
#include "select.h"

/* la boite de dialogue */
GtkWidget *Select;
GtkWidget *vbox8;
GtkWidget *hbox9;
GtkWidget *Label;
GtkWidget *QueryText;
GtkWidget *scrolledwindow2;
GtkWidget *ListElem;
GtkWidget *hbox8;
GtkWidget *Select_BtOk;
GtkWidget *Select_BtCancel;
GtkTooltips *tooltips;

/* Variables */

gchar SelectCodeRet[20],SelectSoc[25],SelectCode[25],SelectLib[25];
gchar SelectTable[25];
gint  ModalResult;

/* protos */
void create_Select (void);
void Sel_QueryText_changed(GtkEditable *editable,gpointer user_data);
void Sel_BtOk_clicked(GtkButton *button,gpointer user_data);
void Sel_BtCancel_clicked(GtkButton *button,gpointer user_data);
gboolean Sel_ListElem_button_press_event(GtkWidget *widget,GdkEventButton *event,gpointer user_data);
void Sel_ListElem_unselect_row         (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);
void Sel_ListElem_select_row           (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);
/***********/

void Sel_QueryText_changed(GtkEditable *editable,gpointer user_data)
{
  gchar TxtSearch[16],SqlCmd[120],Soc[3];
  gchar *Gr[2];
  MYSQL_ROW Row;
  MYSQL_RES *Result;

  strcpy(TxtSearch,gtk_entry_get_text(GTK_ENTRY (editable)));
  GetSocRun(Soc);
  if (strlen(TxtSearch)!=0)  sprintf(SqlCmd,"Select %s,%s From %s where %s='%s' and ((%s like '%s') Or (%s like '%s'))",SelectCode,SelectLib,SelectTable,SelectSoc,Soc,SelectCode,TxtSearch,SelectLib,TxtSearch);
  else sprintf(SqlCmd,"Select %s,%s From %s Where %s='%s'",SelectCode,SelectLib,SelectTable,SelectSoc,Soc);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    gtk_clist_freeze(GTK_CLIST (ListElem));
    gtk_clist_clear(GTK_CLIST (ListElem));
    gtk_clist_set_column_justification(GTK_CLIST (ListElem),0,GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification(GTK_CLIST (ListElem),1,GTK_JUSTIFY_LEFT);
    Result=mysql_store_result(DbLcpt);
    while ((Row=mysql_fetch_row(Result))) {
      Gr[0]=Row[0];
      Gr[1]=Row[1];
      gtk_clist_append(GTK_CLIST (ListElem),Gr);
    }
    mysql_free_result(Result);
    gtk_clist_thaw(GTK_CLIST (ListElem));
  } else MessageAlerte("Echec sur requte SQL");
}

gboolean Sel_ListElem_button_press_event(GtkWidget *widget,GdkEventButton *event,gpointer user_data)
{
  if (event->type==GDK_2BUTTON_PRESS) {
    ModalResult=MR_OK;
    gtk_widget_destroy(GTK_WIDGET(Select));
  } 
  return FALSE;
}

void Sel_ListElem_select_row           (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gchar *Txt;

  gtk_clist_get_text(clist,row,0,&Txt);
  strcpy(SelectCodeRet,Txt);
  gtk_widget_set_sensitive(Select_BtOk,1);
}

void Sel_ListElem_unselect_row         (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gtk_widget_set_sensitive(Select_BtOk,0);
}

void Sel_BtOk_clicked(GtkButton *button,gpointer user_data)
{
  gtk_grab_remove(Select);
  gtk_widget_destroy(GTK_WIDGET(Select));
  ModalResult=MR_OK;
}

void Sel_BtCancel_clicked(GtkButton *button,gpointer user_data)
{
  gtk_grab_remove(Select);
  gtk_widget_destroy(GTK_WIDGET(Select));
  ModalResult=MR_CANCEL;
}

void create_Select (void)
{
  tooltips = gtk_tooltips_new ();

  Select = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (Select), "Select", Select);
  gtk_window_set_title (GTK_WINDOW (Select), _("Selection"));
  gtk_window_set_position (GTK_WINDOW (Select), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (Select), TRUE);
  gtk_window_set_default_size (GTK_WINDOW (Select), 450, 350);

  vbox8 = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (Select), vbox8);

  hbox9 = gtk_hbox_new (FALSE, 0);

  gtk_box_pack_start (GTK_BOX (vbox8), hbox9, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox9), 4);

  Label = gtk_label_new (_("Recherche :"));

  gtk_box_pack_start (GTK_BOX (hbox9), Label, FALSE, FALSE, 0);

  QueryText = gtk_entry_new_with_max_length (15);
  gtk_signal_connect (GTK_OBJECT (QueryText), "changed",
                      GTK_SIGNAL_FUNC (Sel_QueryText_changed),
                      NULL);
  gtk_box_pack_start (GTK_BOX (hbox9), QueryText, FALSE, TRUE, 0);
  gtk_tooltips_set_tip (tooltips, QueryText, _("Filtrer en utilisant '%' et '_'"), NULL);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);

  gtk_box_pack_start (GTK_BOX (vbox8), scrolledwindow2, TRUE, TRUE, 0);

  ListElem = gtk_clist_new (2);

  gtk_container_add (GTK_CONTAINER (scrolledwindow2), ListElem);
  gtk_container_set_border_width (GTK_CONTAINER (ListElem), 4);
  gtk_clist_set_column_width (GTK_CLIST (ListElem), 0, 80);
  gtk_clist_set_column_title(GTK_CLIST (ListElem),0,"Code");
  gtk_clist_set_column_width (GTK_CLIST (ListElem), 1, 80);
  gtk_clist_set_column_title(GTK_CLIST (ListElem),1,"Libell");
  gtk_clist_column_titles_show (GTK_CLIST (ListElem));
  gtk_clist_set_column_justification(GTK_CLIST (ListElem),0,GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_justification(GTK_CLIST (ListElem),1,GTK_JUSTIFY_LEFT);
  gtk_signal_connect (GTK_OBJECT (ListElem), "select_row",
                      GTK_SIGNAL_FUNC (Sel_ListElem_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ListElem), "unselect_row",
                      GTK_SIGNAL_FUNC (Sel_ListElem_unselect_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ListElem), "button_press_event",
                      GTK_SIGNAL_FUNC (Sel_ListElem_button_press_event),
                      NULL);

  hbox8 = gtk_hbox_new (TRUE, 0);

  gtk_box_pack_start (GTK_BOX (vbox8), hbox8, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox8), 4);

  Select_BtOk = gnome_stock_button (GNOME_STOCK_BUTTON_APPLY);
  gtk_box_pack_start (GTK_BOX (hbox8), Select_BtOk, FALSE, FALSE, 0);
  gtk_signal_connect (GTK_OBJECT (Select_BtOk), "clicked",
                      GTK_SIGNAL_FUNC (Sel_BtOk_clicked),
                      NULL);

  Select_BtCancel = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_box_pack_start (GTK_BOX (hbox8), Select_BtCancel, FALSE, FALSE, 0);
  gtk_signal_connect (GTK_OBJECT (Select_BtCancel), "clicked",
                      GTK_SIGNAL_FUNC (Sel_BtCancel_clicked),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (Select), "tooltips", tooltips);
  gtk_grab_add(Select);
  gtk_widget_show_all(Select);
}

/* Ex ListSelect(Code,"Comptes","CptSoc","CptCode","CptLib","512") */
int ListSelect(char *Ret,char *Tbl,char *Soc,char *Code,char *Lib,char *Init)
{
  gchar *Gr[2],SqlCmd[120],PsCle[LEN_COD_SOC+1],Tmp[20];
  MYSQL_ROW Row;
  MYSQL_RES *Result;
  int Nbe;

  strcpy(SelectSoc,Soc);
  strcpy(SelectCode,Code);
  strcpy(SelectLib,Lib);
  strcpy(SelectTable,Tbl);
  create_Select();
  GetSocRun(PsCle);
  if (Init!=NULL) {
    sprintf(SqlCmd,"Select %s,%s From %s where %s='%s' and (%s like '%s%%') Order By %s",
	    SelectCode,SelectLib,SelectTable,SelectSoc,PsCle,SelectCode,Init,SelectCode);
    sprintf(Tmp,"%s%%",Init);
    gtk_entry_set_text(GTK_ENTRY (QueryText),Tmp);
  }  else sprintf(SqlCmd,"Select %s,%s From %s Where %s='%s' Order By %s",
		  SelectCode,SelectLib,SelectTable,SelectSoc,PsCle,SelectCode);
  if (mysql_query(DbLcpt,SqlCmd)==0) {
    Nbe=0;
    gtk_clist_freeze(GTK_CLIST (ListElem));
    gtk_clist_clear(GTK_CLIST (ListElem));
    Result=mysql_store_result(DbLcpt);
    while ((Row=mysql_fetch_row(Result))) {
      Gr[0]=Row[0];
      Gr[1]=Row[1];
      gtk_clist_append(GTK_CLIST (ListElem),Gr);
      Nbe++;
    }
    if (Nbe) gtk_clist_select_row(GTK_CLIST (ListElem), 0, 0);
    mysql_free_result(Result);
    gtk_clist_thaw(GTK_CLIST (ListElem));
  }
  ModalResult=MR_NONE;
  while (ModalResult==MR_NONE)
    if (gtk_events_pending()) gtk_main_iteration();
  if (ModalResult==MR_OK) strcpy(Ret,SelectCodeRet);else *Ret='\0';
  return (ModalResult);
}
