/*******************************************************************/
/* Comptabilit Analityque Professionnel                           */
/* 01/01/2002 - Version 0.1                                        */
/* CONRAD Pascal                                                   */
/*-----------------------------------------------------------------*/
/* 21/03/02 - Boite de slection d'une socit                     */
/* Fichier source                                                  */
/* 13/04/02 - Modification retour DialSelectSoc en int             */
/*******************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <gtk/gtk.h>
#include <gnome.h>
#include <string.h>
#include <ctype.h>
#include <mysql/mysql.h>
#include "support.h"
#include "common.h"
#include "selectsoc.h"

/* La boite de dialogue */
GtkWidget *SelectSoc;
GtkWidget *vbox2;
GtkWidget *pixmap1;
GtkWidget *scrolledwindow1;
GtkWidget *LstSoc;
GtkWidget *LstSelSoc;
GtkWidget *BtApply;
GtkWidget *BtFermer;

/* Variables */
static int FirstSelectSoc=TRUE;
int ModalResult;

/* Protos */
void LstSoc_select_row (GtkCList *clist,gint row,gint column,GdkEvent *event,gpointer user_data);
void LstSoc_unselect_row(GtkCList *clist,gint row,gint column,GdkEvent *event,gpointer user_data);
gboolean LstSoc_button_press_event(GtkWidget *widget,GdkEventButton *event,gpointer user_data);
void BtFermer_clicked(GtkButton *button,gpointer user_data);
void create_SelectSoc(void);
void LstSoc_destroy(GtkObject *Obj);
void BtApply_clicked(GtkButton *button,gpointer user_data);


/*****/
void LstSoc_select_row (GtkCList *clist,gint row,gint column,GdkEvent *event,gpointer user_data)
{
  char *Tmp;

  gtk_clist_get_text(clist,row,0,&Tmp);
  if (Tmp!=NULL) {
    SetSocRun(Tmp);
    gtk_widget_set_sensitive(BtApply,1);
  }
}

void LstSoc_unselect_row(GtkCList *clist,gint row,gint column,GdkEvent *event,gpointer user_data)
{
  gtk_widget_set_sensitive(BtApply,0);
}

void BtApply_clicked(GtkButton *button,gpointer user_data)
{
  if (GTK_WIDGET_IS_SENSITIVE (BtApply)) {
    ModalResult=MR_OK;
    gtk_widget_destroy(GTK_WIDGET(SelectSoc));
  }
}

gboolean LstSoc_button_press_event(GtkWidget *widget,GdkEventButton *event,gpointer user_data)
{
  if (event->type==GDK_2BUTTON_PRESS) {
    if (GTK_WIDGET_IS_SENSITIVE (BtApply)) {
      ModalResult=MR_OK;
      gtk_widget_destroy(GTK_WIDGET(SelectSoc));
    }
  } 
  return FALSE;
}

void BtFermer_clicked(GtkButton *button,gpointer user_data)
{
  ModalResult=MR_CANCEL;
  if (FirstSelectSoc) gtk_main_quit();else gtk_widget_destroy(GTK_WIDGET(SelectSoc));
}

void LstSoc_destroy(GtkObject *Obj)
{
  FirstSelectSoc=FALSE;
}

void create_SelectSoc(void)
{
  SelectSoc = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_container_set_border_width (GTK_CONTAINER (SelectSoc), 3);
  gtk_window_set_title (GTK_WINDOW (SelectSoc), _("Slection socit"));
  gtk_window_set_position (GTK_WINDOW (SelectSoc), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (SelectSoc), TRUE);
  gtk_window_set_default_size (GTK_WINDOW (SelectSoc), 250, 199);
  gtk_signal_connect (GTK_OBJECT (SelectSoc), "destroy",
                      GTK_SIGNAL_FUNC (LstSoc_destroy),
                      NULL);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (SelectSoc), vbox2);

  pixmap1 = Load_XPMPixmap("logo.xpm",SelectSoc);
  gtk_box_pack_start (GTK_BOX (vbox2), pixmap1, FALSE, TRUE, 0);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_box_pack_start (GTK_BOX (vbox2), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_NEVER, GTK_POLICY_NEVER);

  LstSoc = gtk_clist_new(2);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), LstSoc);
  gtk_container_set_border_width (GTK_CONTAINER (LstSoc), 2);
  gtk_clist_set_column_width (GTK_CLIST (LstSoc), 0, 42);
  gtk_clist_set_column_title(GTK_CLIST (LstSoc),0,_("Code"));
  gtk_clist_set_column_width (GTK_CLIST (LstSoc), 1, 80);
  gtk_clist_set_column_title(GTK_CLIST (LstSoc),1,_("Libell"));
  gtk_clist_column_titles_show (GTK_CLIST (LstSoc));
  gtk_clist_set_shadow_type (GTK_CLIST (LstSoc), GTK_SHADOW_ETCHED_OUT);
  gtk_signal_connect (GTK_OBJECT (LstSoc), "select_row",
                      GTK_SIGNAL_FUNC (LstSoc_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (LstSoc), "unselect_row",
                      GTK_SIGNAL_FUNC (LstSoc_unselect_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (LstSoc), "button_press_event",
                      GTK_SIGNAL_FUNC (LstSoc_button_press_event),
                      NULL);

  LstSelSoc = gtk_hbox_new (TRUE, 0);
  gtk_box_pack_start (GTK_BOX (vbox2), LstSelSoc, FALSE, FALSE, 0);

  BtApply = gnome_stock_button (GNOME_STOCK_BUTTON_APPLY);
  gtk_widget_set_sensitive(BtApply,FALSE);
  gtk_box_pack_start (GTK_BOX (LstSelSoc), BtApply, FALSE, FALSE, 0);
  gtk_signal_connect (GTK_OBJECT (BtApply), "clicked",
                      GTK_SIGNAL_FUNC (BtApply_clicked),
                      NULL);

  BtFermer = gnome_stock_button (GNOME_STOCK_BUTTON_CLOSE);
  gtk_box_pack_start (GTK_BOX (LstSelSoc), BtFermer, FALSE, FALSE, 0);
  gtk_signal_connect (GTK_OBJECT (BtFermer), "clicked",
                      GTK_SIGNAL_FUNC (BtFermer_clicked),
                      NULL);
  gtk_widget_show_all(SelectSoc);
}

gint DialSelectSoc(void)
{
  char SqlCmd[250];
  gchar *Gr[2];
  MYSQL_RES *MyRes;
  MYSQL_ROW Row;

  create_SelectSoc();
  OpenDbLcpt();
  if (DbLcpt!=NULL) {
    strcpy(SqlCmd,"SELECT * FROM Societe");
    mysql_query(DbLcpt,SqlCmd);
    MyRes=mysql_store_result(DbLcpt);
    gtk_clist_clear(GTK_CLIST (LstSoc));
    while ((Row=mysql_fetch_row(MyRes))) {
      Gr[0]=Row[0];
      Gr[1]=Row[1];
      gtk_clist_append(GTK_CLIST (LstSoc),Gr);
    }
    mysql_free_result(MyRes);
    CloseDbLcpt();
  }
  ModalResult=MR_NONE;
  while (ModalResult==MR_NONE)
    if (gtk_events_pending()) gtk_main_iteration();
  return (ModalResult);
};
